using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
//using System.Windows.Forms;

namespace LLNet.DAL.Oracle.PDV
{
    public partial class PDV : LLNet.DAL.OracleDAL
    {
        public PDV()
        {
            InitializeComponent();
            OnLoadQueries += new OnLoadQueriesEventHandler(PDV_OnLoadQueries);
            PDV_OnLoadQueries();
        }

        void PDV_OnLoadQueries()
        {

            #region WRLG. DESARROLLO DE GARANTIAS

            QueryMap.Add("CntSeriesXClasificacion", @"
                SELECT count(1) + NVL(MAX((
                    SELECT count(1) 
                    FROM wms_series_x_documento 
                    WHERE documento = &&DOCUMENTO&& 
                    AND serie = '&&SERIE&&')),0)
                FROM   wms_series_x_documento a, wms_skus_x_documento b, wms_documentos c , wms_skus_x_clasificacion d 
                WHERE  a.documento = b.documento
                AND    a.linea = b.linea
                AND    b.documento = c.documento
                AND    a.serie = '&&SERIE&&'
                AND    c.tipo_documento = 'F'
                AND    nvl(c.situacion,3) = '3'                
                AND    b.sku = d.sku                
                AND    d.clasificacion in (
                       SELECT clasificacion
                       FROM   wms_clasificaciones
                       CONNECT BY PRIOR clasificacion = padre
                       START WITH clasificacion = &&CLASIFICACION&&)
            ");

            QueryMap.Add("BusquedaGarantias", @"
                select *
                from   tda_v_consulta_garantias a
                where  tda_f_consulta_garantias('&&COLUMNA&&',a.garantia) like '&&BUSQUEDA&&'
            ");

            QueryMap.Add("EmitirGarantiaXAnulacion", @"
                UPDATE wms_garantias
                SET    estado = 'E'
                ,      documento_cobro = NULL
                ,      linea_cobro = NULL
                WHERE  documento_cobro = &&DOCUMENTO&&
            ");

            QueryMap.Add("EmitirGarantiaXAnulacionLinea", @"
                UPDATE wms_garantias
                SET    estado = 'E'
                ,      documento_cobro = NULL
                ,      linea_cobro = NULL
                WHERE  documento_cobro = &&DOCUMENTO&&
                AND    linea_cobro = &&LINEA&&
            ");

            QueryMap.Add("IncluirNumLineaxGiftCard", @"
                BEGIN
                    wms_p_insertar_linea(&&TIPO&&,'&&TARJETA&&',&&LINEA&&,&&DOCUMENTO&&);
                END; 
            ");

            QueryMap.Add("tda_p_aplicar_garantia", @"
                BEGIN
                    tda_p_aplicar_garantia(&&DOCUMENTO&&, &&MONTO&&, &&LINEA&&, '&&USUARIO&&', &&GARANTIA&&);
                END;
            ");

            QueryMap.Add("DsGarantias.TDA_V_GARANTIAS_X_FACTURA", @"
                SELECT *
                FROM tda_v_garantias_x_factura
                WHERE serie = '&&SERIE&&'
                AND   no_documento = '&&DOCUMENTO&&'
                AND   estado = 'E'
            ");

            QueryMap.Add("DsGarantias.TDA_V_GARANTIAS_X_FACTURASinSerie", @"
                SELECT *
                FROM tda_v_garantias_x_factura
                WHERE serie IS NULL
                AND   no_documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("ReimpresionGarantias", @"
                SELECT *
                FROM wms_garantias
                WHERE garantia = &&GARANTIA&&
                AND   ESTADO <> 'A'");

            QueryMap.Add("DsGarantias.WMS_GARANTIAS", @"
                SELECT *
                FROM wms_garantias
                WHERE documento = &&DOCUMENTO&&
                AND   ESTADO <> 'A'");

            QueryMap.Add("ProductosConGarantia", @"
                SELECT count(1)
                FROM   wms_skus_x_documento a, wms_skus b
                WHERE  a.sku = b.sku
                AND    b.meses_garantia IS NOT NULL
                AND    a.documento in (&&DOCUMENTO&&)
            ");

            QueryMap.Add("GenerarGarantiasdeProducto", @"
                BEGIN
                    tda_p_generar_garantias(&&DOCUMENTO&&);
                END;
            ");

            QueryMap.Add("EmitirGarantias", @"
                BEGIN
                    tda_p_emitir_garantias(&&PEDIDO&&,&&DOCUMENTO&&);
                END;
            ");

            #endregion

            QueryMap.Add("ArqueoRetiro", "SELECT DENOMINACIONES, MONEDADESC MONEDA, TASA_CAMBIO, CANTIDAD, TOTAL, FACTOR FROM WMS_V_DETALLE_ARQUEOS WHERE ARQUEO = &&ARQUEO&&  AND MONEDA = &&MONEDA&& ORDER BY FACTOR DESC");

            QueryMap.Add("DSListadoEcom", "SELECT * FROM ECOM_V_ORDENES_OMNI@ECOMMERCE WHERE BODEGA = &&pBODEGA&&");

            QueryMap.Add("EjecutarTransaccion", "BEGIN ECOM_P_RECLAMAR_ORDENES('&&pORDEN&&', '&&pUSUARIO&&'); END;");

            QueryMap.Add("ApartadosAnulados", @"SELECT TOTAL
                FROM POS_V_APARTADOS_ANULADOS WHERE JORNADA = &&JORNADA&&");

            QueryMap.Add("UpdateJornadasE", @"UPDATE    WMS_DETALLE_JORNADAS SET MONTO = &&MONTO&& WHERE (JORNADA = &&JORNADA&&) AND (TIPO_PAGO = &&TIPO_PAGO&&)");

            QueryMap.Add("EmisoresPAGOSCREDITO", @"SELECT RV_LOW_VALUE FROM CG_REF_CODES WHERE RV_DOMAIN = 'TIPO PAGO CIERRE'");

            QueryMap.Add("EmisoresJornadasE", @"SELECT RV_LOW_VALUE FROM CG_REF_CODES WHERE RV_DOMAIN = 'TIPO PAGO CIERRE' AND RV_MPNC01
            IN ('1','2','3') AND RV_HIGH_VALUE = 1 OR RV_MPNC01 IN('4','5') AND RV_HIGH_VALUE IN ('32','34') order by rv_low_value asc");

            QueryMap.Add("Tarjeta1Desc", @"SELECT RV_MEANING FROM CG_REF_CODES WHERE RV_DOMAIN = 'TIPO PAGO CIERRE' AND RV_MPNC01
            = '1' AND RV_HIGH_VALUE = 1");

            QueryMap.Add("Tarjeta2Desc", @"SELECT RV_MEANING FROM CG_REF_CODES WHERE RV_DOMAIN = 'TIPO PAGO CIERRE' AND RV_MPNC01
            = '2' AND RV_HIGH_VALUE = 1");

            QueryMap.Add("Tarjeta3Desc", @"SELECT RV_MEANING FROM CG_REF_CODES WHERE RV_DOMAIN = 'TIPO PAGO CIERRE' AND RV_MPNC01
            = '3' AND RV_HIGH_VALUE = 1");

            QueryMap.Add("MontoTarjetas", @"SELECT SUM (a.valor) FROM wms_pago_documentos a, wms_documentos b 
                        WHERE a.documento = b.documento AND b.jornada = &&JORNADA&& AND CAJA =&&CAJA&& AND a.tipo_pago = 1
                        AND NVL(SITUACION, 1) <> 11 AND WMS_F_FACTANUL(NVL(B.DOCUMENTO_PADRE, B.DOCUMENTO)) <> 0");

            QueryMap.Add("DevEfectivo", @"SELECT  (DECODE (Cg_F_Parameter_Value ('MOJO'), 'MB', sum(a.total), sum(a.total / NVL (a.tasa_cambio_ma, 1))) ) total
              FROM   WMS_DOCUMENTOS a, WMS_SOCIOS b
              WHERE  a.tipo_documento = 'D'
              AND    a.socio = b.socio(+)
              AND    a.jornada =&&JORNADA&&
              AND SUBTIPO_DOCUMENTO = 'D'
              AND    NVL (a.situacion, 1) <> 11");

            QueryMap.Add("dsArqueos.JORNADASE", @"
               SELECT * FROM 
                (
                select NVL(sum(total),0) EFECTIVOMB from wms_v_detalle_arqueos
                where arqueo = (select max(arqueo) from wms_arqueos where jornada = &&JORNADA&&)
                AND MONEDA = WMS_F_MONEDA_BASE) A,
                (select NVL(sum(total),0) EFECTIVOMA from wms_v_detalle_arqueos
                where arqueo = (select max(arqueo) from wms_arqueos where jornada = &&JORNADA&&)
                AND MONEDA = WMS_F_MONEDA_ALTERNA )B,
                (select sum(deposito*nvl(tasa_cambio,1))RetirosMB from wms_retiros
                where jornada = &&JORNADA&& and moneda = wms_f_moneda_base and anulado_el is null
                )C,
                (select sum(deposito)RetirosMA from wms_retiros
                where jornada = &&JORNADA&& AND MONEDA = WMS_F_MONEDA_ALTERNA and anulado_el is null)D,
                (select sum(deposito*nvl(tasa_cambio,1))Total_Retiros from wms_retiros
                where jornada = &&JORNADA&& and anulado_el is null)g,
                (select monto tarjeta1 from RET_V_DETALLE_PAGOS_X_JORNADA where jornada = &&JORNADA&& and tipo_pago =
                (SELECT RV_LOW_VALUE FROM CG_REF_CODES WHERE RV_DOMAIN = 'TIPO PAGO CIERRE' AND RV_MPNC01
            ='1' AND RV_HIGH_VALUE = 1))h,            
            (select monto tarjeta2 from RET_V_DETALLE_PAGOS_X_JORNADA where jornada = &&JORNADA&& and tipo_pago =
                (SELECT RV_LOW_VALUE FROM CG_REF_CODES WHERE RV_DOMAIN = 'TIPO PAGO CIERRE' AND RV_MPNC01
            ='2' AND RV_HIGH_VALUE = 1))i,
            (select monto tarjeta3 from RET_V_DETALLE_PAGOS_X_JORNADA where jornada = &&JORNADA&& and tipo_pago =
                (SELECT RV_LOW_VALUE FROM CG_REF_CODES WHERE RV_DOMAIN = 'TIPO PAGO CIERRE' AND RV_MPNC01
            ='3' AND RV_HIGH_VALUE = 1))j,
                (SELECT DECODE(SUM(EFECTIVO_ENTREGADO), NULL, 0, SUM(EFECTIVO_ENTREGADO)) EFECTIVO_ENTREGADO FROM WMS_CASHBACK WHERE JORNADA = &&JORNADA&& AND ANULADO_EL IS NULL)k,
                (SELECT SUM(TOTAL) RECARGAS_SERVICIOSP FROM (
                                SELECT NVL(SUM(MONTO), 0) TOTAL FROM WMS_V_BNSERVICIOS WHERE JORNADA = &&JORNADA&&
                                UNION ALL
                                SELECT NVL(SUM(MONTO), 0) TOTAL FROM WMS_V_RECARGAS2 WHERE JORNADA = &&JORNADA&&                                
                                ))l,   
                 (select nvl(sum(monto),0) Credix from RET_V_DETALLE_PAGOS_X_JORNADA where jornada = &&JORNADA&& and tipo_pago =
                (SELECT RV_LOW_VALUE FROM CG_REF_CODES WHERE RV_DOMAIN = 'TIPO PAGO CIERRE' AND RV_MPNC01
            ='4' AND RV_HIGH_VALUE = 32))m,
            (  SELECT NVL(SUM(MONTO), 0) RECCLARONIC FROM wms_v_RecargsNic WHERE JORNADA = &&JORNADA&&   )n,   
            (  SELECT NVL(WMS_F_DIFCOL_HABLAMAS(&&JORNADA&&) , 0) Difcol FROM DUAL )o,
            (  SELECT NVL(WMS_F_DIFDOL_HABLAMAS(&&JORNADA&&) , 0) Difdol FROM DUAL )p
                ");

            QueryMap.Add("SimboloMB", @"select RV_MEANING  from cg_ref_codes where rv_domain = 'MONEDA' AND RV_LOW_VALUE = WMS_F_MONEDA_BASE");

            QueryMap.Add("SimboloMA", @"select RV_MEANING  from cg_ref_codes where rv_domain = 'MONEDA' AND RV_LOW_VALUE = WMS_F_MONEDA_ALTERNA");

            QueryMap.Add("CerrarArqueo", @"UPDATE WMS_ARQUEOS SET ESTADO = 'C' WHERE ARQUEO = &&ARQUEO&&");

            QueryMap.Add("ElimDetArq", "DELETE WMS_DETALLE_ARQUEOS WHERE ARQUEO = &&ARQUEO&&");

            QueryMap.Add("GuardarArquRet", "INSERT INTO WMS_ARQUEOS_RETIROS (ARQUEO, RETIRO, JORNADA, USUARIO, CREADO_EL) VALUES (&&pARQUEO&&, &&pRETIRO&&, &&JORNADA&&, '&&pUSER&&', SYSDATE)");

            QueryMap.Add("GuardarArqueo", @"UPDATE WMS_DETALLE_ARQUEOS SET CANTIDAD = &&pCANTIDAD&&, MODIFICADO_POR = '&&pUSUARIO&&'  WHERE ARQUEO = &&pARQUEO&& AND MONEDA = &&pMONEDA&& AND FACTOR = &&pFACTOR&&");

            QueryMap.Add("ArqueosA", @"select count(1) from wms_arqueos where estado = 'A' and jornada = &&JORNADA&&");

            QueryMap.Add("ArqueoAb", @"select arqueo from wms_arqueos where estado = 'A' and jornada = &&JORNADA&&");

            QueryMap.Add("NuevoArqueo", @"
                BEGIN
                    WMS_P_CREAR_ARQUEO(&&ARQUEO&&,&&JORNADA&&,'&&USUARIO&&');
                END;                
            ");

            QueryMap.Add("MontoRetiro", @"SELECT SUM(NVL(CANTIDAD,0) * FACTOR) FROM WMS_DETALLE_ARQUEOS WHERE MONEDA = &&pMONEDA&& AND ARQUEO = &&pARQUEO&&");

            QueryMap.Add("dsArqueos.WMS_DETALLE_ARQUEOS", @"
                SELECT * FROM WMS_V_DETALLE_ARQUEOS WHERE ARQUEO = &&ARQUEO&& ORDER BY MONEDA,SUBTIPO_PAGO");

            QueryMap.Add("dsArqueos.WMS_ARQUEOS", @"
                SELECT * FROM WMS_V_ARQUEOS WHERE JORNADA = &&JORNADA&& ORDER BY ARQUEO DESC");

            QueryMap.Add("dsRetiros_en_caja.RETIROS_CAJA", @"
                SELECT EMPRESA, CAJA, MONTO, BOLETA, PLANILLA, CUENTA_CORRIENTE, FECHA, HORA
                FROM RETIROS_CAJA
                WHERE RETIRO = '&&IDRETIROS&&'
            ");

            QueryMap.Add("RetiroJornada", @"select max(idretiro) from wms_retiros where jornada = &&JORNADA&& AND MONEDA = &&MONEDA&& and anulado_el is null");

            QueryMap.Add("Recibos", @"select * from tda_v_recibos where (1=1) and serie = '&&SERIE&&' AND NO_DOCUMENTO = '&&NO_DOCUMENTO&&' ");

            QueryMap.Add("ReciboP", @"select b.documento from wms_documentos a ,wms_documentos b where a.documento = b.documento_padre and a.documento = &&DOCUMENTO&&
            and b.tipo_documento = 'R'");

            QueryMap.Add("MontoRetiros", @"
                SELECT NVL(sum(deposito),0) FROM WMS_V_RETIROS WHERE JORNADA = &&JORNADA&& ");

            //            QueryMap.Add("MontoenCaja", @"SELECT SUM (a.valor) FROM wms_pago_documentos a, wms_documentos b 
            //                        WHERE a.documento = b.documento AND b.jornada = &&JORNADA&& AND CAJA =&&CAJA&& AND a.tipo_pago = 3
            //                        and a.moneda = wms_f_moneda_base");
            /***************SE MODIFICA PARA QUE TOME EN CUENTA TODOS LOS PAGOS EN EFECTIVO    IMG************************/
            QueryMap.Add("MontoenCaja", @"SELECT EKO_F_TOTAL_EFECTIVO(&&JORNADA&&, WMS_F_MONEDA_BASE) TOTAL FROM DUAL");

            QueryMap.Add("PuntosSocio", "SELECT SUM(NVL(PUNTOS,0)) PUNTOS FROM wms_socios WHERE SOCIO = &&SOCIO&& ");

            QueryMap.Add("EfectivoCaja", "SELECT EFECTIVO FROM WMS_V_EFECTIVO_CAJA WHERE MONEDA = 1 AND CAJA =&&CAJA&& AND JORNADA = &&JORNADA&&");

            QueryMap.Add("EfectivoCajaD", "SELECT EFECTIVO FROM WMS_V_EFECTIVO_CAJA WHERE MONEDA = 2 AND CAJA =&&CAJA&& AND JORNADA = &&JORNADA&&");

            QueryMap.Add("dsRetiros.WMS_RETIROS", @"
                SELECT * FROM WMS_V_RETIROS WHERE JORNADA = &&JORNADA&& ");

            QueryMap.Add("JornadasAbiertasDia", @"
                SELECT COUNT(1)Count FROM WMS_JORNADAS WHERE JORNADA =&&JORNADA&& AND 
                FECHA_CIERRE IS NULL AND TRUNC(FECHA_APERTURA) <> TRUNC(SYSDATE)");

            QueryMap.Add("AgrupaLineasPedido", @"
                BEGIN
                    wms_p_agrupa_lineas_pedido(&&DOCUMENTO&&,&&LINEA&&,'&&USUARIO&&');
                END;                
            ");

            QueryMap.Add("GENERAR_IMPRESION_POS", @"
                BEGIN
                    WMS_P_GENERA_IMPRESION.GENERAR_IMPRESION_POS(&&DOCUMENTO&&,&&FORMATO&&,'&&USUARIO&&');
                END;                
            ");

            QueryMap.Add("ActualizarFactura", @"
                BEGIN
                    tda_p_actualizar_factura('&&SERIE&&','&&NO_DOCUMENTO&&','&&NSERIE&&','&&NNO_DOCUMENTO&&');
                END;                
            ");

            QueryMap.Add("ActualizarFacturaConsolidada", @"
                BEGIN
                    tda_p_actualizar_factura_cons('&&SERIE&&','&&NO_DOCUMENTO&&','&&NSERIE&&','&&NNO_DOCUMENTO&&');
                END;                
            ");

            QueryMap.Add("CancelaFactura", @"
                BEGIN
                    wms_p_pago_doc('&&DOCS&&',&&MONTO&&);
                END;                
            ");

            QueryMap.Add("WMS_P_EXONERA_DOCTO", @"
                BEGIN
                    WMS_P_EXONERA_DOCTO(&&DOCUMENTO&&,'&&EXONERA&&');
                END;                
            ");

            QueryMap.Add("FacturaCons", @"
                SELECT *
                  FROM tda_datos_doccons
                 WHERE (serie = '&&SERIE&&') 
                   AND (no_documento = '&&NO_DOCUMENTO&&')
                ");

            QueryMap.Add("CountLine", @"
                SELECT COUNT(1) FROM WMS_SKUS_X_DOCUMENTO WHERE DOCUMENTO = '&&DOCUMENTO&&' AND USUARIO_ANULO IS NULL
            ");

            QueryMap.Add("DescripcionClasificacion", @"
                SELECT DESCRIPCION FROM WMS_CLASIFICACIONES WHERE CLASIFICACION = '&&CLASIFICACION&&'
            ");

            QueryMap.Add("FacturaConsSs", @"
                SELECT *
                  FROM tda_datos_doccons
                 WHERE serie IS NULL 
                   AND no_documento = '&&NO_DOCUMENTO&&'
            ");

            QueryMap.Add("ModificarListaPrecioDocumento", @"
                update wms_documentos set lista_precios = '&&LISTAPRECIO&&'
                 WHERE DOCUMENTO = '&&DOCUMENTO&&'
            ");

            QueryMap.Add("DetalleFacCons", @"
                SELECT * 
                  FROM tda_detalle_pedcons
                 WHERE (serie = '&&SERIE&&') 
                   AND (no_documento = '&&NO_DOCUMENTO&&')
            ");

            QueryMap.Add("DetalleFacConsSs", @"
                SELECT * 
                  FROM tda_detalle_pedcons
                 WHERE serie IS NULL
                   AND no_documento = '&&NO_DOCUMENTO&&'
            ");

            QueryMap.Add("NotaCredito", @"
                SELECT DISTINCT a.documento, a.serie, a.no_documento,
                       b.socio_alterno, b.nombre, b.nit,
                       a.fecha_emision, trunc(sysdate-a.fecha_emision) dias_factura,total,a.subtipo_documento, 
                       c.nombre nombre_bodega
                FROM   wms_documentos a, wms_socios b, wms_bodegas c
                WHERE  a.socio = b.socio
                AND    nvl(a.situacion,1) <> 11
                AND    a.tipo_documento = 'N'
                AND    a.bodega = c.bodega
                AND    a.serie = '&&SERIE&&'
                AND    a.no_documento = '&&NO_DOCUMENTO&&'
            ");

            QueryMap.Add("NotaCreditoSs", @"
                SELECT DISTINCT a.documento, a.serie, a.no_documento,
                       b.socio_alterno, b.nombre, b.nit,
                       a.fecha_emision, trunc(sysdate-a.fecha_emision) dias_factura,total,a.subtipo_documento, 
                       c.nombre nombre_bodega
                FROM   wms_documentos a, wms_socios b, wms_bodegas c
                WHERE  a.socio = b.socio
                AND    nvl(a.situacion,1) <> 11
                AND    a.tipo_documento = 'N'
                AND    a.bodega = c.bodega
                AND    a.serie IS NULL
                AND    a.no_documento = '&&NO_DOCUMENTO&&'
            ");

            QueryMap.Add("RunGenericStatement", @"
                &&STATEMENT&&
            ");

            QueryMap.Add("WMS_P_PARTIR_DOCUMENTO", @"
                BEGIN
                    UPDATE wms_documentos
                    SET    grid_pos = 'X'
                    WHERE  documento = &&DOCUMENTO&&;
                    wms_p_partir_documento(&&DOCUMENTO&&);
                    COMMIT;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    NULL;
                END;
            ");

            QueryMap.Add("DsDespachos.RET_V_DESPACHOS", @"
        SELECT documento, no_documento, fecha_emision, tipo_documento, desc_tipo_documento,
               transaccion, tipo, iniciada_el, finalizada_el, sku, sku_alterno,
               descripcion, cantidad, bodega, desc_bodega, zona, desc_zona, ubicacion,
               ubicacion_logica, bodega_alterna, zona_alterna
        FROM   ret_v_despachos
        WHERE  documento = &&DOCUMENTO&& " + Utils.QueryParams.PredefinedTags.OrderByToolbarTag);

            QueryMap.Add("OrdenamientoDespacho", @"
        SELECT rv_meaning
        FROM   CG_REF_CODES
        WHERE  rv_domain = 'ORDENAMIENTO DESPACHO'
        AND    rv_low_value = NVL(cg_f_parameter_value('ORDD'),'1') ");

            QueryMap.Add("insertar_cliente", @"
                insert into wms_socios(socio) values ('&&SOCIO&&');
                commit;
            ");

            QueryMap.Add("ActImpresiones", @"
                    UPDATE wms_documentos
                    SET    IMPRESIONES = NVL(IMPRESIONES,0)+1
                    WHERE  documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("ImpresionesCredito", @"
                Select tda_f_impresion_credito(&&DOCUMENTO&&) from dual
           ");

            QueryMap.Add("EsExentoImpuesto", @"
                SELECT count(1)
                  FROM doc_abono_documentos
            ");

            QueryMap.Add("UnidadInventarioCombo", @"
                SELECT a.unidad_inventario
                  FROM wms_skus a, wms_skus_x_documento b
                 WHERE a.sku = b.sku
                   AND b.documento = &&DOCUMENTO&&
                   AND b.linea = &&LINEA&&
            ");

            QueryMap.Add("TotalProntoPago", @"
                SELECT ROUND(tda_f_desc_pronto_pago(&&MONTO&&,&&SOCIO&&,&&SESION&&),6) DPP
                FROM   DUAL
            ");

            QueryMap.Add("DsPDV.TDA_DATOS_DOCCONS", @"
                SELECT *
                  FROM tda_datos_doccons
                 WHERE (serie = '&&SERIE&&') 
                   AND (no_documento = '&&NO_DOCUMENTO&&')
            ");

            QueryMap.Add("DsPDV.TDA_DETALLE_PEDCONS", @"
                SELECT * 
                  FROM tda_detalle_pedcons
                 WHERE (serie = '&&SERIE&&') 
                   AND (no_documento = '&&NO_DOCUMENTO&&')
            ");

            QueryMap.Add("ExisteFacturaConsolidada", @"
                SELECT COUNT(1)
                  FROM (
                        SELECT DISTINCT no_documento_padre, serie_padre
                          FROM wms_documentos
                         WHERE tipo_documento = 'F'
                           AND nvl(situacion,3) <> 11 ) a                           
                 WHERE a.no_documento_padre = '&&NO_DOCUMENTO&&'
                   AND a.serie_padre = '&&SERIE&&'
            ");

            QueryMap.Add("ExisteFacturaConsolidadaSinSerie", @"
                SELECT COUNT(1)
                  FROM (
                        SELECT DISTINCT no_documento_padre, serie_padre
                          FROM wms_documentos
                         WHERE tipo_documento = 'F'
                           AND nvl(situacion,3) <> 11 ) a                           
                 WHERE a.no_documento_padre = '&&NO_DOCUMENTO&&'
                   AND a.serie_padre IS NULL
            ");

            QueryMap.Add("SigFacturaConsolidada", @"
                SELECT proxima_factura, serie
                  FROM wms_facturas_caja
                 WHERE caja = &&CAJA&&
                   AND vigente = 'S'
                   AND proxima_factura <= factura_final
                   AND tipo_documento = 'FC'
            ");

            QueryMap.Add("SigNotaCredit", @"
                SELECT proxima_factura
                  FROM wms_facturas_caja
                 WHERE caja = &&CAJA&&
                   AND vigente = 'S'
                   AND proxima_factura <= factura_final
                   AND tipo_documento = 'NC'
            ");

            QueryMap.Add("SerieNotaCredit", @"
                SELECT serie
                  FROM wms_facturas_caja
                 WHERE caja = &&CAJA&&
                   AND vigente = 'S'
                   AND proxima_factura <= factura_final
                   AND tipo_documento = 'NC'
            ");

            QueryMap.Add("ActNotaCredito", @"
                UPDATE wms_facturas_caja
                   SET proxima_factura = proxima_factura + 1
                 WHERE caja = &&CAJA&&
                   AND vigente = 'S'
                   AND tipo_documento = 'NC'
            ");



            QueryMap.Add("ActFacturaConsolidada", @"
                UPDATE wms_facturas_caja
                   SET proxima_factura = proxima_factura + 1
                 WHERE caja = &&CAJA&&
                   AND vigente = 'S'
                   AND tipo_documento = 'FC'
            ");

            QueryMap.Add("ConsolidarFacturas", @"
                BEGIN
                  UPDATE wms_documentos
                  SET    serie_padre = '&&SERIE&&'
                  ,      no_documento_padre = '&&NO_DOCUMENTO&&'
                  ,      seleccionada_el = sysdate
                  WHERE  tipo_documento = 'R'
                  AND    NVL(situacion,3) = 3
                  AND    documento IN ( 
                         SELECT recibo
                         FROM   doc_abono_documentos a, wms_documentos b
                         WHERE  a.documento = b.documento
                         AND    a.documento = &&DOCUMENTO&&
                  );
                  UPDATE wms_documentos
                  SET    serie_padre = '&&SERIE&&'
                  ,      no_documento_padre = '&&NO_DOCUMENTO&&'
                  ,      seleccionada_el = sysdate
                  WHERE  documento = &&DOCUMENTO&&;
                END;

            ");
            QueryMap.Add("TiempodeEmitida", @"SELECT WMS_F_TIEMPO_EMITIDA('&&SERIE&&', '&&NO_DOCUMENTO&&') FROM DUAL");

            QueryMap.Add("ConsolidarFacturasSinSerie", @"
                BEGIN
                  UPDATE wms_documentos
                  SET    serie_padre = null
                  ,      no_documento_padre = '&&NO_DOCUMENTO&&'
                  ,      seleccionada_el = sysdate
                  WHERE  tipo_documento = 'R'
                  AND    NVL(situacion,3) = 3
                  AND    documento IN ( 
                         SELECT recibo
                         FROM   doc_abono_documentos a, wms_documentos b
                         WHERE  a.documento = b.documento
                         AND    a.documento = &&DOCUMENTO&&
                  );
                  UPDATE wms_documentos
                  SET    serie_padre = null
                  ,      no_documento_padre = '&&NO_DOCUMENTO&&'
                  ,      seleccionada_el = sysdate
                  WHERE  documento = &&DOCUMENTO&&;
                END;
            ");

            QueryMap.Add("FacturasAConsolidar", @"
                SELECT a.documento, a.serie || '-' || a.no_documento factura, b.nombre cliente , a.fecha_emision fecha , a.total, a.saldo, a.serie_padre, a.no_documento_padre
                FROM   wms_documentos a, wms_socios b
                WHERE  a.socio = b.socio
                AND    a.tipo_documento = 'F'
                AND    a.situacion = 3
                AND    NVL(a.subtipo_documento,'F') = '&&TIPO_FACTURA&&'
                AND    serie_padre IS NULL
                AND    no_documento_padre IS NULL
            ");

            QueryMap.Add("TotalValeDevolucion", @"
                SELECT tda_f_monto_devuelto(&&DOCUMENTO&&)
                FROM   dual
            ");


            QueryMap.Add("BloquearEfectivo", @"
                SELECT NVL(TDA_F_PERMITIR_DEVOCREDITO(&&DOCUMENTO&&),0)
                FROM   dual
            ");

            QueryMap.Add("ListaPrecioDocumento", @"
                SELECT lista_precios from wms_documentos where documento = '&&DOCUMENTO&&'
            ");

            QueryMap.Add("LineaAnterior", @"
                SELECT *
                  FROM (
                        SELECT documento
                        ,      linea
                        ,      cantidad
                        ,      situacion_sku
                        ,      bodega
                        ,      usuario
                        ,      porcentaje1
                        ,      usuario2
                        ,      porcentaje2
                        ,      usuario3
                        ,      porcentaje3
                        ,      direccion
                        ,      region
                        ,      observaciones
                        ,      WMS_F_ANCESTROS_CLASIFICACION(region) desc_region
                        ,      bodega2
                        ,      bodega3
                        ,      lotes
                        ,      vencimientos
                        ,      a_domicilio
                        ,      fecha_entrega
                        ,      beneficiario
                        ,      sku
                        ,      vencimiento
                        ,      modificado_por
                          FROM wms_skus_x_documento
                         WHERE documento = &&DOCUMENTO&&
                           AND linea < &&LINEA&&
                           AND usuario_anulo IS NULL
                      ORDER BY linea DESC )
                 WHERE ROWNUM = 1
            ");

            QueryMap.Add("CantidadFormatosFactura", @"
                SELECT COUNT(1)
                  FROM CG_REF_CODES
                 WHERE RV_DOMAIN = 'DOCUMENTOS POS'
                   AND RV_DESCRIPTION = 'XRFactura'
            ");

            QueryMap.Add("ValidarExistencia", @"
                SELECT NVL(SUM(a.cantidad_empaque),0) - &&CANTIDAD&& - &&CANTIDADGR&&
                  FROM wms_inventarios a, wms_unidades_moviles b, wms_ubicaciones c, wms_bodegas d
                 WHERE a.empaque_sku = &&SKU&&
                   AND a.unidad_movil = b.unidad_movil
                   AND b.ubicacion = c.ubicacion
                   AND c.bodega =d.bodega
                   AND D.BODEGA = NVL(CG_F_PARAMETER_VALUE('BVEC'),d.bodega)
                   AND d.no_visible IS NULL
            ");

            QueryMap.Add("ValidarCantidad", @"
            select nvl(sum(cantidad),0) Cant from wms_skus_x_documento  
            where documento = '&&DOCUMENTO&&'
            and sku = '&&SKU&&'
            and usuario_anulo is null
            ");

            QueryMap.Add("FacturasVencidas", @"
                SELECT facturas_vencidas, monto_facturas_vencidas, cheques_rechazados, monto_cheques_rechazados
                  FROM wms_socios
                 WHERE socio = &&SOCIO&&
            ");

            QueryMap.Add("AgregarSubtiposPago", @"
                INSERT INTO wms_arqueo_jornadas (JORNADA, TIPO_PAGO, SUBTIPO_PAGO, CANTIDAD)
                SELECT &&JORNADA&&, &&TIPO_PAGO&&, TO_NUMBER(rv_low_value), 0
                  FROM cg_ref_codes
                 WHERE rv_domain = 'SUBTIPO PAGO'
                   AND TO_NUMBER(rv_low_value) NOT IN (
                       SELECT subtipo_pago
                         FROM wms_arqueo_jornadas
                        WHERE jornada = &&JORNADA&&
                          AND tipo_pago = &&TIPO_PAGO&&
                )
            ");

            QueryMap.Add("DsPDV.WMS_ARQUEO_JORNADAS", @"
                SELECT *
                  FROM wms_arqueo_jornadas
                 WHERE jornada = &&JORNADA&&
                   AND tipo_pago = &&TIPO_PAGO&&
            ");

            QueryMap.Add("DsPDV.UNIDADES_INVENTARIO", @"
				SELECT ROUND(NVL(b.factor,0),7) factor, a.rv_low_value unidad, a.rv_meaning descripcion  
				  FROM cg_ref_codes a, (
				       SELECT unidad_destino unidades, factor 
				         FROM wms_equivalencias
        			    WHERE tipo_unidad = 'I'
				          AND unidad_origen = '&&UNIDAD&&'
				        UNION
				       SELECT unidad_origen, 1 / factor 
				         FROM wms_equivalencias
				        WHERE tipo_unidad = 'I'
				          AND unidad_destino = '&&UNIDAD&&'
				        UNION
				       SELECT rv_low_value, 1 
				         FROM cg_ref_codes
				        WHERE rv_domain = 'UNIDAD INVENTARIO' 
				          AND rv_low_value =  '&&UNIDAD&&' ) b 
				 WHERE rv_domain = 'UNIDAD INVENTARIO'
				   AND a.rv_low_value = b.unidades
			");

            QueryMap.Add("ValidarCambioCanal", @"
                SELECT DECODE(clasificacion1,clasificacion2,1,0) valido
                FROM (
                    SELECT a.clasificacion clasificacion1
                      FROM wms_skus_x_clasificacion a, wms_usuarios b, 
                         ( SELECT c.clasificacion, nvl(c.secuencia,0) secuencia, c.catalogo
                             FROM wms_socios_x_clasificacion c, wms_documentos e
                            WHERE c.socio = e.socio
                              AND e.documento = &&DOCUMENTO&&) d, wms_documentos f
                     WHERE a.sku = &&SKU&&
                       AND a.clasificacion = d.clasificacion
                       AND a.catalogo = b.fuerza_ventas
                       AND d.catalogo = b.fuerza_ventas
                       AND b.usuario = f.usuario1
                       AND f.documento = &&DOCUMENTO&&
                     ORDER BY a.secuencia),
                  ( SELECT a.clasificacion clasificacion2
                      FROM wms_skus_x_clasificacion a, wms_usuarios b,
                         ( SELECT c.clasificacion, nvl(c.secuencia,0) secuencia, c.catalogo
                             FROM wms_socios_x_clasificacion c
                            WHERE c.socio = &&SOCIO&&) d
                     WHERE a.sku = &&SKU&&
                       AND a.clasificacion = d.clasificacion
                       AND a.catalogo = b.fuerza_ventas
                       AND d.catalogo = b.fuerza_ventas
                       AND b.usuario = '&&USUARIO&&'
                     ORDER BY a.secuencia)
            ");
            QueryMap.Add("DsPDV.TDA_V_PRODUCTOS", @"
                           SELECT SKU_ALTERNO, CODIGO_BARRAS, DESCRIPCION, CLASIFICACION1, 
                           CLASIFICACION2, CLASIFICACION3, CLASIFICACION4, CLASIFICACION5, 
                           EXISTENCIAS FROM TDA_V_PRODUCTOS WHERE (1=1)
 ");

            QueryMap.Add("DsPDV.JORNADA", @"
                SELECT a.variable, a.valor descripcion,
                       CASE WHEN NVL(c.rv_mpnc03,0) = 1 THEN
                            Wms_F_Dato_Jornada (&&JORNADA&&, a.variable, '&&USUARIO&&')
                       ELSE NVL (TRIM (TO_CHAR (b.monto, '999,999,990.00')),Wms_F_Dato_Jornada (&&JORNADA&&, a.variable, '&&USUARIO&&'))
                       END  valor, a.tipo_letra, a.tamaño, a.alineacion, a.atributos,
                       a.grupo, &&JORNADA&& jornada,
                       NVL (TRIM (TO_CHAR (b.monto_usuario, '999,999,990.00')), '') monto_usuario,
                       NVL (TRIM (TO_CHAR (b.monto_supervisor, '999,999,990.00')), '') monto_supervisor,
					   NVL (TRIM (TO_CHAR (b.monto - b.monto_supervisor, '999,999,990.00')), '') diferencia
			      FROM PAR_FORMATO_IMPRESIONES a, WMS_HISTORICO_JORNADAS b, CG_REF_CODES c
			     WHERE a.VARIABLE = b.rubro(+)
			       AND a.impresion = &&FORMATO&&
                   AND c.rv_domain = 'VARIABLE'
                   AND a.variable = c.rv_low_value
				   AND b.jornada(+) = &&JORNADA&&
				 ORDER BY a.secuencia
            ");

            QueryMap.Add("ActualizaValesHijos", @"
                UPDATE doc_vales
                   SET estado = 'E'
                 WHERE vale_padre in (
                       SELECT vale
                         FROM wms_pago_documentos
                        WHERE documento = &&RECIBO&&
                          AND vale IS NOT NULL) 
                   AND estado = 'P'
            ");

            QueryMap.Add("ValidaRangoVale", @"
                SELECT CASE WHEN &&VALE&& >= TO_NUMBER(rv_low_value) AND &&VALE&& <= TO_NUMBER(rv_high_value) THEN 1 ELSE 0 END ret_value
                  FROM cg_ref_codes
                 WHERE rv_domain = 'RANGOS DE VALES'
                   AND rv_mpnc01 = TO_NUMBER(cg_f_parameter_value('BREE'))
            ");

            QueryMap.Add("SituacionDocumento", @"
                SELECT situacion
                  FROM wms_documentos
                 WHERE documento = '&&DOCUMENTO&&'
            ");

            QueryMap.Add("MonedaBase", @"
                SELECT WMS_F_MONEDA_BASE FROM DUAL
            ");

            QueryMap.Add("EsUsuarioVendedor", @"
                SELECT vendedor 
                  FROM wms_usuarios
                 WHERE usuario = '&&USUARIO&&'
            ");

            QueryMap.Add("DsPDV.RET_V_DETALLE_PAGOS_X_JORNADA", @"
				SELECT jornada, tipo_pago, descripcion, sistema, monto, 
                       tasa_cambio, monto_om, cuenta, referencia, editable,
                       pagado, pagado_om
				  FROM ret_v_detalle_pagos_x_jornada
			   	 WHERE jornada = &&JORNADA&&
                 ORDER BY secuencia
            ");

            QueryMap.Add("ACTUALIZAR_JORNADA", @"
                BEGIN wms_p_jornadas.actualizar_jornada(&&JORNADA&&); END;
            ");

            QueryMap.Add("DIFERENCIAL_CAMBIARIO", @"
				BEGIN wms_p_jornadas.diferencial_cambiario(&&JORNADA&&); END;
            ");

            QueryMap.Add("OfertasxPrecio", @"
                SELECT count(1)
                  FROM wms_ofertas_x_documento a, wms_rangos_de_ofertas b
                 WHERE a.oferta = b.oferta
                   AND b.unidad_valor IN ('C','F','O','S')
                   AND a.documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("TotalRecargo", @"
                SELECT ROUND(SUM(NVL(porcion2_precio,0)),7)
                  FROM wms_skus_x_documento
                 WHERE documento = &&DOCUMENTO&&
                   AND usuario_anulo IS NULL
            ");

            QueryMap.Add("FacturasRestantes", @"
                SELECT factura_final - proxima_factura restantes
                  FROM wms_facturas_caja
                 WHERE caja = &&CAJA&&
                   AND NVL(vigente,'N') = 'S'
                   AND tipo_documento = 'FA'
            ");

            QueryMap.Add("TalonarioValido", @"
                SELECT CASE WHEN factura_final - proxima_factura <= ROUND((factura_final - factura_inicial) * TO_NUMBER(NVL(cg_f_parameter_value('PTFA'),10)) / 100) THEN
                        0 ELSE 1 END validez
                  FROM wms_facturas_caja
                 WHERE caja = &&CAJA&&
                   AND NVL(vigente,'N') = 'S'
                   AND tipo_documento = 'FA'
            ");

            QueryMap.Add("TalonarioValidoNC", @"
                SELECT CASE WHEN factura_final - proxima_factura <= ROUND((factura_final - factura_inicial) * TO_NUMBER(NVL(cg_f_parameter_value('PTFA'),10)) / 100) THEN
                        0 ELSE 1 END validez
                  FROM wms_facturas_caja
                 WHERE caja = &&CAJA&&
                   AND NVL(vigente,'N') = 'S'
                   AND tipo_documento = 'NC'
            ");

            QueryMap.Add("NCRestantes", @"
                SELECT factura_final - proxima_factura restantes
                  FROM wms_facturas_caja
                 WHERE caja = &&CAJA&&
                   AND NVL(vigente,'N') = 'S'
                   AND tipo_documento = 'NC'
            ");

            #region Combos

            QueryMap.Add("DsPDV.COMBOS", @"
                SELECT a.clasificacion, d.descripcion menu, a.sku, b.sku_alterno, b.descripcion, 
                       round(c.cantidad,7) cantidad, round(a.cantidad,7) cantidad_sugerida, 
                       nvl(b.unidad_inventario,'1') unidad_inventario, 
                       ROUND(NVL(wms_f_equivalencia('I',b.unidad_inventario,e.unidad_sku,1),1),7) factor
                  FROM wms_skus_x_clasificacion a, wms_skus b,
                     ( SELECT clasificacion, cantidad
                         FROM wms_skus_x_clasificacion
                        WHERE catalogo = TO_NUMBER(cg_f_parameter_value('COMB'))
                          AND sku = &&SKU&& ) c,
                       wms_clasificaciones d,
                     ( SELECT nvl(unidad_inventario,'1') unidad_sku
                         FROM wms_skus
                        WHERE sku = &&SKU&& ) e
                 WHERE a.sku = b.sku
                   AND a.clasificacion = c.clasificacion
                   AND a.clasificacion = d.clasificacion
                   AND a.combo IS NULL
            ");

            QueryMap.Add("EsComboExplotado", @"
                SELECT tipo_actualizacion_pedido 
                  FROM wms_skus
                 WHERE sku = wms_f_buscar_sku('&&SKU_ALTERNO&&')
            ");

            #endregion

            #region Pagos Anticipados

            QueryMap.Add("CobrarPagoAnticipado", @"
                BEGIN tda_p_cobrar_pago_anticipado(&&FACTURA&&, &&MONTO&&); END;
            ");

            QueryMap.Add("DsPDV.TDA_V_PAGOS_ANTICIPADOS", @"
                SELECT   *
                FROM     tda_v_pagos_anticipados
                WHERE    socio = &&SOCIO&&
                ORDER BY fecha_emision, serie, no_documento
            ");

            #endregion

            #region Vales

            QueryMap.Add("AnularValesxPedido", @"
                DELETE DOC_VALES
                WHERE  VALE IN (
                    SELECT VALE
                    FROM   WMS_SKUS_X_DOCUMENTO
                    WHERE  DOCUMENTO = &&DOCUMENTO&&
                    AND    USUARIO_ANULO IS NULL
                    AND    VALE IS NOT NULL)
            ");

            QueryMap.Add("DsPDV.TDA_V_CONSULTA_VALES", @"
                SELECT *
                FROM   tda_v_consulta_vales
                WHERE  vale = &&VALE&&
            ");

            QueryMap.Add("ActualizarEstadoVale", @"
                UPDATE doc_vales
                SET    estado = '&&ESTADO&&'
                WHERE  vale = &&VALE&&
            ");

            QueryMap.Add("ActualizarVales", @"
                UPDATE doc_vales
                SET    factura_pago = &&DOCUMENTO&&, ESTADO = 'E'                
                WHERE  vale IN (
                SELECT a.vale
                FROM   wms_skus_x_documento a
                WHERE  a.documento = &&DOCUMENTO&&
                AND    a.vale IS NOT NULL
                AND    a.usuario_anulo IS NULL )
            ");

            QueryMap.Add("CobrarValePorPagos", @"
                UPDATE doc_vales
                SET    estado = 'C'
                ,      factura_cobro = &&DOCUMENTO&&
                WHERE  vale IN (
                SELECT a.vale
                FROM   wms_pago_documentos a, wms_documentos b
                WHERE  a.documento = b.documento
                AND    b.documento_padre = &&DOCUMENTO&&
                AND    a.vale IS NOT NULL)
            ");

            QueryMap.Add("EstadoVale", @"
                SELECT estado
                FROM   doc_vales
                WHERE  vale = &&VALE&&
            ");

            #endregion

            #region Devoluciones

            QueryMap.Add("BuscarFacturaDevolucion", @"
                SELECT count(1)
                FROM   wms_documentos a, wms_skus_x_documento b
                WHERE  a.documento = b.documento
                AND    (a.serie = '&&SERIE&&') 
                AND    (a.no_documento = '&&NO_DOCUMENTO&&') 
                AND    b.sku = wms_f_buscar_sku('&&SKU_ALTERNO&&')
            ");

            #endregion

            #region Consultas

            QueryMap.Add("DsPDV.TDA_V_HISTORIAL_FACTURAS_SOCIO", @"
                SELECT   *
                FROM     tda_v_historial_facturas_socio
                WHERE    socio = &&SOCIO&&
                ORDER BY fecha_emision DESC
            ");

            #endregion

            #region Notas de Credito

            QueryMap.Add("NotasCredito", @"
                SELECT n.documento DOCUMENTO
                FROM   wms_documentos n
                WHERE  n.documento_origen = &&DOCUMENTO&&
                AND    n.tipo_documento = 'N'
            ");

            QueryMap.Add("NotasCreditoAn", @"
                SELECT n.documento DOCUMENTO
                FROM   wms_documentos n
                WHERE  n.documento = &&DOCUMENTO&&
                AND    n.tipo_documento = 'N'
            ");

            //---------------------Modificación para ND----------I.M.G.F.--
            QueryMap.Add("NotasDebito", @"
                SELECT n.documento DOCUMENTO
                FROM   wms_documentos n
                WHERE  n.documento = &&DOCUMENTO&&
                AND    n.tipo_documento = 'B'
            ");
            //---------------------Modificación para ND----------I.M.G.F.--

            QueryMap.Add("NotasCreditoxFactura", @"
                SELECT n.documento DOCUMENTO
                FROM   wms_documentos f, wms_documentos n
                WHERE  n.documento_padre = f.documento
                AND    n.tipo_documento = 'N'
                AND    f.documento = &&DOCUMENTO&&
            ");

            #endregion

            #region Detalle de Documentos

            QueryMap.Add("RedondearPedido", @"
                BEGIN WMS_P_REDONDEAR_DOCUMENTO(&&DOCUMENTO&&,FALSE); END;
            ");

            QueryMap.Add("RedondearMontoTotal", @"
                BEGIN WMS_P_REDONDEAR_TOTAL(&&DOCUMENTO&&,FALSE); END;
            ");

            QueryMap.Add("ObtenerSituacionLinea", @"
                SELECT situacion_sku 
                FROM   wms_skus_x_documento 
                WHERE  documento = &&DOCUMENTO&& 
                AND    linea = &&LINEA&&
            ");

            #endregion


            QueryMap.Add("WMS_P_ActualizarImpuestoNx1", @"
                begin WMS_P_ActualizarImpuestoNx1(&&OFERTA&&, &&DOCUMENTO&&, &&LINEA&& , &&OFERTADOS&&); end;
            ");
            QueryMap.Add("WMS_P_ActualizarDescuentoNx1", @"
                begin WMS_P_ActualizarDescuentoNx1(&&OFERTA&&, &&DOCUMENTO&&, &&LINEA&& , &&OFERTADOS&&); end;
            ");


            QueryMap.Add("OfertasDocCount", @"
                SELECT COUNT(1)
                FROM   wms_ofertas_x_documento
                WHERE  documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("OfertasVencidas", @"
                SELECT NVL(SUM(CASE WHEN SYSDATE BETWEEN b.valida_desde AND b.valida_hasta + 0.99999 THEN 0 ELSE 1 END),0) ofertas_vencidas
                FROM   wms_ofertas_x_documento a, wms_ofertas b
                WHERE  a.oferta = b.oferta 
                AND    a.documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("ExisteSkuEnDocumento", @"
                SELECT ROUND(NVL(COUNT(1),0),0)
                FROM   wms_skus_x_documento 
                WHERE  documento = &&DOCUMENTO&& 
                AND    sku = &&SKU&&
                AND    usuario_anulo IS NULL
            ");

            QueryMap.Add("PrecioSkuEnDocumento", @"
                SELECT NVL(precio_unitario,0) + NVL(impuesto,0) - NVL(descuento,0)
                FROM   wms_skus_x_documento 
                WHERE  documento = &&DOCUMENTO&& 
                AND    sku = &&SKU&&
                AND    usuario_anulo IS NULL
                AND    ROWNUM = 1
            ");

            for (int i = 1; i <= 5; i++)
            {
                QueryMap.Add("DsPDV.Clasificacion" + i.ToString(), @"
				    SELECT clasificacion, lpad(' ',(level * 5) -5) || descripcion descripcion
                    FROM   wms_clasificaciones 
                    CONNECT BY PRIOR clasificacion = padre
                    START WITH padre = NVL(to_number(cg_f_parameter_value('CSS" + i.ToString() + @"')),0)
                ");
            }

            QueryMap.Add("tda_p_procesar_pedido", @"
                BEGIN tda_p_procesar_pedido(&&DOCUMENTO&&,'&&TIPO&&'); END;
            ");

            QueryMap.Add("TieneExencionImpuestos", @"
                SELECT COUNT(A.DOCUMENTO) 
                FROM WMS_DOCUMENTOS A, WMS_PAGO_DOCUMENTOS B
                WHERE A.DOCUMENTO_PADRE IN (&&DOCUMENTO&&)
                AND A.TIPO_DOCUMENTO = 'R'
                AND A.DOCUMENTO = B.DOCUMENTO
                AND B.TIPO_PAGO = cg_f_parameter_value('EXEI')
            ");

            QueryMap.Add("UpdateImpuestos", @"
                update wms_skus_x_documento set impuesto = 0 where documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("RecibirDocumento", @"
                BEGIN
                    wms_p_documentos.recibir_documento (
                      &&p_documento&&,
                      &&p_bodega&&,
                      &&p_ajustar_inventario&&,
                      &&p_actualizar_costos&&,
                      &&p_valida_cantidad&&,
                      '&&p_usuario&&',
                      &&p_valida_permiso&&,
                      &&p_commit&&);
                END;
            ");

            QueryMap.Add("FiltroRegionGeografica", @"
                SELECT *
                FROM   tda_v_region_geografica
                WHERE  UPPER(region) LIKE UPPER('%&&FILTRO&&%')
            ");

            QueryMap.Add("DeleteTempDocSession", @"
                DELETE tmp_documentos
                WHERE  sesion = &&SESION&&
            ");

            QueryMap.Add("InsertTempDocument", @"
                INSERT INTO tmp_documentos (documento, sesion)
                VALUES (&&DOCUMENTO&&,&&SESION&&)
            ");

            QueryMap.Add("FacturasAlCredito", @"
                SELECT a.*
                FROM   wms_documentos a, tmp_documentos b
                WHERE  a.documento = b.documento 
                AND    tipo_documento = 'F'
                AND    NVL(situacion,1) <> 11
                AND    saldo <> 0
                AND    socio = &&SOCIO&&   
                AND    b.sesion = &&SESION&&                
                ORDER BY fecha_emision              
            ");

            QueryMap.Add("TotalImpuesto", @"
                SELECT ROUND(wms_f_total_documento(&&DOCUMENTO&&, 'I','&&DOCUMENTOS&&'),6)
                FROM   dual
            ");

            QueryMap.Add("DocumentoProcesado", @"
                SELECT nvl(WMS_F_DOCUMENTO_PROCESADO(&&DOCUMENTO&&),0)
                FROM   dual
            ");



            QueryMap.Add("PagoFacturasCredito", @"
                SELECT null documento, socio, socio_alterno, nombre, nit, 
                        0 total_productos, 0 total_descuento, &&MONTO&& total_sin_desc, 
                        0 devoluciones, 0 canjes, &&MONTO&& total, null descripcion
                FROM   wms_socios
                WHERE  socio = &&SOCIO&&
            ");

            //            QueryMap.Add("DsPDV.TDA_V_FACTURAS_CREDITO", @"
            //                SELECT   *
            //                FROM     tda_v_facturas_credito
            //                WHERE    socio = &&SOCIO&&
            //                ORDER BY fecha_emision
            //            ");

            //            QueryMap.Add("dsLovFacturas.TDA_V_FACTURAS_CREDITO_NC", @"
            //                SELECT   *
            //                FROM     tda_v_facturas_credito_nc
            //                WHERE    (1=1)
            //                ORDER BY fecha_emision
            //            ");




            string strCmd = "";
            strCmd = " SELECT DOCUMENTO, SERIE, NO_DOCUMENTO, FECHA_EMISION, TOTAL, USUARIO1, SALDO, SOCIO FROM  tda_v_facturas_credito_nc WHERE 1=1 ";
            strCmd += Utils.QueryParams.PredefinedTags.PosToolbarTag;
            QueryMap.Add("dsLovFacturas.TDA_V_FACTURAS_CREDITO_NC", strCmd);

            strCmd = " SELECT   * FROM  tda_v_facturas_credito WHERE 1=1 ";
            strCmd += Utils.QueryParams.PredefinedTags.AllToolbarsTag;
            QueryMap.Add("DsPDV.TDA_V_FACTURAS_CREDITO", strCmd);

            QueryMap.Add("ClasificarClientes", @"
                INSERT INTO wms_socios_x_clasificacion (clasificacion, socio) 
                SELECT TO_NUMBER(rv_low_value), &&SOCIO&&
                FROM cg_ref_codes
                WHERE rv_domain = 'CLASIFICACION CLIENTES'
            ");

            QueryMap.Add("ClasificacionesSkus", @"
                SELECT c.descripcion as clasificacion, a.descripcion descripcion
                FROM   wms_clasificaciones a ,wms_skus_x_clasificacion b,wms_clasificaciones c 
                WHERE  a.clasificacion = b.clasificacion 
                AND    b.catalogo = c.clasificacion 
                AND    b.sku = &&SKU&&                   
                AND    b.catalogo in (
                       cg_f_parameter_value('CSC1'),
                       cg_f_parameter_value('CSC2'),
                       cg_f_parameter_value('CSC3'),
                       cg_f_parameter_value('CSC4'),
                       cg_f_parameter_value('CSC5'),
                       cg_f_parameter_value('CSC6'),
                       cg_f_parameter_value('CSC7'))
            ");

            QueryMap.Add("ObtieneEmisor", @"
                SELECT rv_mpcc01
                FROM   cg_ref_codes
                WHERE  rv_domain = 'MODALIDADES EMISOR'
                AND    rv_low_value = '&&MODALIDAD&&'
            ");

            QueryMap.Add("ObtieneEmisorF", @"
                SELECT rv_mpcc03
                FROM   cg_ref_codes
                WHERE  rv_domain = 'ESCENARIOS FINANCIERAS'
                AND    rv_low_value = '&&MODALIDAD&&'
            ");

            QueryMap.Add("WMS_P_CALCULAR_RECARGOS", @"
                BEGIN wms_p_calcular_recargos(&&DOCUMENTO&&,&&MODALIDAD&&,&&PCT_ENGANCHE&&,&&ELIMINAR&&); END;
            ");

            QueryMap.Add("GuardarSeries", @"
                INSERT INTO wms_series_x_documento (documento, linea, serie)
                SELECT &&DOCUMENTO&&, a.linea, a.serie
                FROM   wms_series_x_documento a, wms_skus_x_documento b
                WHERE  a.documento = b.documento
                AND    a.linea = b.linea               
                AND    a.documento = &&PEDIDO&& 
                AND    b.usuario_anulo IS NULL
            ");

            QueryMap.Add("DescriptionSeriesLeft", @"
                SELECT descripcion 
                FROM (
                SELECT NVL(SUM(ABS(a.cantidad)) - (
                    SELECT COUNT(1) 
                    FROM   wms_series_x_documento c 
                    WHERE  a.documento = c.documento 
                    AND    a.linea = c.linea),0) series_left,
                    b.descripcion
                FROM  wms_skus_x_documento a, wms_skus b 
                WHERE a.sku = b.sku
                AND   nvl(a.situacion_sku,1) = 1
                AND   a.usuario_anulo IS NULL
                AND   b.maneja_series = 'S'
                AND   a.documento = &&DOCUMENTO&&
                GROUP BY a.documento, a.linea, a.sku, b.sku_alterno, b.descripcion                
                )
                WHERE series_left > 0
            ");

            QueryMap.Add("GetCntSeriesLeft", @"
                SELECT NVL(SUM(series_left),0)
                FROM (
                SELECT NVL(SUM(ABS(a.cantidad)) - (
                    SELECT COUNT(1) 
                    FROM   wms_series_x_documento c 
                    WHERE  a.documento = c.documento 
                    AND    a.linea = c.linea),0) series_left  
                FROM  wms_skus_x_documento a, wms_skus b 
                WHERE a.sku = b.sku
                AND   NVL(a.situacion_sku,1) = 1
                AND   a.usuario_anulo IS NULL
                AND   b.maneja_series = 'S'
                AND   a.documento = &&DOCUMENTO&&
                GROUP BY a.documento, a.linea)
            ");

            QueryMap.Add("DsPDV.WMS_SERIES_X_DOCUMENTO", @"
                SELECT *
                FROM   wms_series_x_documento
                WHERE  documento = &&DOCUMENTO&&
                AND    linea = &&LINEA&&
            ");

            QueryMap.Add("GetSerieLinea", @"
                SELECT serie
                FROM   wms_series_x_documento
                WHERE  documento = &&DOCUMENTO&&
                AND    linea = &&LINEA&&
            ");

            QueryMap.Add("GetSerieLineaEntrega", @"
                SELECT a.serie
                FROM   wms_series_x_documento a, wms_documentos b
                WHERE  a.documento = b.documento
                AND ( ( b.documento_origen = &&DOCUMENTO&& AND b.tipo_documento = 'V')
                      OR b.documento = &&DOCUMENTO&& )
                AND    nvl(b.situacion,3) in (3, 14)
                AND    a.linea = &&LINEA&&
                AND    a.serie = '&&SERIE&&'
            ");

            QueryMap.Add("SeriesConsolidado", @"
                SELECT a.*
                FROM   wms_series_x_documento a, wms_documentos b
                WHERE  a.documento = b.documento
                AND    (b.documento_origen = &&DOCUMENTO&& OR b.documento = &&DOCUMENTO&& )
                AND    a.linea = &&LINEA&&
            ");

            QueryMap.Add("EfectivoEmpresa", @"
                SELECT TRIM(TO_CHAR(tda_f_redondeo_x_5(NVL(SUM((NVL(a.precio_unitario,0) + NVL(a.impuesto,0) - NVL(a.descuento,0)) * 
                       CASE WHEN NVL(a.cantidad,0) < 0 THEN 0 ELSE NVL(a.cantidad,0) END * b.pmee),0)), '999,999,990.00' ))
                FROM   wms_skus_x_documento a, 
                        (SELECT TO_NUMBER(cg_f_parameter_value('PMEE'))/100 pmee FROM dual) B,
                        (SELECT TO_NUMBER(cg_f_parameter_value('CPEE')) cpee FROM dual) D,
                       wms_skus_x_clasificacion c
                WHERE a.documento = &&DOCUMENTO&&
                AND   a.sku = c.sku
                AND   a.usuario_anulo IS NULL
                AND   c.clasificacion IN (
                      SELECT clasificacion
                      FROM   wms_clasificaciones e
                      CONNECT BY PRIOR e.clasificacion = e.padre
                      START WITH e.clasificacion = d.cpee)
            ");

            QueryMap.Add("ActualizarKit", @"
                UPDATE wms_skus_x_documento
                SET    no_interfazar = 'X'
                ,      situacion_sku = '1'
                WHERE  documento = &&DOCUMENTO&&
                AND    linea = &&LINEA&&
            ");

            QueryMap.Add("wms_p_ponderar_precio", @"
                begin wms_p_ponderar_precio(&&DOCUMENTO&&); end;
            ");

            QueryMap.Add("VerifyLogin", @"
            ");

            QueryMap.Add("GetOfferNx1", @"
                SELECT * 
                FROM   wms_ofertas_nx1 
                WHERE  oferta = &&OFERTA&&
            ");

            QueryMap.Add("AvailableCredit", @"
                SELECT NVL(limite_credito,0) - NVL(saldo,NVL(wms_f_saldo_total(socio),0))
                FROM   wms_socios
                WHERE  socio = &&SOCIO&&
            ");

            QueryMap.Add("ActualizarDescuentoNx1", @"
                UPDATE wms_skus_x_documento
                SET    descuento = precio_unitario *  (
                        SELECT descuento
                        FROM   wms_ofertas_nx1
                        WHERE  oferta = &&OFERTA&&) / 100
                WHERE documento = &&DOCUMENTO&&
                AND linea NOT IN (
                    SELECT linea
                    FROM (
                        SELECT   linea, NVL(a.precio_unitario,0) + NVL(a.impuesto,0) - NVL(a.descuento,0)
                        FROM     wms_skus_x_documento a
                        WHERE    documento = &&DOCUMENTO&&
                        AND      a.usuario_anulo IS NULL
                        AND (    linea = &&LINEA&&
                        OR       linea_padre2 = &&LINEA&& )
                        ORDER BY 2 DESC    
                    )
                    WHERE ROWNUM <= &&OFERTADOS&& )
                AND (linea = &&LINEA&&
                OR  linea_padre2 = &&LINEA&& )
                AND usuario_anulo IS NULL   
            ");

            QueryMap.Add("ActualizarImpuestoNx1", @"
                UPDATE wms_skus_x_documento a
                SET    a.impuesto = (a.precio_unitario - a.descuento) * 
                       tda_f_porcentaje_impuesto(a.sku, (
                        SELECT d.socio 
                          FROM wms_documentos d
                         WHERE d.documento = a.documento )
                       ) / 100 
                WHERE a.documento = &&DOCUMENTO&&
                AND a.linea NOT IN (
                    SELECT linea
                    FROM (
                        SELECT linea, NVL(b.precio_unitario,0) + NVL(b.impuesto,0) - NVL(b.descuento,0)
                        FROM wms_skus_x_documento b
                        WHERE documento = &&DOCUMENTO&&
                        AND b.usuario_anulo IS NULL    
                        AND ( linea = &&LINEA&&
                        OR    linea_padre2 = &&LINEA&& )
                        ORDER BY 2 DESC    
                    )
                    WHERE ROWNUM <= &&OFERTADOS&& )
                AND (linea = &&LINEA&&
                OR  linea_padre2 = &&LINEA&& )
                AND usuario_anulo IS NULL
            ");

            QueryMap.Add("DsPDV.OfertadosNx1", @"
                SELECT a.sku, a.cantidad, 
                       b.sku_alterno, b.descripcion, 
                       NVL(a.precio_unitario,0) + NVL(a.impuesto,0) - NVL(a.descuento,0) precio
                FROM   wms_skus_x_documento a, wms_skus b
                WHERE  a.sku = b.sku
                AND    a.documento = &&DOCUMENTO&&
                AND    (a.linea = &&LINEA&&
                OR     a.linea_padre2 = &&LINEA&&)
            ");

            QueryMap.Add("CountNx1", @"
                SELECT ROUND(NVL(oferta,-1),0) oferta
                FROM (
                  SELECT ROUND(NVL(b.oferta,-1),0) oferta, b.valida_desde
                    FROM wms_ofertas_nx1 b,
                         wms_skus_x_clasificacion c,
                         wms_socios_x_clasificacion d
                   WHERE c.sku = &&SKU&&
                     AND d.clasificacion IN (
                         SELECT     e.clasificacion
                         FROM       wms_clasificaciones e
                         START WITH e.clasificacion = b.clasificacion_socios
                         CONNECT BY PRIOR e.clasificacion = e.padre)
                     AND c.clasificacion IN (
                         SELECT     e.clasificacion
                         FROM       wms_clasificaciones e
                         START WITH e.clasificacion = b.clasificacion1
                         CONNECT BY PRIOR e.clasificacion = e.padre)
                     AND d.socio = &&SOCIO&&
                     AND SYSDATE BETWEEN b.valida_desde AND b.valida_hasta
                     AND (   b.clasificacion_bodegas IS NULL
                          OR cg_f_parameter_value ('GuardarProveerdor') IN (
                             SELECT bodega
                             FROM   wms_bodegas_x_clasificacion
                             WHERE  clasificacion IN (
                                    SELECT     clasificacion
                                    FROM       wms_clasificaciones
                                    START WITH clasificacion = b.clasificacion_bodegas
                                    CONNECT BY PRIOR clasificacion = padre))
                         )
                UNION ALL
                  SELECT ROUND(NVL(b.oferta,-1),0) oferta, b.valida_desde
                    FROM wms_ofertas_nx1 b, wms_socios_x_clasificacion d
                   WHERE d.clasificacion IN (
                         SELECT     e.clasificacion
                         FROM       wms_clasificaciones e
                         START WITH e.clasificacion = b.clasificacion_socios
                         CONNECT BY PRIOR e.clasificacion = e.padre )
                     AND d.socio = &&SOCIO&&
                     AND SYSDATE BETWEEN b.valida_desde AND b.valida_hasta
                     AND b.clasificacion1 IS NULL
                     AND (   b.clasificacion_bodegas IS NULL
                          OR cg_f_parameter_value ('BREE') IN (
                             SELECT bodega
                             FROM   wms_bodegas_x_clasificacion
                             WHERE  clasificacion IN (
                                    SELECT     clasificacion
                                    FROM       wms_clasificaciones
                                    START WITH clasificacion = b.clasificacion_bodegas
                                    CONNECT BY PRIOR clasificacion = padre))
                         )
                UNION ALL
                  SELECT ROUND(NVL(b.oferta,-1),0) oferta, b.valida_desde
                    FROM wms_ofertas_nx1 b, wms_skus_x_clasificacion c
                   WHERE c.sku = &&SKU&&
                     AND c.clasificacion IN (
                         SELECT     e.clasificacion
                         FROM       wms_clasificaciones e
                         START WITH e.clasificacion = b.clasificacion1
                         CONNECT BY PRIOR e.clasificacion = e.padre)
                     AND SYSDATE BETWEEN b.valida_desde AND b.valida_hasta
                     AND b.clasificacion_socios IS NULL
                     AND (   b.clasificacion_bodegas IS NULL
                          OR cg_f_parameter_value ('BREE') IN (
                             SELECT bodega
                             FROM   wms_bodegas_x_clasificacion
                             WHERE  clasificacion IN (
                                    SELECT     clasificacion
                                    FROM       wms_clasificaciones
                                    START WITH clasificacion = b.clasificacion_bodegas
                                    CONNECT BY PRIOR clasificacion = padre))
                         )
                UNION ALL
                  SELECT ROUND(NVL(b.oferta,-1),0) oferta, b.valida_desde
                    FROM wms_ofertas_nx1 b
                   WHERE SYSDATE BETWEEN b.valida_desde AND b.valida_hasta
                     AND b.clasificacion1 IS NULL
                     AND b.clasificacion_socios IS NULL
                     AND (   b.clasificacion_bodegas IS NULL
                          OR cg_f_parameter_value ('BREE') IN (
                             SELECT bodega
                             FROM   wms_bodegas_x_clasificacion
                             WHERE  clasificacion IN (
                                    SELECT     clasificacion
                                    FROM       wms_clasificaciones
                                    START WITH clasificacion = b.clasificacion_bodegas
                                    CONNECT BY PRIOR clasificacion = padre))
                         )
                  ORDER BY 2)
                WHERE ROWNUM = 1
            ");

            QueryMap.Add("DsPDV.SKUS_EQUIVALENTES", @"
                SELECT b.sku_alterno, b.descripcion,
                       cg_f_code_meaning ('TIPO EQUIVALENCIA', a.tipo_equivalencia) tipo,
                       porcentaje_equivalencia
                FROM   wms_skus_equivalentes a, wms_skus b
                WHERE  a.equivalente = b.sku 
                AND    a.sku = &&SKU&& 
                AND    tipo_equivalencia = 'E'
                UNION ALL
                SELECT b.sku_alterno, b.descripcion,
                       cg_f_code_meaning ('TIPO EQUIVALENCIA', a.tipo_equivalencia) tipo,
                       porcentaje_equivalencia
                FROM   wms_skus_x_clasificacion a, wms_skus b
                WHERE  a.sku = b.sku
                AND    clasificacion =
                            (SELECT clasificacion
                             FROM   wms_skus_x_clasificacion
                             WHERE  catalogo = cg_f_parameter_value ('CSEC') 
                             AND    sku = &&SKU&&)
                AND tipo_equivalencia = 'E'
            ");

            QueryMap.Add("DsPDV.SKUS_COMPLEMENTARIOS", @"
                SELECT b.sku_alterno, b.descripcion,
                       cg_f_code_meaning ('TIPO EQUIVALENCIA', a.tipo_equivalencia) tipo,
                       porcentaje_equivalencia, 
                       ROUND (
                        CASE WHEN e.imp = 0 THEN 1 + (tda_f_porcentaje_impuesto(a.sku,c.socio) / 100) ELSE 1 END * 
                            wms_f_precio_unitario_mb (b.sku, c.socio, d.usuario,cg_f_parameter_value('LPP')),6) precio
                  FROM wms_skus_x_clasificacion a, wms_skus b, wms_socios c, wms_usuarios d,
                       (SELECT CG_F_PARAMETER_VALUE('IMP') imp FROM DUAL) e
                 WHERE c.socio = &&SOCIO&&
                   AND d.usuario = '&&USUARIO&&'
                   AND a.sku = b.sku
                   AND clasificacion =
                                 (SELECT clasificacion
                                    FROM wms_skus_x_clasificacion
                                   WHERE catalogo = cg_f_parameter_value ('CSEC') AND sku = &&SKU&&)
                   AND tipo_equivalencia = 'C'
                   AND a.sku <> &&SKU&&
            ");



            QueryMap.Add("DsPDV.CONTENIDO_SKUS", @"
                SELECT cantidad, descripcion_uorig, 
                       sku_alterno, descripcion, cantidad_visual, 
                       descripcion_uinv
                  FROM ret_v_contenido_skus
                 WHERE sku = &&SKU&& 
            ");

            /* QueryMap.Add("DsPDV.EXISTENCIA_TIENDAS", @"
                SELECT C.BODEGA, C.NOMBRE, ROUND(SUM(NVL(A.EXISTENCIA,0)),6) EXISTENCIA
                  FROM MDA_INVENTARIOS_GLOBALES A,
                       WMS_BODEGAS B,
                       WMS_BODEGAS C
                 WHERE A.BODEGA = B.BODEGA
                   AND B.BODEGA_PADRE = C.BODEGA
                   AND A.SKU = &&SKU&& AND A.BODEGA NOT IN (SELECT BODEGA FROM WMS_BODEGAS WHERE BODEGA_PADRE = CG_F_PARAMETER_VALUE('BREE'))
              GROUP BY C.BODEGA, C.NOMBRE
              UNION ALL
                 SELECT   b.bodega, b.nombre,
                          ROUND (SUM (NVL (cantidad_empaque, 0)), 6) existencia
                     FROM wms_inventarios a,
                          wms_bodegas b,
                          wms_ubicaciones c,
                          wms_unidades_moviles d
                    WHERE a.unidad_movil = d.unidad_movil
                      AND c.bodega = b.bodega
                      AND c.ubicacion = d.ubicacion                     
                      AND a.empaque_sku = &&SKU&& 
                 GROUP BY b.bodega, b.nombre

             ");*/

            QueryMap.Add("DsPDV.EXISTENCIA_TIENDAS", @"
                SELECT bodega, nombre, bodega_padre, existencia, ingresos, egresos, 
                       (NVL(existencia,0) + NVL(ingresos,0) - NVL(egresos,0)) disponible 
                FROM  ( SELECT a.bodega, a.nombre, a.bodega_padre, 
                               wms_f_inventario_global(a.bodega,a.bodega_padre,&&SKU&&) existencia,
                               wms_f_ingresos_pendientes(a.bodega,&&SKU&&) Ingresos,
                               wms_f_egresos_pendientes(a.bodega,&&SKU&&) Egresos
                        FROM   wms_bodegas a 
                        WHERE  a.no_visible IS NULL) ");

            QueryMap.Add("ExisteVale", @"
                SELECT COUNT(1)
                  FROM doc_vales
                 WHERE vale = &&VALE&&
            ");

            QueryMap.Add("DsVale.DOC_VALES", @"
                SELECT *
                FROM   doc_vales
                WHERE  vale = &&VALE&&
            ");

            QueryMap.Add("GetSavedOrder", @"
                UPDATE wms_documentos
                   SET grid_pos = null
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("CerrarJornada", @"
                BEGIN wms_p_jornadas.cerrar_jornada(&&JORNADA&&, '&&USUARIO&&', '&&ESTADO&&'); END;
            ");

            QueryMap.Add("CierreCaja", @"
								BEGIN wms_p_jornadas.cierre_caja(&&JORNADA&&); END;");

            #region Filtros de Fechas

            QueryMap.Add("Filters", @"
                SELECT *
                  FROM tda_v_user_filters
                 WHERE module_name = '&&MODULE_NAME&&'
                   AND (user_id = '&&USER_ID&&' 
                    OR private_filter IS NULL )
            ");

            QueryMap.Add("Todos", @"
                SELECT MIN(fecha) de, MAX(fecha) a
                  FROM cud_dias
            ");

            QueryMap.Add("Today", @"
                SELECT MIN(fecha) de, MAX(fecha) a
                  FROM cud_dias
                 WHERE TO_CHAR(fecha,'DDMMYYYY') = TO_CHAR(SYSDATE,'DDMMYYYY')
            ");

            QueryMap.Add("Yesterday", @"
                SELECT MIN(fecha) de, MAX(fecha) a
                  FROM cud_dias
                 WHERE TO_CHAR(fecha,'DDMMYYYY') = TO_CHAR(SYSDATE-1,'DDMMYYYY')
            ");


            QueryMap.Add("LastMonth", @"
                SELECT MIN(fecha) de, MAX(fecha) a
                  FROM cud_dias
                 WHERE TO_CHAR(fecha,'MMYYYY') = TO_CHAR(TRUNC(SYSDATE,'MM')-1,'MMYYYY')
            ");

            QueryMap.Add("LastWeek", @"
                SELECT MIN(fecha) de, MAX(fecha) a
                  FROM cud_dias
                 WHERE TO_CHAR(fecha,'WWYYYY') = TO_CHAR(TRUNC(SYSDATE,'WW')-1,'WWYYYY')
            ");

            QueryMap.Add("LastYear", @"
                SELECT MIN(fecha) de, MAX(fecha) a
                  FROM cud_dias
                 WHERE TO_CHAR(fecha,'YYYY') = TO_CHAR(TRUNC(SYSDATE,'YYYY')-1,'YYYY')
            ");

            QueryMap.Add("ThisMonth", @"
                SELECT MIN(fecha) de, MAX(fecha) a
                  FROM cud_dias
                 WHERE TO_CHAR(fecha,'MMYYYY') = TO_CHAR(SYSDATE,'MMYYYY')
            ");

            QueryMap.Add("ThisWeek", @"
                SELECT MIN(fecha) de, MAX(fecha) a
                  FROM cud_dias
                 WHERE TO_CHAR(fecha,'WWYYYY') = TO_CHAR(SYSDATE,'WWYYYY')
            ");

            QueryMap.Add("ThisYear", @"
                SELECT MIN(fecha) de, MAX(fecha) a
                  FROM cud_dias
                 WHERE TO_CHAR(fecha,'YYYY') = TO_CHAR(SYSDATE,'YYYY')
            ");

            #endregion

            #region Consultas de Asistencias

            QueryMap.Add("Asistencia", @"
                SELECT empleado, inicio, fin, comentario, clock_out_auto, 
                       round(NVL(fin - inicio,0) * 24,2) tiempo 
                  FROM reh_asistencias
                 WHERE empleado = &&EMPLEADO&&");


            QueryMap.Add("DsAttendance.REH_ASISTENCIAS", @"
                SELECT clock_out_auto, comentario, empleado, fin, inicio, 
                       ROUND(NVL(fin - inicio, 0) * 24, 2) AS tiempo 
                  FROM reh_asistencias 
                 WHERE (empleado = &&EMPLEADO&&) 
                   AND inicio BETWEEN TO_DATE('&&DESDE&&','DD/MM/YYYY') AND TO_DATE('&&HASTA&&','DD/MM/YYYY') + 0.99999
            ");

            QueryMap.Add("TurnoIniciado", @"
                SELECT clock_out_auto, comentario, empleado, fin, inicio 
                  FROM reh_asistencias 
                 WHERE (empleado = &&EMPLEADO&&) AND (fin IS NULL)
            ");

            #endregion

            #region Anular Facturas

            QueryMap.Add("DsGeneral.CG_REF_CODES", @"
				SELECT rv_domain, rv_low_value, rv_high_value, rv_abbreviation, 
                       rv_meaning, rv_mpnc01, rv_mpnc02, rv_mpnc03, rv_mpcc01, 
                       rv_mpcc02, rv_mpcc03, rv_mpdc01, rv_mpdc02, rv_mpdc03, 
                       rv_created_by, rv_date_created, rv_changed_by, rv_date_changed, 
                       rv_times_changed, rv_sequence, rv_description 
				  FROM cg_ref_codes
				 WHERE rv_domain = '&&RV_DOMAIN&&'");

            QueryMap.Add("DsGeneral.CG_REF_CODES1", @"
				SELECT * FROM WMS_V_TEMISORES");
            //IGF
            //Emisores permitidos para el ingreso manual de transacciones
            QueryMap.Add("DsGeneral.CG_REF_CODES2", @"
				SELECT * FROM WMS_V_EMISORESM");

            QueryMap.Add("GetExchangedCount", @"
                SELECT COUNT(1)
                  FROM wms_skus_x_documento a, doc_vales b
                 WHERE a.documento = &&DOCUMENTO&&
                   AND (a.sku = TO_NUMBER(cg_f_parameter_value('SPIV'))
                    OR a.sku = TO_NUMBER(cg_f_parameter_value('SPIC')))
                   AND a.vale = b.vale
                   AND b.estado in ('C', 'A')
            ");


            //Emanuel Carvajal
            QueryMap.Add("DetallePedidoXFactura", @"
                SELECT * 
                  FROM tda_detalle_pedido 
                 WHERE (serie = '&&SERIE&&') 
                   AND (no_documento = '&&NO_DOCUMENTO&&')
                   AND (NVL(situacion,1) <> 11)
                   AND (tipo_documento = 'F')
            ");

            //

            //Anyuleth
            QueryMap.Add("DetalleDocumentoXNotaCredito", @"
                SELECT * 
                  FROM tda_detalle_pedido 
                 WHERE (serie = '&&SERIE&&') 
                   AND (no_documento = '&&NO_DOCUMENTO&&')
                   AND (NVL(situacion,1) <> 11)
                   AND (tipo_documento = 'N')
            ");

            QueryMap.Add("DetalleDocumentoXNotaDebito", @"
                SELECT * 
                  FROM tda_detalle_pedido 
                 WHERE (serie = '&&SERIE&&') 
                   AND (no_documento = '&&NO_DOCUMENTO&&')
                   AND (NVL(situacion,1) <> 11)
                   AND (tipo_documento = 'B')
            ");

            QueryMap.Add("FE_P_GENERAR_NOTA_DEBITO", "BEGIN FE_P_GENERAR_NOTA_DEBITO('&&DOCUMENTO&&','&&USUARIO_AUTORIZA&&',&&JORNADA&&); END;");

            QueryMap.Add("FE_P_GENERAR_NOTA_CREDITO", "BEGIN WMS_P_GENERA_DEVOLUCION('&&DOCUMENTO&&','&&USUARIO_AUTORIZA&&',&&CAJA&&,&&JORNADA&&); END;");

            QueryMap.Add("FE_P_LIGUE_DOCUMENTO", "BEGIN FE_P_LIGUE_DOCUMENTO('&&pSERIE_DOC1&&','&&pNO_DOCUMENTO1&&', '&&pSERIE_DOC2&&', '&&pNO_DOCUMENTO2&&', '&&pUSUARIO&&', &&pJORNADA&&); END;");

            QueryMap.Add("FE_P_ANUL_LIGUE_DOCUMENTO", "BEGIN FE_P_ANUL_LIGUE_DOCUMENTO('&&pSERIE_DOC1&&','&&pNO_DOCUMENTO1&&', '&&pSERIE_DOC2&&', '&&pNO_DOCUMENTO2&&', '&&pUSUARIO&&', &&pJORNADA&&); END;");

            QueryMap.Add("FE_F_VALIDAR_DOCUMENTOS", "SELECT FE_F_VALIDAR_DOCUMENTOS('&&pSERIE_DOC1&&','&&pNO_DOCUMENTO1&&', '&&pSERIE_DOC2&&', '&&pNO_DOCUMENTO2&&') FROM DUAL");

            QueryMap.Add("WMS_F_OBTIENE_ND_GENERADA", "SELECT WMS_F_OBTIENE_ND_GENERADA(&&DOCUMENTO&&) FROM DUAL");

            QueryMap.Add("FE_NO_DOCUMENTO", @"SELECT NO_DOCUMENTO FROM WMS_DOCUMENTOS WHERE DOCUMENTO=&&DOCUMENTO&&");

            QueryMap.Add("FE_SERIE_DOCUMENTO", @"SELECT SERIE FROM WMS_DOCUMENTOS WHERE DOCUMENTO=&&DOCUMENTO&&");

            QueryMap.Add("FE_F_LIGUE_DOCUMENTO", @"SELECT FE_F_LIGUE_DOCUMENTO('&&pSERIE&&','&&pNO_DOCUMENTO&&') FROM DUAL");

            //

            QueryMap.Add("DetalleDocumentoXRecibo", @"
                SELECT A.DOCUMENTO, A.SOCIO, A.SOCIO_ALTERNO, A.NOMBRE, A.NIT, A.TOTAL_PRODUCTOS, A.TOTAL_DESCUENTO, A.TOTAL_SIN_DESC, A.DEVOLUCIONES, A.CANJES, A.TOTAL, 
                       A.DESCRIPCION, A.TIENDA, A.DIRECCION, A.TELEFONOS, A.EMAIL, A.HORARIO, A.DIRECCION_SOCIO, A.TELEFONO_SOCIO, A.EMAIL_SOCIO, A.CONTACTO, A.SOCIO_PEDIDO, 
                       A.VALIDEZ_COTIZACION, A.TOTAL_LETRAS, A.NOMBRES, A.APELLIDOS, A.AVALISTA, A.DIRECCIONA, A.SERIE, A.NO_DOCUMENTO, A.CAJA, A.JORNADA, A.DIA, A.MES, 
                       A.ANIO, A.IMPUESTO, A.TOTAL_SIMP
                  FROM TDA_DATOS_DOCUMENTO A, WMS_DOCUMENTOS B 
                 WHERE (A.serie = '&&SERIE&&') 
                   AND (A.no_documento = '&&NO_DOCUMENTO&&')
                   AND A.DOCUMENTO = B.DOCUMENTO
                   AND B.TIPO_DOCUMENTO = 'R'
                   AND B.ANULADA_EL IS NULL
            ");

            QueryMap.Add("FacturaG", @"
                SELECT * 
                  FROM tda_v_facturas 
                 WHERE (documento = &&DOCUMENTO&&)                   
            ");
            QueryMap.Add("Factura", @"
                SELECT * 
                  FROM tda_v_facturas 
                 WHERE (serie = '&&SERIE&&') 
                   AND (no_documento = '&&NO_DOCUMENTO&&')                   
            ");

            QueryMap.Add("FacturaSs", @"
                SELECT * 
                  FROM tda_v_facturas 
                 WHERE (no_documento = '&&NO_DOCUMENTO&&') 
                   AND serie IS NULL
            ");

            QueryMap.Add("FacturaGe", @"
                    SELECT DISTINCT a.documento, a.serie, a.no_documento,
                           b.socio_alterno, b.nombre, b.nit, a.fecha_emision, 
                           TRUNC(SYSDATE - a.fecha_emision) dias_factura,
                           total, a.subtipo_documento, c.nombre nombre_bodega
                    FROM   wms_documentos a, wms_socios b, wms_bodegas c
                    WHERE  a.socio = b.socio 
                    AND    a.tipo_documento = 'F'
                    AND    a.bodega = c.bodega
                    AND    (documento = &&DOCUMENTO&&)                   
            ");
            QueryMap.Add("Facturae", @"
                SELECT DISTINCT a.documento, a.serie, a.no_documento,
                       b.socio_alterno, b.nombre, b.nit, a.fecha_emision, 
                       TRUNC(SYSDATE - a.fecha_emision) dias_factura,
                       total, a.subtipo_documento, c.nombre nombre_bodega
                FROM   wms_documentos a, wms_socios b, wms_bodegas c
                WHERE  a.socio = b.socio
                AND    a.bodega = c.bodega 
                AND    a.tipo_documento = 'F'
                AND    (serie = '&&SERIE&&') 
                AND    (no_documento = '&&NO_DOCUMENTO&&')                   
            ");

            QueryMap.Add("FacturaSse", @"
                SELECT DISTINCT a.documento, a.serie, a.no_documento,
                       b.socio_alterno, b.nombre, b.nit, a.fecha_emision, 
                       TRUNC(SYSDATE - a.fecha_emision) dias_factura,
                       total, a.subtipo_documento, c.nombre nombre_bodega
                FROM   wms_documentos a, wms_socios b, wms_bodegas c
                WHERE  a.socio = b.socio 
                AND    a.bodega = c.bodega
                AND    a.tipo_documento = 'F'
                AND    (no_documento = '&&NO_DOCUMENTO&&') 
                AND    serie IS NULL
            ");
            QueryMap.Add("DsPDV.TDA_DETALLE_PEDIDO", @"
                SELECT * 
                  FROM tda_detalle_pedido 
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("AnularFactura", @"
            BEGIN tda_p_anular_factura(
                '&&NO_DOCUMENTO&&', 
                '&&SERIE&&',
                '&&USUARIO&&',
                &&TIPO_ANULACION&&,
                '&&ANULAR_RECIBOS&&',
                '&&NULIFICAR_ENTREGA&&',
                &&DOCUMENTO&&); END;
            ");

            QueryMap.Add("AnularFacturaconDevo", @"
            BEGIN WMS_P_GENERA_DEVOLUCION(
                &&DOCUMENTO&&, 
                '&&USUARIO&&',&&CAJA&&,&&JORNADA&&); END;
            ");

            QueryMap.Add("OBTIENE_NC_GENERADA", @"
            select WMS_F_OBTIENE_NC_GENERADA(
                &&DOCUMENTO&&) FROM DUAL  ");

            QueryMap.Add("AnularRecibo", @"
            BEGIN Tda_P_Anular_Recibos(
                '&&NO_DOCUMENTO&&', 
                '&&SERIE&&',
                '&&USUARIO&&',
                &&TIPO_ANULACION&&,
                &&DOCUMENTO&&); END;
            ");

            #endregion

            #region Operaciones

            QueryMap.Add("DeleteLine", @"
                UPDATE wms_skus_x_documento
                   SET usuario_anulo = '&&USUARIO_ANULO&&', 
                       fecha_anulacion = SYSDATE,
                       tipo_anulacion = &&TIPO_ANULACION&&, vale = null
                 WHERE (documento = &&DOCUMENTO&&) 
                   AND (linea = &&LINEA&&
                    OR  linea_padre = &&LINEA&&
                    OR  linea_padre2 = &&LINEA&&
                    OR  linea_padre3 = &&LINEA&&
                    )
                   
            ");

            QueryMap.Add("wms_p_delete_lines", @"
                begin wms_p_delete_lines('&&USUARIO_ANULO&&',&&TIPO_ANULACION&&, &&DOCUMENTO&&, &&LINEA&&); end;
            ");


            QueryMap.Add("UpdateTotal", @"
                UPDATE wms_documentos 
                   SET total = wms_f_total_documento(documento)
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("UpdateTotalConExepcionImpuestos", @"
                UPDATE wms_documentos 
                   SET total = wms_f_total_documento(documento,'TSI')
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("EsFacturaExenta", @"
                SELECT WMS_F_FACTURA_EXENTA(NVL(&&DOCUMENTO&&,0)) FROM DUAL
            ");

            QueryMap.Add("ActualizarSituacion", @"
                UPDATE wms_documentos 
                   SET situacion = &&SITUACION&&
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("ApplyOfferToDocument", @"
                BEGIN wms_p_documentos.aplicar_ofertas(&&DOCUMENTO&&); END;
            ");

            QueryMap.Add("DeleteDiscountToDocument", @"
                BEGIN wms_p_eliminar_descuentos(&&DOCUMENTO&&); END;
            ");

            QueryMap.Add("DescuentosApartados", @"
                BEGIN wms_p_aplica_descuentoapartado(&&DOCUMENTO&&, '&&tipo_descuento&&'); END;
            ");

            QueryMap.Add("DeleteOfferToDocument", @"
                BEGIN wms_p_documentos.eliminar_ofertas(&&DOCUMENTO&&); END;
            ");

            QueryMap.Add("ApplyOfferToDocLine", @"
                BEGIN wms_p_documentos.aplicar_ofertas(&&DOCUMENTO&&,true,true,&&LINEA&&); END;
            ");

            QueryMap.Add("CreateDiscount", @"
                BEGIN wms_p_descuento_documento(&&DOCUMENTO&&, &&DESCUENTO&&, '&&TIPO&&', '&&USUARIO&&', &&ACUMULA&&, &&LINEA&&); END;
            ");

            QueryMap.Add("CreateDiscountOBS", @"
                BEGIN wms_p_descuento_documento_OBS(&&DOCUMENTO&&, &&DESCUENTO&&, '&&TIPO&&', '&&USUARIO&&', &&ACUMULA&&, &&LINEA&&,'&&OBSERVACION&&'); END;
            ");


            //Almacenar el usuario que autorizó el descuento
            //EKO_P_AUTORIZA_DESC_BITAC(pDocumento number, pUsuario varchar2,  plinea NUMBER DEFAULT NULL)
            QueryMap.Add("AutorizaDiscount", @"
                BEGIN EKO_P_AUTORIZA_DESC_BITAC(&&PDOCUMENTO&&,'&&PUSUARIO&&',&&PLINEA&&); END;
            ");

            QueryMap.Add("CreateDiscountEE", @"
                BEGIN wms_p_descuento_documento(&&DOCUMENTO&&, &&DESCUENTO&&, '&&TIPO&&', '&&USUARIO&&', &&ACUMULA&&, &&LINEA&&, &&CLASIFICACION&&); END;
            ");

            #endregion

            QueryMap.Add("wms_p_documentos.procesar_facturas_in", @"
                BEGIN wms_p_documentos.procesar_facturas_in(3,&&DOCUMENTO&&,false); END;
            ");

            QueryMap.Add("MinimoPagos", @"
                SELECT rv_mpnc01
                  FROM cg_ref_codes
                 WHERE rv_domain = 'FINANCIERAS'
                   AND rv_low_value = '&&FINANCIERA&&'
            ");

            QueryMap.Add("MaximoPagos", @"
                SELECT rv_mpnc02 
                  FROM cg_ref_codes
                 WHERE rv_domain = 'FINANCIERAS'
                   AND rv_low_value = '&&FINANCIERA&&'
            ");

            QueryMap.Add("ListaArticulos", @"SELECT A.LINEA, A.CANTIDAD, B.SKU_ALTERNO, B.DESCRIPCION, A.PRECIO_UNITARIO, A.IMPUESTO, A.DESCUENTO, A.CANTIDAD * (A.PRECIO_UNITARIO - A.DESCUENTO + A.IMPUESTO) TOTAL, 
                                             A.DESCUENTO/A.PRECIO_UNITARIO*100 AS ""% DESCUENTO""
                                             FROM WMS_SKUS_X_DOCUMENTO A, WMS_SKUS B
                                             WHERE B.SKU = A.SKU
                                             AND A.DOCUMENTO = &&DOCU&&
                                             ORDER BY A.LINEA");

            QueryMap.Add("ValidarNC", @"SELECT COUNT(*) FROM WMS_DOCUMENTOS WHERE TIPO_DOCUMENTO = 'N' AND DOCUMENTO_PADRE = &&DOCU&&");

            QueryMap.Add("ObtenerDOC", @"SELECT DOCUMENTO FROM WMS_DOCUMENTOS WHERE SERIE = '&&SERIE&&' AND NO_DOCUMENTO = &&NODOC&&");

            QueryMap.Add("GuardarHijosEcom", @"INSERT INTO ECOM_DEVOL_HIJOS_PROP (DOCUMENTO, LINEA, CANTIDAD, SKU, SKU_ALTERNO, CREADO_POR, CREADO_EL)
                                               SELECT &&pDOCUMENTO&&, &&pLINEA&&, &&pCANTIDAD&&, &&pSKU&&, '&&pSKUALT&&', '&&pUSUARIO&&', SYSDATE FROM DUAL");

            QueryMap.Add("CodigoSku", @"SELECT SKU FROM WMS_SKUS WHERE SKU_ALTERNO = '&&pSKUALT&&'");

            QueryMap.Add("ValidarSKU", @"SELECT ECOM_SKU_HIJOPRO('&&pSKU&&') FROM DUAL");

            QueryMap.Add("ListaSkuHijos", @"SELECT A.SKU_ALTERNO CODIGO, NVL(A.CUSTOM7, A.DESCRIPCION) DESCRIPCION, B.DESCRIPCION TALLA, C.DESCRIPCION COLOR 
                                            FROM WMS_SKUS A INNER JOIN  EC_V_TALLAS B ON B.CODIGO = A.ID_TALLA INNER JOIN EC_V_COLORES C ON C.CODIGO = A.ID_COLOR
                                            WHERE A.REFERENCIA = '&&pSKU&&' AND A.HIJOSSAP IS NULL");


            #region Busquedas

            QueryMap.Add("BusquedaClientesFEAsociaciones", @"
                SELECT socio, socio_alterno, nombre, nombre_comercial, nit, telefonos, email
                  FROM tda_v_clientes a, 
                       (SELECT cg_f_parameter_value('NRBU') nrbu
                          FROM dual ) b
                 WHERE (UPPER(socio_alterno) like '&&BUSQUEDA&&'
                    OR UPPER(nombre) like '&&BUSQUEDA&&'
                    OR UPPER(nombre_comercial) like '&&BUSQUEDA&&'
                    OR UPPER(nit) like '&&BUSQUEDA&&'
                    OR UPPER(replace(NIT, '-', '')) like replace('&&BUSQUEDA&&', '-', '')
                    OR UPPER(telefonos) like '&&BUSQUEDA&&'
                    OR UPPER(email) like '&&BUSQUEDA&&' )
                   AND ROWNUM <= TO_NUMBER(b.nrbu)
            ");

            QueryMap.Add("BusquedaClientes", @"
                SELECT socio, socio_alterno, nombre, nombre_comercial, nit, telefonos, email
                  FROM tda_v_clientes a, 
                       (SELECT cg_f_parameter_value('NRBU') nrbu
                          FROM dual ) b
                 WHERE (UPPER(socio_alterno) like '&&BUSQUEDA&&'
                    OR UPPER(nombre) like '&&BUSQUEDA&&'
                    OR UPPER(nombre_comercial) like '&&BUSQUEDA&&'
                    OR UPPER(nit) like '&&BUSQUEDA&&'
                    OR UPPER(telefonos) like '&&BUSQUEDA&&'
                    OR UPPER(email) like '&&BUSQUEDA&&' )
                   AND ROWNUM <= TO_NUMBER(b.nrbu)
            ");

            QueryMap.Add("BusquedaProductos", @"
                SELECT sku_alterno, codigo_barras, descripcion, existencias
                  FROM tda_v_productos a, 
                       (SELECT TO_NUMBER(cg_f_parameter_value('NRBU')) nrbu
                          FROM dual ) b
                 WHERE (UPPER(sku_alterno) like UPPER('&&BUSQUEDA&&')
                    OR UPPER(codigo_barras) like UPPER('&&BUSQUEDA&&')
                    OR UPPER(descripcion) like UPPER('&&BUSQUEDA&&') )
                   AND ROWNUM <= b.nrbu
            ");

            QueryMap.Add("BusquedaFacturas", @"
                SELECT documento, serie, no_documento, socio_alterno, nombre, nit, fecha_emision, dias_factura
                  FROM tda_v_facturas a, 
                       (SELECT cg_f_parameter_value('HBMM') HBMM
                          FROM dual) b
                 WHERE (DECODE(b.hbmm,'X',UPPER(serie),serie) LIKE '&&BUSQUEDA&&'
                    OR no_documento LIKE '&&BUSQUEDA&&'
                    OR socio_alterno LIKE '&&BUSQUEDA&&'
                    OR nombre LIKE '&&BUSQUEDA&&'
                    OR nit LIKE '&&BUSQUEDA&&'
                    OR TO_CHAR(fecha_emision,'DD/MM/YYYY') LIKE '&&BUSQUEDA&&')
            ");

            #endregion

            #region Recibos de Pago

            QueryMap.Add("DsPDV.DOC_ABONO_DOCUMENTOS", @"
                SELECT * 
                  FROM doc_abono_documentos
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("DsPDV.WMS_PAGO_DOCUMENTOS", @"
                SELECT  * 
                  FROM wms_pago_documentos
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("SiguienteLineaPago", @"
                SELECT nvl(max(linea),0)+1 
                  FROM wms_pago_documentos
                 WHERE documento = &&DOCUMENTO&&
            ");

            #endregion

            #region Clientes

            QueryMap.Add("FillBySocio", @"
                SELECT socio, socio_alterno, nit, nombre, nombre_comercial, nombre_envio, 
                       region1, direccion1, region2, direccion2, telefonos, telefonos2, 
                       email, cliente, credito, NVL(limite_credito,0) limite_credito, forma_pago, plazo_pago, 
                       dias_gracia, excento_impuesto, descuento_pronto_pago, cobrar_intereses, 
                       tasa_interes_mensual, moneda, password, contacto, aceptar_cheque, 
                       empleado, usuario, foto, fax, telefono_envio, fecha_inicio, fecha_fin, 
                       fecha_nacimiento, observaciones, retencion, fecha_aniversario, 
                       comision1, comision2, descuento, tipo_comision, sexo, telefono_oficina, 
                       celular, ocupacion, conyugue, hijos, direccion_oficina, estado_civil, 
                       custom0, custom1, custom2, custom3, custom4, custom5, custom6, custom7, 
                       custom8, custom9, tipo_membresia, ranking_ventas, ranking_visitas, ranking_promedio, 
                       facturas_vencidas, monto_facturas_vencidas, cheques_rechazados, monto_cheques_rechazados, 
                       pedir_autorizacion, tarjeta, rfc, tipo_factura, vencimiento_tarjeta, 
                       referido_de, pct_sobregiro, activo, excento_impuesto1, excento_impuesto2, 
                       excento_impuesto3, empresa, wms_f_ancestros_clasificacion(region1) desc_region1, 
                       wms_f_ancestros_clasificacion(region2) desc_region2, tarjeta1, tarjeta2, 
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS1'),socio) clas1, 
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS2'),socio) clas2,
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS3'),socio) clas3, 
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS4'),socio) clas4,
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS5'),socio) clas5, 
                       creado_por, modificado_por, banco, codigo_postal, impuesto, vendedor_asignado, 
                       tipo_proveedor, formato_nota_credito, estado, ciudad, block, calle, WMS_F_DISPONIBLE_SOCIO(SOCIO) disponible
                       ,puntos
                  FROM wms_socios
                 WHERE socio = &&SOCIO&&
            ");

            QueryMap.Add("CustomerByCode", @"
                SELECT socio, socio_alterno, nit, nombre, nombre_comercial, nombre_envio, 
                       region1, direccion1, region2, direccion2, telefonos, telefonos2, 
                       email, cliente, credito, limite_credito, forma_pago, plazo_pago, 
                       dias_gracia, excento_impuesto, descuento_pronto_pago, cobrar_intereses, 
                       tasa_interes_mensual, moneda, password, contacto, aceptar_cheque, 
                       empleado, usuario, foto, fax, telefono_envio, fecha_inicio, fecha_fin, 
                       fecha_nacimiento, observaciones, retencion, fecha_aniversario, 
                       comision1, comision2, descuento, tipo_comision, sexo, telefono_oficina, 
                       celular, ocupacion, conyugue, hijos, direccion_oficina, estado_civil, 
                       custom0, custom1, custom2, custom3, custom4, custom5, custom6, custom7, 
                       custom8, custom9, tipo_membresia, ranking_ventas, ranking_visitas, ranking_promedio, 
                       facturas_vencidas, monto_facturas_vencidas, cheques_rechazados, monto_cheques_rechazados, 
                       pedir_autorizacion, tarjeta, rfc, tipo_factura, vencimiento_tarjeta, 
                       referido_de, pct_sobregiro, activo, excento_impuesto1, excento_impuesto2, 
                       excento_impuesto3, empresa, wms_f_ancestros_clasificacion(region1) desc_region1, 
                       wms_f_ancestros_clasificacion(region2) desc_region2, tarjeta1, tarjeta2, 
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS1'),socio) clas1, 
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS2'),socio) clas2,
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS3'),socio) clas3, 
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS4'),socio) clas4,
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS5'),socio) clas5, 
                       creado_por, modificado_por, banco, codigo_postal, impuesto, vendedor_asignado, 
                       tipo_proveedor, formato_nota_credito
                  FROM wms_socios
                 WHERE socio_alterno = '&&SOCIO_ALTERNO&&'
            ");

            QueryMap.Add("CustomerByNIT", @"
                SELECT socio, socio_alterno, nit, nombre, nombre_comercial, nombre_envio, 
                       region1, direccion1, region2, direccion2, telefonos, telefonos2, 
                       email, cliente, credito, NVL(limite_credito,0) limite_credito, forma_pago, plazo_pago, 
                       dias_gracia, excento_impuesto, descuento_pronto_pago, cobrar_intereses, 
                       tasa_interes_mensual, moneda, password, contacto, aceptar_cheque, 
                       empleado, usuario, foto, fax, telefono_envio, fecha_inicio, fecha_fin, 
                       fecha_nacimiento, observaciones, retencion, fecha_aniversario, 
                       comision1, comision2, descuento, tipo_comision, sexo, telefono_oficina, 
                       celular, ocupacion, conyugue, hijos, direccion_oficina, estado_civil, 
                       custom0, custom1, custom2, custom3, custom4, custom5, custom6, custom7, 
                       custom8, custom9, tipo_membresia, ranking_ventas, ranking_visitas, ranking_promedio, 
                       facturas_vencidas, monto_facturas_vencidas, cheques_rechazados, monto_cheques_rechazados, 
                       pedir_autorizacion, tarjeta, rfc, tipo_factura, vencimiento_tarjeta, 
                       referido_de, pct_sobregiro, activo, excento_impuesto1, excento_impuesto2, 
                       excento_impuesto3, empresa, wms_f_ancestros_clasificacion(region1) desc_region1, 
                       wms_f_ancestros_clasificacion(region2) desc_region2, tarjeta1, tarjeta2, 
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS1'),socio) clas1, 
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS2'),socio) clas2,
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS3'),socio) clas3, 
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS4'),socio) clas4,
                       wms_f_codigo_propiedad_socio(cg_f_parameter_value('CSS5'),socio) clas5, 
                       creado_por, modificado_por, banco, codigo_postal, impuesto, vendedor_asignado, 
                       tipo_proveedor, formato_nota_credito, estado, ciudad, block, calle,
                       WMS_F_DISPONIBLE_SOCIO(SOCIO) disponible,puntos
                  FROM wms_socios
                 WHERE nit = '&&NIT&&'
                   AND cliente = 'S'
            ");

            QueryMap.Add("Restriccion_edit_cf", @"
                SELECT COUNT(1) FROM CG_PARAMETERS A, WMS_SOCIOS B
                WHERE A.PARAMETER = 'NSCF'
                AND A.VALUE = B.SOCIO
                AND NVL(B.NIT,'CF') = NVL ('&&NIT&&','CF')
            ");

            QueryMap.Add("ds_r_caja.RETIROS_CAJA", @"

            SELECT * FROM RETIROS_CAJA 
            WHERE JORNADA = &&JORNADA&& AND USUARIO = '&&USUARIO&&' AND FECHA = SYSDATE;

            ");



            #endregion

            #region Impresion

            QueryMap.Add("GetCopiesInvoice", @"
                SELECT rv_mpnc02
                  FROM cg_ref_codes
                 WHERE rv_domain = 'DOCUMENTOS TIENDA'
                   AND rv_low_value = 'FA'
            ");

            QueryMap.Add("GetFormatInvoice", @"
                SELECT rv_mpcc02
                  FROM cg_ref_codes
                 WHERE rv_domain = 'DOCUMENTOS TIENDA'
                   AND rv_low_value = 'FA'
            ");

            QueryMap.Add("GetPrinterInvoice", @"
                SELECT rv_mpcc00
                  FROM cg_ref_codes
                 WHERE rv_domain = 'DOCUMENTOS TIENDA'
                   AND rv_low_value = 'FA'
            ");

            #endregion

            #region Jornadas

            QueryMap.Add("GetOpenPos", @"
                SELECT jornada 
                  FROM wms_jornadas 
                 WHERE usuario = '&&USUARIO&&'
                   AND caja = &&CAJA&&
                   AND fecha_cierre IS NULL
            ");

            //DLQG --ELIMINAR LA VALIDACION DE LA CAJA -> AND caja = &&CAJA&&
            QueryMap.Add("GetOpenPosSCaja", @"
                SELECT jornada 
                  FROM wms_jornadas 
                 WHERE usuario = '&&USUARIO&&'                 
                   AND fecha_cierre IS NULL
            ");

            QueryMap.Add("OpenPOS", @"
                INSERT INTO wms_jornadas (jornada,usuario,fecha_apertura,monto_apertura,caja)
                VALUES (wms_s_jornada.NEXTVAL,'&&USUARIO&&',SYSDATE,&&MONTO&&,&&CAJA&&)
            ");

            #endregion

            #region Tasas de Cambio

            QueryMap.Add("TasaCambio", @"
                SELECT a.tipo_unidad, a.unidad_origen, a.unidad_destino, a.factor, 
                       b.rv_meaning moneda_origen, c.rv_meaning moneda_destino 
                  FROM par_equivalencias a, cg_ref_codes b, cg_ref_codes c
                 WHERE a.tipo_unidad = 'M'
                   AND a.unidad_origen = b.rv_low_value
                   AND a.unidad_destino = c.rv_low_value
                   AND b.rv_domain = 'MONEDA'
                   AND c.rv_domain = 'MONEDA' and b.rv_mpcc01 = 'X' and c.rv_mpcc01 = 'X'
            ");

            QueryMap.Add("DsPDV.TDA_V_MONEDAS", @"
                SELECT * 
                  FROM tda_v_monedas");



            #endregion

            #region Datos del Pedido

            QueryMap.Add("DsPDV.WMS_DOCUMENTOS", @"
                SELECT *
                  FROM wms_documentos
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("DsPDV.WMS_SKUS_X_DOCUMENTO", @"
                SELECT documento, linea, sku, cantidad, ROUND(NVL(descuento, 0), 9) AS descuento, 
                       documento_asociado, usuario, no_devoluciones, estado_sku, 
                       situacion_sku, situacion_producto, precio_negociado, 
                       costo_promedio, ROUND(NVL(costo_total, 0), 9) AS costo_total, 
                       inventario_unidades, creado_por,
                       ROUND(NVL(precio_unitario, 0), 9) AS precio_unitario, 
                       ROUND(NVL(impuesto, 0), 9) AS impuesto, 
                       unidad_inventario, usuario_anulo, 
                       fecha_anulacion, tipo_anulacion, linea_padre, impreso_el, 
                       facturado, vencimientos, lotes, 
                       bodega, cantidad_pedida, vencimiento, 
                       cantidad_recibida, factura_devolucion, empresa, precio_base, 
                       linea_padre2, despachado, situacion_entrega, descripcion, documento_padre3, 
                       linea_padre3, vale, usuario2, usuario3, porcentaje1, porcentaje2,
                       porcentaje3, direccion, region, serie, modificado_por, fecha_bonificacion,
                       tipo_bonificacion, bodega2, bodega3, a_domicilio, observaciones,
                       no_interfazar, precio_unitario_ponderado, impuesto_ponderado, descuento_ponderado,
                       fecha_entrega, beneficiario, linea_padre4, documento_padre4, vencimiento_garantia, sku_garantia
                  FROM wms_skus_x_documento
                 WHERE (documento = &&DOCUMENTO&&)
            ");

            QueryMap.Add("FillDetailByOrderorInv", @"
                SELECT documento, linea, sku, cantidad, ROUND(NVL(descuento, 0), 9) AS descuento, 
                       documento_asociado, usuario, no_devoluciones, estado_sku, 
                       situacion_sku, situacion_producto, precio_negociado, 
                       costo_promedio, ROUND(NVL(costo_total, 0), 9) AS costo_total, 
                       inventario_unidades, creado_por,
                       ROUND(NVL(precio_unitario, 0), 9) AS precio_unitario, 
                       ROUND(NVL(impuesto, 0), 9) AS impuesto, 
                       unidad_inventario, usuario_anulo, 
                       fecha_anulacion, tipo_anulacion, linea_padre, impreso_el, 
                       facturado, vencimientos, lotes, 
                       bodega, cantidad_pedida, vencimiento, 
                       cantidad_recibida, factura_devolucion, empresa, precio_base, 
                       linea_padre2, despachado, situacion_entrega, descripcion, documento_padre3, 
                       linea_padre3, vale, usuario2, usuario3, porcentaje1, porcentaje2,
                       porcentaje3, direccion, region, serie, modificado_por, fecha_bonificacion,
                       tipo_bonificacion, bodega2, bodega3, a_domicilio, observaciones,
                       no_interfazar, precio_unitario_ponderado, impuesto_ponderado, descuento_ponderado,
                       fecha_entrega, beneficiario, linea_padre4, documento_padre4, vencimiento_garantia, sku_garantia
                  FROM wms_skus_x_documento 
                 WHERE (documento = &&DOCUMENTO&&) 
                    OR (documento = &&FACTURA&&) 
              ORDER BY documento
            ");

            QueryMap.Add("DsPDV.TDA_DATOS_DOCUMENTO", @"
                SELECT *
                  FROM tda_datos_documento
                 WHERE documento in (&&DOCUMENTO&&)
            ");

            QueryMap.Add("DsPDV.TDA_V_VENTAS_USUARIO", @"
                  SELECT usuario, nombre
                       , ROUND(SUM(total),6) total
                       , ROUND(AVG(total),6) ticket_promedio
                       , ROUND(SUM(facturas),6) facturas
                    FROM tda_v_ventas_usuario
                   WHERE fecha BETWEEN TO_DATE('&&DESDE&&','DD/MM/YYYY') 
                     AND TO_DATE('&&HASTA&&','DD/MM/YYYY') + 0.99999
                GROUP BY usuario, nombre
            ");

            QueryMap.Add("ValidarSituacionEntrega", @"
                SELECT a.situacion
                FROM   wms_documentos a, wms_skus_x_documento b
                WHERE  a.documento = b.documento
                AND    a.documento_origen = &&DOCUMENTO&&
                AND    a.tipo_documento = 'V'
                AND    b.linea = &&LINEA&&
                AND    a.situacion = 14
            ");

            QueryMap.Add("DsPDV.TDA_V_DATOS_FACTURA", @"
                SELECT *
                  FROM tda_v_datos_factura
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("DevueltoEnPedido", @"
                SELECT -NVL(sum(cantidad),0)  
                FROM   wms_skus_x_documento c
                WHERE  c.documento = &&PEDIDO&&
                AND    c.usuario_anulo IS NULL
                AND    c.documento_padre3 = &&DOCUMENTO&&
                AND    c.linea_padre3 = &&LINEA&&
            ");

            QueryMap.Add("DatosFacturaDevolucion", @"
                SELECT a.cantidad, a.descripcion, a.descuento, a.dias_factura, 
                       a.disponible - nvl((
                          SELECT -cantidad 
                          FROM   wms_skus_x_documento c
                          WHERE  c.documento = &&PEDIDO&&
                          AND    c.usuario_anulo IS NULL
                          AND    c.documento_padre3 = b.documento
                          AND    c.linea_padre3 = b.linea),0) disponible,
                       a.documento, a.fecha_emision, a.impuesto, 
                       a.linea, a.nit, a.nombre, a.no_documento, a.precio_base, 
                       a.precio_factura, a.precio_unitario, a.serie, a.sku, 
                       a.sku_alterno, a.socio, a.socio_alterno, a.vendedor,
                       a.situacion_sku, a.vale
                  FROM tda_v_datos_factura a, wms_skus_x_documento b
                 WHERE a.documento = b.documento
                   AND a.linea = b.linea
                   AND (a.serie = '&&SERIE&&') 
                   AND (a.no_documento = '&&NO_DOCUMENTO&&') 
                   AND (DECODE(cg_f_parameter_value('HBMM'), 'X', UPPER(a.sku_alterno), a.sku_alterno) = '&&SKU_ALTERNO&&')
            ");

            #endregion

            QueryMap.Add("CalculaPuntos", @"
                BEGIN WMS_P_CALCULA_PUNTOS(&&DOCUMENTO&&); END;");

            QueryMap.Add("GuardarPedido", @"
                UPDATE wms_documentos
                   SET grid_pos = 'X'
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("DsPDV.VENDEDORES", @"
           SELECT U.usuario, UPPER(NVL(U.nombres, ' ') || ' ' || NVL(U.apellidos, ' ')) AS nombre
                    FROM wms_usuarios U, WMS_USUARIOS_X_BODEGA UB
                   WHERE (U.vendedor = 'S')
                   AND  U.USUARIO = UB.USUARIO AND
                              UB.BODEGA = (select VALUE from cg_parameters where parameter = 'BREE')                               
                     UNION ALL
                                    SELECT U.usuario, UPPER(NVL(U.nombres, ' ') || ' ' || NVL(U.apellidos, ' ')) AS nombre
                    FROM wms_usuarios U, WMS_OTROS_VENDEDORES OV
                   WHERE (U.vendedor = 'S')
                   AND  U.USUARIO = OV.USUARIO
                                 ORDER BY 2
            ");

            QueryMap.Add("ActualizarUsuario", @"
                UPDATE WMS_SKUS_X_DOCUMENTO
                   SET USUARIO = (SELECT USUARIO1 
                                    FROM WMS_DOCUMENTOS
                                   WHERE DOCUMENTO = &&DOCUMENTO&&)
                 WHERE DOCUMENTO =  &&DOCUMENTO&&
                   AND USUARIO = '&&USUARIO&&'
            ");

            QueryMap.Add("FillByOrder", @"
                  SELECT *
                    FROM wms_documentos
                   WHERE (documento = &&DOCUMENTO&&
                      OR documento_padre = &&DOCUMENTO&&)
                     AND nvl(situacion,1) <> 11
                ORDER BY documento ASC
            ");

            QueryMap.Add("SigDetalleDocumento", @"
                SELECT NVL(MAX(linea),0)+1 
                  FROM wms_skus_x_documento
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("LinesUnderMinimumPrice", @"
                SELECT wms_f_precio_bajo_minimo(&&DOCUMENTO&&,&&DESCUENTO&&,'&&TIPO&&',&&LINEA&&)
                  FROM dual
            ");

            QueryMap.Add("SkusUnderMinimumPrice", @"
                SELECT WMS_F_SKU_BAJO_MINIMO(&&DOCUMENTO&&,&&DESCUENTO&&,'&&TIPO&&',&&LINEA&&)
                  FROM dual
            ");

            QueryMap.Add("LinesDocto", @"
                SELECT WMS_F_LINEAS_DOCUMENTO(&&DOCUMENTO&&)
                  FROM dual
            ");

            QueryMap.Add("DescuentoAutorizado", @"
                SELECT NVL(descuento_autorizado,0) descuento_autorizado
                  FROM wms_usuarios
                 WHERE usuario = '&&USUARIO&&'
            ");

            QueryMap.Add("FillByUser", @"
                SELECT usuario, nombres, apellidos, telefonos, fotografia, password,
                       codigo_alterno, descuento_autorizado, margen_compra, catalogo_default, 
                       tipo_lista_productos, dias_para_entrega, tipo_usuario, 
                       preguntas_mercadeo, cuenta_corriente, tipo_encuesta, fuerza_ventas, 
                       vendedor, investigador, encuestador, cobrador, email, clasifica_indicadores, 
                       creado_por, creado_el, modificado_por, modificado_el, modificaciones, 
                       ultima_operacion, usuario_padre, socio, ruta, caja, orden_sku, 
                       tiempo_espera, filtro_portal, bodega, pagina_inicial, menu_restaurante, 
                       menu_domicilio, menu_para_llevar, menu_tienda, ultima_sincronizacion, 
                       menu_express, porcentaje_aprobacion, clasificacion_compra, tareas_almacenaje, 
                       tareas_reabasto, tareas_seleccion, tareas_conteo 
                  FROM wms_usuarios 
                 WHERE usuario = '&&USUARIO&&'
            ");


            QueryMap.Add("ArmarArbolPedido", @"begin wms_p_skus.armar_arbol_pedido(&&SKU&&, &&CANTIDAD&&); end;");

            QueryMap.Add("ArmarArbol", @"BEGIN Wms_P_Skus.armar_arbol(&&SKU&&,1); END;");

            QueryMap.Add("DsPDV.TMP_ARBOL_SKU", @"
    			SELECT SKU, SKU_PADRE, COPIA_DE, SKU_ALTERNO, DESCRIPCION, 
                       NIVEL, ATOMICO, CANTIDAD, TOTAL, INVENTARIO, 
                       COSTO_PROMEDIO, CANTIDAD_PRODUCCIONA
	    		FROM   RET_V_ARBOL_SKU 
            ");

            QueryMap.Add("GetSkus", @"
                SELECT e.sku, e.sku_alterno, e.descripcion, e.imagen,
                       e.tipo_actualizacion_pedido, e.imp, e.descripcion_larga,
	                   e.tipo_inventario, e.es_combo, e.url,
                       ROUND (CASE WHEN e.imp = 0 THEN 1 + (e.impuesto / 100) ELSE 1 END * e.precio_unitario,6) precio_base,                       
                       ROUND (CASE WHEN e.imp = 0 THEN 1 + (e.impuesto / 100) ELSE 1 END * wms_f_equivalencia('M',WMS_F_MONEDA_BASE(),WMS_F_MONEDA_ALTERNA,(e.precio_unitario)),6) precio_base_alterna,
                       ROUND (e.precio_unitario / CASE WHEN e.imp = 0 THEN 1 ELSE 1 + (e.impuesto / 100) END,6) precio_base_simp,                       
                       ROUND (wms_f_equivalencia('M',WMS_F_MONEDA_BASE(),WMS_F_MONEDA_ALTERNA,(e.precio_unitario)) / CASE WHEN e.imp = 0 THEN 1 ELSE 1 + (e.impuesto / 100) END,6) precio_base_alt_simp,
                       ROUND (ROUND (e.precio_unitario,6) / CASE WHEN e.imp = 1 THEN (1 + (e.impuesto / 100) ) ELSE 1 END,6) precio_unitario,       
                       ROUND (ROUND (ROUND (e.precio_unitario,6) / CASE WHEN e.imp = 1 THEN (1 + (e.impuesto / 100) ) ELSE 1 END,6) * (e.impuesto / 100),6) impuesto,
                       ROUND(e.costo_promedio,7) costo_promedio,
	                   e.impuesto, e.lleva_inventario
                  FROM dual,
                       (SELECT a.sku, &&SOCIO&& socio, a.sku_alterno, a.descripcion, a.imagen,a.url,
                               a.costo_promedio, a.descripcion_larga, a.tipo_inventario, 
                               a.es_combo, a.tipo_actualizacion_pedido,
			                   tda_f_porcentaje_impuesto(a.sku,&&SOCIO&&) impuesto,
                               cg_f_parameter_value('IMP') imp,               
                               nvl(wms_f_precio_unitario_mb (a.sku, &&SOCIO&&, '&&USUARIO&&',cg_f_parameter_value('LPP'),&&DOCUMENTO&&),0) precio_unitario,
                               nvl(a.lleva_inventario,'S') lleva_inventario
                          FROM wms_skus a
                         WHERE a.sku = wms_f_buscar_sku('&&SKU_ALTERNO&&')
                           AND NVL(a.vendible,'S') = 'S') e
                ");

            QueryMap.Add("consulta_Apartados_Vencidos", @"
                SELECT count(1) VENCIDO
                FROM TDA_V_FACTURAS_CREDITO
                WHERE DOCUMENTO = &&DOCUMENTO&&
                and NVL(FECHA_VENCIMIENTO, SYSDATE)+ cg_f_parameter_value('DGAV') < sysdate 
                ");

            /* -- COMENTADO 
            QueryMap.Add("GetSkusNx1", @"
                SELECT e.sku, e.sku_alterno, e.descripcion, e.imagen,
                       e.tipo_actualizacion_pedido, e.imp, e.descripcion_larga,
                       e.tipo_inventario, e.es_combo, 
                       ROUND (CASE WHEN e.imp = 0 THEN 1 + (e.impuesto / 100) ELSE 1 END * e.precio_unitario,6) precio_base,                       
                       ROUND (CASE WHEN e.imp = 0 THEN 1 + (e.impuesto / 100) ELSE 1 END * wms_f_equivalencia('M',WMS_F_MONEDA_BASE(),WMS_F_MONEDA_ALTERNA,(e.precio_unitario)),6) precio_base_alterna,
                       ROUND (e.precio_unitario / CASE WHEN e.imp = 0 THEN 1 ELSE 1 + (e.impuesto / 100) END,6) precio_base_simp,                       
                       ROUND (wms_f_equivalencia('M',WMS_F_MONEDA_BASE(),WMS_F_MONEDA_ALTERNA,(e.precio_unitario)) / CASE WHEN e.imp = 0 THEN 1 ELSE 1 + (e.impuesto / 100) END,6) precio_base_alt_simp,
                       ROUND (ROUND (e.precio_unitario,6) / CASE WHEN e.imp = 1 THEN (1 + (e.impuesto / 100) ) ELSE 1 END,6) precio_unitario,       
                       ROUND (ROUND (ROUND (e.precio_unitario,6) / CASE WHEN e.imp = 1 THEN (1 + (e.impuesto / 100) ) ELSE 1 END,6) * (e.impuesto / 100),6) impuesto,
                       ROUND(e.costo_promedio,7) costo_promedio,
                       e.impuesto, e.lleva_inventario
                  FROM wms_ofertas_nx1 g, wms_skus_x_clasificacion f,
                       (SELECT a.sku, &&SOCIO&& socio, a.sku_alterno, a.descripcion, a.imagen,
                               a.costo_promedio, a.descripcion_larga, a.tipo_inventario, 
                               a.es_combo, a.tipo_actualizacion_pedido,
                               tda_f_porcentaje_impuesto(a.sku,&&SOCIO&&) impuesto,
                               cg_f_parameter_value('IMP') imp,               
                               nvl(wms_f_precio_unitario_mb (a.sku, &&SOCIO&&, '&&USUARIO&&'),0) precio_unitario,
                               nvl(a.lleva_inventario,'S') lleva_inventario
                          FROM wms_skus a
                         WHERE a.sku = wms_f_buscar_sku('&&SKU_ALTERNO&&')
                           AND NVL(a.vendible,'S') = 'S') e
                 WHERE g.oferta = &&OFERTA&&
                   AND f.clasificacion = g.clasificacion2
                   AND f.sku = e.sku  
            ");
            */

            QueryMap.Add("GetSkusNx1", @"
                SELECT e.sku, e.sku_alterno, e.descripcion, e.imagen,
                       e.tipo_actualizacion_pedido, e.imp, e.descripcion_larga,
	                   e.tipo_inventario, e.es_combo, 
                       ROUND (CASE WHEN e.imp = 0 THEN 1 + (e.impuesto / 100) ELSE 1 END * e.precio_unitario,6) precio_base,                       
                       ROUND (CASE WHEN e.imp = 0 THEN 1 + (e.impuesto / 100) ELSE 1 END * wms_f_equivalencia('M',WMS_F_MONEDA_BASE(),WMS_F_MONEDA_ALTERNA,(e.precio_unitario)),6) precio_base_alterna,
                       ROUND (e.precio_unitario / CASE WHEN e.imp = 0 THEN 1 ELSE 1 + (e.impuesto / 100) END,6) precio_base_simp,                       
                       ROUND (wms_f_equivalencia('M',WMS_F_MONEDA_BASE(),WMS_F_MONEDA_ALTERNA,(e.precio_unitario)) / CASE WHEN e.imp = 0 THEN 1 ELSE 1 + (e.impuesto / 100) END,6) precio_base_alt_simp,
                       ROUND (ROUND (e.precio_unitario,6) / CASE WHEN e.imp = 1 THEN (1 + (e.impuesto / 100) ) ELSE 1 END,6) precio_unitario,       
                       ROUND (ROUND (ROUND (e.precio_unitario,6) / CASE WHEN e.imp = 1 THEN (1 + (e.impuesto / 100) ) ELSE 1 END,6) * (e.impuesto / 100),6) impuesto,
                       ROUND(e.costo_promedio,7) costo_promedio,
	                   e.impuesto, e.lleva_inventario
                  FROM wms_ofertas_nx1 g, wms_skus_x_clasificacion f,
                       (SELECT a.sku, &&SOCIO&& socio, a.sku_alterno, a.descripcion, a.imagen,
                               a.costo_promedio, a.descripcion_larga, a.tipo_inventario, 
                               a.es_combo, a.tipo_actualizacion_pedido,
			                   tda_f_porcentaje_impuesto(a.sku,&&SOCIO&&) impuesto,
                               cg_f_parameter_value('IMP') imp,               
                               nvl(wms_f_precio_unitario_mb (a.sku, &&SOCIO&&, '&&USUARIO&&'),0) precio_unitario,
                               nvl(a.lleva_inventario,'S') lleva_inventario
                          FROM wms_skus a
                         WHERE a.sku = wms_f_buscar_sku('&&SKU_ALTERNO&&')
                           AND NVL(a.vendible,'S') = 'S') e
                 WHERE g.oferta = &&OFERTA&&
                   AND f.clasificacion in  (SELECT  clasificacion
                                           FROM    WMS_CLASIFICACIONES
                                           START   WITH clasificacion = g.clasificacion2
                                           CONNECT BY PRIOR  clasificacion = padre )
                   AND f.sku = e.sku  
            ");


            QueryMap.Add("GetTaxes", @"
                SELECT tda_f_porcentaje_impuesto(&&SKU&&, &&SOCIO&&)
                  FROM dual
            ");

            QueryMap.Add("GetTaxesByCode", @"
                SELECT tda_f_porcentaje_impuesto(sku, &&SOCIO&&)
                  FROM wms_skus
                 WHERE sku = wms_f_buscar_sku('&&SKU_ALTERNO&&')
            ");

            QueryMap.Add("FillInvoice", @"
                SELECT *
                  FROM tda_v_datos_factura 
                 WHERE (serie = '&&SERIE&&') 
                   AND (no_documento = '&&NO_DOCUMENTO&&') 
                   AND sku = wms_f_buscar_sku('&&SKU_ALTERNO&&')
            ");

            QueryMap.Add("DsPDV.DOC_VALES", @"
                SELECT * 
                  FROM doc_vales
            ");

            QueryMap.Add("DsGeneral.SBOEstados", @"
                SELECT RV_DOMAIN, RV_LOW_VALUE, RV_MEANING 
                FROM CG_V_ESTADOS 
                WHERE (1=1)
            ");

            QueryMap.Add("FillByVale", @"
                SELECT * 
                  FROM doc_vales
                 WHERE estado = 'E'
               CONNECT BY PRIOR vale = vale_padre
                 START WITH vale = &&VALE&&
            ");

            QueryMap.Add("FillByValeExceptOrder", @"
                SELECT * 
                  FROM doc_vales a
                 WHERE a.vale = &&VALE&&
                   AND a.estado = 'E'                                      
                   AND NOT EXISTS (
                       SELECT b.vale
                       FROM   wms_skus_x_documento b
                       WHERE  b.documento = &&DOCUMENTO&&
                       AND    b.vale = a.vale )
            ");

            QueryMap.Add("QuitarImpuesto", @"
                UPDATE wms_skus_x_documento
                   SET impuesto = null
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("ConstanciaExencion", @"
                UPDATE wms_documentos
                   SET observaciones = 'Constancia Exención de Impuesto: &&CONSTANCIA&&'
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("CalcularImpuesto", @"
                UPDATE wms_skus_x_documento
                   SET impuesto = null
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("EliminarExencion", @"
                UPDATE wms_documentos
                   SET observaciones = null
                 WHERE documento = &&DOCUMENTO&&
            ");

            QueryMap.Add("FindSku", @"
                SELECT COUNT(1)
                FROM   WMS_SKUS
                WHERE  SKU = &&SKU&&
            ");

            QueryMap.Add("ObtenerRegion", @"
                SELECT WMS_F_ANCESTROS_CLASIFICACION(&&REGION&&) 
                FROM dual
            ");

            QueryMap.Add("Generar_GarantiasE", @"       
                 BEGIN WMS_P_GENERAR_GARANTIAS_EXT (&&DOCUMENTO&&,&&PEDIDO&&,&&SKUG&&,&&SKU&&,&&LINEA&&,&&LINEAP&&,'&&FECHA_EMISION&&');END;
            ");
            QueryMap.Add("DsPDV.DATOS_LINEA", @"
                SELECT documento
                ,      linea
                ,      cantidad
                ,      situacion_sku
                ,      bodega
                ,      usuario
                ,      porcentaje1
                ,      usuario2
                ,      porcentaje2
                ,      usuario3
                ,      porcentaje3
                ,      direccion
                ,      region
                ,      observaciones
                ,      WMS_F_ANCESTROS_CLASIFICACION(region) desc_region
                ,      bodega2
                ,      bodega3
                ,      lotes
                ,      vencimientos
                ,      a_domicilio
                ,      fecha_entrega
                ,      beneficiario
                ,      sku
                ,      vencimiento
                ,      modificado_por
                  FROM wms_skus_x_documento
                 WHERE documento = &&DOCUMENTO&&
                   AND linea = &&LINEA&&
            ");

            QueryMap.Add("MaximoEfectivoEmpresa", @"
                SELECT ROUND
                          (NVL (SUM (CASE
                                        WHEN nvl(a.descuento,0) > 0
                                           THEN   (  NVL (a.cantidad, 0)
                                                   * (  NVL (a.precio_unitario, 0)
                                                      + NVL (a.impuesto, 0)
                                                      - NVL (a.descuento, 0)
                                                     )
                                                  )
                                                * b.pepo
                                        ELSE   (  NVL (a.cantidad, 0)
                                                * (  NVL (a.precio_unitario, 0)
                                                   + NVL (a.impuesto, 0)
                                                   - NVL (a.descuento, 0)
                                                  )
                                               )
                                             * b.pepn
                                     END
                                    ),
                                0
                               ),
                           6
                          ) max_efectivo_empresa
                  FROM wms_skus_x_documento a,
                       (SELECT TO_NUMBER (NVL (cg_f_parameter_value ('PEPO'), 25)) / 100 pepo,
                               TO_NUMBER (NVL (cg_f_parameter_value ('PEPN'), 50)) / 100 pepn,
                               TO_NUMBER (NVL (cg_f_parameter_value ('CPEE'), 0)) cpee
                          FROM DUAL) b,
                       wms_skus_x_clasificacion c
                 WHERE a.documento = &&DOCUMENTO&&
                   AND a.sku = c.sku
                   AND a.usuario_anulo is null
                   AND c.clasificacion IN ( SELECT clasificacion
                                              FROM wms_clasificaciones
                                  CONNECT BY PRIOR clasificacion = padre
                                        START WITH clasificacion = b.cpee)
            ");


            QueryMap.Add("TipoDocCotizacion", @"update wms_documentos set subtipo_documento = 'C' WHERE DOCUMENTO =&&DOCUMENTO&& ");

            QueryMap.Add("AnulaVale", @"delete from doc_vales where vale = &&VALE&&");

            QueryMap.Add("AplicaFact", @"INSERT INTO DOC_ABONO_DOCUMENTOS
                                       (RECIBO, TIPO_DOCUMENTO, DOCUMENTO, VALOR)
                                VALUES (&&RECIBO&&, '&&TIPO_DOCUMENTO&&', &&DOCUMENTO&&, &&VALOR&&)
                       ");

            QueryMap.Add("ActualizaNC", @"UPDATE DOC_ABONO_DOCUMENTOS SET VALOR = &&VALOR&& 
                                         WHERE RECIBO = &&RECIBO&& AND DOCUMENTO =&&DOCUMENTO&&
                       ");
            QueryMap.Add("ActualizaTotalNC", @"UPDATE WMS_DOCUMENTOS SET TOTAL = &&TOTAL&&, SITUACION = 3, MESA = 1 
                                         WHERE DOCUMENTO =&&DOCUMENTO&&
                       ");
            QueryMap.Add("ActualizaFactura", @"UPDATE WMS_DOCUMENTOS SET SALDO = SALDO - &&VALOR&&
                                         WHERE DOCUMENTO =&&DOCUMENTO&&
                       ");
            QueryMap.Add("ActualizaSituacion", @"update WMS_DOCUMENTOS
                                       set situacion = 3 where documento = &&DOCUMENTO&&
                       ");

            QueryMap.Add("ValidarLinesxTipoDocumento", @"
                select tda_f_validar_lineas_doc(&&DOCUMENTO&&,'&&OPCION&&') existe from dual 
            ");


            QueryMap.Add("ActualizaDelNC", @"UPDATE WMS_DOCUMENTOS SET SALDO = SALDO + &&VALOR&& 
                                         WHERE DOCUMENTO =&&DOCUMENTO&&
                       ");

            QueryMap.Add("EliminaDetNC", @"DELETE DOC_ABONO_DOCUMENTOS 
                                         WHERE RECIBO = &&RECIBO&& AND DOCUMENTO =&&DOCUMENTO&&
                       ");

            QueryMap.Add("GrabaNC", @"INSERT INTO WMS_DOCUMENTOS
                                     (DOCUMENTO, TIPO_DOCUMENTO, NO_DOCUMENTO, SERIE, FECHA_EMISION, JORNADA, CAJA, CREADO_POR, CREADO_EL, TOTAL, DOCUMENTO_PADRE,
                                     SOCIO, OBSERVACIONES, SITUACION, SUBTIPO_DOCUMENTO, USUARIO1)
                             VALUES('&&DOCUMENTO&&', '&&TIPO_DOCUMENTO&&', '&&NO_DOCUMENTO&&', '&&SERIE&&',sysdate, '&&JORNADA&&','&&CAJA&&', '&&CREADO_POR&&', sysdate, &&TOTAL&&, '&&DOCUMENTO_PADRE&&',
                                   '&&SOCIO&&', '&&OBSERVACIONES&&',  '&&SITUACION&&', '&&SUBTIPO_DOCUMENTO&&', '&&USUARIO&&')
                                       
                       ");
            QueryMap.Add("ActualizaMotivo", @"UPDATE WMS_DOCUMENTOS SET SUBTIPO_DOCUMENTO = &&MOTIVO&& 
                                         WHERE DOCUMENTO =&&DOCUMENTO&&
                       ");
            QueryMap.Add("AnulaDocNC", @"UPDATE WMS_DOCUMENTOS SET SITUACION = 11 
                                         WHERE DOCUMENTO =&&DOCUMENTO&&
                       ");
            QueryMap.Add("GetSku", @"select sku from wms_skus where sku_alterno = '&&SKU_ALTERNO&&'");

            QueryMap.Add("GetIVA", @"SELECT F_IMPUESTO_SKU(&&pSKU&&) FROM DUAL");

            QueryMap.Add("ValidarExistenciaFacturar", @"
            select WMS_F_VALIDA_CANTIDAD_EGRE_DET(&&DOCUMENTO&&) from dual
           ");

            QueryMap.Add("EsFacturaCredito", @"
                Select tda_f_factura_credito(&&DOCUMENTO&&) from dual
           ");

            // GUSTAVO MIRANDA, SE UTILIZA PARA VALIDAR SI HABILITAMOS LOS BOTONES DE DEVO ACREDITAR O DINERO EN LAS DEVOLUCIONES 
            QueryMap.Add("HabilitarCredito", @"
                Select tda_f_habilitar_credito(&&DOCUMENTO&&) from dual
           ");

            QueryMap.Add("GanarRifa", @"
                Select wms_f_gana_rifa(&&DOCUMENTO&&) from dual
           ");

            QueryMap.Add("AsignaRifa", @"
                BEGIN WMS_P_ASIGNA_RIFA(&&DOCUMENTO&&, 'A'); end;
           ");

            QueryMap.Add("DesAsignaRifa", @"
                BEGIN WMS_P_ASIGNA_RIFA(&&DOCUMENTO&&, 'D'); end;
           ");

            QueryMap.Add("CrearValeRifa", @"
                BEGIN wms_p_crear_valerifa(&&DOCUMENTO&&, &&NUMVALE&&); end;
           ");

            QueryMap.Add("NextVale", @"
                Select doc_s_vale.nextval from dual
           ");

            #region  /****************************BITACORAS***********************************/

            //Parámetros:Documento number, pCaja number, pUsuario varchar2
            //CREA LA BITACORA QUE INDICA QUE UN USUARIO CANCELA EL VALE QUE GANO EN LA RIFA, DESASIGNA LA RIFA
            QueryMap.Add("WMS_P_RIFA_BITAC_CANC", @"
                BEGIN
                     EKO_P_RIFA_BITAC_CANC(&&DOCUMENTO&&,&&pCaja&&,'&&pUsuario&&');
                END;                
            ");

            //EKO_P_REIMPRESION_BITAC
            //Parámetros:Documento number, pUsuario varchar2
            //CREA LA BITACORA QUE INDICA QUE UN USUARIO REIMPRIMIO UN DOCUMENTO DESDE LA PANTALLA REIMPRESION
            QueryMap.Add("WMS_P_REIMPRESION_BITAC", @"
                BEGIN
                     EKO_P_REIMPRESION_BITAC(&&Documento&&,'&&pUsuario&&');
                END;                
            ");

            #endregion

            QueryMap.Add("SocioNoExcento", @"
            SELECT Count(1) FROM WMS_SOCIOS WHERE SOCIO = &&SOCIO&& and Impuesto > 0
             ");

            QueryMap.Add("MarcaFactura", @"
               Update wms_documentos set SOCIO_ES_EXCENTO = 'S' Where documento = &&DOCUMENTO&&
             ");


            QueryMap.Add("ACTUALIZAOBSERVACIONES", @"
               Update wms_documentos set OBSERVACIONES = '&&OBSERVACIONES&&' Where documento = &&DOCUMENTO&&
             ");


            QueryMap.Add("GetComments", @"
               Select OBSERVACIONES from wms_documentos Where documento = &&DOCUMENTO&&
             ");


            QueryMap.Add("dsTraduccion.SFA_V_TRADUCCION", @"select id,idioma,frase,traduccion from sfa_v_traduccion where idioma = '&&IDIOMA&&' order by frase");

            QueryMap.Add("Diccionario", @"select id,idioma,frase,traduccion from sfa_v_traduccion where idioma = '&&IDIOMA&&' order by frase");

            //            QueryMap.Add("SetNoPlanilla", @"
            //            
            //                UPDATE WMS_RETIROS SET NO_PLANILLA = &&VALUE&& WHERE IDRETIRO = &&IDRETIRO&&
            //            
            //            ");
            QueryMap.Add("SetNoPlanilla", @"BEGIN EKO_P_AGREGAR_NOPLANILLA(&&IDRETIRO&&, '&&VALUE&&'); END;");

            // Actualiza el contador
            QueryMap.Add("EKO_P_CONTADOR_BLOQUEO", "BEGIN EKO_P_CONTADOR_BLOQUEO(&&JORNADA&&); END;");

            // Verifica si se debe bloquear las funciones de cobro en el POS
            QueryMap.Add("EKO_F_BLOQUEAR_POS", "SELECT EKO_F_BLOQUEAR_POS(&&JORNADA&&) FROM DUAL");

            QueryMap.Add("Aplicar_precio_costo", @"
                BEGIN
                    wms_p_costo_promedio(&&DOCUMENTO&&);
                END;                
            ");

            QueryMap.Add("RegModUser", @"
                
                 UPDATE wms_documentos SET modificado_por = '&&USUARIO&&' WHERE documento = &&DOCUMENTO&&

            ");

            QueryMap.Add("Valida_permisos_marcas", @"
                 
                SELECT COUNT(1) AS VALIDAR FROM WMS_USUARIOS A, CG_USER_ROLES B, CG_MODULE_ROLES C
                WHERE B.USER_ID = A.USUARIO AND
                B.ROLE = C.ROLE AND
                C.MODULE = 'EDITAR_ASISTENCIA' AND
                A.USUARIO = '&&Param1&&' AND A.PASSWORD = '&&Param2&&'

           ");

            QueryMap.Add("TIPO_MARCAS", @"
                select RV_LOW_VALUE from cg_ref_codes where upper(rv_meaning) = upper('&&Param&&')
           ");

            QueryMap.Add("VALIDA_MARCA_ENT_GEN", @"
             SELECT GET_CONS_MARCA_ENTRADA('&&Param1&&','&&Param2&&','&&Param3&&')FROM DUAL
           ");

            QueryMap.Add("VALIDA_MARCA_JEFE_ENTRADAS", @"
            SELECT COUNT(1) 
            FROM RH_MARCAS
            WHERE (SELECT USUARIO FROM WMS_USUARIOS WHERE EMAIL = '&&Param1&&')=RH_MARCAS.USUARIO AND
            TRUNC(NVL(ENTRADA, ENTRADA_JEFE)) = TRUNC(to_date('&&Param2&&', 'dd/mm/yyyy hh:mi:ss a.m.')) AND 
            SALIDA IS NULL AND
            SALIDA_JEFE IS NULL AND
            TIPO_MARCA = '&&Param3&&' AND
            INTERFASADO_EL IS NULL
            AND ANULADO_EL IS NULL  
           "); //AND ANULADO_EL IS NULL ->DLQG

            QueryMap.Add("UPDATE_MARCA_JEFE_S", @"
                UPDATE RH_MARCAS
                SET SALIDA_JEFE = to_date('&&Param1&&', 'dd/mm/yyyy hh:mi:ss a.m.'), TIPO_SALIDA = '&&Param2&&', MARCA_JEFE = '&&Param4&&' 
                WHERE 
                USUARIO = (SELECT USUARIO FROM WMS_USUARIOS WHERE EMAIL = '&&Param3&&') AND INTERFASADO_EL IS NULL AND TIPO_MARCA = '&&Param5&&' AND CONSECUTIVO = '&&Param6&&'
           ");

            QueryMap.Add("INSERT_MARCA_JEFE_E", @"
                INSERT INTO RH_MARCAS (USUARIO, ENTRADA_JEFE, TIPO_ENTRADA, MARCA_JEFE, TIPO_MARCA)
                VALUES((SELECT USUARIO FROM WMS_USUARIOS WHERE EMAIL ='&&Param1&&'), to_date('&&Param2&&', 'dd/mm/yyyy hh:mi:ss a.m.'), '&&Param3&&', '&&Param4&&', '01')
           ");

            QueryMap.Add("INSERT_MARCA_JEFE_LUNCH", @"
                INSERT INTO RH_MARCAS (USUARIO, ENTRADA_JEFE, TIPO_ENTRADA, MARCA_JEFE, TIPO_MARCA)
                VALUES((SELECT USUARIO FROM WMS_USUARIOS WHERE EMAIL = '&&Param1&&'), to_date('&&Param2&&', 'dd/mm/yyyy hh:mi:ss a.m.'), '&&Param3&&', '&&Param4&&', '02')
           ");

            QueryMap.Add("UPDATE_MARCAS", @"
                UPDATE RH_MARCAS 
                SET ENTRADA_JEFE =to_date('&&Param1&&', 'dd/mm/yyyy hh:mi:ss a.m.'), 
                SALIDA_JEFE = to_date('&&Param2&&', 'dd/mm/yyyy hh:mi:ss a.m.'),
                MARCA_JEFE = '&&Param3&&'
                WHERE ENTRADA = to_date('&&Param4&&', 'dd/mm/yyyy hh:mi:ss a.m.') AND
                USUARIO = '&&Param6&&' AND CREADO_EL = to_date('&&Param7&&', 'dd/mm/yyyy hh:mi:ss a.m.')
            ");

            QueryMap.Add("ANULADO_EL", @"
                UPDATE RH_MARCAS SET ANULADO_EL = to_date('&&Param1&&', 'dd/mm/yyyy hh:mi:ss a.m.'), ANULADO_POR = '&&Param2&&' 
                WHERE ENTRADA = to_date('&&Param3&&', 'dd/mm/yyyy hh:mi:ss a.m.') AND
                CREADO_EL = to_date('&&Param4&&', 'dd/mm/yyyy hh:mi:ss a.m.') AND
                USUARIO = '&&Param5&&' 
            ");

            QueryMap.Add("INSERT_CARGA_TMP", @"
                INSERT INTO RH_TMP_MARCAS (VALOR)
                SELECT '&&Param1&&'
                FROM DUAL
            ");

            QueryMap.Add("PL_RH_MARCAS", @"
                BEGIN RH_P_PROCESAR_MARCAS(TRUE); END;
            ");

            QueryMap.Add("INTERFASADAS", @"
                SELECT COUNT(1) FROM EKONO_CONSOLIDADO.RH_MARCAS 
                WHERE INTERFASADO_EL IS NULL
            ");
            QueryMap.Add("SET_INTERFASADAS", @"
                BEGIN ekono_consolidado.rh_marcas_update_sync('&&Param1&&'); END;
            ");

            QueryMap.Add("GET_EMP_NAME", @"
                SELECT NOMBRES FROM WMS_USUARIOS WHERE EMAIL = '&&Param1&&'
            ");

            QueryMap.Add("GET_EMP_USER", @"
                SELECT USUARIO FROM WMS_USUARIOS WHERE EMAIL = '&&Param1&&'
            ");

            QueryMap.Add("GET_VALIDATION_F_E", @"
                SELECT COUNT(1) FROM RH_MARCAS WHERE CONSECUTIVO = '&&Param1&&' AND INTERFASADO_EL IS NULL
            ");

            QueryMap.Add("GET_BODEGA_VALUE", @"
               select VALUE from cg_parameters where parameter = 'BREE'
            ");

            QueryMap.Add("INSERT_DIA_LIBRE_PER_USER", @"
                INSERT INTO RH_MARCAS (USUARIO, ENTRADA, SALIDA, TIPO_ENTRADA, TIPO_SALIDA, MARCA_JEFE, TIPO_MARCA, ENTRADA_JEFE, SALIDA_JEFE)
                VALUES((SELECT USUARIO FROM WMS_USUARIOS WHERE EMAIL = '&&Param1&&'), to_date('&&Param2&&', 'dd/mm/yyyy hh:mi:ss a.m.'), to_date('&&Param3&&', 'dd/mm/yyyy hh:mi:ss a.m.'), '01', '01', '&&Param4&&', '03',
                to_date('&&Param5&&', 'dd/mm/yyyy hh:mi:ss a.m.'), to_date('&&Param6&&', 'dd/mm/yyyy hh:mi:ss a.m.'))
            ");

            QueryMap.Add("GET_EMPLOYEE_NAME_ON_H", @"
                SELECT NOMBRES FROM WMS_USUARIOS WHERE EMAIL = '&&Param1&&'
            ");

            QueryMap.Add("DELETE_TMP_TABLE", @"
                DELETE RH_TMP_MARCAS
            ");

            QueryMap.Add("VALIDATE_USER_REPORTS_ACCESS", @"
                SELECT COUNT(1) FROM CG_USER_ROLES A,CG_MODULE_ROLES B
                WHERE A.ROLE = B.ROLE 
                AND B.MODULE = 'REPORTES_MARCAS_C'
                AND A.USER_ID ='&&Param1&&'
            ");

            QueryMap.Add("VALIDATE_MODIFY_M", @"
                SELECT COUNT(1) FROM DUAL 
                WHERE (SELECT TRUNC(SYSDATE)-TRUNC(TO_DATE('&&Param1&&','dd/mm/yyyy hh:mi:ss a.m.')) FROM DUAL) > 0
                AND cg_f_parameter_value ('EMFA') = 'NO' 
            ");

            #region /************EKONO EXPRESS DLQG**********/
            
            //TIENDAS ORIGEN
            QueryMap.Add("ORIGENEXP", @"
                select nombre, bodega from express_v_Tiendas WHERE BODEGA = '&&pBREE&&'
           ");
            
            //TIENDAS DESTINO
            QueryMap.Add("DESTINOSEXP", @"
                select nombre, bodega, direccion from express_v_TiendasDes
           ");


            //TIENDAS DESTINO PROVINCIA
            QueryMap.Add("DESTPROVEXP", @"
                select nombre, bodega, direccion from express_v_TiendasDes WHERE BODEGA IN(
                SELECT BODEGA FROM EXPRESS_DIST_TIENDA WHERE BODEGA IS NOT NULL AND PROVINCIA = '&&pPROVINCIA&&'
                )
           ");

            //TIENDAS DESTINO CANTON
            QueryMap.Add("DESTCANTONEXP", @"
                select nombre, bodega, direccion from express_v_TiendasDes WHERE BODEGA IN(
                SELECT BODEGA FROM EXPRESS_DIST_TIENDA WHERE BODEGA IS NOT NULL AND PROVINCIA = '&&pPROVINCIA&&' AND CANTON = '&&pCANTON&&'
                )
           ");

            //TIENDAS DESTINO CANTON
            QueryMap.Add("DESTDISTEXP", @"
                select nombre, bodega, direccion from express_v_TiendasDes WHERE BODEGA IN(
                SELECT BODEGA FROM EXPRESS_DIST_TIENDA WHERE BODEGA IS NOT NULL AND PROVINCIA = '&&pPROVINCIA&&' AND CANTON = '&&pCANTON&&'  AND DISTRITO = '&&pDIST&&'
                )
           ");

            //CALCULAR MONTO Y DÍAS 
            QueryMap.Add("CALCULOSEXP", @"
                SELECT EXPRESS_F_MONTO('&&PORIGEN&&','&&PDESTINO&&','&&PPESO&&') monto, EXPRESS_F_DIA('&&PORIGEN&&','&&PDESTINO&&','&&PPESO&&') dias FROM DUAL
            ");
                       
            //CALCULAR MONTO Y DÍAS 
            QueryMap.Add("CALCULOSUMEXP", @"
                SELECT EXPRESS_F_MONTO_DUUM('&&PORIGEN&&','&&PDESTINO&&','&&PPESO&&','&&P_TIPO_DEST&&') monto, EXPRESS_F_DIA('&&PORIGEN&&','&&PDESTINO&&','&&PPESO&&') dias FROM DUAL
            ");

            //SELECCIONA EL NÚMERO DE GUÍA
            QueryMap.Add("GUIAEXP", @"
                SELECT EXPRESS_F_GUIA(&&PORDEN&&) GUIA FROM DUAL
            ");

            //GENERAR EL NÚMERO DE GUÍA 
            QueryMap.Add("GGUIAEXP", @"
                BEGIN 
                     EXPRESS_GGUIA( &&PORDEN&& , '&&pUsername&&' );
                END;                
            ");

            //ANULAR ORDEN EKONO EXPRESS AL ANULAR FACTURA
            QueryMap.Add("AFactExp", @"
                BEGIN 
                     EXPRESS_AFACT( '&&pFactura&&' , '&&pUsername&&' );
                END;                
            ");

            //DATOS CLIENTE
            QueryMap.Add("CLIENTEEXP", @"
                SELECT CEDULA, NOMBRE, APELLIDO1, APELLIDO2, TELEFONO FROM EXPRESS_V_CLIENTES WHERE CEDULA = '&&PCEDULA&&'
           ");
            
            //Almacena la cotización
            QueryMap.Add("COTIZAREXP", @"
                BEGIN                     
                     EXPRESS_P_IORDEN('&&PBODORIGEN&&'  , '&&PBODDESTINO&&'  , 
                     '&&PNOMBCLI_E&&'  , '&&PNOMBCLI_R&&'  , '&&PAPEL1CLI_E&&'  , 
                     '&&PAPEL2CLI_E&&'  , '&&PAPEL1CLI_R&&'  , '&&PAPEL2CLI_R&&'  , 
                     '&&PTELEFCLI_E&&'  , '&&PTELEFCLI_R&&'  , &&PMONTO&& , &&PPESO&& , 
                     '&&PCREADO_POR&&','&&PCEDCLI_E&&', '&&PCEDCLI_R&&');
                END;                
            ");

            //Almacena la cotización Última Milla
            QueryMap.Add("COTIZARUMEXP", @"
                BEGIN                     
                     EXPRESS_P_IORDEN_UM('&&PBODORIGEN&&'  , '&&PBODDESTINO&&'  , 
                     '&&PNOMBCLI_E&&'  , '&&PNOMBCLI_R&&'  , '&&PAPEL1CLI_E&&'  , 
                     '&&PAPEL2CLI_E&&'  , '&&PAPEL1CLI_R&&'  , '&&PAPEL2CLI_R&&'  , 
                     '&&PTELEFCLI_E&&'  , '&&PTELEFCLI_R&&'  , &&PMONTO&& , &&PPESO&& , 
                     '&&PCREADO_POR&&','&&PCEDCLI_E&&', '&&PCEDCLI_R&&', '&&PTIPO&&', '&&PDIRECCION&&');
                END;                
            ");

            //Cambio de estado de la orden
            QueryMap.Add("CESTADOEXP", @"
                BEGIN 
                     EXPRESS_CAMBIOESTADO( &&pOrden&&, '&&pEstado&&', '&&pUsername&&'                    
                     );
                END;                
            ");

            //Cambio de estado a facturado de la orden EXPRESS_P_FORDEN( pOrden NUMBER, pFactura VARCHAR2, pUsername VARCHAR2)
            QueryMap.Add("ESTADOFACTEXP", @"
                BEGIN 
                     EXPRESS_P_FORDEN( &&pOrden&&, '&&pFactura&&', '&&pUsername&&'                    
                     );
                END;                
            ");


            //Selecciona las cotizaciones 
            QueryMap.Add("COTIZEXP", @"
                SELECT 
                   E.IDORDEN, E.ORIGEN, E.DESTINO , E.CEDCLI_E CLIENTE_ENVIA,
                   E.NOMBCLI_E || ' ' || E.APEL1CLI_E || ' ' || E.APEL2CLI_E CLIENTE_ENVIA,
                   E.CEDCLI_R CLIENTE_RECIBE,
                   E.NOMBCLI_R || ' ' || E.APEL1CLI_R || ' ' || E.APEL2CLI_R CLIENTE_RECIBE,
                   E.MONTO, E.PESO
                FROM EXPRESS_V_COTIZADOSP E WHERE E.CREADO_POR = '&&pUsuario&&'
           ");

            //Selecciona las ordenes facturadas
            QueryMap.Add("FACTEXP", @"
                SELECT 
                   E.IDORDEN, E.ORIGEN, E.DESTINO , E.CEDCLI_E CLIENTE_ENVIA,
                   E.NOMBCLI_E || ' ' || E.APEL1CLI_E || ' ' || E.APEL2CLI_E CLIENTE_ENVIA,
                   E.CEDCLI_R CLIENTE_RECIBE,
                   E.NOMBCLI_R || ' ' || E.APEL1CLI_R || ' ' || E.APEL2CLI_R CLIENTE_RECIBE,
                   E.MONTO, E.FACTURA, E.PESO
                FROM EXPRESS_V_FACTURADOSP E WHERE E.CREADO_POR = '&&pUsuario&&'
           ");

            //Selecciona las ordenes Entregadas en la tienda Y entregadas a clientes
            QueryMap.Add("ENTREGTIENDAEXP", @"
                SELECT 
                   E.IDORDEN,E.GUIA, E.ORIGEN, E.DESTINO , E.CEDCLI_E CLIENTE_ENVIA,
                   E.NOMBCLI_E || ' ' || E.APEL1CLI_E || ' ' || E.APEL2CLI_E CLIENTE_ENVIA,
                   E.CEDCLI_R CLIENTE_RECIBE,
                   E.NOMBCLI_R || ' ' || E.APEL1CLI_R || ' ' || E.APEL2CLI_R CLIENTE_RECIBE,
                   E.MONTO, E.PESO, E.ESTADO
                FROM express_v_EIyEC E WHERE E.BODDESTINO = '&&pDestino&&' 
           ");

            //Selecciona las ordenes Entregadas en la tienda Y eNTREGADAS AL CLIENTE CON FILTRO
            QueryMap.Add("ENTREGTIENDAEXPF", @"
                SELECT 
                   E.IDORDEN,E.GUIA, E.ORIGEN, E.DESTINO , E.CEDCLI_E CLIENTE_ENVIA,
                   E.NOMBCLI_E || ' ' || E.APEL1CLI_E || ' ' || E.APEL2CLI_E CLIENTE_ENVIA,
                   E.CEDCLI_R CLIENTE_RECIBE,
                   E.NOMBCLI_R || ' ' || E.APEL1CLI_R || ' ' || E.APEL2CLI_R CLIENTE_RECIBE,
                   E.MONTO, E.PESO, E.ESTADO
                FROM express_v_EIyEC E WHERE E.BODDESTINO = '&&pDestino&&' AND &&FILTRO&&
           ");

            //Selecciona las ordenes CON GUÍA GENERADAS
            QueryMap.Add("GUIASEXP", @"
                SELECT 
                   E.IDORDEN,E.GUIA, E.ORIGEN, E.DESTINO , E.CEDCLI_E CLIENTE_ENVIA,
                   E.NOMBCLI_E || ' ' || E.APEL1CLI_E || ' ' || E.APEL2CLI_E CLIENTE_ENVIA,
                   E.CEDCLI_R CLIENTE_RECIBE,
                   E.NOMBCLI_R || ' ' || E.APEL1CLI_R || ' ' || E.APEL2CLI_R CLIENTE_RECIBE,
                   E.MONTO, E.PESO
                FROM express_v_GUIAS E WHERE E.CREADO_POR = '&&pUsuario&&'
           ");

            //Valida si fue facturado 
            QueryMap.Add("VALIDAFACEXP", @"
                SELECT EXPRESS_F_VALFAC('&&PSERIE&&','&&PNODOC&&','&&PMONTO&&') FROM DUAL
            ");

            //Valida si fue facturado 
            QueryMap.Add("IMPGUIAEXP", @"
                SELECT IDORDEN, ORIGEN, DESTINO, ENVIA, RECIBE, CEDULA , GUIA, TIPO, DIRECCION, IDTIPO
                FROM EXPRESS_V_GUIA WHERE IDORDEN = &&PORDEN&&
            ");

            #endregion

            #region /************RECARGA CELULAR DLQG**********/
            //Operadores de Telefonía Celular
            QueryMap.Add("OPER_TEL", @"
                select RV_MEANING,RV_MPCC01,RV_HIGH_VALUE from CG_REF_CODES where RV_DOMAIN = 'TELEF_OPERADORES' order By RV_HIGH_VALUE
           ");

            //Proveedores de Cada Operador de Telefonía Celular
            QueryMap.Add("PROV_OPER_TEL", @"
                select RV_MEANING,RV_MPCC01,RV_HIGH_VALUE,RV_DOMAIN from CG_REF_CODES where RV_DOMAIN = 'PROV_ICE' 
                union
                select RV_MEANING,RV_MPCC01,RV_HIGH_VALUE,RV_DOMAIN from CG_REF_CODES where RV_DOMAIN = 'PROV_FULL'  
                union
                select RV_MEANING,RV_MPCC01,RV_HIGH_VALUE,RV_DOMAIN from CG_REF_CODES where RV_DOMAIN = 'PROV_TUYO'  
                union
                select RV_MEANING,RV_MPCC01,RV_HIGH_VALUE,RV_DOMAIN from CG_REF_CODES where RV_DOMAIN = 'PROV_CLARO' 
                union 
                select RV_MEANING,RV_MPCC01,RV_HIGH_VALUE,RV_DOMAIN from CG_REF_CODES where RV_DOMAIN = 'PROV_MOVISTAR'                
                order by RV_DOMAIN,RV_HIGH_VALUE
            ");

            //Secuencia de documentos
            QueryMap.Add("SEC_DOCUMENTO", @"
                Select wms_s_documento.nextval from dual
           ");

            //Secuencia de documentos
            QueryMap.Add("SEC_ALO", @"
                Select wms_s_ALO.nextval from dual
           ");

            //Secuencias para Transacciones
            QueryMap.Add("SEC_PN", @"
                Select wms_s_NumSec.nextval as NumSec , wms_s_RefExt.nextval as RefExt from dual
           ");

            //Provincia , canton y distrito , CODPREPAGO ,IDTERMINAL, USR PN, PWD DE PN, CODTIENDA PN,CODTERCERO PN, CODPREQ QCARGA
            //varRangoQ, varMinMov, VarMaxMov, varMinICE, varMaxICE, varMinFM, varMaxFM;
            QueryMap.Add("C_PCD", @"
               SELECT cg_f_parameter_value ('PROV') as Provincia,CG_F_PARAMETER_VALUE('CANO') as Canton,CG_F_PARAMETER_VALUE('DIST') as Distrito,CG_F_PARAMETER_VALUE('CPRE') as CODPREPAGO ,CG_F_PARAMETER_VALUE('TIID') as IDTERMINAL,CG_F_PARAMETER_VALUE('USPN') as USR,CG_F_PARAMETER_VALUE('CVPN') as PWD,CG_F_PARAMETER_VALUE('CTPN') as CODTIENDA,CG_F_PARAMETER_VALUE('CIPN') as CODTERCERO,cg_f_parameter_value ('CPRQ') as CODPREQ 
                ,cg_f_parameter_value ('RANC') as RangoClaro ,cg_f_parameter_value ('MIMS') as MinMoviStar ,cg_f_parameter_value ('MAMS') as MaxMoviStar ,cg_f_parameter_value ('MIIC') as MinICE ,cg_f_parameter_value ('MAIC') as MaxICE ,cg_f_parameter_value ('MIFM') as MinFMovil ,cg_f_parameter_value ('MAFM') as MaxFMovil,WMS_F_USR_CARACT_ESP ('&&pUsuario&&') as usuario
               , cg_f_parameter_value ('UALO') as UsuarioAlo, cg_f_parameter_value ('EALO') as EntidadAlo, cg_f_parameter_value ('CALO') as ClaveAlo, cg_f_parameter_value ('CPRP') as CODPREP, cg_f_parameter_value ('BNSB') as BNServBanco, cg_f_parameter_value ('BNSA') as BNServAgencia, cg_f_parameter_value ('BNSC') as BNServCanal
               ,(select substr(usuario_bdd,7) from wms_bodegas where bodega in ( select value from cg_parameters where parameter = 'BREE')) Sucursal, cg_f_parameter_value ('USRH') as USRHMAS, cg_f_parameter_value ('PWDH') as PWDHMAS, cg_f_parameter_value ('MDOH') as MDOHMAS
               ,EKO_F_TIPCAMBIO_DOLAR_VENTA, EKO_F_TIPCAMBIO_DOLAR_COMPRA, cg_f_parameter_value ('UPDS') as UsuarioPrides, cg_f_parameter_value ('SPDS') as SemillaPrides, cg_f_parameter_value ('CPDS') as TiendaPrides, cg_f_parameter_value ('TNDH') as TNDHMAS
                FROM DUAL               
            ");

            //Parámetros:pDocumento number, pCaja number, pUsuario varchar2, pTotal number, pJornada number, pComision number, pIdTRans varchar2, pTelefono varchar2 
            //Crea el recibo prepago
            QueryMap.Add("WMS_P_RECARGA_CELULAR", @"
                BEGIN
                     EKO_P_CREAR_RECIBOPREPAGO(&&pDocumento&&,&&pCaja&&,'&&pUsuario&&',&&pTotal&&,&&pJornada&&,&&pComision&&,'&&pIdTRans&&','&&pTelefono&&','&&pProveedor&&','&&pOperador&&');
                END;                
            ");

            //Parámetros:pDocumento number, pCaja number, pUsuario varchar2, pTotal number, pJornada number, pComision number, pIdTRans varchar2, pTelefono varchar2 
            //Crea el recibo prepago
            QueryMap.Add("WMS_P_RECARGA_CELULAR2", @"
                BEGIN
                     EKO_P_CREAR_RECIBOPREPAGO2(&&pDocumento&&,&&pCaja&&,'&&pUsuario&&',&&pTotal&&,&&pJornada&&,&&pComision&&,'&&pIdTRans&&','&&pTelefono&&','&&pProveedor&&','&&pOperador&&','&&pFecha&&');
                END;                
            ");

            //pOperadori varchar2,pProveedor varchar2, pOperador varchar2, pProducto varchar2, pRef_Externa varchar2, pTotal number, pFecha Date, pTiempoResp varchar2, pInf_Partic varchar2
            //Guarda los intentos de recarga para la conciliación estos cuando no se ha recibido respuesta (TimeOut). 
            QueryMap.Add("WMS_P_TELEF_CONCILIACION", @"
                BEGIN
                     EKO_P_TELEF_CONCILIACION('&&pOperadori&&','&&pProveedor&&','&&pOperador&&','&&pProducto&&','&&pRef_Externa&&',&&pTotal&&,'&&pFecha&&','&&pTiempoResp&&','&&pInf_Partic&&');
                END;                
            ");

            //Consulta el registro del recibo de la recarga por Documento
            QueryMap.Add("C_RECIBO", @"
                SELECT (SELECT NOMBRE FROM WMS_EMPRESAS) AS TIENDA, S.FECHA, S.NUM_SERVICIO, S.TRANS_PROVEEDOR, S.MONTO , D.NO_DOCUMENTO , D.USUARIO1 FROM WMS_DOCUMENTOS D INNER JOIN WMS_PAGUE_SERVICIOS S  ON D.DOCUMENTO = S.DOCUMENTO
                WHERE D.DOCUMENTO = &&pDocumento&&
           ");

            //Consulta el registro del recibo de la recarga por Número de Documento
            QueryMap.Add("C_RECIBO_No", @"
                SELECT (SELECT NOMBRE FROM WMS_EMPRESAS) AS TIENDA, S.FECHA, S.NUM_SERVICIO, S.TRANS_PROVEEDOR, S.MONTO , D.NO_DOCUMENTO , D.USUARIO1 FROM WMS_DOCUMENTOS D INNER JOIN WMS_PAGUE_SERVICIOS S  ON D.DOCUMENTO = S.DOCUMENTO
                WHERE D.NO_DOCUMENTO = &&pDocumento&&
           ");

            //Consulta el reporte de los recibos generados en la jornada y caja específica
            QueryMap.Add("C_REPORTE_RECIBOS", @"
                 SELECT to_char(S.FECHA,'dd/mm/yyyy hh:mi:ss a.m.') as FECHA, S.NUM_SERVICIO AS NUMERO,  S.MONTO , D.NO_DOCUMENTO AS RECIBO, S.TRANS_PROVEEDOR, D.DOCUMENTO, S.OPERADOR, S.TIPO_SERVICIO FROM WMS_DOCUMENTOS D INNER JOIN WMS_PAGUE_SERVICIOS S  ON D.DOCUMENTO = S.DOCUMENTO
                 WHERE D.DOCUMENTO IN (SELECT DOCUMENTO FROM WMS_DOCUMENTOS W where W.JORNADA = &&pJornada&& AND W.CAJA = &&pCaja&&) ORDER BY S.FECHA DESC
           ");

            //Consulta el reporte de los recibos generados en la jornada y caja específica
            QueryMap.Add("C_REPORTE_RECIBOS_ARQ", @"
                SELECT to_char(S.FECHA,'dd/mm/yyyy hh:mi:ss a.m.') as FECHA, S.NUM_SERVICIO AS NUMERO , D.NO_DOCUMENTO AS RECIBO,  S.MONTO, DECODE(S.OPERADOR,'01','ICE KOLBI','02','FULL MOVIL','03','TUYO MOVIL','04','CLARO','05','MOVISTAR') OPERADOR, DECODE(S.PROVEEDOR,'01','ALO PREPAGO','02','PUNTOS NARANJA','03','QCARGA','04','PAGOOL') PROVEEDOR FROM WMS_DOCUMENTOS D INNER JOIN WMS_PAGUE_SERVICIOS S  ON D.DOCUMENTO = S.DOCUMENTO
                 WHERE D.DOCUMENTO IN (SELECT DOCUMENTO FROM WMS_DOCUMENTOS W where W.JORNADA = &&pJornada&& AND W.CAJA = &&pCaja&&) AND tipo_servicio = '01' ORDER BY S.FECHA DESC
           ");

            //Consulta el registro de las transacciones realizadas más la de timeout
            QueryMap.Add("C_ARQ_RECARGAS", @"
                SELECT to_char(S.FECHA,'dd/mm/yyyy hh:mi:ss a.m.') as FECHA, S.NUM_SERVICIO AS NUMERO , D.NO_DOCUMENTO AS RECIBO,  S.MONTO, DECODE(S.OPERADOR,'01','ICE KOLBI','02','FULL MOVIL','03','TUYO MOVIL','04','CLARO','05','MOVISTAR') OPERADOR, DECODE(S.PROVEEDOR,'01','ALO PREPAGO','02','PUNTOS NARANJA','03','QCARGA','04','PAGOOL') PROVEEDOR FROM WMS_DOCUMENTOS D INNER JOIN WMS_PAGUE_SERVICIOS S  ON D.DOCUMENTO = S.DOCUMENTO
                 WHERE D.DOCUMENTO IN (SELECT DOCUMENTO FROM WMS_DOCUMENTOS W where W.JORNADA = &&pJornada&& AND W.CAJA = &&pCaja&&)  ORDER BY S.FECHA DESC
           ");

            //Parámetros:TIPO_SERVICIO VARCHAR2(2 BYTE),PROVEEDOR VARCHAR2(2 BYTE),MONTO NUMBER,FECHA DATE,NUM_SERVICIO VARCHAR2(20 BYTE),OPERADOR VARCHAR2(2 BYTE),USUARIO VARCHAR2(20 BYTE),ERRORES VARCHAR2(20 BYTE), ESTADO VARCHAR2(20 BYTE)
            //Parámetros:PROVEEDOR VARCHAR2(2 BYTE),MONTO NUMBER,NUM_SERVICIO VARCHAR2(20 BYTE),OPERADOR VARCHAR2(2 BYTE),USUARIO VARCHAR2(20 BYTE),ERRORES VARCHAR2(20 BYTE), ESTADO VARCHAR2(20 BYTE)
            //pUsuario varchar2, pTotal number, pTelefono varchar2, pProveedor varchar2, pOperador varchar2            
            //Almacena el intento de recarga en la bitácora
            QueryMap.Add("WMS_P_BITAC_INT", @"
                BEGIN
                     EKO_P_BITAC_INT('&&pUsuario&&',&&pTotal&&,'&&pTelefono&&','&&pProveedor&&','&&pOperador&&','&&pID_INT&&');
                END;                
            ");

            //Seleciona la secuencia como id del intento
            QueryMap.Add("C_SEC_LOG_PAG_SERV", @"
                SELECT LOG_S_PAG_SERV.nextval FROM dual
           ");

            //Actualiza el intento de recarga en la bitácora como ejecutado correctamente
            QueryMap.Add("WMS_P_BITAC_INT_C", @"
                BEGIN
                     EKO_P_BITAC_INT_C('&&pID_INT&&');
                END;                
            ");

            //Almacena el intento de recarga en la bitácora como ejecutado con error
            QueryMap.Add("WMS_P_BITAC_INT_E", @"
                BEGIN
                     EKO_P_BITAC_INT_E('&&pError&&','&&pID_INT&&');
                END;                
            ");

            /*****************************/
            #endregion

            #region /************RECARGA PRIDES DLQG**********/

            //Seleciona la secuencia como id del intento
            QueryMap.Add("SEC_Prides", @"
                SELECT SEC_Prides.nextval FROM dual
           ");

            QueryMap.Add("WMS_P_BITAC_INTP", @"
                BEGIN
                     EKO_P_BITAC_INTP('&&pUsuario&&',&&pTotal&&,'&&pTelefono&&','&&pProveedor&&','&&pOperador&&','&&pID_INT&&',&&pTRANSACTIONSEQUENT&&);
                END;                
            ");

            /*****************************/
            #endregion


            #region /************VUELTOS DOLAR DLQG ****************/

            //vueltos de facturas pagadas con Dolares
            QueryMap.Add("VUELTFACDOL", @"
                SELECT NVL(sum(nvl(vuelto ,0)),0) FROM (SELECT a.documento, e.serie||' '||e.no_documento no_documento, b.socio_alterno, b.nombre, a.jornada,
                        ROUND(c.valor/ NVL (a.tasa_cambio_ma, 1),2) total, c.tasa_cambio tipo_cambio, c.VALOR_MONEDA totalDolar ,(c.PAGADO - c.VALOR) vuelto 
                        FROM   WMS_DOCUMENTOS a, WMS_SOCIOS b, wms_pago_documentos c, doc_abono_documentos d, wms_documentos e
                        WHERE  a.tipo_documento = 'R'
                        AND   A.DOCUMENTO = C.DOCUMENTO
                        AND   C.MONEDA = WMS_F_MONEDA_ALTERNA 
                        AND  C.TIPO_PAGO = '3'
                        AND    a.socio = b.socio(+)
                        AND    a.jornada IN ( &&JORNADA&& )
                        AND    NVL (a.situacion, 1) <> 11
                        and   d.recibo = a.documento
                        and   d.documento = e.documento
                        and   nvl(e.fecha_vencimiento,e.fecha_emision) =  nvl(e.fecha_emision, sysdate))
            ");
            #endregion


            #region  /************RECARGA HABLAMAS DLQG*********/

            //Seleciona la secuencia como id del intento
            QueryMap.Add("C_SEC_LOG_HABLAMAS", @"
                SELECT LOG_S_HABLAMAS.nextval FROM dual
           ");

            //ALMACENA LA BITACORA DE INTENTOS DE RECARGAS A NICARAGUA, LO QUE SE ENVIA
            //pID number , pNUMRECNIC varchar2, pNUMCLIENTE varchar2, pMONTODOL number, pDOLDISP number, pJORNADA number,  pPAGACON number, pVUELTO number, pMONEDA number, pDCompra number, pDVenta number) IS
            QueryMap.Add("WMS_P_BITACN_INT", @"
                BEGIN
                     EKO_P_BITAC_INTNIC(&&pID&&,'&&pNUMRECNIC&&','&&pNUMCLIENTE&&',&&pMONTODOL&&,&&pDOLDISP&&,&&pJORNADA&&, &&pPAGACON&&, &&pVUELTO&&, &&pMONEDA&&, &&pDCompra&& , &&pDVenta&&);
                END;                
            ");

            //Actualiza el intento de recarga en la bitácora como ejecutado correctamente
            QueryMap.Add("WMS_P_BITACN_INT_C", @"
                BEGIN
                     EKO_P_BITACN_INT_C('&&pID&&');
                END;                
            ");

            //Actualiza el intento de recarga en la bitácora como ejecutado correctamente
            QueryMap.Add("WMS_P_BITAC_RESNIC", @"
                BEGIN
                    EKO_P_BITAC_RESNIC(&&pID&&,&&pCODSTATE&&,'&&pNUMBERTRANS&&');
                END;                
            ");

            //EKO_P_RECIBOHABLAMAS(pID number, pDocumento number, pCaja number, pUsuario varchar2, pTotal number, pJornada number, pIdTRans varchar2, pTelefono varchar2, pMoneda NUMBER, pTasa_Cambio NUMBER)
            QueryMap.Add("WMS_P_RECIBOHABLAMAS", @"
                BEGIN
                     EKO_P_RECIBOHABLAMAS(&&pID&&,&&pDocumento&&,&&pCaja&&,'&&pUsuario&&',&&pTotal&&,&&pJornada&&,'&&pIdTRans&&', '&&pTelefono&&',&&pMoneda&&,&&pTasa_Cambio&&);
                END;                
            ");

            //Almacena el intento de recarga en la bitácora como ejecutado con error
            QueryMap.Add("WMS_P_BITACN_INT_E", @"
                BEGIN
                     EKO_P_BITACN_INT_E('&&pError&&','&&pID_INT&&');
                END;                
            ");

            //Consulta el reporte de los SERVICIOS PAGADOS generados en la jornada y caja específica
            QueryMap.Add("C_REPORTE_RECNIC_ARQ", @"
                 SELECT to_char(N.FECHA,'dd/mm/yyyy hh:mi:ss a.m.') as FECHA, N.NUM_SERVICIO, N.MONTOD, N.RECIBO_NO 
                 FROM wms_v_RECARGANIC N WHERE DOCUMENTO IN ( SELECT DOCUMENTO FROM WMS_DOCUMENTOS W where W.JORNADA = &&pJornada&& AND W.CAJA = &&pCaja&& ) 
                 ORDER BY FECHA DESC
           ");


            //TIPO DE CAMBIO DE DOLAR
            QueryMap.Add("DOLARVENTA", @"
                SELECT RV_LOW_VALUE ID,B.RV_MEANING,a.factor
                   FROM par_equivalencias a, cg_ref_codes b
                   WHERE a.tipo_unidad = 'M'
                   AND a.unidad_origen = b.rv_low_value
                   AND a.unidad_destino = b.rv_low_value
                   AND b.rv_domain = 'MONEDA'
                   AND B.RV_LOW_VALUE IN (6)
           ");

            //TIPO DE CAMBIO DE VENTA
            QueryMap.Add("DOLARCOMPRA", @"
                SELECT RV_LOW_VALUE ID,B.RV_MEANING,a.factor
                   FROM par_equivalencias a, cg_ref_codes b
                   WHERE a.tipo_unidad = 'M'
                   AND a.unidad_origen = b.rv_low_value
                   AND a.unidad_destino = b.rv_low_value
                   AND b.rv_domain = 'MONEDA'
                   AND B.RV_LOW_VALUE IN (5)
           ");

            //TOTAL DOLARES REC NIC CAJA
            QueryMap.Add("DOLARCAJANIC", @"
            select wms_f_dol_hablamas(&&JORNADA&&) from dual
           ");

            //TOTAL COLONES REC NIC CAJA
            QueryMap.Add("COLONCAJANIC", @"
            select WMS_F_DIFCOL_HABLAMAS(&&JORNADA&&) from dual            
           ");

            #endregion

            #region  /************BNSERVICIOS CELULAR DLQG**********/

            //Almacena el intento Bnserv con error
            QueryMap.Add("WMS_P_BITAC_ERRORBN", @"
                BEGIN
                     EKO_P_ERROR_BNSERV('&&pEstado&&','&&pError&&',&&pComprobante&&,
                        '&&pTipo&&', &&pJornada&&, '&&pUsuario&&');
                END;                
            ");


            //Almacena el intento de reversion BNSERV ejecutado con error
            //            QueryMap.Add("WMS_P_BITAC_REVBN", @"
            //                BEGIN
            //                     EKO_P_REV_BNSERV('&&pEstado&&',&&pComp&&,'&&pError&&');
            //                END;                
            //            ");


            //Secuencia de documentos
            QueryMap.Add("DOLAR", @"
                SELECT a.factor
                  FROM par_equivalencias a, cg_ref_codes b, cg_ref_codes c
                 WHERE a.tipo_unidad = 'M'
                   AND a.unidad_origen = b.rv_low_value
                   AND a.unidad_destino = c.rv_low_value
                   AND b.rv_domain = 'MONEDA'
                   AND c.rv_domain = 'MONEDA' and b.rv_mpcc01 = 'X' and c.rv_mpcc01 = 'X'
           ");

            //Secuencia de documentos
            QueryMap.Add("SEC_BNCOMPR", @"
                Select wms_s_BNCOMPR.nextval from dual
           ");

            //Secuencia de documentos
            QueryMap.Add("DATOIMP", @"
                SELECT * FROM WMS_V_FORMATOS_IMP WHERE DOCUMENTO = '&&pDoc&&'
           ");

            //Selecciona el request por comprobante
            QueryMap.Add("REQ_X_COMPR", @"
                SELECT 
                W.NNUMCOMPROBANTE, W.NCODBANCO, W.NCODAGENCIA, 
                   W.STRTIPOCANAL, W.NCODEMPRESA, W.NCODCONVENIO, 
                   W.STRVALORSERV, W.STRPERIODO, W.NMONTOTOTAL, 
                   W.DTFECHAVTO, W.STRNUMFACTURA, W.NSELFVERIFIC, 
                   W.STRCODMONEDA, W.NNUMCUOTAS, W.ARRTPAGO_NMONTOT, 
                   W.STRRECIBO, W.NTIPOLLAVE, W.CREADO_EL, 
                   W.INSTITUCION, W.CONVENIO, W.CLIENTE, 
                   W.LLAVE
                FROM WMS_BNSERV_REQ W WHERE W.NNUMCOMPROBANTE = &&pCOMPR&&
                ");

            //almacena el BNServicios Request
            QueryMap.Add("WMS_P_IBNSERVREQ", @"
                BEGIN
                      EKO_P_IBNSERVREQ(&&pNNUMCOMPROBANTE&&,&&pNCODBANCO&&, &&pNCODAGENCIA&&, 
                        '&&pSTRTIPOCANAL&&', &&pNCODEMPRESA&& , &&pNCODCONVENIO&& , 
                        '&&pSTRVALORSERV&&' , '&&pSTRPERIODO&&' , 
                        &&pNMONTOTOTAL&&, '&&pDTFECHAVTO&&', '&&pSTRNUMFACTURA&&' , 
                        &&pNSELFVERIFIC&&, '&&pSTRCODMONEDA&&', &&pNNUMCUOTAS&&, 
                        &&pARRTPAGO_NMONTOT&& , '&&pSTRRECIBO&&', &&pNTIPOLLAVE&&, '&&pINSTITUCION&&' , 
                        '&&pCONVENIO&&','&&pCLIENTE&&','&&pLLAVE&&',
                        &&pJORNADA&&);
                END;                
            ");

            //Almacena las anulaciones de BNServicios            
            QueryMap.Add("WMS_P_REVBNSERV", @"
                BEGIN
                      EKO_P_REVBNSERV('&&pCOMPR&&','&&pREVX&&');
                END;                
            ");

            //Almacena el BNServicios Response
            QueryMap.Add("WMS_P_IBNSERVRES", @"
                BEGIN
                      EKO_P_IBNSERVRES(&&pNNUMCOMPROBANTE&&, &&pNCODBANCO&&, &&pNCODAGENCIA&&, 
                      '&&pSTRTIPOCANAL&&', '&&pSTRCODRES&&', '&&pSTRDESCRESP&&', 
                      '&&pDTFECHA&&', &&pNCANTCONCEPINF&&, &&pNCANTCONCEPPAGO&& 
                      );
                END;                
            ");

            //Almacena el BNServicios Response          
            QueryMap.Add("WMS_P_IBNSERVRA", @"
                BEGIN
                      EKO_P_IBNSERVRA(&&pNNUMCOMPROBANTE&&, &&pNCODCONCEPTO&&, '&&pSTRDESCCONCEP&&', 
                      '&&pSTRVALORCONCEP&&', '&&pTIPO&&');
                END;                
            ");

            //Crea el recibo BNServicios Response
            QueryMap.Add("WMS_P_RECIBOBNSERV", @"
                BEGIN
                     EKO_P_RECIBOBNSERV(&&pDocumento&&,&&pCaja&&,'&&pUsuario&&',&&pTotal&&,&&pJornada&&,'&&pIdTRans&&','&&pProveedor&&','&&pOperador&&');
                END;                
            ");

            //Consulta el reporte de los SERVICIOS PAGADOS generados en la jornada y caja específica
            QueryMap.Add("C_REPORTE_BNSERV_ARQ", @"
                  SELECT to_char(S.FECHA,'dd/mm/yyyy hh:mi:ss a.m.') as FECHA, D.NO_DOCUMENTO AS RECIBO,  S.MONTO,BN.NNUMCOMPROBANTE COMPROBANTE, BN.INSTITUCION, BN.CONVENIO
                  FROM
                  WMS_DOCUMENTOS D INNER JOIN WMS_PAGUE_SERVICIOS S  ON D.DOCUMENTO = S.DOCUMENTO 
                  INNER JOIN WMS_BNSERV_REQ BN  ON S.TRANS_PROVEEDOR = BN.NNUMCOMPROBANTE
                  WHERE D.DOCUMENTO IN (SELECT DOCUMENTO FROM WMS_DOCUMENTOS W where W.JORNADA = &&pJornada&& AND W.CAJA = &&pCaja&&)  AND tipo_servicio = '02' ORDER BY S.FECHA DESC
           ");

            //IGF
            //Consulta los pagos cuyo proceso no terminó, es decir, están correctos del lado del banco,
            //pero no del lado de la tienda
            QueryMap.Add("C_REPORTE_PAGOS_INCOMPLETOS", @"
            SELECT TRUNC(A.CREADO_EL) FECHA, A.NNUMCOMPROBANTE COMPROBANTE, A.NMONTOTOTAL MONTO, 
                A.INSTITUCION, A.CONVENIO
            FROM WMS_BNSERV_REQ A 
                LEFT OUTER JOIN WMS_BNSERV_REV B
                   ON TO_CHAR(A.NNUMCOMPROBANTE)  = B.NNUMCOMPROBANTE
                LEFT OUTER JOIN WMS_PAGUE_SERVICIOS C
                    ON C.TIPO_SERVICIO = '02' AND A.NNUMCOMPROBANTE = C.TRANS_PROVEEDOR
            WHERE TRUNC(A.CREADO_EL) = TO_DATE('&&pFECHA&&', 'DD/MM/YYYY') AND B.NNUMCOMPROBANTE IS NULL
                AND C.TRANS_PROVEEDOR IS NULL
            ORDER BY A.CREADO_EL DESC");

            //Consultar instituciones
            QueryMap.Add("C_INST_BNSERV", @"
                SELECT W.NEMPRESA, W.STRNOMBREEMPRESA FROM WMS_BNSERV_EMPRESAS W ORDER BY W.STRNOMBREEMPRESA
           ");

            //Consultar convenios por empresa
            QueryMap.Add("C_CONV_BNSERV", @"
                SELECT W.NCONVENIO, W.NEMPRESA, W.STRNOMBCONV, W.STRMONEDA, W.NPERIODO, W.STRTIPOPAGO, W.STRCOBROTARDIO, W.STRVALANTIG FROM WMS_BNSERV_CONVENIOS W WHERE
                W.NEMPRESA = &&pEmpresa&& AND W.STRMONEDA = 'COL' ORDER BY W.STRNOMBCONV
            ");

            //Consultar llaves por convenio
            QueryMap.Add("C_LLAVE_BNSERV", @"
                SELECT W.NEMPRESA, W.NCONVENIO, W.NTIPOLLAVE, W.STRDESCRIPCION FROM EKONO.WMS_BNSERV_LLAVES W WHERE 
                W.NEMPRESA = &&pEmpresa&& AND W.NCONVENIO = &&pConvenio&& ORDER BY W.STRDESCRIPCION
            ");

            #endregion

            #region /************MARCAS DLQG**********/
            //SELECCIONA LA RUTA DEL ARCHIVO MARCAS DLQG
            QueryMap.Add("RUT_ARCH_MARCAS", @"
                SELECT cg_f_parameter_value ('MARC') as Provincia FROM DUAL
           ");

            //ACTUALIZA LA RUTA DEL ARCHIVO MARCAS DLQG
            QueryMap.Add("UPDATE_RUT_ARCH_MARCAS", @"
                UPDATE CG_PARAMETERS
                SET    
                VALUE = '&&pRuta&&'
                WHERE PARAMETER = 'MARC'  
            ");
            #endregion

            #region /************Mis Puntos DLQG**********/
            //secuencia de tiempo
            //Seleciona la secuencia como id del intento
            QueryMap.Add("C_SEC_LOG_BIT_TIEMPO", @"
                SELECT WMS_S_BIT_TIME.nextval FROM dual
           ");

            //EKO_P_BITAC_TIEMP(pDocumento varchar2, pWs varchar2, pID_INT varchar2)
            QueryMap.Add("WMS_P_BITAC_TIEMP", @"
                BEGIN
                     EKO_P_BITAC_TIEMP('&&pDocumento&&','&&pWs&&','&&pID_INT&&');
                END;                
            ");

            //Actualiza el intento de recarga en la bitácora como ejecutado correctamente
            QueryMap.Add("WMS_P_BITAC_TIEMP_C", @"
                BEGIN
                     EKO_P_BITAC_TIEMP_C('&&pID_INT&&');
                END;                
            ");

            //Almacena los Datos de Afiliación del Cliente
            QueryMap.Add("WMS_IClienteMisPts", @"
                BEGIN                     
                     wms_IClientPts('&&pTARJETA&&','&&pCEDULA&&','&&pNOMBRE&&','&&pAPELLIDO1&&','&&pAPELLIDO2&&','&&pTELEFONO1&&','&&pTELEFONO2&&','&&pEMAIL&&',to_date('&&pFECHA_NAC&&', 'DD/MM/YYYY'),'&&pGENERO&&','&&pPROVINCIA&&','&&pCANTON&&','&&pDISTRITO&&','&&pPERTENECE_A&&','&&pCAJERO&&');
                END;                
            ");

            //Actualiza los Datos de Afiliación del Cliente
            QueryMap.Add("WMS_AClienteMisPts", @"
                BEGIN                     
                     wms_AClientPts('&&pTARJETA&&','&&pCEDULA&&','&&pNOMBRE&&','&&pAPELLIDO1&&','&&pAPELLIDO2&&','&&pTELEFONO1&&','&&pTELEFONO2&&','&&pEMAIL&&',to_date('&&pFECHA_NAC&&', 'DD/MM/YYYY'),'&&pGENERO&&','&&pPROVINCIA&&','&&pCANTON&&','&&pDISTRITO&&','&&pPERTENECE_A&&','&&pCAJERO&&');
                END;                
            ");

            //Asocia una Tarjeta un Documento
            QueryMap.Add("WMS_ADocTarMisPts", @"
                BEGIN                     
                     wms_ADocTarMisPts('&&pTARJETA&&','&&pDOCUMENTO&&');
                END;                
            ");

            //Reemplazo del Plástico
            QueryMap.Add("wms_RPlasticoMisPts", @"
                BEGIN                     
                     wms_RPlastPts('&&pTARJETA&&','&&pNEWTARJETA&&');
                END;                
            ");

            //Selecciona el detalle de la factura que se envia al proveedor de Mis Puntos SIN IVA
            QueryMap.Add("FacturaMisPuntos", @"
                SELECT b.SKU CODIGO,a.DESCRIPCION, crm_f_nodo_clasificacion(b.SKU) CLASIFICACION, wms_f_monto_x_clasif(b.SKU,b.documento) AS MONTO 
                FROM wms_skus_x_documento b, wms_skus a
                WHERE b.documento = '&&pDocumento&&' and b.SKU = a.SKU AND (b.descUENTO = 0 or b.descUENTO is null)
                GROUP BY b.SKU, a.descripcion,b.documento             
           ");
            //monto minimo x articulo -> having sum(b.cantidad * (b.precio_unitario-b.descuento)) > cg_f_parameter_value('MMPT')

            //Selecciona el detalle de la factura que se envia al proveedor de Mis Puntos SIN IVA con articulos con descuento
            QueryMap.Add("FacturaDMisPuntos", @"
                SELECT b.SKU CODIGO,a.DESCRIPCION, crm_f_nodo_clasificacion(b.SKU) CLASIFICACION,wms_f_monto_x_clasif(b.SKU,b.documento) AS MONTO 
                FROM wms_skus_x_documento b, wms_skus a
                WHERE b.documento = '&&pDocumento&&' and b.SKU = a.SKU 
                GROUP BY b.SKU, a.descripcion,b.documento              
           ");

            //Selecciona si la tarjeta acumula a pesar del descuento
            QueryMap.Add("TarjetaDPts", @"
                SELECT wms_f_CON_DESC('&&pTarj&&') 
                FROM dual
           ");
           
            //Selecciona los datos de clientes del Link
            QueryMap.Add("CliLink", @"
                SELECT w.cedula, w.nombre, w.apellido1, w.apellido2, w.telefono1,
                w.telefono2, w.email, w.fecha_nac, w.genero, w.provincia, w.canton,
                w.distrito FROM PLUS_v_clilink w WHERE w.CEDULA = '&&pCed&&'
           ");

            //Selecciona la tarjeta desde el Pedido
            QueryMap.Add("TarjetaPedido", @"
                SELECT tarjeta1 
                FROM wms_documentos 
                WHERE documento = (SELECT documento_padre FROM wms_documentos WHERE documento  = '&&pDocumento&&')                
           ");

            //Selecciona la longitud de la tarjeta
            QueryMap.Add("LongTarj", @"
                SELECT cg_f_parameter_value('LTPT')
                FROM dual                
           ");

            //Selecciona la tarjeta desde el Documento
            QueryMap.Add("TarjetaDOC", @"
                SELECT tarjeta1 
                FROM wms_documentos 
                WHERE documento = '&&pDocumento&&'                
           ");

            //AGREGA LOS PUNTOS DE DESCUENTO A LAS DEVOLUCIONES
            QueryMap.Add("PTS_DEVOLUCION", @"
                BEGIN                     
                     WMS_PTS_DEVOLUCION('&&v_ORDEN&&');
                END;             
           ");

            //Selecciona los Puntos para redimir en la devolucion
            QueryMap.Add("PTS_REDIMIR_DEVO", @"
             SELECT ROUND(sum(desc_pts), 2) desc_pts, tarj_desc_pts, DOCUMENTO_PADRE3 FROM WMS_SKUS_X_DOCUMENTO WHERE documento = '&&v_DOC&&' and cantidad < 0 group by tarj_desc_pts, DOCUMENTO_PADRE3                            
           ");

            //Selecciona los Puntos para redimir en la devolucion
            QueryMap.Add("PUNTOS_DEVOLUCION", @"
             SELECT WMS_F_PUNTOS_DEVOLUCION_CON ( '&&v_ORDEN&&' ) FROM dual
           ");

            //Selecciona los Puntos para redimir en la devolucion
            QueryMap.Add("TyF_DEVOLUCION", @"
                SELECT nvl(tarj_desc_pts,(SELECT tarjeta1 from wms_documentos where documento = d.documento_padre3 )) tarjeta, documento_padre3 FROM wms_skus_x_documento d
                    where documento =  '&&v_ORDEN&&' and documento_padre3 is not null AND usuario_anulo is null
           ");

            //Selecciona los pagos realizados con Puntos 
            QueryMap.Add("PagosPts", @"
                SELECT valor,tarjeta
                FROM wms_pago_documentos 
                WHERE documento  = (select documento from wms_documentos where tipo_documento = 'R' and documento_padre = '&&pDocumento&&') and TIPO_PAGO = '16'                           
           ");

            //Selecciona la tarjeta que se uso para Pagar o que Gano Puntos
            QueryMap.Add("TarjPtsFact", @"
                SELECT (SELECT p.tarjeta 
                FROM wms_pago_documentos  p
                WHERE p.documento  = (select documento from wms_documentos where tipo_documento = 'R' and documento_padre = '&&pDocumento&&') and p.TIPO_PAGO = '16')
                TarjPagos
                ,(SELECT TARJETA1 TarjGano
                FROM wms_documentos 
                WHERE documento  = '&&pDocumento&&') 
                TarjGano
                FROM DUAL
           ");

            //ID MAESTRO y PUNTOS QUE GANO UNA FACTURA
            QueryMap.Add("PtsyIDFac", @"
            select pts_id_maestro,puntos from wms_documentos where documento = '&&pDocumento&&'
            ");

            //Almacena los PunToS ganados con la compra
            QueryMap.Add("WMS_IPtsFACTURA", @"
                BEGIN                     
                     wms_APTSGanoDoc('&&pPTSGANA&&','&&pDOCUMENTO&&');
                END;                
            ");

            //Almacena el id maestro de la transaccion de redimir puntos
            QueryMap.Add("WMS_IIDMAESTRO", @"
                BEGIN                     
                     wms_APTSIDMAESTRO('&&pIDMAESTRO&&','&&pDOCUMENTO&&');
                END;                
            ");

            //Selecciona la Tarjeta y el Saldo del Apartado Puntos
            QueryMap.Add("SaldyTarjPts", @"
                SELECT  SALDO,nvl(TARJETA1,-1),TOTAL,NVL(PUNTOS,-1)
                FROM wms_documentos 
                WHERE documento  = '&&pDocumento&&'
           ");

            //Selecciona los pagos realizados con Puntos  EN LOS APARTADOS
            QueryMap.Add("PagosAPts", @"
                SELECT valor,tarjeta
                FROM wms_pago_documentos 
                WHERE documento  = '&&pDocumento&&' and TIPO_PAGO = '16'                           
           ");

            //
            QueryMap.Add("WMS_F_DEVTODOPTS", @"
                Select WMS_F_DEVTODOPTS(&&PEDIDO&&) from dual
           ");

            QueryMap.Add("CUMPLEPTS", @"
                SELECT WMS_F_CUMPLE('&&pTARJETA&&') FROM DUAL              
            ");


            QueryMap.Add("PROVINCIAS", @"
                select distinct provincia from wms_dist_geografica ORDER BY PROVINCIA             
            ");

            QueryMap.Add("CANTONES", @"
                select distinct canton from wms_dist_geografica where provincia = '&&pPROVINCIA&&'  ORDER BY CANTON            
            ");

            QueryMap.Add("DISTRITOS", @"
                select distinct distrito from wms_dist_geografica where provincia = '&&pPROVINCIA&&' and canton = '&&pCANTON&&' ORDER BY DISTRITO
            ");

            //PROVINCIA POR DEFECTO
            QueryMap.Add("PROVDEFECTO", @"
                select cg_f_parameter_value('PDPT') FROM DUAL
            ");

            //convierte el pago con puntos como un descuento
            QueryMap.Add("DescuentoPTS", @"
                BEGIN wms_p_descuento_Puntos(&&p_documento&&,&&p_linea&&); END;
            ");

            //Almacena lOS ERRORES DEL WS
            QueryMap.Add("WMS_P_BITAC_E_AFIL", @"
                BEGIN                     
                     WMS_BITAC_E_AFIL('&&pError&&','&&pWServ&&');
                END;                
            ");

            //consulta los parametros : url del WS,código de sucursal , código de la empresa y si los Art con descuento
            QueryMap.Add("C_PPTS", @"
                SELECT cg_f_parameter_value ('URLP') as URLPTS,CG_F_PARAMETER_VALUE('CEP') as COD_EMPRESA,CG_F_PARAMETER_VALUE('CSP') as COD_SUCURSAL, CG_F_PARAMETER_VALUE('ACDP') as ART_C_DESC
                FROM DUAL  
            ");

            //consulta los parametros: monto minimo para compra con puntos
            QueryMap.Add("MinPts", @"
                SELECT cg_f_parameter_value('MMPT')
                FROM DUAL  
            ");

            //Selecciona el factor de puntos
            QueryMap.Add("C_Factor", @"
                 SELECT cg_f_parameter_value ('FACP') FROM dual
           ");

            //Seleciona el factor de puntos almacenado en wms_skus_x_documento
            QueryMap.Add("C_FactorAlm", @"
                 SELECT DISTINCT NVL(PORCENTAJE2, 0) FROM WMS_SKUS_X_DOCUMENTO WHERE DOCUMENTO = &&DEVOLUCION&&
           ");

            //Selecciona los datos del cliente pts por cedula desde la Base de Datos
            QueryMap.Add("ClixCedPts", @"
                select cedula, TARJETA , nombre, apellido1, apellido2 from wms_CLIENTES_PTS WHERE CEDULA = '&&pCed&&'
           ");

            //Selecciona los datos del cliente pts por tarjeta desde la Base de Datos
            QueryMap.Add("ClixTarjPts", @"
                select cedula, TARJETA , nombre, apellido1, apellido2 from wms_CLIENTES_PTS WHERE tarjeta = '&&pTarj&&'
           ");

            //Selecciona los datos del cliente pts por CEDULA desde la Base de Datos
            QueryMap.Add("ASOxCedPts", @"
               SELECT  W.CEDULA, W.SOCIO CODIGO, (select RV_MEANING from CG_REF_CODES where RV_DOMAIN = 'ASOCIACIONES' AND rv_mpcc01 = W.SOCIO) ASOCIACION FROM WMS_ASOCIACIONES_PTS W WHERE W.CEDULA = '&&pCed&&'
           ");

            //Selecciona los datos del cliente pts por CEDULA desde la Base de Datos
            QueryMap.Add("ASOxTarjPts", @"
                 SELECT  W.CEDULA, W.SOCIO CODIGO, (select RV_MEANING from CG_REF_CODES where RV_DOMAIN = 'ASOCIACIONES' AND rv_mpcc01 = W.SOCIO) ASOCIACION FROM WMS_ASOCIACIONES_PTS W WHERE W.CEDULA = (SELECT CEDULA FROM WMS_CLIENTES_PTS WHERE TARJETA = '&&pTarj&&')
           ");

            //Selecciona el tipo de cliente x tarjeta
            QueryMap.Add("PTS_F_TIPOXTARJ", @"
                select PTS_F_TIPOXTARJ('&&pTARJETA&&') from dual               
           ");

            //Almacena los PunToS ganados con la compra
            QueryMap.Add("WMS_IASOCli", @"
                BEGIN                     
                     WMS_p_IASOCli('&&pCEDULA&&','&&pSOCIO&&');
                END;                
            ");

            //Almacena los PunToS ganados con la compra
            QueryMap.Add("WMS_EASOCli", @"
                BEGIN                     
                     WMS_p_EASOCli('&&pCEDULA&&','&&pSOCIO&&');
                END;                
            ");

            //Selecciona las asociacines
            QueryMap.Add("ASOC", @"
                select RV_MEANING,RV_MPCC01 from CG_REF_CODES where RV_DOMAIN = 'ASOCIACIONES' order By RV_MEANING
           ");

            //Selecciona EL HISTORIAL de la categorias de las tarjetas Puntos de un cliente por cedula
            QueryMap.Add("CatTarjPts", @"
                SELECT DECODE( TIPOANTERIOR,'PR', 'Preferencial','PL', 'Platino','ZA', 'Zafiro') ANTERIOR, 
                DECODE( TIPONUEVO,'PR', 'Preferencial','PL', 'Platino','ZA', 'Zafiro') NUEVO,
                DECODE( MOVIMIENTO,'S', 'Subir','B', 'Bajar') MOVIMIENTO,
                ACTUALIZADO_EL FECHA from WMS_PTS_HISTIPCLI where 
                ESTADO = 1 AND cedula = '&&pCEDULA&&'
           ");

            //Selecciona la cedula del cliente por el número de tarjeta
            QueryMap.Add("CedcliPts", @"
                SELECT CEDULA FROM WMS_CLIENTES_PTS WHERE TARJETA = '&&pTARJETA&&'
           ");

            //Selecciona la tarjeta del cliente por la cédula
            QueryMap.Add("TarjcliPts", @"
                SELECT TARJETA FROM WMS_CLIENTES_PTS WHERE CEDULA = '&&pCEDULA&&'
           ");

            //Seleciona el monto de la(s) compra(s) de hoy
            QueryMap.Add("MONTODIAPTS", @"
                select sum(total * decode(tipo_documento, 'F',1,-1)) monto 
                from WMS_documentos 
                where tipo_documento in ('F','D')
                AND TARJETA1 = '&&pTarj&&'
                AND  TRUNC(FECHA_EMISION) = TRUNC(SYSDATE)                
           ");

            //Almacena los PunToS ganados con la compra
            QueryMap.Add("PTS_P_SUBIR_CLI_CAT", @"
                BEGIN                     
                     PTS_P_SUBIR_CLI_CAT('&&pTARJETA&&');
                END;                
            ");

            //Selecciona si hay que hacer el cambio 
            QueryMap.Add("PTS_F_ACTTIPO", @"
                select PTS_F_ACTTIPO('&&pTARJETA&&') from dual               
           ");

            //Almacena los PunToS ganados con la compra
            QueryMap.Add("PTS_P_ACT_HISTIPCLI", @"
                BEGIN                     
                     PTS_P_ACT_HISTIPCLI('&&pTARJETA&&', '&&pTIPO&&');
                END;                
            ");

            //Secuencia de Tarjetas virtuales para afiliación
            QueryMap.Add("PTS_S_TARJ_VIRTUALS", @"
                SELECT PTS_F_TARJETAS FROM DUAL
           ");

            //Marjorie Arce INICIO

            #region PARAMETERS

            QueryMap.Add("PARAMETROSCREDIE", @"
            SELECT PARAMETER,VALUE FROM CG_PARAMETERS WHERE PARAMETER IN ('ALIM','INSM','TIEM')
            ");

            #endregion

            #region GuardaErrores
            QueryMap.Add("WMS_P_ERRORESCREDI", @"
                BEGIN
                    EKO_P_ERRORES('&&pREFERENCIA&&' , '&&pERROR&&' , '&&pJORNADA&&', '&&pVARIABLE&&' );                    
                END;                
            ");
            #endregion

            #region Busqueda

            QueryMap.Add("BUSQUEDA", @"
                
            SELECT 
               DISTINCT W.CEDULA, W.NOMBRE, A.TARJETA
               FROM EKONO.WMS_CREDITOEK_PAGOSPEND W, WMS_CLIENTES_PTS A
                         where W.CEDULA= A.CEDULA        
               and (UPPER(W.CEDULA) IN (SELECT CEDULA FROM WMS_CLIENTES_PTS WHERE CEDULA = '&&pCEDULA&&'))
            ");

            #endregion

            #region GuardaConsultaCrediE

            QueryMap.Add("WMS_P_GUARDACONSULTA", @"                
                 BEGIN
                    EKO_P_CONSULTACREDIE('&&pCEDULA&&' , '&&pNOMBRE&&' , '&&pOPERACION&&', '&&pRECIBO&&', '&&pPERIODO&&', '&&pVENCIMIENTO&&', '&&pMONTO&&','&&pUSUARIO&&','&&pJORNADA&&','&&pIDConsulta&&','&&pTipoPago&&');                    
                END;  
            ");

            #endregion

            #region GuardaSecuenciaConsulta

            QueryMap.Add("WMS_SECUENCIACONSULTA", @"                
                 Select WMS_S_CONSULTACRED.nextval from dual
            ");

            #endregion

            #region ConsultaEmailXCedula

            QueryMap.Add("ConsultaEmail", @"
                 SELECT   EMAIL
                 FROM     wms_clientes_pts
                 WHERE    CEDULA = '&&CEDULA&&'
            ");

            #endregion

            #region ConsultaEmailXTarjeta

            QueryMap.Add("ConsultaEmailxTarjeta", @"
                 SELECT   EMAIL
                 FROM     wms_clientes_pts
                 WHERE    TARJETA = '&&TARJETA&&'
            ");

            #endregion

            #region DeshabilitaActualizacion

            QueryMap.Add("GET_ACTUALIZA_VALUE", @"
               select VALUE from cg_parameters where parameter = 'ACTM'
            ");

            QueryMap.Add("GET_ACTUALIZA_PERT", @"
                SELECT EKO_F_ACTT_CLI_PTS('&&TARJETA&&')FROM DUAL
            ");

            QueryMap.Add("GET_ACTUALIZA_PERC", @"
                SELECT EKO_F_ACTC_CLI_PTS('&&CEDULA&&')FROM DUAL
            ");

            #endregion

            #region mValidarAccesoActualizacionCorreo

            QueryMap.Add("WMS_F_ACCESO_GERENTE", @"
              SELECT cg_f_access('&&USUARIO&&','&&MODULO&&')FROM DUAL
            ");

            #endregion

            #region niveles tajeta
            QueryMap.Add("WMS_F_NIVELES_TARJ", @"
              SELECT WMS_F_NIVELES_TARJ('&&TARJETA&&','&&NIVEL&&')FROM DUAL
            ");

            #endregion

            #region InsertaModoIngresoSku

            QueryMap.Add("InsertModoSku", @"
               BEGIN                     
                     INSERT_MODO('&&DOCUMENTO&&', '&&LINEA&&', '&&MODO&&');
                END;  
            ");

            #endregion

            #region BuscaSiguienteTarjeta

            QueryMap.Add("TipoSiguienteTarjeta", @"
              SELECT PTS_F_UNCION_DV('&&TARJETA&&')FROM DUAL
            ");

            #endregion

            #region AbreviaturaTarjetaActual

            QueryMap.Add("TarjetaActual", @"
                 SELECT   NVL(TIPO,'PR')
                 FROM     wms_clientes_pts
                 WHERE    TARJETA = '&&TARJETA&&'
            ");

            QueryMap.Add("TarjetaActual2", @"
                 SELECT   NVL(TIPO,'PR')
                 FROM     wms_clientes_pts
                 WHERE    TARJETA = '&&TarjetaActual&&'
            ");

            #endregion

            #region ParametroLector

            QueryMap.Add("ParametroLector", @"
                 SELECT   VALUE
                 FROM     CG_PARAMETERS
                 WHERE    PARAMETER='&&PARAMETRO&&'
            ");

            #endregion

            #region Existencia_tarj
            QueryMap.Add("EXISTENCIATAJ", @"

                 Select TARJETA_NULA('&&TarjetaActual&&') from dual              
            ");

            #endregion

            #region RESPUESTA_DIRECTA_PROVEEDOR
            QueryMap.Add("EWS_P_RESP_WS", @"
                BEGIN 
                   EKONO.WMS_P_REGISTRO_RESPUESTA_WS('&&pVARIABLE&&', '&&pRESPUESTA&&','&&pJORNADA&&','&&pCEDULA&&');
                END;                 
            ");
            #endregion

            #region SECUENCE_TABLA_RESP_WS_PROVEE
            QueryMap.Add("SEC_SECWS", @"
                Select EKONO.WMS_S_RESWS.nextval from dual
           ");
            #endregion


            //Marjorie Arce FIN

            // Función que indica si el pago con puntos procede o no

            QueryMap.Add("POS_F_APROBACION_PTS", @"
              SELECT POS_F_APROBACION_PTS(&&pDOCUMENTO&&, &&pTOTAL_X_ABONAR&&, &&pTOTAL_PTS&&)FROM DUAL
            ");

            #endregion

            #region /********************Marcas - Bitacora Idalí GF***********************/
            //Consulta las marcas de una fecha en específico (Llama a una vista)
            QueryMap.Add("C_MARCAS_FECHA", @"SELECT EMAIL, NOMBRES,TIPO_USUARIO,ENTRADA, ENTRADA_JEFE, TIPO_ENTRADA, SALIDA, SALIDA_JEFE, TIPO_SALIDA,
                OBSERVACIONES, MARCA_JEFE, CREADO_EL FROM RH_MARCAS_V WHERE TRUNC(ENTRADA) = TRUNC (to_date('&&fecha&&', 'dd/mm/yyyy hh:mi:ss a.m.')) AND ANULADO_EL IS NULL");
            #endregion

            #region /******************** DONACIONES DLQG **************************/

            //OBTIENE la linea donde se encuentra el sku
            QueryMap.Add("LINEA_DONACION", @"select LINEA FROM wms_skus_x_documento
              WHERE documento = &&pDocumento&&
              AND sku = (select sku from wms_skus where sku_alterno = (select cg_f_parameter_value('SADO') from dual))         
              AND USUARIO_ANULO IS NULL
            ");

            QueryMap.Add("DocDonacion", @"select precio_unitario FROM wms_skus_x_documento
              WHERE documento = &&pDocumento&&
              AND sku = (select sku from wms_skus where sku_alterno = (select cg_f_parameter_value('SADO') from dual))         
              AND USUARIO_ANULO IS NULL
            ");

            //Elimina los descuentos del producto Donacion y del producto GiftCard
            QueryMap.Add("ELIDESCDON", @"
                BEGIN                     
                     WMS_ELI_DESC_DON(&&pDOCUMENTO&&);
                END;                
            ");

            #endregion

            #region /************Credix DLQG**********/

            //Cuotas credix
            QueryMap.Add("C_CUOTAS", @"
                select RV_LOW_VALUE, RV_MEANING from CG_REF_CODES where RV_DOMAIN = 'CUOTAS_CREDIX' order By RV_SEQUENCE
            ");

            //Parametros
            QueryMap.Add("C_PC", @"
                SELECT CG_F_PARAMETER_VALUE('USCX') as USUARIO,CG_F_PARAMETER_VALUE('PWCX') as CLAVE,                
                CG_F_PARAMETER_VALUE('NCD1') as CUOTASGENCDX, CG_F_PARAMETER_VALUE('NCD2') as CUOTASTECNOCDX  
                FROM DUAL            
            ");

            //Secuencia de documentos
            QueryMap.Add("SEC_CREDIX", @"
                Select wms_s_CREDIX.nextval from dual
           ");

            //almacena la transaccion credix
            QueryMap.Add("WMS_P_ITRACREDIX", @"
                BEGIN
                      EKO_P_ITRACREDIX('&&ptarj&&', '&&pfven&&', '&&pthab&&', '&&pcvv&&', '&&pimprt&&','&&pmonto&&', '&&pmoned&&', '&&pcuots&&', '&&prefer&&', '&&ptip&&',&&pjornada&&,&&pdoc&&);
                END;                
            ");

            //almacena la transaccion Pin credix
            QueryMap.Add("WMS_P_ITRAPCREDIX", @"
                BEGIN
                      EKO_P_ITRAPCREDIX('&&ppin&&','&&pimprt&&','&&pmonto&&', '&&pmoned&&', '&&pcuots&&', '&&prefer&&', '&&ptip&&',&&pjornada&&,&&pdoc&&);
                END;                
            ");

            //WMS_P_ERRORLDCREDIX
            //almacena la transaccion Pin credix
            QueryMap.Add("WMS_P_ERRORLDCREDIX", @"
                BEGIN
                      WMS_P_ERRORLDCREDIX('&&ID_CREDIX&&','&&JORNADA&&','&&ERROR&&');
                END;                
            ");

            //almacena la respuesta de la transaccion Credix
            //PESTADO
            QueryMap.Add("WMS_P_IRESPCREDIX", @"
                BEGIN
                      EKO_P_IRESPCREDIX('&&prefer&&','&&presp&&','&&pestado&&','&&pauto&&','&&pnumcrdx&&');
                END;                
            ");

            //Obtener los pagos con credix de la jornada
            QueryMap.Add("WMS_V_TRANSCREDIX", @" SELECT 
            W.NUMTAR, W.FECHA_VENC, W.CVV, W.MONTO, 
            W.IMPORTE, W.MONEDA, W.CUOTAS, 
            W.REFERENCIA, W.TIPO_TRANS, W.PIN, 
            W.DOCUMENTO, TO_CHAR(W.CREADO_EL, 'YYYYMMDD') FECHA, W.AUTORIZACION, wms_p_factpedido(W.DOCUMENTO) FACTURA, W.NUM_CRDX
            FROM WMS_CREDIX_TRANS W WHERE W.JORNADA = &&JORNADA&& and ESTADO = 'C'");

            //Obtener los pagos con credix de un pedido para anularlos
            QueryMap.Add("WMS_TRANSCREDIX", @" SELECT 
            W.NUMTAR, W.FECHA_VENC, W.CVV, W.MONTO, 
            W.IMPORTE, W.MONEDA, W.CUOTAS, 
            W.REFERENCIA, W.TIPO_TRANS, W.PIN, 
            W.DOCUMENTO, TO_CHAR(W.CREADO_EL, 'YYYYMMDD') FECHA, W.AUTORIZACION, wms_p_factpedido(W.DOCUMENTO) FACTURA, W.NUM_CRDX
            FROM WMS_CREDIX_TRANS W WHERE W.DOCUMENTO = &&pdoc&& and ESTADO = 'C'");

            //almacena la transaccion credix
            QueryMap.Add("WMS_P_IATRACREDIX", @"
                BEGIN
                      EKO_P_IATRACREDIX('&&presp&&','&&prefer&&','&&pusrauto&&',&&pjornada&&);
                END;                
            ");

            QueryMap.Add("CREDIX_FECHA","SELECT TO_CHAR(SYSDATE, 'YYYYMMDD') FROM DUAL");

            //Obtener el pedido de una factura pagada con credix
            QueryMap.Add("WMS_F_PEFACREDIX", @" select WMS_F_PCREDIX(&&pFactura&&) from dual
            ");

            //Total de pagos con Credix
            QueryMap.Add("TotalPagoCredix", "SELECT NVL(SUM(MONTO),0) TOTAL_CREDIX FROM WMS_V_CREDIX WHERE JORNADA = &&JORNADA&&");


            //Total de pagos con CrediCUOTAS
            QueryMap.Add("TotalCrediCuotas", "select NVL(SUM (VALORCOMPRA),0) FROM WMS_CREDITOEK_RPAGS WHERE  ESTADO ='C' AND JORNADA = &&JORNADA&&");

            //Total de pagos con CrediCUOTAS
            QueryMap.Add("Totalpagocredi", @"SELECT NVL(SUM(MONTO_CANCELADO),0)FROM (select NVL(SUM(MONTO_CANCELADO),0)MONTO_CANCELADO from WMS_CREDITOEK_PAGOS WHERE JORNADA = &&JORNADA&&
            AND ANULADO_EL IS NULL
            union all
            select NVL(SUM(MONTO_CANCELADO),0)MONTO_CANCELADO from WMS_INSTACREDIT_PAGOS WHERE JORNADA = &&JORNADA&&
            AND ANULADO_EL IS NULL
            union all
            select nvl(sum(monto_cancelado),0) MONTO_CANCELADO froM wms_multicred_pagos where jornada = &&JORNADA&&
            AND ANULADO_EL IS NULL)");




            #endregion

            #region /************Monedero Alo Express DLQG**********/

            //Parametros
            QueryMap.Add("C_PM", @"
                SELECT cg_f_parameter_value ('ENAE') as ENTIDAD,CG_F_PARAMETER_VALUE('USAE') as USUARIO,CG_F_PARAMETER_VALUE('PWAE') as CLAVE                
                FROM DUAL            
            ");

            //Secuencia de documentos
            QueryMap.Add("SEC_MOALO", @"
                Select WMS_S_MONEDEROALO.nextval from dual
           ");

            //almacena la transaccion de consulta pr crear llave de pago
            QueryMap.Add("WMS_P_ICMONEDEROALO", @"
                BEGIN
                      EKO_P_ICMONEDEROALO('&&pASOCIACION&&','&&pCODASOCIACION&&','&&pIDENTIFICACION&&',
                      &&pMONTO&&, &&pREFERENCIA&&,&&pjornada&&,&&pdoc&&);
                END;                
            ");

            //almacena la llave de Pago
            QueryMap.Add("WMS_P_ILLAVEMONEDALO", @"
                BEGIN
                      EKO_P_IKEYMONEDEROALO('&&pLLAVEPAGO&&','&&pNOMBRE&&', &&pREFERENCIA&&);
                END;                
            ");

            //almacena el codigo de autorizacion
            QueryMap.Add("WMS_P_ICODAUTOMONEDALO", @"
                BEGIN
                      EKO_P_ICODMONEDEROALO('&&pCODAUTORIZ&&', &&pREFERENCIA&&);
                END;                
            ");

            //almacena la transaccion de consulta pr crear llave de pago
            QueryMap.Add("WMS_P_IPMONEDEROALO", @"
                BEGIN
                      EKO_P_IPMONEDEROALO(&&pREFERENCIA&&);
                END;                
            ");

            //almacena el error en el proceso del monedero alo
            QueryMap.Add("WMS_P_ERRORCodAuto", @"
                BEGIN
                      EKO_P_ERRORMONEDEROALO(&&pREFERENCIA&&,'&&pERROR&&','&&pWEBSERVICE&&');
                END;                
            ");

            //almacena la transaccion 
            QueryMap.Add("WMS_P_IATMONEDEROALO", @"
                BEGIN
                      EKO_P_IATMONEDEROALO('&&prefer&&','&&pusrauto&&',&&pjornada&&);
                END;                
            ");

            //Obtener los pagos con Monedero Alo de la jornada
            QueryMap.Add("WMS_V_TRANSMONEDEROALO", @" SELECT 
                W.REFERENCIA,W.ASOCIACION, W.IDENTIFICACION CLIENTE, W.NOMBRE,  
                W.MONTO, W.CREADO_EL FECHA, wms_p_factpedido(W.DOCUMENTO) FACTURA , W.DOCUMENTO
                FROM WMS_MONEDEROALO W WHERE W.JORNADA = &&JORNADA&& and ESTADO = 'C'");

            //Obtener el pedido de una factura pagada con MONEDERO ALO
            QueryMap.Add("WMS_F_PEFAMOA", @" select WMS_F_PMONEDEROALO(&&pFactura&&) from dual
            ");

            //Obtener los pagos con Monedero Alo de un pedido para anularlos
            QueryMap.Add("WMS_TRANSMONEDALO", @" SELECT 
                W.REFERENCIA,W.ASOCIACION, W.IDENTIFICACION CLIENTE
                FROM WMS_MONEDEROALO W WHERE W.DOCUMENTO = &&pdoc&& and ESTADO = 'C'");

            #endregion

            #region /************Credi-E Ekono DLQG**********/
            //consulta los parametros : USUARIO Y CLAVE
            QueryMap.Add("C_PGEN", @"
                SELECT cg_f_parameter_value ('USRG') as USUARIOG,CG_F_PARAMETER_VALUE('PWDG') as CLAVEG, CG_F_PARAMETER_VALUE('URLE') as URLG FROM DUAL 
            ");

            //Obtener los clientes que coinciden con la cedula o nombre
            QueryMap.Add("WMS_ClICREDITOEK", @" SELECT 
               DISTINCT W.CEDULA, W.NOMBRE
               FROM EKONO.WMS_CREDITOEK_PAGOSPEND W
               WHERE (UPPER(W.CEDULA) like '&&BUSQUEDA&&'
               OR UPPER(W.NOMBRE) like '&&BUSQUEDA&&')
            ");

            //Obtener los pagos pendientes de clientes que coinciden con la cedula o nombre
            QueryMap.Add("WMS_PAGPCREDITOEK", @" SELECT  prefijosucursal  , NUmcredito , cuotasenmora ,VALORVENCIDO,VALORXCUOTA, VALORTOTALCREDITO
               FROM EKONO.WMS_CREDITOEK_PAGOSPEND 
               WHERE (UPPER(CEDULA) = '&&CEDULA&&' AND UPPER(NOMBRE) = '&&NOMBRE&&' and ESTADO_ACTUAL IS NULL )
            ");


            //almacena la transaccion DE PAGO DE UNA CUOTA CREDITO EKONO
            QueryMap.Add("WMS_P_ICUOTSCREDEK", @"
                BEGIN
                    EKO_P_ICUOTCREDEK('&&pCEDULA&&' , '&&pNOMBRE&&' , '&&pPREFSUC&&' , 
                    &&pNUMCREDITO&& , &&pCUOTASENMORA&& , &&pVALORVENCIDO&& , 
                    &&pVALORXCUOTA&& , &&pVALORTOTALCREDITO&& , '&&pCREADO_EL&&' , 
                    &&pMONTO_CANCELADO&& , &&pJORNADA&& , &&pREFER&& , &&pDEUDAPAGADA&& );                    
                END;                
            ");
            /* //Almacena la transaccion DE PAGO DE UNA CUOTA CREDITO EKONO EXPERTB
             QueryMap.Add("WMS_P_ICUOTSCREDEK", @"
               BEGIN
                     EKO_P_ICUOTCREDEK('&&pCEDULA&&' , '&&pNOMBRE&&' , '&&pPREFSUC&&','&&pNUMCREDITO&&' , '&&pCUOTASENMORA&&' , '&&pVALORVENCIDO&&' , 
                     '&&pVALORXCUOTA&&' , '&&pVALORTOTALCREDITO&&' , '' , '&&pMONTO_CANCELADO&&' , '&&pJORNADA&&' , '&&pREFER&&', TO_DATE('&&pPERIODO&&','YYYY,MM,DD') , 
                     '&&pOPERACION&&', '&&pTIPOPAGO&&', '&&pEXAM&&','&&pRA&&','&&pPPEA&&',
                     '&&pAP&&', '&&pPNO&&', '&&pPPA&&', '&&pOPI&&', '&&pEPI&&', '&&pPPI&&', '&&pMRA&&', '&&pMPPA&&', '&&pPMI&&','&&pDED&&', '&&pPDED&&' );                   
                 END;               
             ");
             * */

            //Secuencia de documentos
            QueryMap.Add("SEC_CREDEK", @"
                Select wms_s_CREDEK.nextval from dual
           ");


            //PAGOS DE CUOTAS CREDICUOTAS QUE SE REALIZARON EN LA JORNADA
            QueryMap.Add("PAGSCUOTSCREDEK", @"
                SELECT W.REFERENCIA, W.CEDULA, W.NOMBRE, W.PREFIJOSUCURSAL, W.NUMCREDITO, W.MONTO_CANCELADO FROM WMS_CREDITOEK_PAGOS W WHERE W.JORNADA = '&&pJORNADA&&' AND ANULADO_EL IS NULL ORDER BY REFERENCIA DESC
           ");
            /* //PAGOS DE CUOTAS CREDICUOTAS QUE SE REALIZARON EN LA JORNADA EXPERTB
              QueryMap.Add("PAGSCUOTSCREDEK", @"
                  SELECT W.REFERENCIA, W.CEDULA, W.NOMBRE, W.PREFIJOSUCURSAL, W.NUMCREDITO as NUM_RECIBO, W.MONTO_CANCELADO, W.PERIODO,W.NUMOPERACION,W.TIPOPAGO, W.VALORTOTALCREDITO  FROM WMS_CREDITOEK_PAGOS W WHERE W.JORNADA = '&&pJORNADA&&' AND ANULADO_EL IS NULL ORDER BY REFERENCIA DESC
             ");
              */

            //ANULA la transaccion DE PAGO DE UNA CUOTA CREDITO EKONO
            QueryMap.Add("WMS_P_ACUOTSCREDEK", @"
                BEGIN                                     
                    EKO_P_ACUOTCREDEK( '&&pPREFSUC&&' , &&pNUMCREDITO&& , &&pREFER&&,'&&pUSUARIO&&' );                    
                END;                
            ");

            //almacena la consulta de CREDITO EKONO
            QueryMap.Add("WMS_P_CREDITOEK_ICONS", @"
                BEGIN
                    EKO_P_CREDITOEK_ICONS('&&pERR_COD_ESTADO&&','&&pERR_DESC&&','&&pCOD_ESTADO&&', 
                    '&&pDESC_ESTADO&&','&&pPER_CEDULA&&','&&pPER_NOMBRE&&',&&pPER_SALDO_DISP&&,&&pPER_SALDO_POST&&,&&pPER_CUOTA_TMP&&, 
                    &&pREFERENCIA&&,&&pMONTO&&,&&pJORNADA&&);
                END;                
            ");

            //rEGISTRO UN ERROR DE CREDITO EKONO
            QueryMap.Add("WMS_P_CREDITOEK_ERROR", @"
                BEGIN                                     
                    EKO_P_CREDITOEK_ERROR('&&pREFERENCIA&&', &&pJORNADA&& ,
                    '&&pCOD_ESTADO&&' , '&&pDESC_ESTADO&&', '&&pERR_COD_EST&&' , 
                    '&&pERR_DESC&&', '&&pWS&&','&&pERROR&&');
                END;                
            ");

            //actualiza la consulta de CREDITO EKONO
            QueryMap.Add("WMS_P_CREDITOEK_ACONS", @"
                BEGIN
                    EKO_P_CREDITOEK_ACONS('&&pERR_COD_ESTADO&&','&&pERR_DESC&&','&&pCOD_ESTADO&&', 
                    '&&pDESC_ESTADO&&','&&pPER_CEDULA&&','&&pPER_NOMBRE&&',&&pPER_SALDO_DISP&&,&&pPER_SALDO_POST&&,&&pPER_CUOTA_TMP&&, 
                    &&pREFERENCIA&&,&&pMONTO&&,&&pJORNADA&&);
                END;                
            ");

            //INSERTA EL ERROR EN consulta de CREDITO EKONO
            QueryMap.Add("WMS_P_CREDITOEK_ECONS", @"
                BEGIN
                    EKO_P_CREDITOEK_ECONS(&&pREFERENCIA&&,&&pJORNADA&&,'&&pCEDULA&&',&&pMONTO&&,'&&pERROR&&');
                END;                
            ");

            //Secuencia de documentos
            QueryMap.Add("SEC_CREDCONSEK", @"
                Select wms_s_CREDCONSEK.nextval from dual
           ");

            //PAGOS DE CUOTAS CREDICUOTAS QUE SE REALIZARON EN LA JORNADA
            QueryMap.Add("CCREDCUOTSEK", @"
              SELECT (select bodega_alterna from wms_bodegas where bodega = (SELECT CG_F_PARAMETER_VALUE ('BREE') from dual)),W.PER_CEDULA, W.MONTO, to_char(sysdate,'YYYY-MM-dd HH:mm:SS'), wms_s_CREDRPAGSEK.nextval REFER FROM EKONO.WMS_CREDITOEK_CONS W where W.REFERENCIA = '&&pREFERENCIA&&'
           ");

            //ALMACENA la consulta de PAGO CREDITO EKONO
            QueryMap.Add("WMS_P_CREDITOEK_ICPAGS", @"
                BEGIN
                    EKO_P_CREDITOEK_ICPAGS('&&pSUCURSAL&&', '&&pUSUARIO&&', &&pJORNADA&&, 
                    &&pCAJA&&, '&&pIDCLIENTE&&' , &&pVALORCOMPRA&&, &&pID&&, &&pREFERENCIA&&);
                END;                
            ");

            //ALMACENA la RESPUESTA de PAGO CREDITO EKONO
            QueryMap.Add("WMS_P_CREDITOEK_IRPAGS", @"
                BEGIN
                    EKO_P_CREDITOEK_IRPAGS(&&pID&&, &&pCOD_COMPRA&&, '&&pDESC_COMPR&&', 
                    &&pCOD_ERROR&& , '&&pDESC_ERROR&&' , '&&pID_TRANS_PROV&&', 
                    '&&pNIT_CLIENTE&&', '&&pNOMBRE&&', '&&pFECHA_TRANS&&', 
                    &&pVALORCOMPRA&&, '&&pLEYENDA&&','&&pESTADO&&',&&pJORNADA&& , &&pDOC&& , &&pREFERENCIA&& );
                END;                
            ");

            //Obtener los pagos con credicuotas de la jornada
            QueryMap.Add("WMS_V_TRANSCREDITOEK", @"SELECT W.REFERENCIA, (select bodega_alterna from wms_bodegas where bodega = (SELECT CG_F_PARAMETER_VALUE ('BREE') from dual)) SUCURSAL, W.ID_TRANS_PROV, W.NIT_CLIENTE, W.NOMBRE, W.VALORCOMPRA,FECHA_TRANS,wms_p_factpedido(W.DOCUMENTO) FACTURA,DECODE(W.ESTADO,'C','CORRECTO','A','ANULADO',W.ESTADO) AS ESTADO, DECODE(W.ENT_EXTERNA,'B','BOMBA',W.ENT_EXTERNA) ORIGEN
                FROM WMS_CREDITOEK_RPAGS W WHERE W.JORNADA = &&pJORNADA&& and W.ESTADO = 'C' order by referencia desc");

            //Obtener los pagos con credicuotas CORRECTAS Y ANULADAS de la jornada
            QueryMap.Add("WMS_V_TRANSACREDITOEK", @"SELECT W.REFERENCIA, (select bodega_alterna from wms_bodegas where bodega = (SELECT CG_F_PARAMETER_VALUE ('BREE') from dual)) SUCURSAL, W.ID_TRANS_PROV, W.NIT_CLIENTE, W.NOMBRE, W.VALORCOMPRA,FECHA_TRANS,wms_p_factpedido(W.DOCUMENTO) FACTURA,DECODE(W.ESTADO,'C','CORRECTO','A','ANULADO',W.ESTADO) AS ESTADO, DECODE(W.ENT_EXTERNA,'B','BOMBA',W.ENT_EXTERNA) ORIGEN
                FROM WMS_CREDITOEK_RPAGS W WHERE W.JORNADA = &&pJORNADA&& and W.ESTADO IN ('C','A') order by referencia desc");

            //Obtener los pagos con credicuotas CORRECTAS Y ANULADAS de la jornada
            QueryMap.Add("WMS_V_ARQUEOJCREDITOEK", @"SELECT W.REFERENCIA, W.ID_TRANS_PROV, W.NIT_CLIENTE, W.VALORCOMPRA,creado_el ,wms_p_factpedido(W.DOCUMENTO) FACTURA,DECODE(W.ESTADO,'C','CORRECTO','A','ANULADO',W.ESTADO) AS ESTADO , DECODE(W.ENT_EXTERNA,'B','BOMBA',W.ENT_EXTERNA) ORIGEN, w.jornada
                FROM WMS_CREDITOEK_RPAGS W WHERE W.JORNADA = &&pJORNADA&& and W.ESTADO IN ('C','A') order by referencia asc
            ");

            //Obtener los pagos con credicuotas CORRECTAS Y ANULADAS de la jornada
            QueryMap.Add("WMS_V_ARQUEOTCREDITOEK", @"SELECT W.REFERENCIA, W.ID_TRANS_PROV, W.NIT_CLIENTE, W.VALORCOMPRA,creado_el ,wms_p_factpedido(W.DOCUMENTO) FACTURA,DECODE(W.ESTADO,'C','CORRECTO','A','ANULADO',W.ESTADO) AS ESTADO , DECODE(W.ENT_EXTERNA,'B','BOMBA',W.ENT_EXTERNA) ORIGEN, w.jornada                
                FROM WMS_CREDITOEK_RPAGS W WHERE CREADO_EL BETWEEN to_date(to_char(sysdate , 'dd/mm/yyyy'), 'dd/mm/yyyy') AND to_date(to_char(sysdate , 'dd/mm/yyyy')||' 23:59:59', 'dd/mm/yyyy hh24:mi:ss')  and W.ESTADO IN ('C','A') order by referencia asc
            ");

            //Valida que la fecha de creacion sea igual al día de hoy
            QueryMap.Add("VALFECCREDITOEK", @"Select count(1) from WMS_CREDITOEK_RPAGS where referencia = &&pREFERENCIA&& and to_char(creado_el , 'dd/mm/yyyy') = to_char(sysdate , 'dd/mm/yyyy') 
            ");

            //ALMACENA la anulacion de PAGO CREDITO EKONO
            QueryMap.Add("WMS_P_CREDITOEK_IAPAGS", @"
                BEGIN
                    EKO_P_CREDITOEK_IAPAGS(&&pREFERENCIA&& , '&&pUSUARIO&&' , '&&pID_TRANS_PROV&&','&&pID_TRANS_ANUL&&');
                END;                
            ");

            //Obtener el pedido de una factura pagada con CREDICUOTAS EKONO
            QueryMap.Add("WMS_F_PEFACCE", @" select WMS_F_PCREDICUOTSEK(&&pFactura&&) from dual
            ");

            //Obtener el pedido de un recibo pagada con CREDICUOTAS EKONO
            QueryMap.Add("WMS_F_REFACCE", @" select WMS_F_RCREDICUOTSEK(&&pFactura&&) from dual
            ");

            //Valida LA CANTIDAD DE PAGOS DE UNA MISMA FACTURA O RECIBO 
            QueryMap.Add("VAL_F_CANTCOMP", @"select count(documento) from wms_creditoek_rpags where documento = (
                select documento from wms_creditoek_rpags where referencia = &&pREFERENCIA&&
                ) and creado_el between sysdate - 5 and sysdate and estado = 'C' 
            ");

            //Obtener un pago con credicuotas por documento
            QueryMap.Add("WMS_TRANSCREDITOEK", @"SELECT w.ID_TRANS_PROV,(select bodega_alterna from wms_bodegas where bodega = (SELECT CG_F_PARAMETER_VALUE ('BREE') from dual)) bodega, w.NIT_CLIENTE, w.VALORCOMPRA, w.FECHA_TRANS, w.referencia FROM WMS_CREDITOEK_RPAGS W WHERE W.DOCUMENTO = &&pdoc&& and ESTADO = 'C'");

            //PAGOS DE CUOTAS CREDICUOTAS QUE SE REALIZARON EN LA JORNADA
            QueryMap.Add("SUCFECHACREDEK", @"
                SELECT (select bodega_alterna from wms_bodegas where bodega = (SELECT CG_F_PARAMETER_VALUE ('BREE') from dual)), TO_CHAR(SYSDATE, 'yyyy-MM-dd') FROM DUAL
           ");

            //Asocia la Tarjeta de Pts con el cliente Credi-E
            QueryMap.Add("WMS_P_ACrediEPts", @"
                BEGIN
                    EKO_P_ACrediEPts('&&pNIT_CREDIE&&', '&&pTARJETA&&', '&&pUSR_ASO&&');                    
                END;                
            ");

            //Selecciona la tarjeta asociada 
            QueryMap.Add("WMS_CLITARJPTSCREDIE", @"
                SELECT NIT_CREDIE FROM WMS_CLIENTES_PTS WHERE TARJETA = '&&pTARJETA&&'
           ");

            //Selecciona la tarjeta asociada 
            QueryMap.Add("WMS_CLICREDIETARJ", @"
             SELECT DISTINCT CEDULA, NOMBRE ||' ' || APELLIDO1 ||' '|| APELLIDO2 AS NOMBRE
             FROM WMS_CLIENTES_PTS WHERE TARJETA = '&&pTARJETA&&'
            ");

            //GET EL MAXIMO RECIBO DE LA CONSULTA DEL PROVEEDOR
            QueryMap.Add("GETMAYORECIBO", @"
            SELECT IDENTIFICACION,NOMBRE_CLIENTE,OPERACION,N_RECIBO,PERIODO,VENCIMIENTO,MONTO_RECIBO FROM WMS_CONSULTAS_CREDIE W
            WHERE IDENTIFICACION= '&&pCEDULA&&' AND ID_CONSULTA= '&&pIDCONSULTA&&' ORDER BY N_RECIBO ASC              
           ");

            //ALMACENA EL SOCIO cliente Credi-E
            QueryMap.Add("WMS_ASocioCrediE", @"
                BEGIN
                    wms_ASocioCrediE('&&pDOCUMENTO&&');                    
                END;                
            ");

            //ALMACENA pago cliente Credi-E en wms_documentos
            QueryMap.Add("WMS_APCrediE", @"
                BEGIN
                    wms_APCrediE('&&pDOCUMENTO&&');                    
                END;                
            ");

            //ELIMINA EL SOCIO cliente Credi-E
            QueryMap.Add("WMS_ESocioCrediE", @"
                BEGIN
                    wms_ESocioCrediE('&&pDOCUMENTO&&');                    
                END;                
            ");

            //Selecciona el cliente CrediE
            QueryMap.Add("C_CliCrediE", @"
                 SELECT NVL(cg_f_parameter_value ('SCCE'),0) FROM dual
           ");

            //Selecciona si el documento va a ser pagado con credie
            QueryMap.Add("C_PagaCrediE", @"
                 SELECT aprobacion2 FROM wms_documentos where documento = '&&pDOCUMENTO&&'
           ");


            //indica si tienes asociacion cliente pts
            QueryMap.Add("VALIDACLICREDPTS", @"
                SELECT PTS_f_CLICRED(&&pNitCredie&&) FROM DUAL
            ");
            // Obtiene el nit credie, si existe
            QueryMap.Add("EKO_F_CLIENTE_CREDIE", "SELECT EKO_F_CLIENTE_CREDIE('&&TARJETA&&') FROM DUAL");

            #endregion

            #region QuerysStevenArce ARTICULOS TECNOLOGIA
            //Valida si la factura tiene artículos de tecnología junto con otros tipos
            QueryMap.Add("WMS_F_CHEQUEA_SI_E_TECNO", @"
                SELECT WMS_F_CHEQUEA_SI_E_TECNO(&&pDocumento&&) FROM DUAL
            ");

            //Valida si la factura tiene artículos de tecnología junto con otros tipos para Credix
            QueryMap.Add("WMS_F_CHEQUEA_SI_E_TECNOCDX", @"
                SELECT WMS_F_CHEQUEA_SI_E_TECNOCDX(&&pDocumento&&) FROM DUAL
            ");

            //Cuotas credix condicionado
            QueryMap.Add("C_CUOTAS_CONDIC", @"
                select RV_LOW_VALUE, RV_MEANING from CG_REF_CODES where RV_DOMAIN = 'CUOTAS_CREDIX' and 
                RV_LOW_VALUE <= &&pCantCuotas&& order By RV_SEQUENCE
            ");

            #endregion

            #region /************Instacredit DLQG**********/
            //Obtener los clientes que coinciden con la cedula o nombre
            QueryMap.Add("WMS_ClIINSTACREDIT", @" SELECT 
               DISTINCT W.CEDULA, W.NOMBRE
               FROM EKONO.WMS_INSTACREDIT_PAGOSPEND W
               WHERE (UPPER(W.CEDULA) like '&&BUSQUEDA&&'
               OR UPPER(W.NOMBRE) like '&&BUSQUEDA&&')
            ");

            //Obtener los pagos pendientes de clientes que coinciden con la cedula o nombre
            QueryMap.Add("WMS_PAGPINSTACREDIT", @" SELECT  prefijosucursal  , NUmcredito , cuotasenmora ,VALORVENCIDO,VALORXCUOTA, VALORTOTALCREDITO
               FROM EKONO.WMS_INSTACREDIT_PAGOSPEND 
               WHERE (UPPER(CEDULA) = '&&CEDULA&&' AND UPPER(NOMBRE) = '&&NOMBRE&&' and ESTADO_ACTUAL IS NULL )
            ");

            //almacena la transaccion DE PAGO DE UNA CUOTA CREDITO EKONO
            QueryMap.Add("WMS_P_ICUOTSINSTAC", @"
                BEGIN
                    EKO_P_ICUOTINSTAC('&&pCEDULA&&' , '&&pNOMBRE&&' , '&&pPREFSUC&&' , 
                    &&pNUMCREDITO&& , &&pCUOTASENMORA&& , &&pVALORVENCIDO&& , 
                    &&pVALORXCUOTA&& , &&pVALORTOTALCREDITO&& , '&&pCREADO_EL&&' , 
                    &&pMONTO_CANCELADO&& , &&pJORNADA&& , &&pREFER&& );                    
                END;                
            ");

            //Secuencia de documentos
            QueryMap.Add("SEC_INSTAC", @"
                Select wms_s_INSTAC.nextval from dual
           ");

            //PAGOS DE CUOTAS INSTACREDIT QUE SE REALIZARON EN LA JORNADA
            QueryMap.Add("PAGSCUOTSINSTAC", @"
                SELECT W.REFERENCIA, W.CEDULA, W.NOMBRE, W.PREFIJOSUCURSAL, W.NUMCREDITO, W.MONTO_CANCELADO FROM WMS_INSTACREDIT_PAGOS W WHERE W.JORNADA = '&&pJORNADA&&' AND ANULADO_EL IS NULL ORDER BY REFERENCIA DESC
           ");

            //ANULA la transaccion DE PAGO DE UNA CUOTA INSTACREDIT
            QueryMap.Add("WMS_P_ACUOTSINSTAC", @"
                BEGIN                                     
                    EKO_P_ACUOTINSTAC( '&&pPREFSUC&&' , &&pNUMCREDITO&& , &&pREFER&&,'&&pUSUARIO&&' );                    
                END;                
            ");

            #endregion

            #region /************MultiCreditos DLQG**********/
            //Obtener los clientes que coinciden con la cedula o nombre
            QueryMap.Add("WMS_ClIMULTICRED", @" SELECT 
               DISTINCT W.CEDULA, W.NOMBRE
               FROM EKONO.WMS_MULTICRED_PAGOSPEND W
               WHERE (UPPER(W.CEDULA) like '&&BUSQUEDA&&'
               OR UPPER(W.NOMBRE) like '&&BUSQUEDA&&')
            ");

            //Obtener los pagos pendientes de clientes que coinciden con la cedula o nombre
            QueryMap.Add("WMS_PAGPMULTICRED", @" SELECT  prefijosucursal  , NUmcredito , cuotasenmora ,VALORVENCIDO,VALORXCUOTA, VALORTOTALCREDITO
               FROM EKONO.WMS_MULTICRED_PAGOSPEND 
               WHERE (UPPER(CEDULA) = '&&CEDULA&&' AND UPPER(NOMBRE) = '&&NOMBRE&&' and ESTADO_ACTUAL IS NULL )
            ");

            //almacena la transaccion DE PAGO DE UNA CUOTA CREDITO EKONO
            QueryMap.Add("WMS_P_ICUOTSMULTICRED", @"
                BEGIN
                    EKO_P_ICUOTMULTICRED('&&pCEDULA&&' , '&&pNOMBRE&&' , '&&pPREFSUC&&' , 
                    &&pNUMCREDITO&& , &&pCUOTASENMORA&& , &&pVALORVENCIDO&& , 
                    &&pVALORXCUOTA&& , &&pVALORTOTALCREDITO&& , '&&pCREADO_EL&&' , 
                    &&pMONTO_CANCELADO&& , &&pJORNADA&& , &&pREFER&& );                    
                END;                
            ");

            /*
            //almacena la transaccion DE PAGO DE UNA CUOTA CREDITO EKONO EXPERTB
            QueryMap.Add("WMS_P_ICUOTSMULTICRED", @"
               BEGIN
                    EKO_P_ICUOTMULTICRED('&&pCEDULA&&' , '&&pNOMBRE&&' , '&&pPREFSUC&&','&&pNUMCREDITO&&' , '&&pCUOTASENMORA&&' , '&&pVALORVENCIDO&&' , 
                    '&&pVALORXCUOTA&&' , '&&pVALORTOTALCREDITO&&' , '' , '&&pMONTO_CANCELADO&&' , '&&pJORNADA&&' , '&&pREFER&&', TO_DATE('&&pPERIODO&&','DD,MM,YYYY') , 
                    '&&pOPERACION&&', '&&pTIPOPAGO&&', '&&pEXAM&&','&&pRA&&','&&pPPEA&&',
                    '&&pAP&&', '&&pPNO&&', '&&pPPA&&', '&&pOPI&&', '&&pEPI&&', '&&pPPI&&', '&&pMRA&&', '&&pMPPA&&', '&&pPMI&&','&&pDED&&', '&&pPDED&&' );                    
                END;            
            ");
             * 
             */

            //Secuencia de documentos
            QueryMap.Add("SEC_MULTICRED", @"
                Select wms_s_MULTICRED.nextval from dual
           ");

            /*  //PAGOS DE CUOTAS MULTICREDITOS QUE SE REALIZARON EN LA JORNADA EXPERTB
              QueryMap.Add("PAGSCUOTSMULTICRED", @"
            SELECT W.REFERENCIA, W.CEDULA, W.NOMBRE, W.PREFIJOSUCURSAL, W.NUMCREDITO as NUM_RECIBO, W.MONTO_CANCELADO, W.PERIODO,W.NUMOPERACION,W.TIPOPAGO, W.VALORTOTALCREDITO  FROM WMS_MULTICRED_PAGOS W
           WHERE W.JORNADA = '&&pJORNADA&&' AND ANULADO_EL IS NULL ORDER BY REFERENCIA DESC        
             ");
              */

            //PAGOS DE CUOTAS MULTICREDITOS QUE SE REALIZARON EN LA JORNADA
            QueryMap.Add("PAGSCUOTSMULTICRED", @"
          SELECT W.REFERENCIA, W.CEDULA, W.NOMBRE, W.PREFIJOSUCURSAL, W.NUMCREDITO , W.MONTO_CANCELADO, W.PERIODO,W.NUMOPERACION,W.TIPOPAGO, W.VALORTOTALCREDITO  FROM WMS_MULTICRED_PAGOS W
         WHERE W.JORNADA = '&&pJORNADA&&' AND ANULADO_EL IS NULL ORDER BY REFERENCIA DESC        
           ");


            //ANULA la transaccion DE PAGO DE UNA CUOTA IMULTICREDITOS
            QueryMap.Add("WMS_P_ACUOTSMULTICRED", @"
                BEGIN                                     
                    EKO_P_ACUOTMULTICRED( '&&pPREFSUC&&' , '&&pNUMCREDITO&&' , '&&pREFER&&','&&pUSUARIO&&' );                    
                END;                
            ");

            //Materializa los instrumentos financieros del pedido
            QueryMap.Add("WMS_P_INSTRFINANC", @"
                BEGIN                                     
                    cred_p_instr_financ( '&&p_documento&&' );                    
                END;                
            ");


            //Valida los instrumentos financieros del pedido
            QueryMap.Add("ValINSTRFIPEDIDO", @"
                SELECT CRED_F_INSTFINANCIEROS( '&&p_documento&&' ) from dual
           ");

            //Valida los VOUCHER del pedido
            QueryMap.Add("ValVOUCHERPEDIDO", @"
                SELECT CRED_F_VALVOUCHER( '&&p_documento&&' ) from dual
           ");

            //Consulta los instrumentos financieros del pedido
            QueryMap.Add("INSTRFIPEDIDO", @"
                SELECT distinct(ID),INF_NOMBRE, INF_CODIGO from CRED_INST_FINANCIEROS_DETALLE WHERE DOCUMENTO = '&&p_documento&&' 
           ");

            //Almacena los datos enviados al proveedor al metodo solicitudcredito
            QueryMap.Add("ISOLCREDREQ", @"
            BEGIN 
              cred_P_ICUOTCREDREQ( '&&pPAIS&&','&&pESTADO&&','&&pFRECUENCIA&&','&&pCOMPANIA&&','&&pCEDULA&&','&&pPRESOLICITUD&&', 
             '&&pMONEDA&&','&&pPLAZO&&','&&pTASA&&','&&pIMPUESTO&&','&&pTIENDA&&','&&pINSTRUMENTO&&','&&pREFERENCIA&&','&&pUSUARIO&&',
             '&&pALIADO&&', '&&pMONTOORIGINAL&&','&&pMONTOSOLICITADO&&','&&pMONTOPRIMA&&','&&pSUBTOTAL&&','&&pJORNADA&&','&&pID&&' );
            END; 
           ");

            //Almacena los datos enviados al proveedor al metodo solicitudcredito
            QueryMap.Add("ISOLCREDRES", @"
            BEGIN 
              cred_P_ICUOTCREDRES( '&&pID&&', '&&pRES&&' );
            END; 
           ");

            //Seleciona la secuencia como id del intento
            QueryMap.Add("C_SEC_LOG_CREDITO", @"
                SELECT CRED_S_MULTREQ.nextval FROM dual
           ");

            //consulta los parametros iniciales para el WS de crediE
            QueryMap.Add("C_PWSC", @"
                SELECT cg_f_parameter_value ('MONM') as MONEDAC,CG_F_PARAMETER_VALUE('PAIM') as PAISC,
                cg_f_parameter_value ('COMM') as COMPANIAC,CG_F_PARAMETER_VALUE('ALIM') as ALIADOC ,
                cg_f_parameter_value ('TIEM') as TIENDAC,CG_F_PARAMETER_VALUE('USUM') as USUARIOC
                FROM DUAL 
            ");

            //consulta las condiciones del instrumento Financiero
            QueryMap.Add("C_DAIF", @"
               select TASA, PLAZO from CRED_INST_FINANCIEROS where INF_CODIGO = '&&p_IDFI&&'
            ");

            #endregion

            #region /*****************Western Union***********************/
            //Selecciona el fondo Disponible de Western Union
            QueryMap.Add("WU_FONDODISP", @"
                 SELECT 
                    WU_F_FONDODISPWU(&&pJORNADA&&) FROM DUAL
           ");


            //Selecciona los datos de ENVIOS Western Union
            QueryMap.Add("WU_ENVIOS", @"
                SELECT W.MTCN, W.ID, W.REMITENTE1,  
                    W.DESTINATARIO1,
                    W.TOTAL, 
                    W.MONEDA,MONTODOLARDIVISA, MONTOLOCALDIVISA, W.CREADO_EL
                FROM EKONO.WU_V_ENVIOS W
                WHERE TRIM(W.USUARIOEKONO) = '&&pUsuario&&' AND monedaoriginaltransacciontl <> 'LOCAL'  
                UNION ALL
                SELECT W.MTCN, W.ID, W.REMITENTE1,  
                    W.DESTINATARIO1,
                    TO_CHAR (ceil(TO_NUMBER(W.cargos) * TO_NUMBER(TASADECAMBIOFD) + w.MONTOORIGINALTRANSACCIONTL)) TOTAL, 
                    W.monedaoriginaltransacciontl MONEDA,MONTODOLARDIVISA, MONTOLOCALDIVISA, W.CREADO_EL
                FROM EKONO.WU_V_ENVIOS W
                WHERE TRIM(W.USUARIOEKONO) = '&&pUsuario&&' AND monedaoriginaltransacciontl = 'LOCAL' ORDER BY ID DESC
           ");

            //Selecciona los datos de PAGOS Western Union
            QueryMap.Add("WU_PAGOS", @"
                 SELECT 
                    W.MTCN,W.ID,W.DESTINATARIO1,W.DIRECCION1,  W.IDENTIFICACION, 
                   W.NUMEROID, W.REMITENTE1, W.MONTOORIGINALTRANSACCIONTL TOTAL, W.CREADO_EL
                FROM EKONO.WU_V_PAGOS W
                WHERE TRIM(W.USUARIOEKONO) = '&&pUsuario&&' ORDER BY ID DESC
           ");

            //Selecciona los datos de PAGOS Y ENVIOS Western Union para la reimpresion
            QueryMap.Add("WU_DATOS_REIMP", @"
                SELECT d.documento, d.no_documento recibo, s.MTCN ,upper(s.tipo) AS tipo,                     
                      s.id AS ID,                      
                      s.PAGO_COL Colones, s.PAGO_DOL Dolares
                 FROM wms_documentos d INNER JOIN wu_comp_envio s
                      ON d.documento = s.documento 
                      WHERE USUARIOEKONO = '&&pUsuario&&' AND d.JORNADA = &&pJornada&&                     
                      union all                      
                SELECT d.documento, d.no_documento recibo, s.MTCN ,upper(s.tipo) AS tipo,                     
                       s.id AS ID,
                       to_number(s.montooriginaltransacciontl) Colones, 0 Dolares
                 FROM wms_documentos d INNER JOIN wu_comp_PAGO s
                      ON d.documento = s.documento
                      WHERE USUARIOEKONO = '&&pUsuario&&' AND d.JORNADA = &&pJornada&&
                 ORDER BY RECIBO DESC
           ");

            //Selecciona los datos de PAGOS Y ENVIOS Western Union para el Arqueo de la Jornada
            QueryMap.Add("C_REPORTE_WU_ARQ", @"
                SELECT d.documento, d.no_documento recibo, upper(s.tipo) AS tipo, s.MTCN ,                     
                      s.id AS ID,
                      s.fecha || ' ' || s.hora AS fecha,
                      s.PAGO_COL Colones, s.PAGO_DOL Dolares,
                    ceil(TO_NUMBER(s.cargos) * TO_NUMBER(s.TASADECAMBIOFD) + s.MONTOORIGINALTRANSACCIONTL) TOTAL, 
                    s.monedaoriginaltransacciontl MONEDA
                 FROM wms_documentos d INNER JOIN wu_comp_envio s
                      ON d.documento = s.documento 
                      WHERE USUARIOEKONO = '&&pUsuario&&' AND d.JORNADA = &&pJornada&&  AND monedaoriginaltransacciontl = 'LOCAL'
                      union all
                 SELECT d.documento, d.no_documento recibo, upper(s.tipo) AS tipo, s.MTCN ,                     
                      s.id AS ID,
                      s.fecha || ' ' || s.hora AS fecha,
                      s.PAGO_COL Colones, s.PAGO_DOL Dolares, to_number( s.TOTAL) TOTAL, s.monedaoriginaltransacciontl MONEDA
                 FROM wms_documentos d INNER JOIN wu_comp_envio s
                      ON d.documento = s.documento 
                      WHERE USUARIOEKONO = '&&pUsuario&&' AND d.JORNADA = &&pJornada&&  AND monedaoriginaltransacciontl <> 'LOCAL'
                   union all
                 SELECT d.documento, d.no_documento recibo, upper(s.tipo) AS tipo, s.MTCN ,                     
                      s.id AS ID, 
                      s.fecha || ' ' || s.hora AS fecha,
                      to_number(s.montooriginaltransacciontl) Colones, 0 Dolares,to_number(s.montooriginaltransacciontl) TOTAL, 'LOCAL' MONEDA 
                 FROM wms_documentos d INNER JOIN wu_comp_PAGO s
                      ON d.documento = s.documento
                      WHERE USUARIOEKONO = '&&pUsuario&&' AND d.JORNADA = &&pJornada&&
                 ORDER BY RECIBO DESC
           ");

            //Copia los datos para la impresion de Envios 
            QueryMap.Add("WU_P_DENVIOS", @"
                BEGIN  
                   WU_p_ENVIOCOMP( &&pID&& ,  &&pDocumento&& , &&pCaja&& , '&&pUsuario&&' , &&pJornada&&, &&pPAGA_CON_COL&& , &&pPAGA_CON_DOL&& , &&pVUELTO_COL&& , &&pPAGO_COL&& , &&pPAGO_DOL&&  ); 
                END;                
            ");

            //Copia los datos para la impresion de PAGOS 
            QueryMap.Add("WU_P_DPAGOS", @"
                BEGIN                                     
                   WU_p_PAGOCOMP( &&pID&& ,  &&pDocumento&& , &&pCaja&& , '&&pUsuario&&' , &&pJornada&& );
                END;                
            ");

            //Aumentar el número de impresiones del comprobante
            QueryMap.Add("WU_P_CANTIMP", "BEGIN WMS_P_CantidadIMPRWU(&&pDOCUMENTO&&, &&pTABLA&&); END;");

            //Anula el ENVIO
            QueryMap.Add("WU_P_AENVIOS", @"
                BEGIN                                     
                   WU_p_ENVIOCOMPELI( &&pID&& , '&&pUsuario&&');
                END;                
            ");


            //Anula el PAGO 
            QueryMap.Add("WU_P_APAGOS", @"
                BEGIN                                    
                   WU_p_PAGOCOMPELI( &&pID&& , '&&pUsuario&&');
                END;                
            ");

            //Verifica si ya fue facturado el envio
            QueryMap.Add("WU_ESTADO_TRA_E", @"
                Select WU_F_EST_TRA_ENVIO(&&pID&&) from dual
           ");

            //Verifica si ya fue facturado el pago
            QueryMap.Add("WU_ESTADO_TRA_P", @"
                Select WU_F_EST_TRA_PAGO(&&pID&&) from dual
           ");

            //Verifica si ya fue ANULADO el envio
            QueryMap.Add("WU_ESTADO_TRA_EA", @"
                Select WU_F_EST_TRA_ENVIOE(&&pID&&) from dual
           ");

            //Verifica si ya fue ANULADO el pago
            QueryMap.Add("WU_ESTADO_TRA_PA", @"
                Select WU_F_EST_TRA_PAGOE(&&pID&&) from dual
           ");

            //Parametros WU
            QueryMap.Add("C_PWU", @"
              SELECT WU_F_TIPCAMBIO_DOLR_C, cg_f_parameter_value('CIWU')
                FROM DUAL              
            ");

            //Selecciona los datos de los Fondos 
            QueryMap.Add("WU_FONDOS", @"
                SELECT 
                    IDFONDO, MONTO
                    FROM WU_FONDOS
                    WHERE JORNADA = &&pJORNADA&& AND ANULADO_POR IS NULL AND TIPO = 'I' ORDER BY IDFONDO DESC
           ");

            //Selecciona los datos de los Fondos 
            QueryMap.Add("WU_SFONDOS", @"
                SELECT 
                    IDFONDO, MONTO
                    FROM WU_FONDOS
                    WHERE JORNADA = &&pJORNADA&& AND ANULADO_POR IS NULL AND TIPO = 'S' ORDER BY IDFONDO DESC
           ");

            //Selecciona los datos de un fondo
            QueryMap.Add("WU_FONDO", @"
                SELECT TO_CHAR(IDFONDO) IDFONDO, MONTO, TO_CHAR(JORNADA) JORNADA,TO_CHAR(CAJA) CAJA,(SELECT NIT FROM WMS_EMPRESAS) EMPRESA, CREADO_EL FECHA
                    FROM WU_FONDOS
                    WHERE IDFONDO = &&pIDFondo&&
           ");

            //Selecciona los datos de un fondo
            QueryMap.Add("WU_SFONDO", @"
                SELECT TO_CHAR(IDFONDO) IDFONDO, MONTO, TO_CHAR(JORNADA) JORNADA,TO_CHAR(CAJA) CAJA,(SELECT NIT FROM WMS_EMPRESAS) EMPRESA, CREADO_EL FECHA
                    FROM WU_FONDOS
                    WHERE IDFONDO = &&pIDFondo&&
           ");

            //Almacena un ingreso al Fondo 
            QueryMap.Add("WU_P_AFONDOS", @"
                BEGIN                                    
                   WU_p_AFONDOS( &&pID&&,'&&pUsuario&&',&&pJORNADA&&, &&pMONTO&&, &&pCAJA&& );
                END;                
            ");

            //Eliminar un ingreso al Fondo 
            QueryMap.Add("WU_P_EFONDOS", @"
                BEGIN                                    
                   WU_p_EFONDOS( &&pID&&,'&&pUSUARIO&&');
                END;                
            ");

            //Almacena una salida de un Fondo 
            QueryMap.Add("WU_P_ASFONDOS", @"
                BEGIN                                    
                   WU_p_ASFONDOS( &&pID&&,'&&pUsuario&&',&&pJORNADA&&, &&pMONTO&&, &&pCAJA&& );
                END;                
            ");

            //Eliminar la salida de un Fondo 
            QueryMap.Add("WU_P_ESFONDOS", @"
                BEGIN                                    
                   WU_p_ESFONDOS( &&pID&&,'&&pUSUARIO&&');
                END;                
            ");

            #endregion

            #region /*****************Marchamos***********************/
            //Selecciona los datos de pagos 
            QueryMap.Add("AM_RECIBOS", @"
                SELECT 
                A.ID, A.MONTO, 
                A.NOMBRECLIENTE, A.DESCRIPCION, A.NO_PROVE, 
                A.REFERENCIA, A.EMPRESA, A.MONEDA, A.CREADO_EL
                FROM AM_V_RECIBOS_PENDIENTES A
                    WHERE CAJERO = '&&pUsuario&&' ORDER BY ID DESC              
           ");

            //selecciona el sku_alterno del producto marchamo
            QueryMap.Add("C_PAM", @"
                SELECT cg_f_parameter_value ('SAMA') as MARCHAMO_SKU_ALT
                FROM DUAL                
            ");

            //Selecciona el cliente Marchamos
            QueryMap.Add("C_CliMarchams", @"
                 SELECT NVL(cg_f_parameter_value ('SCMA'),'0') FROM dual
           ");

            //Almacena el socio cliente Marchamos
            QueryMap.Add("WMS_ASocioMarchams", @"
                BEGIN
                    wms_ASocioMarchams('&&pDOCUMENTO&&','&&pEMPRESA&&');                    
                END;                
            ");

            // Almacena el recibo
            QueryMap.Add("AM_P_RECIBO", @"
                BEGIN
                    AM_P_RECIBO(&&pDocumento&&, &&pDoc_padre&&, &&pCaja&&, &&pSocio&&, '&&pUsuario&&', &&pTotal&&, &&pJornada&&);                    
                END;                
            ");

            // Almacena un tipo de pago del recibo
            QueryMap.Add("AM_P_RECIBO_TIPO_PAGO", @"
                BEGIN
                    AM_P_RECIBO_TIPO_PAGO(&&pDOCUMENTO&&, &&pLINEA&&, &&pTIPO_PAGO&&, &&pVALOR&&, &&pEMISOR&&,
                        '&&pTARJETA&&', '&&pAUTORIZACION&&', &&pPAGADO&&, &&pMONEDA&&, &&pTASA_CAMBIO&&, &&pVALOR_MONEDA&&);                    
                END;                
            ");


            // Actualiza el estado del recibo y/o asigna el documento padre del recibo
            QueryMap.Add("AM_P_REC_CAMBIO_ESTADO", @"
                BEGIN
                    AM_P_REC_CAMBIO_ESTADO(&&pID&&, '&&pESTADO&&', &&pDOCUMENTO&&);                    
                END;                
            ");

            // Actualiza el campo que indica el número de reimpresiones del recibo
            QueryMap.Add("AM_P_INDICA_REIMPRESION", @"
                BEGIN
                    AM_P_INDICA_REIMPRESION(&&pDOCUMENTO&&);                    
                END;                
            ");

            // Anula el recibo del marchamo
            QueryMap.Add("AM_P_ANUL_RECIBO", @"
                BEGIN
                    AM_P_ANUL_RECIBO(&&pDOCUMENTO&&, &&pID&&, '&&pUSUARIO&&');                    
                END;                
            ");

            // Inserta los datos de un recibo manual
            QueryMap.Add("AM_P_ING_MANUAL_REC", @"
                BEGIN
                    AM_P_ING_MANUAL_REC(&&pID&&, '&&pCAJA&&', '&&pCAJERO&&', &&pMONTO&&, 
                        '&&pNO_PROVE&&', '&&pAUTORIZADO_POR&&');                    
                END;                
            ");


            //Selecciona los datos de los recibos pagados 
            QueryMap.Add("AM_V_RECIBOS_COBRADOS", @"
                SELECT 
                    ID, DOCUMENTO, RECIBO,
                    NOMBRECLIENTE, MONTO, NO_PROVE, 
                    REFERENCIA, EMPRESA, MONEDA, CREADO_EL, DOCUMENTO_PADRE
                    FROM AM_V_RECIBOS_COBRADOS A
                    WHERE JORNADA = &&pJORNADA&& ORDER BY ID DESC              
           ");

            //Selecciona los datos para el reporte de marchamos
            QueryMap.Add("AM_V_REPORTE_MARCHAMOS", @"
                SELECT JORNADA, CAJA, CREADO_EL, NO_PROVE, RECIBO, MONTO, NOMBRECLIENTE
                    FROM AM_V_REPORTE_MARCHAMOS
                    WHERE JORNADA = &&pJORNADA&& AND COD_ESTADO = '&&pCOD_ESTADO&&' ORDER BY ID DESC              
           ");

            #endregion

            #region /********************RapiBAC***************************/
            //Verifica si está abierta la jornada 
            QueryMap.Add("ESTADO_TERMINAL", @"
                SELECT COUNT(1) FROM WMS_JORNADAS_BAC WHERE JORNADA = '&&pJornada&&' AND FECHA_CIERRE IS NULL
            ");

            //Obtiene el número de terminal de la caja
            QueryMap.Add("TERMINAL_BAC", @"
                SELECT TERMINALNUMBER FROM WMS_DATOS_EMISORES WHERE MERCHANT = 'EKONOBAC' AND CAJA = '&&pCaja&&'
            ");

            //Parametros RapiBAC
            QueryMap.Add("C_BAC", @"
              SELECT MERCHANTNUMBER AS TERMINAL, USERNAME, KEY AS PASSWORD, cg_f_parameter_value('CIBC'),  cg_f_parameter_value('CTBC')
                FROM WMS_DATOS_EMISORES 
              WHERE MERCHANT = 'EKONOBAC' AND CAJA = '&&pCaja&&'
            ");

            //Consultar instituciones
            QueryMap.Add("C_INST_BACSERV", @"
                SELECT W.NEMPRESA, W.CNOMBREEMPRESA FROM WMS_BACSERV_EMPRESAS W ORDER BY W.CNOMBREEMPRESA
           ");

            //Consultar convenios por empresa
            QueryMap.Add("C_CONV_BACSERV", @"
                SELECT W.NCONVENIO, W.NEMPRESA, W.CNOMBCONV FROM WMS_BACSERV_CONVENIOS W WHERE
                W.NEMPRESA = &&pEmpresa&& ORDER BY W.CNOMBCONV
            ");

            //Consultar llaves por convenio
            QueryMap.Add("C_LLAVE_BACSERV", @"
                SELECT W.NEMPRESA, W.NCONVENIO, W.NTIPOLLAVE, W.CDESCRIPCION FROM EKONO.WMS_BACSERV_LLAVES W WHERE 
                W.NEMPRESA = &&pEmpresa&& AND W.NCONVENIO = &&pConvenio&& ORDER BY W.CDESCRIPCION
            ");

            //Usuario y clave de Ekono del Bac
            QueryMap.Add("BACREFCODES", @"
               select VALUE from cg_parameters where parameter = '&&pParam1&&'
            ");

            //Transacción y nombre de descripción
            QueryMap.Add("TRANSAC_BAC", @"
               select RV_LOW_VALUE || '+' || RV_HIGH_VALUE  || '+' || RV_MPCC01 transaccion from CG_REF_CODES 
               where rv_domain = 'TRANSACCIONES BAC' and rv_abbreviation = '&&pParam1&&'
            ");

            //Transacción y nombre de descripción
            QueryMap.Add("C_TIDENTIF_BAC", @"
               select RV_LOW_VALUE ID, RV_MEANING TIPOID from CG_REF_CODES where rv_domain = 'TIPO IDENTIFICACION'
            ");

            //Consulta el reporte de los recibos generados en la jornada y caja específica
            QueryMap.Add("C_REPORTE_RECIBOS_BAC", @"
                 SELECT to_char(S.FECHA,'dd/mm/yyyy hh:mi:ss a.m.') as FECHA, S.NUM_SERVICIO AS NUMERO,  S.MONTO , 
                 D.NO_DOCUMENTO AS RECIBO, S.TRANS_PROVEEDOR, D.DOCUMENTO, S.OPERADOR, S.TIPO_SERVICIO 
                 FROM WMS_DOCUMENTOS D INNER JOIN WMS_PAGUE_SERVICIOS S  ON D.DOCUMENTO = S.DOCUMENTO
                 WHERE D.DOCUMENTO IN (SELECT DOCUMENTO FROM WMS_DOCUMENTOS W where W.JORNADA = &&pJornada&& 
                 AND W.CAJA = &&pCaja&&) AND S.TIPO_SERVICIO = '05' ORDER BY S.FECHA DESC
           ");

            //Inserta lo que se pregunta al webservice en la tabla local
            QueryMap.Add("insertaReqRapiBac", @"
            INSERT INTO WMS_BACSERV_REQ_XML(NCONSE_DOC, CCLIENTE, CTARJETA, NEMPRESA, NCONVENIO, NTIPOLLAVE, CXML, CJORNADA, DFECHA, CUSUARIO)
                                 VALUES('&&pConsecutivo&&', '&&pCliente&&', '&&pTarjeta&&', '&&pEmpresa&&', '&&pConvenio&&', '&&pTipoLlave&&', '&&pXML&&', 
                                        '&&pJornada&&', SYSDATE,'&&pUsuario&&')");

            //Inserta lo que se pregunta al webservice en la tabla local
            QueryMap.Add("insertaReqBac", @"
            BEGIN
                EKO_P_IBACSERVREQ('&&pConsecutivo&&', '&&pCodAgencia&&', '&&pEmpresa&&', '&&pConvenio&&', '&&pIdentificacion&&', 
                                  '&&pTotal&&', '&&pFechaVto&&', '&&pNumFactura&&', '&&pCodMoneda&&', '&&pLlave&&', 
                                  '&&pNombreEmpresa&&', '&&pNombreConvenio&&', '&&pCliente&&', '&&pNombreLlave&&', '&&pJornada&&',
                                  '&&pNumTarjeta&&', '&&pTipoIdentificacion&&', '&&pTrack2&&', '&&pMonedaPago&&', '&&pMonedaSaldo&&','&&pSecInvoice&&','&&pSecBAC&&');
            END;");

            //Inserta lo que se pregunta al webservice en la tabla local
            QueryMap.Add("insertaResaBac", @"
            BEGIN
                EKO_P_IBACSERVRESA('&&pConsecutivo&&', '&&pSystemTraceNumber&&', '&&pTerminal&&', '&&pLote&&', '&&pRef&&', 
                                   '&&pFecha&&', '&&pHora&&', '&&pAutorizacion&&', '&&pNumTarjeta&&', &&pMontoTransac&&, 
                                   &&pMontoConvers&&, '&&pTipoCambio&&', '&&pTipoPago&&', &&pVuelto&&, '&&pDescConcep&&', '&&pValorConcep&&',  
                                   '&&pTipo&&', '&&pCreadoPor&&', '&&pTipoSaldo&&',&&pMontoRecibido&&);
            END;");

            //Inserta la respuesta del webservice en la tabla local
            QueryMap.Add("insertaResRapiBac", @"    
            INSERT INTO WMS_BACSERV_RES_XML(NCONSE_DOC, CCLIENTE, CTARJETA, CSTATUS, CDESCRIPCION, NSYSTEMTRACENUMBER, CXML, CJORNADA, DFECHA, CUSUARIO)
                                 VALUES('&&pConsecutivo&&', '&&pCliente&&', '&&pTarjeta&&', '&&pEstatus&&', '&&pDescripcion&&', '&&pSystemTraceNumber&&',
                                        '&&pXML&&', '&&pJornada&&', SYSDATE,'&&pUsuario&&')");

            //Inserta la respuesta del webservice en la tabla local
            QueryMap.Add("insertaResERapiBac", @"    
            INSERT INTO WMS_BACSERV_ERRORES(NCONSE_DOC, CERROR, DFECHA)
                                 VALUES('&&pConsecutivo&&', '&&pXML&&', SYSDATE)");
            //Inserta la jornada nueva
            QueryMap.Add("insertaRegTermBac", @"  
            INSERT INTO WMS_JORNADAS_BAC(JORNADA, FECHA_APERTURA, CREADO_POR)VALUES('&&pJornada&&', SYSDATE, '&&pUsuario&&')");

            //Cerrar la jornada nueva
            QueryMap.Add("ACT_TARJ_BAC", @"    
            UPDATE WMS_JORNADAS_BAC SET FECHA_CIERRE = SYSDATE WHERE JORNADA = '&&pJornada&&'");

            //Crea el recibo BACServicios Response
            QueryMap.Add("WMS_P_RECIBOBACSERV", @"
                BEGIN
                     EKO_P_RECIBOBACSERV(&&pDocumento&&,&&pCaja&&,'&&pUsuario&&',&&pTotal&&,&&pJornada&&,'&&pIdTRans&&','&&pProveedor&&','&&pOperador&&');
                END;                
            ");

            //Secuencia de documentos
            QueryMap.Add("SEC_DOC_BAC_RES", @"
                Select WMS_S_BACRES.nextval from dual
           ");

            //Secuencia de documentos
            QueryMap.Add("SEC_BACCOMPR", @"
                Select wms_s_BACCOMPR.nextval from dual
           ");

            //Consulta el reporte de los SERVICIOS PAGADOS generados en la jornada y caja específica
            QueryMap.Add("C_REPORTE_BACSERV_ARQ", @"                    
               SELECT  * FROM wms_v_resumen_jornada WHERE JORNADA='&&pJornada&&'
           ");

            //Selecciona el request por comprobante
            QueryMap.Add("REQ_X_COMPR_BAC", @"
                  SELECT  REQ.NNUMCOMPROBANTE, REQ.NCODBANCO, REQ.CCODAGENCIA, REQ.STRTIPOCANAL, REQ.NCODEMPRESA,
                          REQ.NCODCONVENIO, REQ.STRVALORSERV, REQ.STRPERIODO, REQ.DTFECHAVTO,
                          REQ.STRNUMFACTURA, REQ.NSELFVERIFIC, REQ.STRCODMONEDA, REQ.NNUMCUOTAS, REQ.ARRTPAGO_NMONTOT,
                          REQ.STRRECIBO, REQ.NTIPOLLAVE, REQ.INSTITUCION, REQ.CONVENIO, REQ.CLIENTE,
                          REQ.LLAVE, REQ.JORNADA, REQ.CNUMTARJETA, REQ.CTIPOIDENTIF, REQ.CTRACK2,
                          REQ.CMONEDAPAGO, REQ.CMONEDASALDO, RESA.NMONTO_TRANSAC, RESA.CSYSTEMTRACERNUMBER
                  FROM    WMS_BACSERV_REQ REQ, WMS_BACSERV_RES_A RESA
                  WHERE   REQ.NNUMCOMPROBANTE = &&pCOMPR&&
                          AND REQ.NNUMCOMPROBANTE = RESA.NNUMCOMPROBANTE          
            ");

            //Selecciona los datos para reversion
            QueryMap.Add("REV_COMPR_BAC", @"
                  SELECT    REQ.CMONEDAPAGO, RESA.NMONTO_TRANSAC, REQ.CMONEDASALDO, REQ.CTRACK2, REQ.CTIPOIDENTIF, 
                            REQ.STRVALORSERV, RESA.CSYSTEMTRACERNUMBER 
                  FROM      WMS_BACSERV_REQ REQ, WMS_BACSERV_RES_A RESA
                  WHERE     REQ.NNUMCOMPROBANTE = &&pCOMPR&&
                            AND REQ.NNUMCOMPROBANTE = RESA.NNUMCOMPROBANTE
            ");

            //Tipos de moneda para transacciones RapiBAC
            QueryMap.Add("C_MONEDA_CAMBIO", @"
               select RV_LOW_VALUE ID, RV_MEANING TIPOID from CG_REF_CODES where rv_domain = 'MONEDA' and RV_LOW_VALUE <= 2
            ");


            //Tipos de moneda para transacciones RapiBACretiro
            QueryMap.Add("C_MONEDA_CAMBIOretiro", @"
               select RV_LOW_VALUE ID, RV_MEANING TIPOID from CG_REF_CODES where rv_domain = 'MONEDA' and RV_LOW_VALUE = 1
            ");

            //Retorna la conversión del tipo de cambio
            QueryMap.Add("CONV_TIPO_CAMBIO", @"
                SELECT EKO_F_CONVERSION(&&pTipoPago&&, &&pTipoSaldo&&, &&pTipoCambio&&, &&pMonto&&, &&pMontoPagado&&) FROM DUAL
            ");

            // SEGMENTO DE DEPOSITOS

            #region Secuencia Invoice de RapiBac
            QueryMap.Add("SEC_SECRAPI", @"
                SELECT WMS_S_BAC_INVOICE.NEXTVAL FROM DUAL
           ");
            #endregion

            #region Secuencia Invoice secuence de RapiBac
            QueryMap.Add("SEC_SECRAPIsec", @"
                SELECT WMS_S_BAC_SEC.NEXTVAL FROM DUAL
           ");
            #endregion

            #region Secuencia Invoice de RapiBac
            QueryMap.Add("SEC_SECTC", @"
               select EWS_S_SECUENCIA_TC.NEXTVAL from dual
           ");
            #endregion

            //Parametros RapiBAC
            #region C_tiposCambio
            QueryMap.Add("C_tiposCambio", @"
                SELECT EKO_F_RAPIBAC_DOLAR_VENTA as VENTA,
                EKO_F_RAPIBAC_DOLAR_COMPRA AS COMPRA
                FROM DUAL                           
            ");
            #endregion

            #region WMS_P_REVERSA_TRANS
            QueryMap.Add("WMS_P_REVERSA_TRANS", @"
                BEGIN
                     EKO_P_ANULATRANSACCION_BAC('&&pNumComprobante&&','&&pDocumento&&','&&pTransProveedor&&','&&pUsuario&&','&&pJornada&&','&&pTC&&');
                END;                
            ");
            #endregion

            #region WMS_P_REVERSA_TRANSTIMEOUT
            QueryMap.Add("WMS_P_REVERSA_TRANSTIMEOUT", @"
                BEGIN
                     EKO_P_ANULA_BACtimeout('&&pInvoice&&','&&pSecBac&&','&&pTotalTras&&','&&pMontoMoneda&&','&&pTI&&','&&pNumCedula&&','&&pJornada&&','&&pConvenio&&','&&pTipoCuenta&&','&&pMonedaSaldo&&','&&pTarjeta&&');
                END;                
            ");
            #endregion


            #region insertaResaBacDepositos
            QueryMap.Add("insertaResaBacDepositos", @"
            BEGIN
                EKO_P_IBACSERVRESADEPOSITOS('&&pConsecutivo&&', '&&pSystemTraceNumber&&', '&&pTerminal&&', '&&pLote&&', '&&pRef&&', 
                                   '&&pFecha&&', '&&pHora&&', '&&pAutorizacion&&', '&&pNumTarjeta&&', '&&pMontoTransac&&', 
                                   '&&pMontoConvers&&', '&&pTipoCambio&&', '&&pTipoPago&&','&&pVuelto&&', '&&pDescConcep&&', '&&pValorConcep&&',  
                                   '&&pTipo&&', '&&pCreadoPor&&', '&&pTipoSaldo&&','&&pMontoRecibido&&','&&pPagoCol&&','&&pPagoDol&&','&&pMonedaCuenta&&',
                                     '&&pVenta&&','&&pCompra&&','&&psecMC&&');
            END;");
            #endregion



            #region insertaResaBacRetiros
            QueryMap.Add("insertaResaBacRetiros", @"
            BEGIN
                EKO_P_IBACSERVRESARETIRO('&&pConsecutivo&&', '&&pSystemTraceNumber&&', '&&pTerminal&&', '&&pLote&&', '&&pRef&&', 
                                   '&&pFecha&&', '&&pHora&&', '&&pAutorizacion&&', '&&pNumTarjeta&&', '&&pMontoTransac&&', 
                                   '&&pMontoRetiro&&', '&&pTipoCambio&&', '&&pTipoPago&&','&&pVuelto&&', '&&pDescConcep&&', '&&pValorConcep&&',  
                                   '&&pTipo&&', '&&pCreadoPor&&', '&&pTipoSaldo&&','&&pMontoRecibido&&','&&pPagoCol&&','&&pPagoDol&&','&&pMonedaCuenta&&',
                                     '&&pVenta&&','&&pCompra&&','&&psecMC&&');
            END;");
            #endregion



            #region CONV_TIPO_CAMBIO_DEPOSITOS

            QueryMap.Add("CONV_TIPO_CAMBIO_DEPOSITOS", @"
                  SELECT EKO_F_CONVER_DEPOSITOS('&&pTipoPago&&','&&pMonto&&','&&pMontoPagado&&','&&pConversionBac&&') FROM DUAL
           ");
            #endregion

            #region insertaTipoCambio
            //Crea el recibo Tipo Cambio
            QueryMap.Add("insertaTipoCambio", @"
                BEGIN 
                     EKO_P_RECIBOTIPO_CAMBIO('&&pDOCUMENTO&&','&&pUsuario&&','&&pMONTO&&','&&pTIPO_CAMBIO&&','&&pCONVERSION&&','&&pVUELTO&&','&&pCAJERO&&','&&pJORNADA&&','&&pTIPO_MONEDA&&');
                END;                
            ");
            #endregion

            #region anulaMesaCambio
            // anula mesa de cambio 
            //Crea el recibo Tipo Cambio
            QueryMap.Add("anulaMesaCambio", @"
                BEGIN 
                     EKO_P_ANULA_MESACAMBIO('&&pDOCUMENTO&&','&&pCAJERO&&');
                END;                
            ");
            #endregion

            #region DATOIMP_DEPO
            //Secuencia de documentos
            QueryMap.Add("DATOIMP_DEPO", @"
                SELECT * FROM wms_v_for_imp_depo WHERE DOCUMENTO = '&&pDoc&&'
           ");
            #endregion


            #region DATOIMP_DEPO
            //Secuencia de documentos
            QueryMap.Add("DATOIMP_RETI", @"
                SELECT * FROM wms_v_for_imp_reti WHERE DOCUMENTO = '&&pDoc&&'
           ");
            #endregion


            #region DATOIMP_TC
            //Secuencia de documentos
            QueryMap.Add("DATOIMP_TC", @"
                  SELECT COMPROBANTE,NOMBRE_CLIENTE,a.MONTO,TIPO_CAMBIO,CONVERSION,VUELTO,a.FECHA,CAJERO,BODEGA
                  FROM WMS_CAMBIO_DIVISAS_BAC a
                  WHERE COMPROBANTE='&&pDoc&&'
                           ");
            #endregion

            #region DATOIMP_REVERSA
            //Secuencia de documentos
            QueryMap.Add("DATOIMP_REVERSA", @"
              SELECT A.NNUMCOMPROBANTE AS RECIBO_INTERNO, TRANS_PROVEEDOR AS NUM_RECIBO_ANULADO_PROV, ANULADO_EL,A.ANULADO_POR,
               A.JORNADA,CONVENIO AS SERVICIO,NMONTOTOTAL AS MONTO
              FROM WMS_BACSERV_ANULACION A, WMS_BACSERV_REQ E
              WHERE A.NNUMCOMPROBANTE='&&pDoc&&'
              AND E.NNUMCOMPROBANTE= A.NNUMCOMPROBANTE
               ");
            #endregion



            #region TRANSAC_BACREVERSA
            //Selecciona los datos para reversion/ CONSULTA DE REVERSIONES POR JORNADA
            QueryMap.Add("TRANSAC_BACREVERSA", @"

          SELECT    REQ.CMONEDAPAGO, RESA.CMONTO_TRANSAC, REQ.CMONEDASALDO, REQ.CTRACK2 AS TARJETA, REQ.CTIPOIDENTIF, 
                    REQ.STRVALORSERV AS CEDULA, RESA.CSYSTEMTRACERNUMBER AS RECIBO_PROVEEDOR, REQ.CSEC_INVOICE,REQ.NNUMCOMPROBANTE AS NUM_COMPROBANTE,E.DOCUMENTO,
            CASE REQ.cmonedapago WHEN '1' THEN 'C ' || RESA.cmonto_transac ELSE '$' || RESA.cmonto_transac END MONTO_RECIBO, A.SERIE ||'-'|| A.NO_DOCUMENTO AS RECIBO,
           REQ.NCODEMPRESA,REQ.NCODCONVENIO,REQ.NTIPOLLAVE,REQ.CLIENTE,CONVENIO,RESA.CMONTO_CONVERS,
            CASE RESA.TIPO_CUENTA WHEN 'valor' 
            then 'retiro'  else RESA.TIPO_CUENTA end TIPO_CUENTA,
             NVL((SELECT COMPROBANTE_TC FROM WMS_CAMBIO_DIVISAS_BAC WHERE COMPROBANTE=COMPROBANTE_TC ),0) AS MESA,CSEC_BAC                       
                  FROM      WMS_BACSERV_REQ REQ, WMS_BACSERV_RES_A RESA,WMS_PAGUE_SERVICIOS E,WMS_DOCUMENTOS A
                  WHERE     REQ.NNUMCOMPROBANTE = RESA.NNUMCOMPROBANTE                 
                  AND       REQ.JORNADA='&&pJORNADA&&'  
                  AND       E.TRANS_PROVEEDOR= TO_CHAR(REQ.NNUMCOMPROBANTE)
                  AND       E.TRANS_PROVEEDOR=TO_CHAR(RESA.NNUMCOMPROBANTE)
                  AND       A.DOCUMENTO= E.DOCUMENTO ORDER BY NUM_COMPROBANTE DESC
            ");
            #endregion

            #region CMONTO_MAX
            //Secuencia de documentos
            QueryMap.Add("CMONTO_MAX", @"
                SELECT VALUE FROM CG_PARAMETERS WHERE PARAMETER='&&CMONTO_MAX&&'
               union all
                SELECT VALUE FROM CG_PARAMETERS WHERE PARAMETER='&&CMONTORETIRO_MAX&&'
             ");
            #endregion

            #region WU_FONDODISPRAPIBAC
            //Secuencia de documentos
            QueryMap.Add("WU_FONDODISPRAPIBAC", @"
                    SELECT  WU_F_FONDODISPWU(&&pJORNADA&&)AS MONTO FROM DUAL
                     union all
                    SELECT f_f_efectivocaja(&&pJORNADA&&) AS MONTO FROM DUAL
                     union all
                    SELECT f_f_efectivocajaDolares(&&pJORNADA&&) AS MONTO FROM DUAL
             ");
            #endregion


            #endregion

            //FIN////

            #region  /*   - - Davivienda - -  */
            //Obtiene la secuencia de números para la tabla EKONO.DAVIVIENDA_TRAN
            QueryMap.Add("GetId_DAV_TRAN", "SELECT SEQ_DAVIVIENDA_TRAN.NEXTVAL FROM DUAL");

            //Obtiene la secuencia de números para la tabla EKONO.DAVIVIENDA_LOG
            //QueryMap.Add("GetId_DAV_LOG", "SELECT SEQ_DAVIVIENDA_LOG.NEXTVAL FROM DUAL");

            //Registra Transacción de Davivienda
            QueryMap.Add("Add_DAV_TRAN", @"BEGIN ADD_DAVIVIENDA_TRAN( &&p_N_ID&&, 
                                                                     '&&p_C_CEDULA&&', 
                                                                     '&&p_C_TIPO_TRANS&&',
                                                                      &&p_N_MONTO&&,
                                                                     '&&p_C_TARJETA&&',
                                                                     '&&p_C_CUENTA&&',
                                                                     '&&p_C_MONEDA&&',
                                                                     '&&p_C_ESTADO&&',
                                                                      &&p_N_REPORTE&&,
                                                                     '&&p_C_COMENTARIO&&'
                                                                    );
                                            END;");

            //Registra el Log de Davivienda
            QueryMap.Add("Add_DAV_LOG", @"BEGIN ADD_DAVIVIENDA_LOG(   &&p_N_ID_DAVIVIENDA_TRAN&&, 
                                                                     '&&p_C_REQ_RES&&', 
                                                                     '&&p_C_ESTADO&&',
                                                                     '&&p_C_USUARIO&&',
                                                                     '&&p_C_JORNADA&&',
                                                                    );
                                            END;");


            #endregion


            #region  /*   - - Zunify - -  */

            //Obtiene la secuencia de números para la tabla EKONO.SEQ_ZUNIFY_TRAN
            QueryMap.Add("GetId_ZUN_TRAN", "SELECT SEQ_ZUNIFY_TRAN.NEXTVAL FROM DUAL");

            //Registra Transacción de Zunify
            QueryMap.Add("Add_ZUN_TRAN", @"BEGIN ADD_ZUNIFY_TRAN( &&p_N_ID&&, 
                                                                 '&&p_C_ESTADO&&',
                                                                  &&p_N_MONTO&&,
                                                                 '&&p_C_CARGO&&',
                                                                 '&&p_C_MONEDA&&',
                                                                 '&&p_C_TERMINAL&&',
                                                                  &&p_N_DOCUMENTO&&
                                                                    );
                                            END;");

            //Registra Log de Zunify
            QueryMap.Add("Add_ZUN_LOG", @"BEGIN ADD_ZUNIFY_LOG( &&p_N_ID_ZUNIFY_TRAN&&,
                                                               '&&p_C_REQ_RES&&',
                                                               '&&p_C_ESTADO&&',
                                                               '&&p_C_USUARIO&&',
                                                               '&&p_C_JORNADA&&' 
                                                                    );
                                            END;");

            //Actualiza Estado de Transacción de Zunify
            QueryMap.Add("Upt_ZUN_TRAN", @"BEGIN UPDATE_ZUNIFY_TRAN( 
                                                                 '&&p_C_ESTADO&&',
                                                                 '&&p_C_CARGO&&'
                                                                    );
                                            END;");

            //Actualiza Pedudi Transacción de Zunify
            QueryMap.Add("Upt_ZUN_TRANDOCU", @"BEGIN UPDATE_ZUNIFY_TRANDOCU( 
                                                                 '&&p_C_CARGO&&',
                                                                 &&p_N_DOCUMENTO&&
                                                                    );
                                            END;");

            //Obtener Transacción de Zunify
            QueryMap.Add("Get_ZUN_TRAN", @"SELECT * FROM EKONO.ZUNIFY_TRAN WHERE C_CARGO = '&&p_C_CARGO&&'");

            //Obtener lista de las últimas 20 transacción de Zunify de una terminal en especial
            QueryMap.Add("Get_ZUN_TRAN_LIST", @"SELECT *
                                                FROM (SELECT * FROM EKONO.ZUNIFY_TRAN WHERE C_TERMINAL = '&&p_C_TERMINAL&&' ORDER BY N_ID DESC )
                                                WHERE ROWNUM <= 20
                                                ORDER BY ROWNUM");
            
            //Obtener Código de Terminal de Zunify
            QueryMap.Add("Get_ZUN_TERMCODE", @"SELECT * FROM EKONO.ZUNIFY_TERMINALS WHERE C_CODE_CAJA = '&&p_C_CODE_CAJA&&' AND C_SUCE_TIENDA = '&&p_C_SUCE_TIENDA&&'");


            //Valida si existe un documento con el mismo numero de pedido pero sin factura
            QueryMap.Add("Get_ZUN_VALIDAPEDIDO", @"SELECT COUNT(DOCUMENTO) FROM WMS_DOCUMENTOS WHERE DOCUMENTO_PADRE = &&p_C_DOCUMENTO_PADRE&&");

            //Valida si existe un documento con el mismo numero de pedido pero sin factura
            QueryMap.Add("Get_ZUN_TRANESTADO", @"SELECT C_ESTADO FROM EKONO.ZUNIFY_TRAN WHERE C_CARGO = '&&p_C_CARGO&&'");
            

            #endregion

            //FIN//

            #region /***************** Club PLUS ***********************/
            //valida si tienes un artículo de la membresia PLUS
            QueryMap.Add("VALIDAPLUSPEDIDO", @"
                SELECT PLUS_F_VALPEDIDO(&&P_DOCUMENTO&&) FROM DUAL
            ");

            //cantidad de artículo de la membresia PLUS
            QueryMap.Add("PLUSCARTPEDIDO", @"
                SELECT PLUS_F_CARTPEDIDO(&&P_DOCUMENTO&&) FROM DUAL
            ");

            QueryMap.Add("TDA_V_MONEDASCLUB", @"
                SELECT * 
                  FROM tda_v_monedasMembres TDA_V_MONEDAS");


            //Selecciona los datos de la membresia plus del cliente por Cedula desde la Base de Datos
            QueryMap.Add("ClixMemCedPtsP", @"               
                SELECT  w.C_CEDULA, w.C_TARJETA, w.D_FEC_REGISTRO,
                        w.D_FEC_MODIF,  w.D_INI_MEMBRESIA,
                        w.D_FIN_MEMBRESIA, w.C_ESTADO, w.C_REGIST_POR,
                        w.C_MODIF_POR, w.BODEGA
                        FROM EKONO.PLUS_FIDELIZA_CLIENTE W WHERE C_CEDULA  = '&&pCed&&' AND ROWNUM = 1
           ");
            //Selecciona los datos del cliente pts por cedula desde la Base de Datos
            QueryMap.Add("ClixCedPtsP", @"               
                SELECT 
                W.CEDULA, W.NOMBRE, W.APELLIDO1, 
                W.APELLIDO2, W.TELEFONO1, W.TELEFONO2, 
                W.EMAIL, W.FECHA_NAC, W.GENERO, 
                W.PROVINCIA, W.CANTON, W.DISTRITO, 
                W.TARJETA
                FROM EKONO.WMS_CLIENTES_PTS W  WHERE w.CEDULA = '&&pCed&&'
           ");

            //Selecciona los datos del cliente pts por tarjeta desde la Base de Datos
            QueryMap.Add("ClixTarjPtsP", @"
                SELECT 
                W.CEDULA, W.NOMBRE, W.APELLIDO1, 
                W.APELLIDO2, W.TELEFONO1, W.TELEFONO2, 
                W.EMAIL, W.FECHA_NAC, W.GENERO, 
                W.PROVINCIA, W.CANTON, W.DISTRITO, 
                W.TARJETA
                FROM EKONO.WMS_CLIENTES_PTS W WHERE w.tarjeta = '&&pTarj&&'
           ");

            //Valida si el cliente ya pertenece al club ekono Plus
            QueryMap.Add("PLUS_CLIENTE_EXISTE", @"SELECT COUNT(C_CEDULA) FROM PLUS_FIDELIZA_CLIENTE WHERE C_CEDULA = '&&p_C_CEDULA&&'");

            //Valida si el cliente ya pertenece al club ekono Plus y si esta pendiente de pago la mem
            QueryMap.Add("PLUS_CLIENTE_EXISTE_MEMBRE", @"SELECT COUNT(C_CEDULA) FROM PLUS_MEMBRESIA_CUOTAS WHERE C_CEDULA = '&&p_C_CEDULA&&' AND C_ESTADO = 'I' ");

            //Valida si se puede agregar el articulo
            QueryMap.Add("PLUS_VAL_ART", @"SELECT PLUS_F_VALAPLI( '&&p_TIPO&&',  '&&p_C_CEDULA&&') FROM DUAL");


            //Almacena los Datos de Afiliación del Cliente al Club ekono Plus
            QueryMap.Add("PLUS_FIDELIZA_CLIENTE", @"
                BEGIN                     
                     PLUS_P_I_FIDELIZA_CLIENTE('&&P_C_CEDULA&&','&&P_C_TARJETA&&','&&P_C_REGISTRADO_POR&&');
                END;                
            ");

            //Almacena el pedido y la acción realizada(pago, renovación, cambio tarjeta) del Cliente al Club ekono Plus
            QueryMap.Add("PLUS_PEDIDO_CLIENTE", @"
                BEGIN                     
                     PLUS_P_I_PED_MEMBRESIA('&&p_C_CEDULA&&',&&P_PEDIDO&&,'&&P_ACCION&&','&&P_CREADO_POR&&',&&P_LINEA&&, &&P_MESES&&);
                END;                
            ");

            //(P_PEDIDO IN NUMBER, P_CREADO_POR IN VARCHAR2, P_FACTURA
            //Almacena lA FACTURA Y actualiza los tiempos del Cliente al Club ekono Plus
            QueryMap.Add("PLUS_FACTURA_CLIENTE", @"
                BEGIN                     
                     PLUS_P_I_FAC_MEMBRESIA(&&P_PEDIDO&&,'&&P_CREADO_POR&&',&&P_FACTURA&&);
                END;                
            ");

            //(P_PEDIDO IN NUMBER, P_CREADO_POR IN VARCHAR2, P_FACTURA
            //Almacena lA FACTURA Y actualiza los tiempos del Cliente al Club ekono Plus
            QueryMap.Add("PLUS_I_ACTUALIZA_MEMB_ACTIVA", @"
                BEGIN                     
                     PLUS_P_I_ACTUALIZA_MEMB_ACTIVA('&&P_C_CEDULA&&');
                END;                
            ");


            //Almacena el pedido y la acción realizada(cambio tarjeta) del Cliente al Club ekono Plus
            QueryMap.Add("PLUS_PEDIDO_TAR_CLIENTE", @"
                BEGIN 
                     PLUS_P_I_PEDT_MEMBRESIA ('&&PCEDULA&&', '&&PC_TARJETANEW&&', &&PPEDIDO&&, '&&PCREADO_POR&&', &&PLINEA&&);
                END;                
            ");

            //Almacena lA FACTURA Y actualiza la tarjeta del Cliente al Club ekono Plus
            QueryMap.Add("PLUS_FACTURA_TAR_CLIENTE", @"
                BEGIN                     
                     PLUS_P_I_TFAC_MEMBRESIA(&&P_PEDIDO&&,'&&P_CREADO_POR&&',&&P_FACTURA&&);
                END;                
            ");

            //anula la transacción de la factura del Cliente al Club ekono Plus
            QueryMap.Add("PLUS_ElimMembresiaPlus", @"
                BEGIN                     
                     PLUS_P_E_FAC_MEMBRESIA(&&DOCUMENTO&&,'&&USUARIO&&');
                END;                
            ");


            //PRECIO ARTÍCULO MEMBRESIA MES           
            QueryMap.Add("PLUS_PRECIOMM", @"
                SELECT PLUS_F_PRECIO_MEMBRESIA('1') as PRECIO FROM DUAL                           
            ");

            //PRECIO ARTÍCULO MEMBRESIA AÑO           
            QueryMap.Add("PLUS_PRECIOMA", @"
                SELECT PLUS_F_PRECIO_MEMBRESIA('12') as PRECIO FROM DUAL                           
            ");

            //PRECIO REEMPLAZO TARJETA MEMBRESIA
            QueryMap.Add("PLUS_PRECIORT", @"
                SELECT PLUS_F_PRECIO_MEMBRESIA('RT') as PRECIO FROM DUAL                           
            ");

            //Actualiza la couta al cambio del dolar 
            QueryMap.Add("PLUS_ACTUALIZA_COUTA", @"
                BEGIN
                    PLUS_P_ACTUALIZAR_N_MONTO(&&P_PEDIDO&&);
                END;
            ");

            //PRECIO DE LA MEMBRESIA PLUS RENOVACION
            QueryMap.Add("PLUS_PRECIO_RENOVACION", "SELECT PLUS_F_PRECIO_RENOVACION('1') FROM DUAL");


            /*-------------------------------------------*/

            //valida si tienes un artículo de la membresia PLUS
            QueryMap.Add("MSJPLUSC", @"
                SELECT EC_F_VENCI_PLUS('&&pCEDULA&&',  '&&pTARJETA&&') FROM DUAL
            ");

            QueryMap.Add("MSJPLUST", @"
                SELECT EC_F_VENCI_PLUS('&&pCEDULA&&', '&&pTARJETA&&') FROM DUAL
            ");

            QueryMap.Add("GET_SKU_MEMBRESIA", @"
               SELECT VALUE FROM CG_PARAMETERS WHERE PARAMETER = 'MEKP'
            ");

            QueryMap.Add("PLUS_I_REGISTRA_FINAN_MEMBRE", @"
                BEGIN                     
                     PLUS_P_I_REGISTRA_FINAN_MEMBRE('&&P_C_CEDULA&&','&&P_C_TARJETA_PAGO&&','&&P_C_BOLETA&&','&&P_N_MONTO_CUOTAS&&','&&P_N_CANT_CUOTAS&&','&&P_N_CANT_CUOTAS_PAGADAS&&','&&P_N_PAGO_CONTADO&&','&&P_N_PLAZO_MESES&&','&&P_D_FEC_VEN_TAR_PAGO&&','&&P_C_REGISTRADO_POR&&');
                END;                
            ");

            QueryMap.Add("PLUS_A_ACTUALIZA_FINAN_MEMBRE", @"
                BEGIN                     
                     PLUS_P_A_ACTUALIZ_FINAN_MEMBRE('&&P_C_CEDULA&&','&&P_C_TARJETA_PAGO&&','&&P_C_BOLETA&&','&&P_N_MONTO_CUOTAS&&','&&P_N_CANT_CUOTAS&&','&&P_N_CANT_CUOTAS_PAGADAS&&','&&P_N_PAGO_CONTADO&&','&&P_N_PLAZO_MESES&&','&&P_D_FEC_VEN_TAR_PAGO&&','&&P_C_REGISTRADO_POR&&');
                END;                
            ");

            //Valida que sea cobrado el monto por credito
            //TODO: VALIDAR QUE ESTO FUNCIONE CORRECTAMENTE
            QueryMap.Add("PLUS_CONFIGURACION_MEMBRESIA", @"SELECT N_MONTO_CUOTA FROM PLUS_MEMBRESIA_CUOTAS WHERE  N_PAGO_CONTADO = 0 AND C_CEDULA = '&&P_C_CEDULA&&'");

            //Valida metodo pago contado o credito
            QueryMap.Add("PLUS_VALIDA_PAGOCONTADO", @"SELECT N_PAGO_CONTADO FROM PLUS_MEMBRESIA_CUOTAS WHERE  N_PAGO_CONTADO = 1 AND C_CEDULA = '&&P_C_CEDULA&&'");
            //Valida si existe en plus membresia cuotas
            QueryMap.Add("PLUS_VALIDA_EXISTE_MEMBRESIACUOTAS", @"SELECT  CASE WHEN COUNT(*) > 0 THEN 1 ELSE 0 END  FROM PLUS_MEMBRESIA_CUOTAS WHERE  C_CEDULA = '&&P_C_CEDULA&&'");

            //Valida metodo pago contado o credito
            QueryMap.Add("PLUS_OBTIENE_CEDULA_MIEMBRO", @"SELECT CEDULA FROM PLUS_HIST_MEMBRESIA WHERE PEDIDO = '&&P_C_PEDIDO&&' AND FACTURA =  '&&P_C_FACTURA&&'");

            QueryMap.Add("PLUS_PLAZO_MEMBRESIA", @"SELECT N_PLAZO_MESES FROM PLUS_MEMBRESIA_CUOTAS WHERE C_CEDULA = '&&P_C_CEDULA&&'");



            QueryMap.Add("PLUS_A_ACTUALI_TARJETA_MEMB", @"
                BEGIN                     
                     PLUS_P_A_ACTUALI_TARJETA_MEMB('&&P_C_CEDULA&&','&&P_C_TARJETA&&','&&P_C_MODIFICADO_POR&&');
                END;                
            ");

            //Valida si el cliente cuenta con las características de ser anulable _______________________________________
            QueryMap.Add("PLUS_CLIENTE_ANULABLE", @"SELECT COUNT(C_CEDULA) FROM PLUS_FIDELIZA_CLIENTE WHERE C_CEDULA = '&&P_C_CEDULA&&' AND C_TARJETA = &&P_C_TARJETA&& AND D_INI_MEMBRESIA IS NULL AND D_FIN_MEMBRESIA IS NULL ");

            QueryMap.Add("PLUS_FACTURA_ANULABLE", @"
                SELECT PLUS_COUNT_FACTURA_ANULABLE('&&P_C_CEDULA&&') FROM DUAL                           
            ");

            QueryMap.Add("PLUS_MEMBRESIA_ANULADA_SF", @"
                BEGIN                     
                     PLUS_MEMBRE_ANULADA_SIN_FACT('&&P_C_CEDULA&&','&&P_C_REGISTRADO_POR&&');
                END;                
            ");

            QueryMap.Add("PLUS_MEMBRESIA_ANULADA_CF", @"
                BEGIN                     
                     PLUS_MEMBRE_ANULADA_CON_FACT('&&P_C_CEDULA&&','&&P_C_REGISTRADO_POR&&');
                END;                
            ");



            //Validar si existe una cedula asociada al número de tarjeta plus ingresada
            QueryMap.Add("PLUS_GET_CEDULA_FROM_TARJETA_PLUS", @" SELECT NVL(C_CEDULA,0) FROM PLUS_FIDELIZA_CLIENTE WHERE C_TARJETA = '&&p_C_TARJETA&&' AND ROWNUM = 1");



            #endregion

            #region ***** Aeropost*****
            //STEVEN ARCE 10/2018

            //Valida si tienes artículos aeropost
            QueryMap.Add("VALIDAAEROPOSTPEDIDO", @"
                SELECT AEROPOST_F_VALPEDIDO(&&P_DOCUMENTO&&,&&P_TIPO&&) FROM DUAL
            ");

            //Valida si cliente es fidelizado
            QueryMap.Add("VALIDACLIENTEFIDELIZADO", @"
                SELECT WMS_F_VALIDACLIFIDELIZ(&&P_DOCUMENTO&&) FROM DUAL
            ");

            QueryMap.Add("REFCODESCODALTERNO", @"
               select WMS_F_BUSCAR_SKU_ALTERNO2(VALUE) from cg_parameters where parameter = '&&pParam1&&'
            ");

            QueryMap.Add("AEROPOST", @"
               SELECT EBOX_F_SKUS FROM DUAL
            ");

            QueryMap.Add("ActualizarDescripFact", @"
                BEGIN WMS_P_ACTUALIZAR_DESCRIP(&&DOCUMENTO&&); END;
            ");

            /***************************************************************/
            #endregion

            #region ***** TECNOLOGIA DLQG*****

            QueryMap.Add("VALIDATECNOLOGIA", @"
                SELECT wms_f_CajeroVendedor(&&P_DOCUMENTO&&) FROM DUAL
            ");
            /***************************************************************/
            #endregion

            #region ***** Club de Viajes DLQG*****

            //indica si tienes viaje
            QueryMap.Add("VALIDAVIAJESPEDIDO", @"
                SELECT VIAJES_F_VALPEDIDO(&&P_DOCUMENTO&&) FROM DUAL
            ");

            //CANTIDAD DE ARTÍCULOS VIAJES EN EL PEDIDO
            QueryMap.Add("CANTVIAJESPEDIDO", @"
                SELECT VIAJES_F_ARTICLASIF(&&P_DOCUMENTO&&)FROM DUAL
            ");

            //Almacena el nombre y cédula del cliente
            QueryMap.Add("VIAJES_P_CLIENTE", "BEGIN VIAJES_P_CLIENTE(&&pDocumento&&,'&&pNOMBRE&&','&&pCEDULA&&'); END;");


            /***************************************************************/
            #endregion

            #region Club del Bebé
            //Almacena los Datos de Afiliación del Cliente a Club del Bebé
            QueryMap.Add("cbb_FIDELIZA_CLIENTE", @"
                BEGIN                     
                     CBB_P_I_FIDELIZA_CLIENTE('&&P_C_CEDULA&&','&&P_C_TARJETA&&','&&P_C_REGISTRADO_POR&&');
                END;                
            ");
            //Actualiza los datos de una lista del club del bebe
            QueryMap.Add("cbb_A_LISTA_DESEO", @"
                BEGIN                     
                     CBB_P_A_LISTA_DESEO('&&P_N_ID_LISTA_DESEO&&','&&P_C_CEDULA&&','&&P_C_NOMBRE_LISTA&&','&&P_D_FECHA_GESTACION&&','&&P_C_SEXO_BEBE&&','&&P_C_NOMBRE_MAMA&&','&&P_C_CEDULA_MAMA&&','&&P_C_NOMBRE_PAPA&&','&&P_C_CEDULA_PAPA&&');
                END;                
            ");

            //Descuenta los articulos de una lista del club del bebe
            QueryMap.Add("cbb_DescuentaArticulos", @"
                BEGIN                     
                     CBB_P_I_DETALLE_LIST_DESEO_HIS('&&P_C_SKU_ALTERNO&&','&&P_N_DOCUMENTO&&','&&P_N_CANT_ARTICULO_COMPRA&&','&&P_N_ID_LISTA_DESEO&&','&&P_C_REGISTRADO_POR&&');
                END;                
            ");

            //Obtiene la hora actual del servidor
            QueryMap.Add("pos_F_CG_F_SYSDATE", "SELECT CG_F_SYSDATE() FROM DUAL");

            //Valida los permisos especiales para editar en  el modulo de CBB

            QueryMap.Add("cbb_VALIDA_PERMISO_ESPECIAL", @"SELECT CBB_F_S_VALIDAPERMISO_ESPECIAL('&&P_C_USUARIO&&','&&P_C_PASSWORD&&','&&P_C_MODULE&&') FROM DUAL");


            //Valida si el cliente ya pertenece al club del bebe
            QueryMap.Add("cbb_CLIENTE_EXISTE", @"SELECT COUNT(C_CEDULA) FROM CBB_FIDELIZA_CLIENTE WHERE C_CEDULA = '&&p_C_CEDULA&&'");

            //Elimina a nivel Logico los Datos de Afiliación del Cliente a Club del Bebé
            QueryMap.Add("cbb_ELIM_CLIENTE", @"
                BEGIN                     
                     CBB_P_E_FIDELIZA_CLIENTE('&&P_C_CEDULA&&','&&P_C_TARJETA&&','&&P_C_MODIFICADO_POR&&');
                END;                
            ");

            //Anula una factura en club bebe
            QueryMap.Add("cbb_A_ANULA_DOCUMENTO", @"
                BEGIN                     
                     CBB_P_A_ANULA_DOCUMENTO('&&P_N_DOCUMENTO&&','&&P_C_REGISTRADO_POR&&');
                END;                
            ");

            //Valida si el cliente ya pertenece al club del bebe
            QueryMap.Add("cbb_listas_por_usuario", @"SELECT N_ID_LISTA_DESEO,C_CEDULA,C_NOMBRE_LISTA FROM CBB_FIDELIZA_CLIENTE WHERE C_CEDULA = '&&p_C_CEDULA&&'");

            //Valida si la tarjeta del cliente cbb esta activa con los 2 años de vigencia correspondientes a la fecha de gestacion mas reciente de las listas creadas

            QueryMap.Add("cbb_VALIDA_VIGENCIA_TARJECBB", @"SELECT CBB_F_VALIDA_VIGENCIA_TARJECBB('&&P_C_CEDULA&&') FROM DUAL");
            #endregion

            #region Cupones - Credie
            /*****************************DLGQ-IMG*****************************************************/
            //Obtener los datos de un cliente
            QueryMap.Add("ConsultClient", "Select nombre, apellido1, apellido2, telefono1, telefono2, email from eko_v_clientes where cedula ='&&Cedula&&'");
            //
            //Guardar los datos de un cliente
            QueryMap.Add("AlmCliente", "BEGIN EKO_P_REG_CLIENTE('&&pCedula&&', '&&pNombre&&', '&&pApellido1&&', '&&pApellido2&&', '&&pTelefono1&&', '&&pTelefono2&&', '&&pEmail&&'); END;");
            //
            //Guardar cupones
            QueryMap.Add("AlmCupon", "BEGIN EKO_P_CREAR_CUPON('&&pCedula&&',&&pDocumento&&,&&pCant&&); END;");
            //
            //Eliminar cupones
            QueryMap.Add("ElimCupon", "BEGIN EKO_P_BORRAR_CUPONES(&&pDocumento&&); END;");
            //
            //Obtener monto cupon
            QueryMap.Add("MontoCpn", "Select cg_f_parameter_value('MXC') from dual");
            //
            //Obtener número de cupones
            QueryMap.Add("NumCupones", "Select wms_f_num_cupones(&&pDocumento&&) from dual");
            //
            //Registrar cliente (si/no)
            QueryMap.Add("RegCliente", "Select cg_f_parameter_value('RC') from dual");
            //
            //Actualizar los datos del cliente
            QueryMap.Add("ActCliente", "BEGIN EKO_P_ACT_CLIENTE('&&pCedula&&', '&&pTelefono1&&', '&&pTelefono2&&', '&&pEmail&&'); END;");
            #endregion

            #region Cupones App

            //Registra el Log 
            QueryMap.Add("CUP_INSERTAR_LOG_CUPONES", "BEGIN APP_P_CUP_LOGSCAJAS('&&pCMODO&&' , '&&pCCAJERO&&' , '&&pCCODIGO&&'); END;");

            //Aplica el cupon
            QueryMap.Add("CUP_CLAIM_CUPON", "BEGIN APP_P_APLICA_CUPON('&&param0&&', '&&param1&&', '&&param2&&'); END;");

            //Registra el Log de errores
            QueryMap.Add("CUP_LOGS", "BEGIN APP_P_CUP_LOGS('&&pCMENSAJE&&', '&&pCSISTEMA&&', '&&pCTIPO&&'); END;");


            #endregion

            //Ariel Vargas Valverde 30/07/2019
            #region Factura Compra
            //Guardar datos del proveedor de compra
            QueryMap.Add("GuardarProveedor", "BEGIN FE_P_GUARDAR_DATOS('&&p_TIPOID&&','&&p_ID&&','&&p_NOMBRE&&','&&p_PROVINCIA&&', &&p_CODPROV&&, '&&p_CANTON&&', &&p_CODCANTON&&, '&&p_DISTRITO&&', &&p_CODDIST&&, '&&p_BARRIO&&', &&p_CODBARRIO&&, '&&p_DIRECCION&&', '&&p_TELEFONO&&', '&&p_EMAIL&&'); END;");

            //Guardar datos generales de la factura
            QueryMap.Add("GuardarCompra", "BEGIN FE_P_GUARDAR_COMPRA('&&p_TIPODOC&&', TO_DATE('&&p_FECHA&&','DD/MM/YYYY HH:MI:SS'), &&p_NODOC&&, &&p_MONTO&&, '&&p_ID&&', '&&p_TIENDA&&', &&p_JORNADA&&, &&p_CAJA&&, '&&p_USUARIO&&', '&&p_NOMEMPLEADO&&'); END;");

            //Guardar articulos de la factura
            QueryMap.Add("GuardarArticulos", "BEGIN FE_P_GUARDAR_ART_COMPRA(&&p_LINEA&&, '&&p_ARTICULO&&', '&&p_CABYS&&', TO_DATE('&&p_FECHA&&','DD/MM/YYYY HH:MI:SS'), &&p_SUBTOTAL&&, &&p_IMPUESTO&&, &&p_NODOC&&, '&&p_ID&&', '&&p_TIENDA&&', &&p_JORNADA&&, &&p_CAJA&&, '&&p_USUARIO&&', '&&p_TIPODOC&&'); END;");

            //Validar Cedula digitada
            QueryMap.Add("ValidarID", @"SELECT FE_F_VALIDAR_CEDULA('&&P_ID&&') FROM DUAL ");

            //Obtner doumento interno
            QueryMap.Add("DocInterno", @"SELECT FE_F_OBTENER_DOC(&&p_NODOC&&, '&&p_ID&&', '&&p_TIPODOC&&') FROM DUAL");

            //Obtner doumento interno
            QueryMap.Add("DocPadre", @"SELECT FE_F_DOCUMENTO_REAL(&&p_DOCUMENTO&& ) FROM DUAL ");

            //Crear trama factura compra
            QueryMap.Add("FE_P_CREAR_TRAMA_COMPRA", @"BEGIN FE_PQ_COMPRAS_TRAMAS.FE_P_CREAR_TRAMA(&&pNDOCUMENTO&&); END;");

            //Obtener las tramas para el envio
            QueryMap.Add("OBTENER_TRAMA_COMPRA", @"SELECT FE_PQ_COMPRAS_TRAMAS.FE_F_TRAMA(&&pNDOCUMENTO&&, 'TCTL') CTL,
                    FE_PQ_COMPRAS_TRAMAS.FE_F_TRAMA(&&pNDOCUMENTO&&, 'TDFE') TRAMA, CG_F_PARAMETER_VALUE('USFE') USUARIO,
                    CG_F_PARAMETER_VALUE('PAFE') PASSWORD, CG_F_PARAMETER_VALUE('CJFE') CED FROM DUAL");

            //Obtner Articulo
            QueryMap.Add("ObtArt", @"SELECT ARTICULO FROM FE_FACTURA_COMPRA_ARTICULOS WHERE LINEA = &&p_LINEA&& AND DOCUMENTO = &&p_DOCUMENTO&&");

            //Obtner Monto
            QueryMap.Add("ObtMonto", @"SELECT SUBTOTAL FROM FE_FACTURA_COMPRA_ARTICULOS WHERE LINEA = &&p_LINEA&& AND DOCUMENTO = &&p_DOCUMENTO&&");

            //Obtener Impuesto
            QueryMap.Add("ObtImpt", @"SELECT IMPUESTO FROM FE_FACTURA_COMPRA_ARTICULOS WHERE LINEA = &&p_LINEA&& AND DOCUMENTO = &&p_DOCUMENTO&&");

            //Obtener Cantidad de lineas
            QueryMap.Add("CantLinea", @"SELECT FE_F_COMPRA_NULA(&&p_NODOC&&, '&&p_ID&&', '&&p_TIPODOC&&') FROM DUAL");

            //
            QueryMap.Add("BuscarNom", @"SELECT IDENTIFICACION, NOMBRE FROM FE_V_DATOS_COMPRA WHERE NOMBRE LIKE '&&pBUSQUEDA&&' ");

            QueryMap.Add("BuscarID", @"SELECT IDENTIFICACION, NOMBRE FROM FE_V_DATOS_COMPRA WHERE IDENTIFICACION LIKE '&&pBUSQUEDA&&' ");

            //Buscar Departamentos
            QueryMap.Add("BuscarDepto", @"SELECT RV_MEANING, RV_LOW_VALUE FROM CG_REF_CODES WHERE RV_DOMAIN = 'DEPARTAMENTOS'");


            #endregion

            #region Distribucion Geografica
            QueryMap.Add("FE_PROVINCIAS", @"
                select distinct provincia, IDPROV  from FE_dist_geografica ORDER BY PROVINCIA             
            ");

            QueryMap.Add("FE_CANTONES", @"
                select distinct canton, IDCANTON from FE_dist_geografica where provincia = '&&pPROVINCIA&&' ORDER BY CANTON             
            ");

            QueryMap.Add("FE_DISTRITOS", @"
                select distinct distrito,IDDISTRITO from FE_dist_geografica where provincia = '&&pPROVINCIA&&' and canton = '&&pCANTON&&' ORDER BY DISTRITO
            ");

            QueryMap.Add("FE_BARRIOS", @"
                select distinct BARRIO, IDBARRIO from FE_dist_geografica where provincia = '&&pPROVINCIA&&' and canton = '&&pCANTON&&'  and DISTRITO= '&&pDISTRITO&&' ORDER BY BARRIO
            ");
            #endregion


            #region Tiempos Facturación - Impresión / IGF
            //Guarda el tiempo en el que se inicia el cobro o impresión (factura)
            QueryMap.Add("AlmTiempoI", @"Begin eko_p_almanc_tiempo_inicio(&&Documento&&, '&&Tipo&&'); end;");

            //Guarda el tiempo en el que finaliza el cobro o impresión (factura)
            QueryMap.Add("AlmTiempoF", @"Begin eko_p_almanc_tiempo_fin(&&Documento&&); end;");

            //Eliminar el tiempo de cobro o impresión almacenado
            QueryMap.Add("ElimTiempo", @"Begin eko_p_elim_tiempo(&&Documento&&); end;");
            #endregion

            #region Tarjetas - Posware / IGF
            //Verifica que haya datos en la tabla para la caja            
            QueryMap.Add("HayDatos", "SELECT COUNT(*) FROM WMS_DATOS_EMISORES WHERE CAJA = &&CAJA&& AND EMISOR = &&EMISOR&&");
            //
            //Obtiene el merchant, merchantnumber, terminalnumber a partir del número de caja
            QueryMap.Add("ObtDatosB", "SELECT MERCHANT, MERCHANTNUMBER, TERMINALNUMBER FROM WMS_DATOS_EMISORES WHERE CAJA = &&CAJA&& AND EMISOR = &&EMISOR&&");
            //
            //Obtiene los emisores (Banco Nacional, etc)
            QueryMap.Add("Emisores", "SELECT RV_MEANING, RV_LOW_VALUE FROM CG_REF_CODES WHERE RV_DOMAIN = 'EMISOR' ORDER BY RV_LOW_VALUE DESC");
            //
            //Obtiene el siguiente valor de ID_TR_TARJ
            QueryMap.Add("Sig_Id_tr_tarj", "SELECT WMS_S_TR_TARJ.NEXTVAL FROM DUAL");
            //
            //Guarda el tiempo en el que se llama a la pantalla del PosWare para realizar una transacción
            QueryMap.Add("Ini_Log_Tarjetas", "BEGIN WMS_P_LOG_TR_TARJETAS_INI(&&ID_TR_TARJ&&, '&&CAJA&&', '&&TIPO&&', '&&USUARIO&&', &&MONTO&&, '&&ESTADO&&', &&EMISOR&&, &&JORNADA&&); END;");
            //
            //Guarda el tiempo en el que se llama a la pantalla del PosWare para realizar una transacción (anulación)
            QueryMap.Add("Ini_Log_Tarjetas_Anul", "BEGIN WMS_P_LOG_TR_TARJETAS_INI_ANUL(&&ID_TR_TARJ&&, &&DOCUMENTO&&, '&&CAJA&&', '&&TIPO&&', '&&USUARIO&&', &&MONTO&&, '&&ESTADO&&', &&EMISOR&&, &&JORNADA&&); END;");
            //
            //Guarda el tiempo en el que se termina de realizar una transacción
            QueryMap.Add("Fin_Log_Tarjetas", "BEGIN WMS_P_LOG_TR_TARJETAS_FIN(&&ID_TR_TARJ&&, '&&TARJETA&&', '&&AUTORIZACION&&', '&&REFERENCIA&&', '&&ESTADO&&', '&&ERRORES&&'); END;");
            //
            //Guarda el tiempo en el que se termina de realizar una transacción en el bncr
            QueryMap.Add("Fin_Log_TarjetasBNCR", "BEGIN WMS_P_LOG_TR_TARJETAS_FIN_BNCR(&&ID_TR_TARJ&&, '&&TARJETA&&', '&&AUTORIZACION&&', '&&REFERENCIA&&', '&&ESTADO&&', '&&ERRORES&&', '&&pINVOICE&&',  '&&pTRAMA&&'); END;");
            //
            //Guarda el número de pedido / recibo
            QueryMap.Add("Act_Log_Tarjetas", "BEGIN WMS_P_LOG_TR_TARJETAS_ACT(&&ID_TR_TARJ&&, &&DOCUMENTO&&, '&&TIPO&&', '&&TARJETA&&', '&&AUTORIZACION&&', '&&REFERENCIA&&'); END;");
            //
            //Verifica si el número de tarjeta, de autorización y referencia están asociados a una venta, si
            //la venta existe, el select devuelve el número de caja en el que se hizo la transacción
            //QueryMap.Add("ExisteVenta", @"SELECT NVL(CAJA, 0) FROM WMS_LOG_TR_TARJETAS WHERE TARJETA = '&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&' AND TIPO = 'Venta'");
            QueryMap.Add("ExisteVenta", @"SELECT NVL(CAJA, 0) FROM WMS_LOG_TR_TARJETAS WHERE TARJETA LIKE '%&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&' AND CINVOICE = '&&INVOICE&&' AND TIPO = 'Venta'");
            //Selecciona el número de tarjeta almacenado en a BD de la transacción 
            QueryMap.Add("TarjVenta", @"SELECT TARJETA FROM WMS_LOG_TR_TARJETAS WHERE TARJETA LIKE '%&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&' AND CINVOICE = '&&INVOICE&&' AND TIPO = 'Venta'");
            //
            //Verifica si la transacción ya había sido anulada
//            QueryMap.Add("ExisteAnulacion", @"SELECT COUNT(*) FROM WMS_LOG_TR_TARJETAS WHERE TARJETA = '&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&' 
//AND TIPO = 'Anulación' AND ESTADO = 'Aprobada'");
            QueryMap.Add("ExisteAnulacion", @"SELECT COUNT(*) FROM WMS_LOG_TR_TARJETAS WHERE TARJETA LIKE '%&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&' AND CINVOICE = '&&INVOICE&&'
            AND TIPO = 'Anulación' AND ESTADO = ' Aprobada'");
            //
            //Obtiene el monto de la transacción
            //QueryMap.Add("MontoTrans", @"SELECT NVL(MONTO, 0) FROM WMS_LOG_TR_TARJETAS WHERE TARJETA = '&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&'
//AND TIPO = 'Venta' AND ESTADO = 'Aprobada'");
            QueryMap.Add("MontoTrans", @"SELECT NVL(MONTO, 0) FROM WMS_LOG_TR_TARJETAS WHERE TARJETA LIKE '%&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&'  AND CINVOICE = '&&INVOICE&&'
            AND TIPO = 'Venta' AND ESTADO = 'Aprobada'");
            //
            //Verifica si se puede anular la factura
            QueryMap.Add("AnulFact", @"SELECT WMS_F_COMPROBACION(&&DOCUMENTO&&, '&&USUARIO&&') FROM DUAL");
            //
            //Obtiene los datos de la transacción
            QueryMap.Add("DatosTrans", "SELECT * FROM WMS_V_DATOS_TRANSACC WHERE DOCUMENTO_PADRE =&&DOCUMENTO&& ORDER BY EMISOR ASC");
            //
            //Obtiene los datos de la transacción de un recibo (abono apartado)
            QueryMap.Add("DatosTransRec", "SELECT * FROM WMS_V_DATOSR_TRANSACC WHERE DOCUMENTO =&&DOCUMENTO&&");
            //
            //Verifica si la transacción esta asociada a un documento
            //QueryMap.Add("ExisteDoc", "SELECT COUNT(*) FROM WMS_PAGO_DOCUMENTOS WHERE TARJETA = '&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&'");
            QueryMap.Add("ExisteDoc", "SELECT COUNT(*) FROM WMS_PAGO_DOCUMENTOS WHERE TARJETA LIKE '%&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&'");
            //
            //Modifica el campo CERRADA, para indicar que ya se hizo el cierre de transacciones
            QueryMap.Add("CerrarTrans", "BEGIN WMS_P_LOG_TR_TARJETAS_CIERRE(&&CAJA&&, '&&USUARIO&&'); END;");
            //
            //Verifica si la transacción ya fue cerrada
//            QueryMap.Add("TransCerrada", @"SELECT COUNT(*) FROM WMS_LOG_TR_TARJETAS WHERE TARJETA = '&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&'
//AND TIPO = 'Venta' AND ESTADO = 'Aprobada' AND CERRADA_EL IS NOT NULL");
            QueryMap.Add("TransCerrada", @"SELECT COUNT(*) FROM WMS_LOG_TR_TARJETAS WHERE TARJETA LIKE '%&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&'
            AND TIPO = 'Venta' AND ESTADO = 'Aprobada' AND CERRADA_EL IS NOT NULL");
            //Obtiene el número de pedido
            //QueryMap.Add("NumPedido", "SELECT NVL(DOCUMENTO, 0) DOCUMENTO FROM WMS_LOG_TR_TARJETAS WHERE TARJETA = '&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&'");
            QueryMap.Add("NumPedido", "SELECT NVL(DOCUMENTO, 0) DOCUMENTO FROM WMS_LOG_TR_TARJETAS WHERE TARJETA LIKE '%&&TARJETA&&' AND AUTORIZACION = '&&AUTORIZACION&&' AND REFERENCIA = '&&REFERENCIA&&'");
            //
            //Obtiene las transacciones del día
            QueryMap.Add("Transacciones", "SELECT * FROM WMS_V_DATOS_TR_TRANS WHERE JORNADA = &&JORNADA&&");
            //
            //Verifica si el usuario tiene transacciones por cerrar (cierre transacciones)
            QueryMap.Add("TieneTrans", "SELECT COUNT(*) FROM WMS_V_DATOS_TR_TRANSC WHERE USUARIO = '&&USUARIO&&' AND CAJA = &&CAJA&& AND EMISOR = 2");
            #endregion

            //IGF
            //Obtiene la serie y número de la factura
            QueryMap.Add("ObtenerFact", "SELECT SERIE || '-' || NO_DOCUMENTO FROM WMS_DOCUMENTOS WHERE DOCUMENTO =&&DOCUMENTO&&");
            //
            //Verifica si hay artículos incluidos en wms_recetas, y si hay, verifica que cada insumo tenga inventario
            QueryMap.Add("ValidarExistInsumos", @"SELECT WMS_F_VALIDA_CANTIDAD_EGRE_INS(&&DOCUMENTO&&) FROM DUAL");
            //
            //Indica si se muestra o no la pantalla de reintento de impresión de vales/certificados
            QueryMap.Add("ObtenerMP", "SELECT CG_F_PARAMETER_VALUE('MP') FROM DUAL");
            //
            //Obtiene los vales de la jornada
            QueryMap.Add("ValesJornada", @"SELECT VALE, DESCRIPCION_ESTADO ESTADO, DESCRIPCION_TIPO TIPO, MONTO, VENCE_EL, CREADO_EL, 
            AUTORIZADO_POR FROM RET_V_VALES WHERE JORNADA = &&JORNADA&& ORDER BY VALE DESC");

            //Vale prueba
            QueryMap.Add("NVP", "SELECT CG_F_PARAMETER_VALUE('NVP') FROM DUAL");
            //
            //IGF
            //REUBICACIÓN AUTOMÁTICA
            QueryMap.Add("ReubicAut", "BEGIN WMS_P_REUBIC_FACTURA(&&DOCUMENTO&&); END;");

            #region Cierre Consolidado
            //IGF
            //Inserta los rubros de cierre por cajero
            QueryMap.Add("REGISTRO_CAJERO", "BEGIN WMS_P_REGISTRO_CAJERO(&&JORNADA&&, '&&USUARIO&&'); END;");
            //
            //Obtiene los datos del cierre por cajero
            QueryMap.Add("ObtRegCaj", "SELECT * FROM WMS_V_REGISTRO_CAJEROS WHERE JORNADA = &&JORNADA&&");
            //
            //Guarda el monto de un rubro del cierre por cajero
            QueryMap.Add("AlmRubro", "BEGIN WMS_P_ALMRUBRO(&&JORNADA&&, '&&RUBRO&&', &&MONTO&&); END;");
            //
            //Obtener documentos manuales
            QueryMap.Add("DocsManuales", "SELECT * FROM WMS_V_DOCS_MANUALES WHERE JORNADA = &&JORNADA&&");
            //
            //Tipos de documentos manuales
            QueryMap.Add("dsArqueos.CG_REF_CODES", @"SELECT RV_LOW_VALUE, RV_MEANING FROM WMS_V_TIPO_DOCMANUAL");
            //
            //Guarda los datos de un documento(factura, nota de crédito) manual
            QueryMap.Add("AlmDocsM", "BEGIN WMS_P_ALMDOCSMANUAL(&&JORNADA&&, '&&SERIE&&', '&&NO_DOCUMENTO&&', &&MONTO&&, '&&TIPO&&', '&&USUARIO&&'); END;");
            //
            //Elimina un documento manual
            QueryMap.Add("AnulDocsM", "BEGIN WMS_P_ELIMDOCSMANUAL(&&DOCUMENTO&&, '&&USUARIO&&');END;");
            //
            //Cerrar el registro por usuario
            QueryMap.Add("CerrarRegC", "BEGIN WMS_P_CERRAR_REGCAJ(&&JORNADA&&, '&&USUARIO&&'); END;");
            //
            //Cargar datos de cierre consolidado
            QueryMap.Add("CierreCons", @"SELECT ID, RUBRO, ROUND(SUM(DEBE), 2) DEBE, ROUND(SUM(HABER), 2) HABER, OBSERVACIONES, IDCIERRE, USUARIO,FECHA_CIERRE  FROM WMS_V_CIERRE_CONSOLIDADO GROUP BY ID, RUBRO, OBSERVACIONES, IDCIERRE, USUARIO,FECHA_CIERRE  ORDER BY ID ASC");
            //
            //Obtener las jornadas del día
            QueryMap.Add("ObtJornadas", "SELECT DISTINCT JORNADA FROM WMS_V_CIERRE_CONSOLIDADO");
            //
            //Cacula el monto de las facturas y notas de crédito manuales, venta bruta y depósitos en tránsito
            QueryMap.Add("MovManuales", "BEGIN WMS_P_DOCS_MAN(&&JORNADA&&); END;");
            //
            //Cargar datos de cierre consolidado de una jornada
            QueryMap.Add("CierreConsXJorn", @"SELECT ID, RUBRO, ROUND(SUM(DEBE), 2) DEBE, ROUND(SUM(HABER), 2) HABER FROM WMS_V_CIERRE_CONSOLIDADO WHERE JORNADA = &&JORNADA&& GROUP BY ID, RUBRO ORDER BY ID ASC");
            //
            //Obtiene el impuesto de todas las ventas del día
            QueryMap.Add("ObtImp", @"SELECT ROUND(SUM(DISTINCT IMPUESTO), 2) FROM WMS_V_CIERRE_CONSOLIDADO");
            //
            //Obtiene el impuesto de las ventas de una jornada
            QueryMap.Add("ObtImpJorn", @"SELECT ROUND(SUM(DISTINCT IMPUESTO), 2) FROM WMS_V_CIERRE_CONSOLIDADO WHERE JORNADA IN (&&JORNADA&&)");
            //
            //Obtiene los datos de los depósitos
            QueryMap.Add("ObtDepositos", "SELECT * FROM WMS_V_DEPOSITOS");
            //
            //Obtiene los datos de los depósitos de una jornada
            QueryMap.Add("ObtDepositosxJorn", "SELECT * FROM WMS_V_DEPOSITOS WHERE JORNADA = &&JORNADA&&");
            //
            //Obtiene los datos de la tienda
            QueryMap.Add("WMS_EMPRESAS", "SELECT EMPRESA, NOMBRE, DIRECCION, TELEFONOS, NIT, EMAIL, PATENTE_DE_COMERCIO, LOGO, ESTADO FROM WMS_EMPRESAS");
            //
            //Indica si se imprime el ciere consolidado, a pesar de tener diferencias entre el debe y el haber
            QueryMap.Add("ImpReporteCC", "SELECT WMS_F_IMPREPORTECC() FROM DUAL");
            //
            //Guarda las observaciones del cierre consolidado
            QueryMap.Add("AlmObservaciones", "BEGIN WMS_P_REGCAJ_OBSERV('&&OBSERVACIONES&&'); END;");
            //
            //Obtiene las observaciones del cierre consolidado
            QueryMap.Add("ObtObservaciones", "SELECT DISTINCT OBSERVACIONES FROM WMS_V_CIERRE_CONSOLIDADO");
            //
            //Verifica si el registro por cajero esta cerrado
            QueryMap.Add("RegistCCerrado", "SELECT COUNT(1) FROM WMS_REGISTRO_CAJEROS WHERE JORNADA = &&JORNADA&& AND CERRADO_EL IS NULL");
            //
            //Obtiene los datos del cierre por cajero
            QueryMap.Add("ObtRegCajRep", "SELECT * FROM WMS_V_REGISTRO_CAJEROS_CC WHERE JORNADA = &&JORNADA&&");
            //
            //Realiza el cierre consolidado de la tienda
            QueryMap.Add("WMS_P_CIERRE_CONSOL", "BEGIN WMS_P_CIERRE_CONSOL('&&USUARIO&&', &&JORNADA&&, &&IDCIERRE&&); END;");
            //
            //Obtiene un cierre consolidado a partir del número de cierre o la fecha
            QueryMap.Add("WMS_V_HIST_CIERRE_CONSOLIDADO", @"SELECT ID, RUBRO, ROUND(SUM(TOTAL_SISTEMA), 2) TOTAL_SISTEMA, ROUND(SUM(TOTAL_USUARIO + NVL( AJUSTE,0 ) ), 2) TOTAL_USUARIO,
                 IDCIERRE, USUARIO,FECHA_CIERRE, ROUND(SUM(SOBRANTE), 2) SOBRANTE, ROUND(SUM(FALTANTE), 2) FALTANTE FROM WMS_V_HIST_CIERRE_CONSOLIDADO WHERE &&CONDIC&& GROUP BY ID, RUBRO,IDCIERRE, USUARIO,FECHA_CIERRE ORDER BY RUBRO ASC");
            //
            //Obtiene los depósitos de un cierre consolidado a partir del número de cierre o la fecha
            QueryMap.Add("WMS_V_HIST_DEPOSITOS", "SELECT * FROM WMS_V_HIST_DEPOSITOS WHERE &&CONDIC&&");
            //
            //Obtiene el total o los rubros a mostrar, para el ingreso de totales, por parte del cajero
            QueryMap.Add("WMS_V_TOTALES_CAJERO", "SELECT * FROM WMS_V_TOTALES_CAJERO WHERE JORNADA = &&JORNADA&&");
            //
            //Obtiene las formas de pago, excepto la indicada por parámetro
            QueryMap.Add("POS_V_TIPO_PAGOS", "SELECT * FROM POS_V_TIPO_PAGOS WHERE PAGO <> '&&PAGO&&'");
            //
            //Realiza el cambio de forma de pago de un documento
            QueryMap.Add("WMS_P_MODIF_FORMAPAGO", @"BEGIN WMS_P_MODIF_FORMAPAGO(&&DOCUMENTO&&, &&LINEA&&, &&TIPO_PAGO&&, &&EMISOR&&, '&&RUBRO&&', '&&USUARIO&&', 
                &&JORNADA&&, '&&TARJETA&&', '&&AUTORIZACION&&', &&VALE&&); END;");
            //
            //Realiza el cambio de forma de pago de un documento
            QueryMap.Add("WMS_P_LOG_CAMBIO_PAGO", @"BEGIN WMS_P_LOG_CAMBIO_PAGO(&&JORNADA&&, &&TIPO_PAGO_ORIGEN&&, &&TIPO_PAGO_FINAL&&, &&EMISOR_ORIGEN&&,
	            &&EMISOR_FINAL&&, '&&RUBRO&&', '&&USUARIO&&', '&&RAZON&&', &&DOCUMENTO_ORIGEN&&, &&DOCUMENTO_FINAL&&, &&LINEA&&); END;");
            //
            //Registra la diferencia en un rubro de una jornada
            QueryMap.Add("WMS_P_REG_DIFERENCIA", @"BEGIN WMS_P_REG_DIFERENCIA(&&JORNADA&&, '&&RUBRO&&', &&TOTAL_USUARIO&&, &&TOTAL_SISTEMA&&,
                &&DIFERENCIA&&, '&&USUARIO&&', '&&RAZON&&'); END;");
            //
            //Obtener el número de depósito y planilla de los depósitos
            QueryMap.Add("DEPOSITOS", "SELECT DISTINCT NO_DEPOSITO, NO_PLANILLA, MONEDA FROM WMS_V_DEPOSITOS WHERE JORNADA = &&JORNADA&& ORDER BY NO_DEPOSITO DESC");
            //
            //Modifica el número de depósito
            QueryMap.Add("WMS_P_MODIF_NUMDEPOSITO", @"BEGIN WMS_P_MODIF_NUMDEPOSITO('&&NO_DEPOSITO&&', '&&NO_DEPOSITOV&&', &&JORNADA&&, '&&USUARIO&&', '&&MONEDA&&'); END;");
            //
            //Modifica el número de planilla
            QueryMap.Add("WMS_P_MODIF_NUMPLANILLA", @"BEGIN WMS_P_MODIF_NUMPLANILLA('&&NO_PLANILLA&&', '&&NO_PLANILLAV&&', &&JORNADA&&, '&&USUARIO&&', '&&MONEDA&&'); END;");
            //
            //Obtiene el pedido asociado al voucher de credix o credie
            QueryMap.Add("POS_F_PEDIDO_VOUCHER", "SELECT POS_F_PEDIDO_VOUCHER(&&TIPO_PAGO&&, &&JORNADA&&, &&REFERENCIA&&, '&&AUTORIZACION&&', &&ID_PROV&&) FROM DUAL");
            //
            //Verifica que exista el vale
            QueryMap.Add("ExisteValeEmitido", "SELECT COUNT(1) FROM RET_V_VALES WHERE VALE = &&VALE&& AND ESTADO NOT IN ('A', 'C')");
            //
            //Verifica si se puede registrar la diferencia de un rubro
            QueryMap.Add("POS_F_HABIL_REGISTRO_DIF_RUBRO", "SELECT POS_F_HABIL_REGISTRO_DIF_RUBRO('&&RUBRO&&') FROM DUAL");
            //
            //Obtiene la diferencia de la jornada
            QueryMap.Add("POS_F_DIFERENCIACC", "SELECT POS_F_DIFERENCIACC(&&JORNADA&&) FROM DUAL");
            //
            //Elimina la diferencia en un rubro de una jornada
            QueryMap.Add("WMS_P_ELIM_DIFERENCIA", @"BEGIN WMS_P_ELIM_DIFERENCIA(&&JORNADA&&, '&&RUBRO&&'); END;");
            //
            //Obtiene el sobrante o faltante, y las observaciones de la jornada
            QueryMap.Add("DIFERENCIAS_OBSERVACIONES_JORNADA", @"SELECT POS_F_DIFERENCIA_JORNADACC(&&JORNADA&&) TOTAL_DIFERENCIAS, WMS_F_OBSERV_BANCOS(1, &&JORNADA&&) OBSERV_BANCOS,
                 WMS_F_OBSERV_CIERRE(1, &&JORNADA&&) OBSERV_CIERRE FROM DUAL");
            //
            //Obtiene el sobrante o faltante de la tienda
            /*QueryMap.Add("DIFERENCIAS_OBSERVACIONES_TIENDA", @"SELECT POS_F_DIFERENCIA_TIENDACC(&&IDCIERRE&&) TOTAL_DIFERENCIAS, WMS_F_OBSERV_BANCOS(&&IDCIERRE&&, NULL) OBSERV_BANCOS,
                 WMS_F_OBSERV_CIERRE(&&IDCIERRE&&, NULL) OBSERV_CIERRE FROM DUAL");*/
            QueryMap.Add("DIFERENCIAS_OBSERVACIONES_TIENDA", @"SELECT POS_F_DIFERENCIA_TIENDACC(&&IDCIERRE&&) TOTAL_DIFERENCIAS FROM DUAL");
            //
            //Obtiene el id del cierre consolidado
            QueryMap.Add("POS_F_IDCIERRE", "SELECT POS_F_IDCIERRE( TO_DATE('&&FECHA_CIERRE&&', 'DD/MM/YYYY') ) FROM DUAL");
            //
            //Obtiene el total o los rubros a mostrar de la jornada
            QueryMap.Add("WMS_V_REP_CIERRES_CONSOLIDADOS", "SELECT JORNADA, RUBRO, TOTAL_SISTEMA, TOTAL_USUARIO, SOBRANTE, FALTANTE, USUARIO FROM WMS_V_REP_CIERRES_CONSOLIDADOS WHERE JORNADA = &&JORNADA&&");
            //
            //Obtiene los datos para el cobro de faltantes
            QueryMap.Add("POS_V_COBRO_DIFERENCIASCC", @"SELECT JORNADA, USUARIO, CAJERO, CEDULA, FECHA, PATRONO, CUENTA, FALTANTE, FALTANTE_LETRAS, IMPRESION, TIENDA
                    FROM POS_V_COBRO_DIFERENCIASCC WHERE JORNADA = &&JORNADA&&");

            #endregion

            #region FONABE
            //Procedimiento para registrar la devolución de efectivo
            QueryMap.Add("WMS_P_DEVOLEFECTIVOF", "BEGIN WMS_P_DEVOLEFECTIVOF(&&DOCUMENTO&&, '&&USUARIO&&', &&JORNADA&&); END;");
            //
            //Función que indica si a la factura se le han hecho devoluciones en efectivo de FONABE
            QueryMap.Add("WMS_F_EXISTEDEVOLF", "SELECT WMS_F_EXISTEDEVOLF(&&DOCUMENTO&&) FROM DUAL");
            //
            //Anula la devolución de efectivo de FONABE
            QueryMap.Add("WMS_P_ANULDEVOLFONABE", "BEGIN WMS_P_ANULDEVOLFONABE(&&DOCUMENTO&&); END;");
            //
            //Obtiene el total de le entrega de efectivo de FONABE
            QueryMap.Add("WMS_F_FONABE", "SELECT WMS_F_FONABE(&&JORNADA&&) FROM DUAL");
            //
            //Aumenta el número de impresiones del comprobante
            QueryMap.Add("WMS_P_FONIMPRESIONES", "BEGIN WMS_P_FONIMPRESIONES(&&DOCUMENTO&&); END;");
            #endregion

            #region BCR
            //Obtener terminalid y key
            QueryMap.Add("ObtTermKey", "SELECT TERMINALNUMBER, KEY FROM WMS_DATOS_EMISORES WHERE CAJA = &&CAJA&& AND EMISOR = 3");
            //
            //Obtener el RV_LOW_VALUE
            QueryMap.Add("RV_LOW_VALUE", "SELECT RV_LOW_VALUE FROM CG_REF_CODES WHERE RV_DOMAIN = '&&DOMAIN&&' AND RV_MEANING = '&&MEANING&&'");
            //
            //Obtiene el siguiente valor de una secuencia
            QueryMap.Add("ObtSecuencia", "SELECT &&SECUENCIA&&.NEXTVAL FROM DUAL");
            //
            //Almacena el número de tarjeta y tarjetahabiente
            QueryMap.Add("WMS_P_REGDATTARJ", "BEGIN WMS_P_REGDATTARJ(&&ID_TR_TARJ&&, '&&TARJETHAB&&', '&&TARJETA&&', &&SYSTEMTRACE&&); END;");
            //
            //Obtener los vouchers de la jornada
            QueryMap.Add("WMS_V_VOUCHERS_BCR", @"SELECT ID, TARJETA, MONTO, AUTORIZACION, REFERENCIA, TIPO, TARJETAHABIENTE, 
            FACTURA, FECHA, CAJA, USUARIO, JORNADA, DOCUMENTO, SYSTEMTRACE FROM WMS_V_VOUCHERS_BCR WHERE JORNADA = &&JORNADA&&");
            //
            //Imprimir voucher
            QueryMap.Add("WMS_P_GENERAR_IMPRVO", @"
                BEGIN
                    WMS_P_GENERAR_IMPRVO.GENERAR_IMPRESIONVO(&&ID_TR_TARJ&&,&&FORMATO&&,'&&USUARIO&&');
                END;                
            ");
            //
            //Imprimir voucher con factura o recibo
            QueryMap.Add("GENERAR_IMPRESIONVOF", @"
                BEGIN
                    WMS_P_GENERAR_IMPRVO.GENERAR_IMPRESIONVO(&&ID_TR_TARJ&&,&&FORMATO&&,'&&USUARIO&&', &&DOCUMENTO&&);
                END;                
            ");
            //
            //Genera factura con voucher
            QueryMap.Add("GENERAR_IMPRESION_POSV", @"
                BEGIN
                    WMS_P_GENERA_IMPRESION.GENERAR_IMPRESION_POS(&&DOCUMENTO&&,&&FORMATO&&,'&&USUARIO&&', &&ID_TR_TARJ&&);
                END;                
            ");
            //Imprimir vale
            QueryMap.Add("WMS_P_GENERAR_IMPRV", @"
                BEGIN
                    WMS_P_GENERAR_IMPRV.GENERAR_IMPRESIONV(&&DOCUMENTO&&,&&FORMATO&&,'&&USUARIO&&');
                END;                
            ");
            //
            //Obtener tarjeta
            QueryMap.Add("ObtTarj", "SELECT F_DECRYPT(PRIMACNUM) FROM WMS_LOG_TR_TARJETAS WHERE ID_TR_TARJ = &&ID_TR_TARJ&&");
            //
            //Obtener fecha key
            QueryMap.Add("ObtFechaK", "SELECT MODIFICACION_KEY FROM WMS_DATOS_EMISORES WHERE EMISOR = 3 AND CAJA = &&CAJA&&");
            //
            //
            QueryMap.Add("AlmKey", "BEGIN WMS_P_CAMBIOKEY(&&CAJA&&, '&&KEY&&'); END;");
            //
            //
            QueryMap.Add("ObtAnul", "SELECT ID FROM WMS_V_VOUCHERS_BCR WHERE AUTORIZACION = '&&AUTORIZACION&&' AND  REFERENCIA = '&&REFERENCIA&&' AND TIPO = 'Anulación'");
            //
            //Logs
            QueryMap.Add("WMS_LOG_INI_BCR", "BEGIN WMS_LOG_INI_BCR(&&IDLOG&&, '&&TEXTO&&', &&CAJA&&); END;");
            //
            QueryMap.Add("WMS_LOG_FIN_BCR", "BEGIN WMS_LOG_FIN_BCR(&&IDLOG&&, '&&TEXTO&&'); END;");
            #endregion

            //Aumentar el número de impresiones del comprobante de recarga IGF
            QueryMap.Add("WMS_P_RECARGIMPRESIONES", "BEGIN WMS_P_RECARGIMPRESIONES(&&DOCUMENTO&&); END;");

            #region Caja Chica
            //Obtiene las categorías de retiros de caja chica
            QueryMap.Add("ObtCategorias", "SELECT RV_LOW_VALUE, RV_MEANING FROM CAJACH_V_CATEGORIAS");
            //
            //Obtiene las subcategorías de retiros de caja chica
            QueryMap.Add("ObtSubcategorias", "SELECT RV_LOW_VALUE, RV_MEANING FROM CAJACH_V_SUBCATEGORIAS WHERE RV_MPCC01 = '&&SUBCATEGORIA&&'");
            //
            //Obtienelos porcentajes de iva de retiros de caja chica
            QueryMap.Add("ObtIva", "SELECT IMPUESTO FROM wms_impuestos_iva WHERE PIVA = &&PIVA&&");
            //

            //Almacena el retiro de caja chica
            QueryMap.Add("WMS_P_ALMCAJACH", "BEGIN WMS_P_ALMCAJACH(&&IDCAJACH&&, &&JORNADA&&,'&&CATEGORIA&&', '&&SUBCATEGORIA&&', '&&NO_DEPOSITO&&', '&&USUARIO&&', '&&DOCUMENTO&&', &&SUBTOTAL&&, &&MONTO&&); END;");
            //
            //Obtener los retiros de caja chica de la jornada
            QueryMap.Add("WMS_V_CAJACHICA", "SELECT RETIRO, MONTO, NO_DEPOSITO, CATEGORIA, SUBCATEGORIA, DOCUMENTO FROM WMS_V_CAJACHICA WHERE JORNADA = &&JORNADA&&");
            //
            //Anular un retiro de caja chica de la jornada
            QueryMap.Add("WMS_P_ANULCAJACH", "BEGIN WMS_P_ANULCAJACH(&&RETIRO&&, '&&USUARIO&&'); END;");
            //
            //Almacena los iva de caja chica de la jornada
            QueryMap.Add("WMS_P_IVA_CAJACHICA", "BEGIN WMS_P_IVA_CAJACHICA(&&IDCAJACH&&, &&PORCENTAJEIVA&&, &&IVA&&); END;");
            //
            //Obtener los datos de un retiro de caja chica
            QueryMap.Add("WMS_V_RETIROS_CAJACH", "SELECT RETIRO, EMPRESA, CAJA, MONTO, NO_DEPOSITO, JORNADA, USUARIO, CATEGORIA, SUBCATEGORIA, FECHA, HORA, DOCUMENTO FROM WMS_V_RETIROS_CAJACH WHERE RETIRO = &&RETIRO&&");
            //
            //Obtiene el total de retiros de caja chica
            QueryMap.Add("TotalCajaCH", "SELECT NVL(SUM(MONTO), 0) FROM WMS_V_CAJACHICA WHERE JORNADA = &&JORNADA&&");
            //
            //Obtener los retiros de caja chica
            QueryMap.Add("WMS_V_RETIROS_CAJACHJ", "SELECT RETIRO, EMPRESA, CAJA, MONTO, NO_DEPOSITO, JORNADA, USUARIO, CATEGORIA, SUBCATEGORIA, FECHA, HORA, DOCUMENTO FROM WMS_V_RETIROS_CAJACH WHERE JORNADA = &&JORNADA&&");
            #endregion

            #region Gift Card
            //Guarda los datos de las gift card
            QueryMap.Add("WMS_P_ALMGIFTCARD", "BEGIN WMS_P_ALMGIFTCARD('&&TARJETA&&', '&&USUARIO&&', &&DOCPEDIDO&&, &&MONTO&&); END;");
            //
            //Guarda el documento de la factura donde se cobró la gift card
            QueryMap.Add("WMS_P_FACTGIFTCARD", "BEGIN WMS_P_FACTGIFTCARD('&&pTARJETA&&', &&pDOCPEDIDO&&, &&pDOCFACTURA&&); END;");
            //
            //Guarda la recarga de la gift card
            QueryMap.Add("WMS_P_RECGIFTCARD", "BEGIN WMS_P_RECGIFTCARD('&&TARJETA&&', &&DOCUMENTO&&, &&MONTO&&, '&&USUARIO&&'); END;");
            //
            //Guarda los datos del reemplazo de tarjeta
            QueryMap.Add("WMS_P_REEMPLAZARGC", "BEGIN WMS_P_REEMPLAZARGC('&&TARJETAV&&', '&&TARJETAN&&', '&&USUARIO&&'); END;");
            //
            //Verifica si existe la tarjeta
            QueryMap.Add("GiftCExiste", "SELECT COUNT(1) FROM WMS_GIFTCARD WHERE TARJETA = '&&TARJETA&&' AND DOC_FACTURA IS NOT NULL");

            //Selecciona las GiftCards de un Pedido para activarlas
            QueryMap.Add("GiftCards", "select tarjeta, monto,usuario_anulo,fecha_anulacion FROM wms_GIFTCARD WHERE DOC_PEDIDO = &&pDOCPEDIDO&&");

            //Guarda los datos del id de redimir giftcard proveedor pDOCUMENTO", pTARJETA","pVALOR","pIDMAESTRO
            QueryMap.Add("WMS_AIDGIFTCARD", "BEGIN WMS_P_AIDGIFTCARD(&&pDOCUMENTO&&,'&&pTARJETA&&',&&pVALOR&&,'&&pIDMAESTRO&&'); END;");

            //Guarda la factura, saldo y fecha de la recarga de la gift card    pTARJETA , pDOCUMENTO ,pFACTURA , pSALDO , pUSUARIO
            QueryMap.Add("WMS_P_ACTRECGIFTCARD", "BEGIN WMS_P_ACTRECGIFTCARD('&&pTARJETA&&', &&pDOCUMENTO&&,&&pFACTURA&&, &&pSALDO&&, '&&pUSUARIO&&'); END;");

            //Selecciona las GiftCards de un Pedido para recargar
            QueryMap.Add("GiftCardsRec", "select tarjeta, monto, usuario_anulo,fecha_anulacion FROM WMS_RECARGAS_GIFTCARD WHERE DOC_PEDIDO = &&pDOCPEDIDO&&");
            //
            //Total de pagos con giftcard
            QueryMap.Add("TotalGiftCard", "SELECT NVL(SUM(MONTO), 0) TOTAL_GIFTCARD FROM WMS_V_GIFTCARD WHERE JORNADA = &&JORNADA&&");
            //
            //Verifica si tiene un pago con gift card
            QueryMap.Add("WMS_F_EXISTEGIFTC", "SELECT WMS_F_EXISTEGIFTC(&&DOCUMENTO&&) FROM DUAL");
            #endregion

            //Valida que no haya en el pedido, artículos con la cantidad en negativo
            QueryMap.Add("WMS_F_CANTNEGATIVO", "SELECT WMS_F_CANTNEGATIVO(&&DOCUMENTO&&) FROM DUAL");

            #region Devoluciones Entre Tiendas
            //Obtiene el documento de la factura
            QueryMap.Add("WMS_F_DEVOLTIENDS_DOC", "SELECT WMS_F_DEVOLTIENDS_DOC('&&SERIE&&', '&&NO_DOCUMENTO&&') FROM DUAL");
            //
            //Obtiene la cantidad del artículo en el documento
            QueryMap.Add("WMS_F_DEVOLTIENDS_CANTIDAD", "SELECT WMS_F_DEVOLTIENDS_CANTIDAD(&&DOCUMENTO&&, '&&SKU_ALTERNO&&', &&CANTIDAD&&, &&DOCUMENTOD&&) FROM DUAL");
            #endregion

            //Anulación de un retiro
            QueryMap.Add("WMS_P_ELIMRETIRO", "BEGIN WMS_P_ELIMRETIRO(&&RETIRO&&, &&JORNADA&&, '&&USUARIO&&'); END;");
            //
            //Total Recargas y Servicios Públicos
            QueryMap.Add("TotalRecargas_ServP", @"SELECT SUM(TOTAL) FROM (
                                SELECT NVL(SUM(MONTO), 0) TOTAL FROM WMS_V_BNSERVICIOS WHERE JORNADA = &&JORNADA&&
                                UNION ALL
                                SELECT NVL(SUM(MONTO), 0) TOTAL FROM WMS_V_RECARGAS2 WHERE JORNADA = &&JORNADA&&                                
                         )");
            //

            #region Cambios Para Cupón Credie IMGF

            //Indica si se habilita o no un botón de la pantalla de pago
            QueryMap.Add("POS_F_BOTON_HABILITADO", "SELECT POS_F_BOTON_HABILITADO('&&TIPO_PAGO&&', &&DOCUMENTO&&, '&&GRUPO_PAGO&&') FROM DUAL");
            //
            //Obtiene el monto del cupón de la factura
            QueryMap.Add("POS_F_MONTO_CUPON", "SELECT POS_F_MONTO_CUPON(&&DOCUMENTO&&) FROM DUAL");

            //Obtiene el monto del cupon y el total aplicable en la factura actual
            QueryMap.Add("POS_MONTOSCUPONCREDIE", @"SELECT NVL(POS_F_MONTO_CUPON(&&pDOCUMENTO&&), 0 ) CUPON,NVL(EKO_F_MONTO_CUPONE(&&pDOCUMENTO&&), 0) APLICABLE
                    FROM DUAL                                                             
                         ");

            //Obtiene el cupon DE UN PEDIDO
            QueryMap.Add("POS_CCUPONCREDIE", @"SELECT NVL(MAX(NID_CUPON),0) FROM pos_cupones_credie WHERE NDOC_ORIGEN = &&pDOCUMENTO&& AND CESTADO = 'E'                        
                         ");

            //CREAR CUPON CREDIE
            QueryMap.Add("EKO_P_CREAR_CUPON_CREDIE", "BEGIN EKO_P_CREAR_CUPON_CREDIE( &&pJORNADA&& , &&pDOCUMENTO&& , '&&pUSUARIO&&' ); END;");

            //APLICA CUPON CREDIE
            QueryMap.Add("EKO_P_APLICA_CUPONE", "BEGIN eko_p_aplica_cupone( &&p_documento&& , &&p_cupon&&, '&&p_local&&' ); END;");

            //Eliminar cupones credIE
            QueryMap.Add("ElimCuponCREDIE", "BEGIN EKO_P_BORRAR_CUPONESCREDIE(&&pDocumento&&); END;");

            //CUPON CREDIE cobrado
            QueryMap.Add("EKO_P_CANJE_CUPON_CREDIE", "BEGIN EKO_P_CANJE_CUPON_CREDIE( &&pDOCUMENTO&& ); END;");

            #endregion

            #region Descuentos Asociaciones

            //Valida si el socio del documento, aplica para los descuentos de la asociaciones
            QueryMap.Add("POS_F_VALIDAR_ASOCIACION", "SELECT POS_F_VALIDAR_ASOCIACION(&&DOCUMENTO&&) FROM DUAL");
            //
            //Marcar documento como documento de una asociación que se pagará con pagos específicos
            QueryMap.Add("POS_P_SOCIO_ASOCIACION", "BEGIN POS_P_SOCIO_ASOCIACION(&&DOCUMENTO&&, '&&GRUPO_PAGO&&'); END;");
            //
            //Obtener el descuento de la asociacion
            QueryMap.Add("OBTENER_DESCUENTO_ASOCIACIONES", "SELECT CASE WHEN '&&TIPO_PAGO&&' = 'Contado' THEN" +
                                "                                NVL(NDESC_CONTADO_CLIENTE, 0) " +
                                "                               WHEN '&&TIPO_PAGO&&' = 'Credito' THEN    " +
                                "                                NVL(NDESC_CREDITO_CLIENTE, 0) " +
                                "                               ELSE " +
                                "                                0" +
                                "                               END" +
                                "                     FROM POS_DESCUENTO_ASOCIACIONES WHERE NSOCIO = &&SOCIO&&");
            //
            //Aplicar descuentos de la asociación
            QueryMap.Add("POS_P_DESCUENTO_ASOCIACIONES", "BEGIN POS_P_DESCUENTO_ASOCIACIONES(&&DOCUMENTO&&, '&&USUARIO&&', &&DESCUENTO&&); END;");
            //
            //QUitar descuentos de la asociación
            QueryMap.Add("POS_P_DESMARCAR_ASOCIACION", "BEGIN POS_P_DESMARCAR_ASOCIACION(&&DOCUMENTO&&); END;");

            #endregion
            //
            //Revisa si el efectivo (colón o dólar) es permitido para el socio
            QueryMap.Add("POS_F_VALIDA_EFECTIVO", "SELECT POS_F_VALIDA_EFECTIVO(&&pMONEDA&&, &&pSOCIO&&) FROM DUAL");
            //

            #region Exoneracion--Ariel Vargas
            //Guarda el impuesto aplicado para un socio
            QueryMap.Add("EX_SP_IVA_VARIABLE", @"BEGIN EX_SP_IVA_VARIABLE('&&pCIDENTIFICACION&&', &&pIMPUESTO&&); END;");

            //Obtiene los tipos de iva nuevos
            QueryMap.Add("EX_VW_IVA_VARIABLE", "SELECT IMPUESTO, IVA FROM EX_VW_IVA_VARIABLE");

            //Guarda o actualiza los campos
            QueryMap.Add("EX_SP_ACTUALIZCION_IVA", "BEGIN EX_SP_ACTUALIZCION_IVA(&&pDOCUMENTO&&, &&pIVA&&, &&pDESC&&, '&&pUSUARIO&&', '&&pSENTENCIA&&'); END;");

            //Muestra los datos guardados
            QueryMap.Add("DATOS_IVA", "SELECT IVA, DESCUENTO, IVA_DIF FROM EX_DESCUENTOS_IVA WHERE ANULADO_POR IS NULL AND DOCUMENTO = &&pDOCUMENTO&&");

            //Vedifirca que exista los datos
            QueryMap.Add("Exonera_documento", "SELECT COUNT(1) FROM EX_DESCUENTOS_IVA WHERE ANULADO_POR IS NULL AND DOCUMENTO = &&pDOCUMENTO&&");
            QueryMap.Add("Exo_Datos", "SELECT COUNT(1) FROM EX_DESCUENTOS_IVA WHERE ANULADO_POR IS NULL AND DOCUMENTO = &&pDOCUMENTO&& AND IVA = &&pIVA&&");
            #endregion

            #region Facturas - ECOM
            //Muestra en que estado se encuentra el numero de orden
            QueryMap.Add("FacturasEcom", @"SELECT CNUM_ORDEN, CFACTURA, NTOTAL, DFECHA, CESTADO, CCOD_ESTADO, NDOCUMENTO, NSHIPPING FROM EKONO.EC_V_FACTURAS &&FILTRO&& ORDER BY CNUM_ORDEN ASC");
            //Muestra el encabezado de un numero de orden
            QueryMap.Add("FacturasEncabezadoEcom", @"SELECT CNUM_ORDEN, CFACTURA, NTOTAL, DFECHA, CESTADO, CCOD_ESTADO, NDOCUMENTO, NSHIPPING FROM EKONO.EC_V_FACTURAS WHERE CNUM_ORDEN='&&NUMORDEN&&'");
            //Muestra el detalle de una orden de compra en especifico
            QueryMap.Add("FacturasDetalleEcom", @"SELECT CNUM_ORDEN,NLINEA,NSKU,CCOLOR,CTALLA,NCANTIDAD,NDOCUMENTO FROM EKONO.EC_V_DET_FACTURAS WHERE CNUM_ORDEN='&&NUMORDEN&&'");
            //Actualiza el estado el estado de la entrega
            QueryMap.Add("EntregarClienteEcom", "BEGIN EC_P_ACTUALIZAR_ENTREGA('&&NUMORDEN&&', '&&USUARIO&&'); END;");
            //Obtiene los filtros del formulario
            QueryMap.Add("Filtros", "SELECT FILTER_NAME, WHERE_CLAUSE FROM CG_USER_FILTERS WHERE MODULE_NAME = '&&MODULE&&' ORDER BY FILTER_NAME");
            //Obtiene el filtro usado la última vez en el formulario
            QueryMap.Add("FiltroUsado", @"SELECT FILTER_NAME FROM CG_USER_FILTERS WHERE LAST_USED =
                (SELECT MAX(LAST_USED) FROM CG_USER_FILTERS WHERE MODULE_NAME = '&&MODULE&&')");

            //Indica cuál filtro se está usando en ese formulario
            QueryMap.Add("ModifFiltro", "BEGIN CG_P_MODFILTRO('&&MODULE&&', '&&FILTER&&'); END;");

            // Reversa la entrega a cliente
            QueryMap.Add("EC_P_REVERSAR_ENTREGA", "BEGIN EC_P_REVERSAR_ENTREGA('&&pCNUM_ORDEN&&', '&&pUSUARIO&&'); END;");
            //
            // Devoluciones - ECOM
            //
            // Verifica si el pedido de devolución tiene más de una factura a devolver, y si es de Ecommerce
            QueryMap.Add("EKO_F_VALIDAR_DEVOL", "SELECT EKO_F_VALIDAR_DEVOL(&&pDOCUMENTO&&) FROM DUAL");
            //
            // Obtiene los bancos para la transferencia
            QueryMap.Add("EC_V_BANCOS_TRANSF", "SELECT ID, BANCO FROM EC_V_BANCOS_TRANSF ORDER BY BANCO ASC");
            //
            // Almacena los datos para la transferencia
            QueryMap.Add("EC_P_ALM_TRANSF_DEVOL", @"BEGIN EC_P_ALM_TRANSF_DEVOL( &&pNDOCUMENTO_DEVOL&&, &&pNDOCUMENTO_FACT&&, '&&pCBANCO&&',
             '&&pCCEDULA&&', '&&pCNOMBRE&&', '&&pCAPELLIDO1&&', '&&pCAPELLIDO2&&', '&&pCTELEFONO&&', 
             '&&pCEMAIL&&', '&&pCCREADO_POR&&', '&&pCAUTORIZADO_POR&&', '&&pCCUENTA&&' ); END;");

            #endregion

            // Registra una devolución en efectivo, donde se entrega una cantidad mayor al límite
            QueryMap.Add("EKO_P_BITAC_DEVOL_EFECTIVO", "BEGIN EKO_P_BITAC_DEVOL_EFECTIVO(&&pNPEDIDO_DEVOL&&, '&&pCAUTORIZADO_POR&&'); END;");

            #region Factura Electrónica

            // Obtiene la tarjeta de puntos del cliente, si existe
            QueryMap.Add("OBTENER_TARJETA", "SELECT MAX(TARJETA) FROM WMS_CLIENTES_PTS WHERE CEDULA = '&&pCEDULA&&'");

            // Se obtiene los datos para el envío
            QueryMap.Add("OBTENER_DATOS_ENVIO", @"SELECT CG_F_PARAMETER_VALUE('USFE') USUARIO,
                    CG_F_PARAMETER_VALUE('PAFE') PASSWORD, CG_F_PARAMETER_VALUE('CJFE') CED FROM DUAL");

            // Se obtiene la trama de control y del documento, además de los datos para el envío
            QueryMap.Add("OBTENER_TRAMAS", @"SELECT FE_PQ_DATOS_TRAMAS.FE_F_TRAMA(&&pNDOCUMENTO&&, 'TCTL') CTL,
                    FE_PQ_DATOS_TRAMAS.FE_F_TRAMA(&&pNDOCUMENTO&&, 'TDFE') TRAMA, CG_F_PARAMETER_VALUE('USFE') USUARIO,
                    CG_F_PARAMETER_VALUE('PAFE') PASSWORD, CG_F_PARAMETER_VALUE('CJFE') CED FROM DUAL");

            // Se obtiene la trama de control y del documento
            QueryMap.Add("OBTENER_SOLO_TRAMAS", @"SELECT FE_PQ_DATOS_TRAMAS.FE_F_TRAMA(&&pNDOCUMENTO&&, 'TCTL') CTL,
                    FE_PQ_DATOS_TRAMAS.FE_F_TRAMA(&&pNDOCUMENTO&&, 'TDFE') TRAMA FROM DUAL");

            // Indica si el documento es factura electrónica o no
            QueryMap.Add("FE_F_FACTURA_ELECTRONICA", "SELECT FE_F_FACTURA_ELECTRONICA('&&pDOCUMENTO&&') FROM DUAL");

            // Dependiendo del dato enviado, se obtiene el socio o la identificación
            QueryMap.Add("FE_F_IDENTIFICACION_INST", "SELECT FE_F_IDENTIFICACION_INST(&&pSOCIO&&, '&&pIDENTIFICACION&&') FROM DUAL");

            // Obtiene el límite de crédito del socio
            QueryMap.Add("WMS_F_LIMITE_CREDITO", "SELECT WMS_F_LIMITE_CREDITO2(&&pSOCIO&&) FROM DUAL");

            // Almacena la respuesta al envío del documento
            QueryMap.Add("FE_P_ALM_RESPUESTA", @"BEGIN FE_P_ALM_RESPUESTA(&&pNDOCUMENTO&&, '&&pCCODIGO&&', '&&pCRESPUESTA&&', '&&pCRESPUESTA_XML&&', '&&pCCLAVE&&'); END;");

            // Anula el registro de los datos de una exoneración
            QueryMap.Add("FE_P_ANUL_EXONERACION", @"BEGIN FE_P_ANUL_EXONERACION(&&pNDOCUMENTO&&, '&&pUSUARIO&&'); END;");

            // Genera las tramas de los documentos que no tienen
            QueryMap.Add("FE_P_CREAR_TRAMAS_FALTANTES", "BEGIN FE_P_CREAR_TRAMAS_FALTANTES; END;");

            // Registra los datos de una exoneración
            QueryMap.Add("FE_P_DATOS_EXONERACION", @"BEGIN FE_P_DATOS_EXONERACION(&&pNDOCUMENTO&&, '&&pCTIPO_DOCUMENTO&&', '&&pCNUMERO_DOCUMENTO&&', 
                '&&pCIDENTIFICACION&&', TO_DATE('&&pDFECHA_EMISION&&', 'DD/MM/YYYY HH:MI:SS A.M.'), '&&pUSUARIO&&'); END;");

            // Crea o actualiza la trama
            QueryMap.Add("FE_P_CREAR_TRAMA", @"BEGIN FE_PQ_DATOS_TRAMAS.FE_P_CREAR_TRAMA(&&pNDOCUMENTO&&); END;");

            // Registra la relacion del cliente al que se le envia la FE de la Asociacion
            QueryMap.Add("FE_P_CREAR_CLIENTE_ASOCIACION", @"BEGIN FE_P_REGIST_CLIENT_ASOCIAC(&&pNCLIENTE&&, &&pNASOCIACION&&, &&pNDOCUMENTO&&, '&&pCTIPO&&'); END;");

            // ELIMINA relacion del cliente al que se le envia la FE de la Asociacion
            QueryMap.Add("DELETE_CLIENTE_FE_ASOCIACION", @" DELETE FROM WMS_FE_DOC_CLIENTEXASOCIACION WHERE NDOCUMENTO = &&pNDOCUMENTO&&");

            // Guarda o actualiza los datos de un receptor
            QueryMap.Add("FE_P_REGISTRAR_RECEPTOR", @"BEGIN FE_P_REGISTRAR_RECEPTOR('&&pCIDENTIFICACION&&', '&&pCNOMBRE&&', '&&pCAPELLIDO1&&', '&&pCAPELLIDO2&&', 
                '&&pCEMAIL&&', '&&pCTELEFONO&&', '&&pCPROVINCIA&&', '&&pCCANTON&&', '&&pCTIPO_IDENTIFICACION&&', '&&pCUSUARIO&&'); END;");

            // Registra un error
            QueryMap.Add("FE_P_REGISTRO_ERROR", @"BEGIN FE_P_REGISTRO_ERROR(&&pNDOCUMENTO&&, '&&pCERROR&&'); END;");

            // Obtiene los documentos de tramas que no se han enviado
            QueryMap.Add("FE_V_DOCUMENTOS_TRAMAS", "SELECT NDOCUMENTO FROM FE_V_DOCUMENTOS_TRAMAS WHERE NVL(CENVIADA, 'N') = 'N' ORDER BY NDOCUMENTO");

            // Obtiene los datos de un receptor
            QueryMap.Add("FE_V_RECEPTORES", @"SELECT IDENTIFICACION, NOMBRE, APELLIDO1, APELLIDO2, TELEFONO, EMAIL, PROVINCIA, CANTON, TIPO_IDENTIFICACION FROM 
                FE_V_RECEPTORES WHERE IDENTIFICACION = '&&pIDENTIFICACION&&'");

            // Obtiene los datos de los receptores que concuerden con el dato de búsqueda
            QueryMap.Add("FE_V_RECEPTORES_BUSQUEDA", @"SELECT DISTINCT IDENTIFICACION, NOMBRE || ' ' || APELLIDO1 || ' ' ||  APELLIDO2 NOMBRE, TELEFONO, EMAIL, PROVINCIA, CANTON, TIPO_IDENTIFICACION FROM 
                FE_V_RECEPTORES WHERE TIPO_IDENTIFICACION IS NOT NULL AND (UPPER(IDENTIFICACION) LIKE UPPER('%&&pTEXTO&&%') OR 
                UPPER(NOMBRE) LIKE UPPER('%&&pTEXTO&&%') OR UPPER(TELEFONO) LIKE UPPER('%&&pTEXTO&&%') OR UPPER(EMAIL) LIKE UPPER('%&&pTEXTO&&%'))");

            // Obtiene los tipos de exoneración
            QueryMap.Add("FE_V_TIPO_DOC_EXONERACION", "SELECT ID_TIPO, TIPO FROM FE_V_TIPO_DOC_EXONERACION ORDER BY TIPO");

            // Obtiene los tipos de identificación
            QueryMap.Add("FE_V_TIPO_IDENTIFICACION", "SELECT ID_TIPO, TIPO FROM FE_V_TIPO_IDENTIFICACION ORDER BY TIPO");

            // Pasa la forma de pago del documento 1 al documento 2
            QueryMap.Add("FE_P_CAMBIO_FORMA_PAGO", "BEGIN FE_P_CAMBIO_FORMA_PAGO('&&pSERIE_DOC1&&','&&pNO_DOCUMENTO1&&', '&&pSERIE_DOC2&&', '&&pNO_DOCUMENTO2&&', '&&pUSUARIO&&', &&pJORNADA&&, &&pREVERSAR&&); END;");

            #endregion

            // Control de versión del POS
            QueryMap.Add("EKO_F_VERSION_POS_CORRECTA", "SELECT EKO_F_VERSION_POS_CORRECTA(&&CAJA&&, '&&VERSION&&') RESULTADO FROM DUAL");

            //Obtiene si una persona debe ser penalizado por el 5%            

            QueryMap.Add("ACC_CONS_PENALI_CREDIE", @"SELECT ACC_F_CONS_PENALI_CREDIE('&&p_cedula&&') FROM DUAL");

            //Registra el recibo generado por el pago efectivo de ecommerce 
            QueryMap.Add("GrabaRecibo", @"UPDATE WMS_DOCUMENTOS
                                          SET FACTURA_PROVEEDOR = '&&FACTURA_PROVEEDOR&&', 
                                              MODIFICADO_POR = '&&USUARIO1&&',
                                              MODIFICADO_EL = SYSDATE,
                                              TRANSPORTISTA = '&&NIT&&',
                                              OBSERVACIONES = '&&CLIENTE&&'
                                          WHERE DOCUMENTO = '&&DOCUMENTO&&' ");
            //Registra el pago generado por el pago efectivo de ecommerce
            QueryMap.Add("Graba_Pago_Documentos", @"UPDATE WMS_PAGO_DOCUMENTOS
                                                    SET TIPO_PAGO = '&&TIPO_PAGO&&',
                                                        MODIFICADO_EL = SYSDATE,
                                                        MODIFICADO_POR = '&&CREADO_POR&&'
                                                     WHERE DOCUMENTO = '&&DOCUMENTO&&' ");

            //Consulta si el recibo generado por pago efectivo ecommerce fue anulado  
            QueryMap.Add("C_Rec_Anulado", @"SELECT TIPO_DOCUMENTO,D.ANULADA_POR, D.ANULADA_EL FROM WMS_DOCUMENTOS D WHERE D.TIPO_DOCUMENTO = 'R' AND D.FACTURA_PROVEEDOR = '&&FACTURA_PROVEEDOR&&' AND D.FECHA_EMISION = (SELECT MAX(FECHA_EMISION) FROM WMS_DOCUMENTOS WHERE FACTURA_PROVEEDOR = '&&FACTURA_PROVEEDOR&&')");

            QueryMap.Add("C_Fecha_Inicio_E_Eco", @"SELECT CG_F_FECHA_INICIO_E_ECOMMERCE FROM DUAL");

            QueryMap.Add("C_Fecha_Fin_E_Eco", @"SELECT CG_F_FECHA_FIN_E_ECOMMERCE FROM DUAL");

            QueryMap.Add("ObtenerSocio", @"select wms_v_obtener_socio('&&NIT&&') from dual");

            QueryMap.Add("C_Cantidad_Recibos_E_Eco", @"select EC_F_CANTIDAD_RECIBOS_E_ECO('&&CAJA&&') from dual");

            QueryMap.Add("Obt_Ordenes_efectivo_ecom_x_caja", @"SELECT  ID_ORDEN,
                                                                    MONTO_ORDEN,
                                                                    NUM_CAJA,
                                                                    COD_SUCURSAL,
                                                                    NOMBRE_CLIENTE,
                                                                    IDENTIFICACION_CLIENTE 
                                                               FROM EC_V_ORDENES_EFECTIVO_ECO@ECOMMERCE
                                                              WHERE COD_SUCURSAL = '&&COD_SUCURSAL&&'
                                                                AND NUM_CAJA = '&&CAJA&&' ");
            QueryMap.Add("Obt_Ordenes_efectivo_ecom", @"SELECT  ID_ORDEN,
                                                                    MONTO_ORDEN,
                                                                    NUM_CAJA,
                                                                    COD_SUCURSAL,
                                                                    NOMBRE_CLIENTE,
                                                                    IDENTIFICACION_CLIENTE 
                                                               FROM EC_V_ORDENES_EFECTIVO_ECO@ECOMMERCE
                                                              WHERE COD_SUCURSAL = '&&COD_SUCURSAL&&' ");

            #region SINPE MOVIL

            QueryMap.Add("ObtTokenSM", @"SELECT cg_f_parameter_value('SMUR') URL_TOKEN,cg_f_parameter_value('SMPS') PASSWORD,cg_f_parameter_value('SMUS') USUARIO,cg_f_parameter_value('SMVP') URL_PAGO FROM DUAL");

            QueryMap.Add("InsertToken", @"BEGIN WMS_P_INSERTA_TOKEN(&&pDOCUMENTO&&,'&&pTOKEN&&',&&pEXPIRA_EN&&,'&&pTOKEN_REFRES&&','&&pCAJA&&','&&pCambContra&&'); END;");

            QueryMap.Add("InsertCliente", @"BEGIN WMS_P_INSERTA_CLIEN(&&pDOCUMENTO&&,'&&pCEDULA&&',&&pMONTO&&,&&pJORNADA&&,'&&pCREADO_POR&&'); END;");

            QueryMap.Add("InsertRespPago", @"BEGIN WMS_P_INSERTA_PAGO(&&pID&&,&&pDOCUMENTO&&,&&pCODIGO&&,'&&pDESCRIPCION&&'); END;");

            QueryMap.Add("InsertTrans", @"BEGIN WMS_P_INSERT_TRANS(&&pID&&,&&pDOCUMENTO&&,'&&pREQUEST&&','&&pRESPONSE&&',&&pJORNADA&&,'&&pUSUARIO&&'); END;");

            QueryMap.Add("ObtCliente", @"SELECT * FROM WMS_V_CLIENTES_SINPE WHERE DOCUMENTO = &&pDOCUMENTO&&");

            QueryMap.Add("ObtCaja", @"SELECT USERNAME, KEY FROM WMS_DATOS_EMISORES WHERE CAJA = &&pCAJA&& AND EMISOR = 37");

            #endregion
        }

        private void adpDocumentos_RowUpdated(object sender, System.Data.OracleClient.OracleRowUpdatedEventArgs e)
        {

        }

        private void adpFacturasAProcesar_RowUpdated(object sender, System.Data.OracleClient.OracleRowUpdatedEventArgs e)
        {

        }

        private void adpArqueos_RowUpdated(object sender, System.Data.OracleClient.OracleRowUpdatedEventArgs e)
        {

        }

        private void PDV_Load(object sender, EventArgs e)
        {

        }
    }
}