﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using LLNet.Utils;
using System.Threading;
using System.Net;
using System.Web.Services.Protocols;
using System.Web;
using LLNet.GUI;
using System.IO;
using System.Xml;

using CSP.Authorizer.Framework.XmlOperator;
using CSP.Authorizer.Framework.Pinpad;
using CSP.Authorizer.Framework.StreamFormats.CNB;


namespace LLNet.Tienda.MainForms.Forms.OtrosServ.RapiBAC
{
    public partial class FrmRapibac : Form
    {
        #region variables
        private string vBacTienda, vBacUsuario, vBacClave, vtcVenta, vtcCompra, vMontoMaximo, vDisponible, vEfectivoCaja, vMontoRetiroMax;
        private string varCanton, varProvincia, varDistrito, varCod, varCodQ, varCodP;
        private string varCBanco, varCAgencia, varCCanal, varCLlave, varCEmpresa, varLlave, varInstit, varCConvenio, varConvenio, varComprob; //Variables de BNSERVICIOS
        private string vTrack1, vTrack2, vPinBlock, vKsn, vNumTarjeta, vNombreCliente, vEmpresa, vNumFactura;
        private string vDetRespuesta, vVarError = "";
        private int varCantImp = 1; // Cantidad de Impresiones que se necesita realice el Sistema
        public static int vtiempo = 3000 ;

        iPP320DriverCNB vPinpad = new iPP320DriverCNB(GUI.CApp.vLectorBac, 9600, System.IO.Ports.Parity.None, 8, System.IO.Ports.StopBits.One, 50000, 50000);
        private LLNet.Tienda.RapiBac2.ClientTerminalServiceClient vTerminalService = null;
        private LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.clsCnbCredentials vBacCredenciales = null;
        private LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle vDetTransaccion = null;


        private string vNumTerminal;
        private string vTipoCambio;
        private string sec_BacInvoice;
        private int sec_BcSequence;
        int varSECdeposito = 0;
        private string varTCompra = "";
        private string varTCventa = "";
        string sec_BacTC = "";
        int varSECconsulta = 0;
        private string vMontoConsulta;
        int varSECretiros = 0;

        #endregion

        public FrmRapibac()
        {
            InitializeComponent();
            mInicializar();
        }

        #region mTarjetaPruebas
        /// <summary>
        /// 
        /// </summary>
        private void mTarjetaPruebas()
        {
            vPinBlock = "28039DCEAC6A76A7";
            vNombreCliente = "KAREN GINETTE ARAYA SALAS";
            vKsn = "2222222222003B800320";
            vTrack1 = "8295A8416B1346179CB845FCFCE235E553083FE3480183ABD7D7CBB8EA63F173FA9CA6C804B561AAD16FB510F4AAE88A40D8C861E088DB1176202F9DE8A901BCD64434378AD494C8B7ECD66C5C5363CC";
            vTrack2 = "13F5D9E03EE800E9EF4655AE71477BE8F42715B891C60E93619E5FA08B4CB32CF140558BE49E8A02";
            vNumTarjeta = "4921XXXXXXXX2163";
        }
        #endregion

        #region mLimpiar
        /// <summary>
        /// Limpia los textos del formulario
        /// </summary>
        private void mLimpiar()
        {
            sbtnPagar.Visible = true;
            btnRecargar.Visible = false;
            //sBtnRecNic.Visible = false;
            //sBtnRecNic.Enabled = false;
            //gridControlBacPendG.DataSource = null;
            //gridControlBacPendG.Refresh();
            txtNombreClienteBac.Text = "";
            txtMonedaBac.Text = "";
            txtLlave.Text = "";
            txtmonto.Text = "";
            txtICEMES.Text = "";
            cboConsultaBac.Focus();
        }
        #endregion

        #region mInicializar
        /// <summary>
        /// Inicializa todos los procesos de conexión y valida las credenciales
        /// </summary>
        private void mInicializar()
        {
            ServicePointManager.SecurityProtocol = (SecurityProtocolType)3072;
            vTerminalService = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient();
            vBacCredenciales = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.clsCnbCredentials();
            vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();

            mIdentificarTerminal();
            mValidarCredenciales();
            vBacTienda = "";
            vBacUsuario = "";
            vBacClave = "";
            varCanton = "";
            varProvincia = "";
            varDistrito = "";
            varCod = "";
            varCodQ = "";
            varCodP = "";
            varCBanco = "";
            varCAgencia = "";
            varCCanal = "";
            varCLlave = "";
            varCEmpresa = "";
            varLlave = "";
            varInstit = "";
            varCConvenio = "";
            varConvenio = "";
            varComprob = ""; //Variables de BNSERVICIOS
            vTrack1 = "";
            vTrack2 = "";
            vPinBlock = "";
            vKsn = "";
            vNumTarjeta = "";
            vNombreCliente = "";
            vEmpresa = "";
            vDetRespuesta = "";
            vNumFactura = "";
            vTipoCambio = "";
            vtcVenta = "";
            vtcCompra = "";
            vMontoConsulta = "10";

        }
        #endregion

        #region mLimpiar2
        /// <summary>
        /// 
        /// </summary>
        private void mLimpiar2()
        {
            txtValorDeBusqueda.Text = "";
            txtNombreClienteBac.Text = "";
            txtMonedaBac.Text = "";
            mCargarTipoIdentificacion();
            mCargarMonedasPago();
            mCargarMonedasSaldo();
            txtIdentificacion.Text = "";
            //gridControlBacPendG.DataSource = null;
            //gridControlBacPendG.Refresh();
            txtMontoPago.Text = "";
            txtMontoPagado.Text = "";
            //txtMesCobroBac.Text = "";
            cboEmpBac.Focus();
        }
        #endregion

        #region mLimpiarBac
        /// <summary>
        /// 
        /// </summary>
        private void mLimpiarBac()
        {
            vDetTransaccion = null;
        }
        #endregion

        #region mLlenarParametros
        /// <summary>Obtiene los parámetros necesarios de cada tienda </summary>
        private void mLlenarParametros()
        {
            Utils.QueryParams vQp = new LLNet.Utils.QueryParams();
            vQp.AddReplaceParam("pCaja", Program.Caja.ToString());

            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_BAC", vQp);

            object[] datos = new object[5];
            datos = dsB.Tables[0].Rows[0].ItemArray;

            vBacTienda = datos[0].ToString();
            vBacUsuario = datos[1].ToString();
            vBacClave = datos[2].ToString();
            varCantImp = int.Parse(datos[3].ToString());
            vtiempo = int.Parse(datos[4].ToString());            
        }
        #endregion

        #region mCargaMontoMaximo
        /// <summary>Obtiene los parámetros necesarios de cada tienda </summary>
        private void mCargaMontoMaximo()
        {
            Utils.QueryParams vQp = new LLNet.Utils.QueryParams();

            vQp.AddReplaceParam("CMONTO_MAX", "RBAC");
            vQp.AddReplaceParam("CMONTORETIRO_MAX", "BRMX");

            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "CMONTO_MAX", vQp);


            if (dsB.Tables[0].Rows.Count > 0)
            {
                object[] datos = new object[2];

                datos = dsB.Tables[0].Rows[0].ItemArray;
                vMontoMaximo = datos[0].ToString();
                datos = dsB.Tables[0].Rows[1].ItemArray;

                vMontoRetiroMax = datos[0].ToString();

            }
        }
        #endregion

        #region mCargarEmpresas
        /// <summary>
        /// Carga en el combobox de las empresas las empresas del convenio con RapiBAC
        /// </summary>
        private void mCargarEmpresas()
        {

            try
            {
                DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_INST_BACSERV");

                foreach (DataRow Fila in dsB.Tables[0].Rows)
                {
                    DevExpress.XtraEditors.Controls.ComboBoxItem item;
                    item = new DevExpress.XtraEditors.Controls.ImageComboBoxItem(Fila[1].ToString(), Fila[0].ToString());
                    cboEmpBac.Properties.Items.Add(item);
                }
            }
            catch (Exception er)
            {
                GUI.CApp.ShowMessage(er.Message, "ERROR", true);
                //BitacoraIntentosE(id, Convert.ToString(er.Message));
            }
        }
        #endregion

        ArrayList lConvenios = new ArrayList();

        #region mCargarConvenios
        /// <summary>
        /// 
        /// </summary>
        private void mCargarConvenios(string pCodEmpresa)
        {
            try
            {
                //Limpiar variables
                lConvenios.Clear();
                cboConvBac.Properties.Items.Clear();

                //selecciona los datos para imprimir
                QueryParams qp = new LLNet.Utils.QueryParams();
                qp.AddReplaceParam("pEmpresa", pCodEmpresa);
                DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_CONV_BACSERV", qp);

                foreach (DataRow vFila in dsB.Tables[0].Rows)
                {
                    DevExpress.XtraEditors.Controls.ComboBoxItem vItem;
                    vItem = new DevExpress.XtraEditors.Controls.ImageComboBoxItem(vFila[2].ToString(), vFila[0].ToString());
                    cboConvBac.Properties.Items.Add(vItem);
                }

            }
            catch (Exception er)
            {
                GUI.CApp.ShowMessage(er.Message, "ERROR", true);
                //BitacoraIntentosE(id, Convert.ToString(er.Message));
            }
        }
        #endregion

        #region mCargarTipoIdentificacion
        /// <summary>
        /// Carga los tipos de identificación del BAC
        /// </summary>
        private void mCargarTipoIdentificacion()
        {
            cboTipoIdentificacion.DataSource = null;
            cboTipoIdentificacion.Refresh();

            try
            {
                QueryParams qp = new LLNet.Utils.QueryParams();
                DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_TIDENTIF_BAC");

                cboTipoIdentificacion.DataSource = dsB.Tables[0];
                cboTipoIdentificacion.ValueMember = "ID";
                cboTipoIdentificacion.DisplayMember = "TIPOID";

            }
            catch (Exception er)
            {
                GUI.CApp.ShowMessage(er.Message, "ERROR", true);
            }
        }
        #endregion

        #region mCargarMonedasPago
        /// <summary>
        /// Carga los tipos de moneda autorizados para el pago
        /// </summary>
        private void mCargarMonedasPago()
        {
            cboMonedaPago.DataSource = null;
            cboMonedaPago.Refresh();

            try
            {
                QueryParams qp = new LLNet.Utils.QueryParams();
                DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_MONEDA_CAMBIO");

                cboMonedaPago.DataSource = dsB.Tables[0];
                cboMonedaPago.ValueMember = "ID";
                cboMonedaPago.DisplayMember = "TIPOID";

            }
            catch (Exception er)
            {
                GUI.CApp.ShowMessage(er.Message, "ERROR", true);
            }
        }
        #endregion

        #region mCargarMonedasSaldo
        /// <summary>
        /// Carga los tipos de moneda autorizados para indicar el tipo de tarjeta
        /// </summary>
        private void mCargarMonedasSaldo()
        {
            cboMonedaSaldo.DataSource = null;
            cboMonedaSaldo.Refresh();

            try
            {
                QueryParams qp = new LLNet.Utils.QueryParams();
                DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_MONEDA_CAMBIO");

                cboMonedaSaldo.DataSource = dsB.Tables[0];
                cboMonedaSaldo.ValueMember = "ID";
                cboMonedaSaldo.DisplayMember = "TIPOID";

            }
            catch (Exception er)
            {
                GUI.CApp.ShowMessage(er.Message, "ERROR", true);
            }
        }
        #endregion

        #region mCargarLlaves
        /// <summary>
        /// 
        /// </summary>
        private void mCargarLlaves(string pCodEmpresa, string pCodConvenio)
        {
            try
            {
                ArrayList lLlaves = new ArrayList();

                //selecciona los datos para imprimir
                QueryParams qp = new LLNet.Utils.QueryParams();
                qp.AddReplaceParam("pEmpresa", pCodEmpresa);
                qp.AddReplaceParam("pConvenio", pCodConvenio);
                DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_LLAVE_BACSERV", qp);
                lLlaves.Clear();

                cboConsultaBac.DataSource = dsB.Tables[0];
                cboConsultaBac.ValueMember = "NTIPOLLAVE";
                cboConsultaBac.DisplayMember = "CDESCRIPCION";
                varLlave = cboConsultaBac.Text;
                //foreach (DataRow vFila in dsB.Tables[0].Rows)
                //{
                //    DevExpress.XtraEditors.Controls.ComboBoxItem vItem;
                //    vItem = new DevExpress.XtraEditors.Controls.ImageComboBoxItem(vFila[3].ToString(), vFila[2].ToString());
                //    cboConsultaBac.Items.Add(vItem);
                //}
            }
            catch (Exception er)
            {
                GUI.CApp.ShowMessage(er.Message, "ERROR", true);
                //BitacoraIntentosE(id, Convert.ToString(er.Message));
            }
        }
        #endregion

        #region mReporteJornada
        /// <summary>
        /// 
        /// </summary>
        private void mReporteJornada()
        {
            Utils.QueryParams qp = new LLNet.Utils.QueryParams();
            qp.AddReplaceParam("pJornada", Program.Jornada.ToString());
            qp.AddReplaceParam("pCaja", Program.Caja.ToString());

            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_REPORTE_BACSERV_ARQ", qp);
            //dsB.Tables[0].Columns[0].DataType = System.Type.GetType("System.String");

            gridCRepJornG.DataSource = dsB.Tables[0];
            gridCRepJornS.Columns[2].Visible = false;
            gridCRepJornS.Columns[3].Visible = false;
            gridCRepJornS.Columns[5].Visible = false;
            gridCRepJornS.Columns[6].Visible = false;
            gridCRepJornS.Columns[10].Visible = false;
            gridCRepJornG.Refresh();


        }
        #endregion

        #region mValidarCredenciales
        /// <summary>
        /// Se validan las credenciales 
        /// </summary>
        private void mValidarCredenciales()
        {
            Utils.QueryParams vQp = new LLNet.Utils.QueryParams();
            vQp.AddReplaceParam("pCaja", Program.Caja.ToString());

            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_BAC", vQp);

            object[] datos = new object[4];
            datos = dsB.Tables[0].Rows[0].ItemArray;

            vBacCredenciales.Username = datos[1].ToString();
            vBacCredenciales.Password = datos[2].ToString();

        }
        #endregion

        #region mRegistroTerminal
        /// <summary>
        /// Reistra en la tabla de Jornadas del BAC la jornada que se abrirá
        /// </summary>
        private void mRegistroTerminal()
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();

            //Inserto en el registro WMS_JORNADAS_BAC
            vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
            vQp.AddReplaceParam("pUsuario", GUI.CApp.usuario.ToString());

            CApp.bll.ExecuteSql("insertaRegTermBac", vQp, "PDV");

        }
        #endregion

        #region mAperturaTerminal
        /// <summary>
        /// Inicia la terminal, si la misma esta abierta no se volverá a abrir
        /// </summary>

        private void mAperturaTerminal()
        {
            try
            {
                QueryParams vQp = new LLNet.Utils.QueryParams();
                string[] vParametros = new string[2];
                vQp.AddReplaceParam("pParam1", "APTE");
                vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');
                mLimpiarBac();
                vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                vDetTransaccion.Id = int.Parse(vParametros[0]);
                vDetTransaccion.Name = vParametros[1];
                vDetTransaccion.Integrated = vParametros[2];
                vDetTransaccion.Sequence = 0;
                vDetTransaccion.Invoice = "";
                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                {
                    Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                    {
                        Transaction = vDetTransaccion,
                        TerminalNumber = vNumTerminal,
                        Credentials = vBacCredenciales,
                    }
                };
                int pConsecutivo = Convert.ToInt32(GUI.CApp.bll.GetSingleValue("SEC_BACCOMPR", "PDV"));
                mRegistrarTransaccion("P", vRequest, null, null, pConsecutivo, "");
                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);
                mRegistrarTransaccion("R", null, vResponse, null, pConsecutivo, "");
                if (vResponse.Header.Status != LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ResponseType.Success)
                {
                    GUI.CApp.ShowMessage("Error de apertura de caja, favor verifique los datos", "ERROR", true);
                    mRegistrarTransaccion("E", null, vResponse, null, pConsecutivo, "");
                    mLimpiar2();
                }
                else
                {
                    mRegistroTerminal();
                }

            }
            catch (SoapException sex)
            {
                GUI.CApp.ShowMessage(Convert.ToString(sex.Detail.FirstChild.Value), "ERROR", true);

            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
            }

        }
        #endregion

        #region mImprimeTiquete
        /// <summary>
        /// 
        /// </summary>
        private void mImprimeTiquete(long pDocumento, string pConvenio, string pComprobateTC)
        {

            switch (pConvenio)
            {
                case "13":

                    object FormatoTipoDeposito = null;
                    QueryParams qparams = new LLNet.Utils.QueryParams();
                    qparams = new LLNet.Utils.QueryParams();
                    qparams.AddReplaceParam("RV_DOMAIN", "DOCUMENTOS TIENDA' AND RV_LOW_VALUE = 'RDBAC");
                    Model.General.CgRefCodes dsDocTienda = new LLNet.Model.General.CgRefCodes();
                    Utils.Helpers.Merge(GUI.CApp.bll.getTypedDataSet(dsDocTienda.GetType(), dsDocTienda.DOMAINS.TableName, qparams), dsDocTienda);
                    string format = Utils.Helpers.Nvl(FormatoTipoDeposito, dsDocTienda.DOMAINS[0].RV_MPCC02).ToString();

                    // imprimirDocumentoDOS(pDocumento, "", Convert.ToInt64("3044"));
                    imprimirDocumentoDOS(pDocumento, "", Convert.ToInt64(format));

                    //Cantidad de impresiones
                    QueryParams qp = new LLNet.Utils.QueryParams();

                    // IMPRIME TIPO DE CAMBIO 
                    if (pComprobateTC.ToString().Equals("0"))
                    {
                        // no imprime
                    }
                    else
                    {

                        CargaDatosTipoCambio(pComprobateTC.ToString());

                    }


                    break;
                case "12":

                    //Cantidad de impresiones

                    object FormatoTipoTarjeta = null;
                    QueryParams qpartarj = new LLNet.Utils.QueryParams();
                    qpartarj = new LLNet.Utils.QueryParams();
                    qpartarj.AddReplaceParam("RV_DOMAIN", "DOCUMENTOS TIENDA' AND RV_LOW_VALUE = 'RTBAC");
                    Model.General.CgRefCodes dsDoctar = new LLNet.Model.General.CgRefCodes();
                    Utils.Helpers.Merge(GUI.CApp.bll.getTypedDataSet(dsDoctar.GetType(), dsDoctar.DOMAINS.TableName, qpartarj), dsDoctar);
                    string formattarj = Utils.Helpers.Nvl(FormatoTipoTarjeta, dsDoctar.DOMAINS[0].RV_MPCC02).ToString();

                    // imprimirDocumentoDOS(pDocumento, "", Convert.ToInt64("3044"));
                    imprimirDocumentoDOS(pDocumento, "", Convert.ToInt64(formattarj));

                    break;


                case "14":

                    object FormatoTiporetiro = null;
                    QueryParams qparetiro = new LLNet.Utils.QueryParams();
                    qpartarj = new LLNet.Utils.QueryParams();
                    qpartarj.AddReplaceParam("RV_DOMAIN", "DOCUMENTOS TIENDA' AND RV_LOW_VALUE = 'RRBAC");
                    Model.General.CgRefCodes dsDocretiro = new LLNet.Model.General.CgRefCodes();
                    Utils.Helpers.Merge(GUI.CApp.bll.getTypedDataSet(dsDocretiro.GetType(), dsDocretiro.DOMAINS.TableName, qpartarj), dsDocretiro);
                    string formatretiro = Utils.Helpers.Nvl(FormatoTiporetiro, dsDocretiro.DOMAINS[0].RV_MPCC02).ToString();

                    // imprimirDocumentoDOS(pDocumento, "", Convert.ToInt64("3044"));
                    imprimirDocumentoDOS(pDocumento, "", Convert.ToInt64(formatretiro));


                    break;
            }


        }
        #endregion

        #region mRegistrarTransaccion
        /// <summary>
        /// Registra la transacción ejecutada
        /// </summary>
        /// <param name="pTipo"></param>
        /// <param name="pPregunta"></param>
        /// <param name="pRespuesta"></param>
        private void mRegistrarTransaccion(string pTipo, LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest pPregunta, LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse pRespuesta,
                                         string pMensaje, long pNumConsecutivo, string pInvoice)
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();
            string vXml = "";

            if (string.IsNullOrEmpty(vNombreCliente))
            {
                vNombreCliente = txtValorDeBusqueda.Text;
            }
            if (string.IsNullOrEmpty(vTrack2))
            {
                vTrack2 = txtValorDeBusqueda.Text;
            }

            if (pTipo.Equals("P"))
            {
                vQp.AddReplaceParam("pConsecutivo", pNumConsecutivo.ToString());
                vQp.AddReplaceParam("pCliente", vNombreCliente);   // no puede null
                vQp.AddReplaceParam("pTarjeta", vTrack2);
                vQp.AddReplaceParam("pEmpresa", varCEmpresa);
                vQp.AddReplaceParam("pConvenio", varCConvenio);
                vQp.AddReplaceParam("pTipoLlave", varCLlave);
                vXml = clsXmlSerializer.SerializeObject(pPregunta);
                vXml = vXml.Replace('&', '_');
                //vXml = vXml.Substring(174, 250);
                vQp.AddReplaceParam("pXML", vXml);
                vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
                vQp.AddReplaceParam("pUsuario", GUI.CApp.usuario.ToString());
                vQp.AddReplaceParam("pInvoice", pInvoice);
                CApp.bll.ExecuteSql("insertaReqRapiBac", vQp, "PDV");
            }

            if (pTipo.Equals("R"))
            {
                vQp.AddReplaceParam("pConsecutivo", pNumConsecutivo.ToString());
                vQp.AddReplaceParam("pCliente", vNombreCliente);
                vQp.AddReplaceParam("pTarjeta", vTrack2);
                vQp.AddReplaceParam("pEstatus", pRespuesta.Header.Status.ToString());
                vQp.AddReplaceParam("pDescripcion", pRespuesta.Header.Description);

                if (string.IsNullOrEmpty(pRespuesta.Header.SystemTraceNumber))
                    vQp.AddReplaceParam("pSystemTraceNumber", "0");
                else
                    vQp.AddReplaceParam("pSystemTraceNumber", pRespuesta.Header.SystemTraceNumber);

                vXml = clsXmlSerializer.SerializeObject(pRespuesta);
                vXml = vXml.Replace('&', '_');
                //vXml = vXml.Substring(174, 250);
                vQp.AddReplaceParam("pXML", vXml);
                vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
                vQp.AddReplaceParam("pUsuario", GUI.CApp.usuario.ToString());
                // vQp.AddReplaceParam("pInvoice", GUI.CApp.usuario.ToString());

                CApp.bll.ExecuteSql("insertaResRapiBac", vQp, "PDV");
            }

            if (pTipo.Equals("E") && pRespuesta != null)
            {
                foreach (LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field vCampo in pRespuesta.Content.ResponseFields)
                {
                    if (vCampo.Name.Equals("Message"))
                    {
                        vXml = vCampo.Value;
                    }
                }

                vQp.AddReplaceParam("pConsecutivo", pNumConsecutivo.ToString());
                //vXml = clsXmlSerializer.SerializeObject(pRespuesta);
                vQp.AddReplaceParam("pXML", vXml + "1");
                CApp.bll.ExecuteSql("insertaResERapiBac", vQp, "PDV");
            }

            if (pTipo.Equals("E") && pRespuesta == null)
            {
                vQp.AddReplaceParam("pConsecutivo", pNumConsecutivo.ToString());
                vQp.AddReplaceParam("pXML", pMensaje + "2");
                CApp.bll.ExecuteSql("insertaResERapiBac", vQp, "PDV");
            }
        }
        #endregion

        #region mDocumPendientesTarjeta
        /// <summary>
        /// Consulta el saldo de la tarjeta de crédito
        /// </summary>
        private void mDocumPendientesTarjeta()
        {

            try
            {
                string[] vParametros = new string[2];
                QueryParams vQp = new LLNet.Utils.QueryParams();

                //Consulta de saldo de la tarjeta 
                vQp.AddReplaceParam("pParam1", "COTA");
                vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');

                mLimpiarBac();

                //  vDetTransaccion = new Detalle();
                vDetTransaccion.Id = int.Parse(vParametros[0]);
                vDetTransaccion.Name = vParametros[1];
                vDetTransaccion.Sequence = 0;

                List<Field> vCampos = new List<Field>();
                vCampos.Add(new Field() { Id = 2, Value = vTrack2 });
                vCampos.Add(new Field() { Id = 4, Value = vNombreCliente });

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                {
                    Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                    {
                        Transaction = vDetTransaccion,
                        TerminalNumber = vNumTerminal,
                        Credentials = vBacCredenciales,
                    },
                    Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                    {
                        //  RequestFields = vCampos.ToArray()
                    }
                };

                string vPregunta = clsXmlSerializer.SerializeObject(vRequest);

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);

                // string vRespuesta = clsXmlSerializer.SerializeObject(vResponse);

                if (vResponse.Header.Status == LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ResponseType.Success)
                {
                    //foreach (vConBacServ.Field vCampo in vResponse.Content.ResponseFields)
                    //{
                    //    if (vCampo.Name.Equals("Message"))
                    //    {
                    //        vDetRespuesta = vCampo.Value;
                    //        //imprimo tiquete
                    //        //mImprimeTiquete();
                    //    }
                    //}

                    foreach (LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field vCampo in vResponse.Content.ResponseFields)
                    {
                        if (vCampo.Name.Equals("Print"))
                        {
                            string vDocumento = vCampo.Value;
                            vNombreCliente = mRetornaValorEspecífico(vDocumento, "Cliente:", "Pago m");

                            if (vNombreCliente.Trim().Equals(""))
                            {
                                vNombreCliente = "Error del banco en el recibo, No retorno nombre";
                                mLimpiar2();
                            }
                        }
                    }
                }
                else
                {
                    GUI.CApp.ShowMessage("Error de datos de la tarjeta, favor verifique la misma", "ERROR", true);
                    mLimpiar2();
                }
            }
            catch (SoapException sex)
            {
                GUI.CApp.ShowMessage(Convert.ToString(sex.Detail.FirstChild.Value), "ERROR", true);
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
            }


        }
        #endregion

        #region mVerificarTarjeta
        /// <summary>
        /// Valida que los datos de la tarjeta física estén correctos
        /// </summary>
        /// <returns></returns>
        private bool mVerificarTarjeta(string pllave)
        {
            if (!vPinpad.openPort())
            {
                GUI.CApp.ShowMessage("Error, el puerto no se encuentra abierto", "ERROR", true);
                return false;
            }
            else
            {

                switch (pllave)
                {

                    case "15":

                        vPinpad.execCARD("Deslice Tarjeta", "por favor", true, false, true, true, 0, 0, "7D3A3F4F1F7A301E8567F415AC0804D2");

                        break;

                    default:
                        vPinpad.execCARD("Deslice Tarjeta", "por favor", true, false, false, true, 0, 0, "7D3A3F4F1F7A301E8567F415AC0804D2");
                        break;

                }

                //El quinto parámetro es el que deshabilita solicitar el pin de la tarjeta

                if (vPinpad.rCardResult == TrxError.NO_ERROR)
                {
                    vPinBlock = vPinpad.rPinBlock + vPinpad.rKeySerialNumber;
                    vNombreCliente = vPinpad.rCardHolderName;
                    vKsn = vPinpad.rKeySerialNumber;
                    vTrack1 = vPinpad.rTrack1;
                    vTrack2 = vPinpad.rTrack2;
                    vNumTarjeta = vPinpad.rMaskPAN;
                    vPinpad.closePort();
                }
                else
                {
                    return false;
                }

                return true;
            }
        }

        #endregion

        #region mConvertirMonto
        /// <summary>
        /// Recibe un monto y le quita los decimales para enviar el dato
        /// </summary>
        /// <param name="pMonto">Monto a convertir</param>
        /// <returns></returns>
        private string mConvertirMonto(string pMonto)
        {
            string vValor = "";
            double vMonto = Double.Parse(pMonto);

            vValor = vMonto.ToString("0.00");
            vValor = vValor.Replace(".", "");
            return vValor;
        }
        #endregion



        #region mMontoConfirma
        /// <summary>
        /// Recibe un monto y le quita los decimales para enviar el dato
        /// </summary>
        /// <param name="pMonto">Monto a convertir</param>
        /// <returns></returns>
        private string mMontoConfirma(string pMonto)
        {
            string vValor = "";
            decimal vMonto = Decimal.Parse(pMonto);

            //  vValor = vValor.Replace("", ".");

            //  vValor = vMonto.ToString("0.00");
            //vValor = vValor.Replace(".", "");

            return vValor;
        }
        #endregion


        #region mBuscarElemento
        /// <summary>
        /// 
        /// </summary>
        /// <param name="pElemento"></param>
        /// <param name="pDondeBusco"></param>
        /// <returns></returns>
        private string mBuscarElemento(string pElemento, int pCantEspacios, string pDondeBusco)
        {
            int vInicio = pDondeBusco.IndexOf(pElemento);
            int vLargoElemento = pElemento.Length;
            string vSubCadena = pDondeBusco.Substring(vInicio + pCantEspacios + vLargoElemento);
            int vEspacio = vSubCadena.IndexOf(" ");
            string vSubCadena2 = vSubCadena.Substring(1, vEspacio);

            return vSubCadena2;
        }
        #endregion

        #region mPagarTarjetaCredito
        /// <summary>
        /// 
        /// </summary>
        private void mPagarTarjetaCredito(int pConsecutivo)
        {
            try
            {
                string[] vParametros = new string[3];
                QueryParams vQp = new LLNet.Utils.QueryParams();

                //Consulta de saldo de la tarjeta 
                vQp.AddReplaceParam("pParam1", "PATA");
                vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');

                mLimpiarBac();

                vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                vDetTransaccion.Id = int.Parse(vParametros[0]);
                vDetTransaccion.Name = vParametros[1];
                vDetTransaccion.Integrated = vParametros[2];
                vDetTransaccion.Sequence = 1;
                vDetTransaccion.Invoice = sec_BacInvoice;

                List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 12, Value = cboMonedaPago.SelectedValue.ToString() }); //moneda nacional
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(txtMontoPago.Text.Trim()) }); //importe transaccion
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 13, Value = cboMonedaSaldo.SelectedValue.ToString() });
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = vTrack2 });
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 9, Value = cboTipoIdentificacion.SelectedValue.ToString() });
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 10, Value = txtIdentificacion.Text.Trim() }); //multimoneda

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                {
                    Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                    {
                        Transaction = vDetTransaccion,
                        TerminalNumber = vNumTerminal,
                        Credentials = vBacCredenciales,
                    },
                    Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                    {
                        RequestFields = vCampos.ToArray()
                    }
                };

                mRegistrarTransaccion("P", vRequest, null, null, pConsecutivo, sec_BacInvoice);

                string vPregunta = clsXmlSerializer.SerializeObject(vRequest);

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);

                string vRespuesta = clsXmlSerializer.SerializeObject(vResponse);

                mRegistrarTransaccion("R", null, vResponse, null, pConsecutivo, sec_BacInvoice);

                if (vResponse.Header.Status == LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ResponseType.Success)
                {
                    foreach (LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field vCampo in vResponse.Content.ResponseFields)
                    {
                        if (vCampo.Name.Equals("Print"))
                        {
                            string vDocumento = vCampo.Value;
                            //Imprimir el comprobante y guardar los datos de pago...
                            mRegistrarPago("P", vDocumento, vRequest, null, pConsecutivo.ToString(), cboMonedaPago.SelectedValue.ToString(),
                                cboMonedaSaldo.SelectedValue.ToString(), "", "", pConsecutivo.ToString(), sec_BacInvoice, "0");

                            mRegistrarPago("R", vDocumento, null, vResponse, pConsecutivo.ToString(), cboMonedaPago.SelectedValue.ToString(),
                                           cboMonedaSaldo.SelectedValue.ToString(), txtMontoPago.Text.Trim(), txtMontoPagado.Text.Trim(), "", sec_BacInvoice, "0");

                            RegistroBDBACServicios(vResponse, txtMontoPago.Text.Trim(), varCEmpresa, varCConvenio, pConsecutivo.ToString());
                            //RegistroBDBACServicios(vResponse, txtTotalBac.Text.Trim(), varCEmpresa, varCConvenio, mBuscarElemento("0",0,vPrueba)); 
                        }
                    }

                    GUI.CApp.ShowMessage("Pago realizado con éxito", "ATENCION", true);
                    mLimpiar2();

                }
                else
                {
                    mRegistrarTransaccion("E", null, vResponse, null, pConsecutivo, "");
                    GUI.CApp.ShowMessage("Error de transacción con el proveedor, favor comuníquese con soporte", "ERROR", true);
                }
            }
            catch (SoapException sex)
            {
                GUI.CApp.ShowMessage(Convert.ToString(sex.Detail.FirstChild.Value), "ERROR", true);
                mRegistrarTransaccion("E", null, null, sex.Detail.FirstChild.Value, pConsecutivo, "");
            }

            catch (TimeoutException sex)
            {
                mReversarRapiBac2TimeOut(sec_BacInvoice, cboMonedaPago.SelectedValue.ToString(), txtMontoPago.Text.Trim(), cboMonedaSaldo.SelectedValue.ToString(), vTrack2,
                cboTipoIdentificacion.SelectedValue.ToString(), txtIdentificacion.Text.Trim(), "", Convert.ToString(pConsecutivo),
                 "", varCConvenio, "", "", sec_BcSequence, "");

                mRegistrarTransaccion("E", null, null, sex.Message, pConsecutivo, "");
            }
            catch (Exception sex)
            {
                GUI.CApp.ShowMessage(Convert.ToString(sex.Message), "ERROR", true);
                mRegistrarTransaccion("E", null, null, sex.Message, pConsecutivo, "");
            }


        }
        #endregion

        #region mRetornaVuelto
        /// <summary>
        /// Regresa el monto del vuelto a partir del monto pagado y el monto de dinero que se entregó
        /// </summary>
        /// <param name="pMonedaPago"></param>
        /// <param name="pMonedaSaldo"></param>
        /// <param name="pTipoCambio"></param>
        /// <param name="pMontoPago"></param>
        /// <param name="pMontoPagado"></param>
        /// <returns></returns>
        private string[] mRetornaVuelto(string pMonedaPago, string pMonedaSaldo, string pTipoCambio, string pMontoPago, string pMontoPagado)
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();
            string[] vParametros = new string[3];

            vQp.AddReplaceParam("pTipoPago", pMonedaPago);
            vQp.AddReplaceParam("pTipoSaldo", pMonedaSaldo);
            vQp.AddReplaceParam("pTipoCambio", pTipoCambio);
            vQp.AddReplaceParam("pMonto", pMontoPago);
            vQp.AddReplaceParam("pMontoPagado", pMontoPagado);

            vParametros = Convert.ToString(CApp.bll.GetSingleValue("CONV_TIPO_CAMBIO", vQp, "PDV")).Split('+');

            return vParametros;
        }
        #endregion

        #region mConsultarTarjetaCredito
        /// <summary>
        /// 
        /// </summary>
        private bool mConsultarTarjetaCredito(int pConsecutivo)
        {
            try
            {
                sec_BacInvoice = Sec_BcInvoice();

                string[] vParametros = new string[4];
                QueryParams vQp = new LLNet.Utils.QueryParams();

                //Consulta de saldo de la tarjeta 
                vQp.AddReplaceParam("pParam1", "COPA");
                vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');

                mLimpiarBac();

                vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                vDetTransaccion.Id = int.Parse(vParametros[0]);
                vDetTransaccion.Name = vParametros[1];
                vDetTransaccion.Integrated = vParametros[2];
                vDetTransaccion.Sequence = 0;
                vDetTransaccion.Invoice = sec_BacInvoice;

                List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 11, Value = "0" }); //multimoneda
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 12, Value = cboMonedaPago.SelectedValue.ToString() }); //moneda nacional
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(txtMontoPago.Text.Trim()) }); //importe transaccion
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 13, Value = cboMonedaSaldo.SelectedValue.ToString() });
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = vTrack2 });

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                {
                    Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                    {
                        Transaction = vDetTransaccion,
                        TerminalNumber = vNumTerminal,
                        Credentials = vBacCredenciales,
                    },
                    Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                    {
                        RequestFields = vCampos.ToArray()
                    }
                };

                mRegistrarTransaccion("P", vRequest, null, null, pConsecutivo, sec_BacInvoice);

                string vPregunta = clsXmlSerializer.SerializeObject(vRequest);

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);

                string vRespuesta = clsXmlSerializer.SerializeObject(vResponse);

                mRegistrarTransaccion("R", null, vResponse, null, pConsecutivo, sec_BacInvoice);

                if (vResponse.Header.Status == LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ResponseType.Success)
                {
                    string vNombreClienteTemp = "";

                    foreach (LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field vCampo in vResponse.Content.ResponseFields)
                    {
                        //;MustraTipo de cambio
                        if (vCampo.Id == 58)
                        {
                            if (string.IsNullOrEmpty(vCampo.Value))
                            {
                                vTipoCambio = "0";
                            }
                            else
                            {
                                vTipoCambio = vCampo.Value;
                            }
                        }

                        //Buscar en el xml el nombre del cliente
                        if (vCampo.Id == 54)
                        {
                            if (string.IsNullOrEmpty(vCampo.Value))
                            {
                                vNombreClienteTemp = "Sin nombre de cliente ";
                            }
                            else
                            {
                                vNombreClienteTemp = vCampo.Value;
                            }
                        }
                    }

                    vParametros = mRetornaVuelto(cboMonedaPago.SelectedValue.ToString(), cboMonedaSaldo.SelectedValue.ToString(),
                                         vTipoCambio, txtMontoPago.Text.Trim(), txtMontoPagado.Text.Trim());

                    string vResponder = GUI.CApp.ShowMessage("Cliente: " + vNombreClienteTemp + "\nAbono: " + txtMontoPago.Text.Trim() + " \nCancela con: " + txtMontoPagado.Text.Trim()
                                                           + "\nTipo de Cambio: " + vTipoCambio + "\nConversion: " + vParametros[0]
                                                           + "\nVuelto: " + vParametros[1], "CONVERSION DE DIVISA", true, true).ToString();

                    //Consultamos al usuario si desea realizar la conversión
                    if (vResponder.Equals("OK"))
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    mRegistrarTransaccion("E", null, vResponse, null, pConsecutivo, "");
                    GUI.CApp.ShowMessage("Error: " + vResponse.Header.Status, "ERROR", true);
                    return false;
                }
            }
            catch (SoapException sex)
            {
                GUI.CApp.ShowMessage(Convert.ToString(sex.Detail.FirstChild.Value), "ERROR", true);
                mRegistrarTransaccion("E", null, null, Convert.ToString(sex.Detail.FirstChild.Value), pConsecutivo, "");
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
                mRegistrarTransaccion("E", null, null, ex.Message, pConsecutivo, "");
            }

            return false;
        }
        #endregion

        #region mEjecutarTramite
        /// <summary>
        /// Realiza el trámite solicitado
        /// </summary>
        private void mEjecutarTramite()
        {

            int vEstado = 0;
            QueryParams vQp = new LLNet.Utils.QueryParams();

            vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
            //Verificamos si la apertura ya se hizo
            vEstado = Convert.ToInt32(CApp.bll.GetSingleValue("ESTADO_TERMINAL", vQp, "PDV"));

            if (vEstado == 0)
            {
                mAperturaTerminal();
            }

            int varSECComp = Convert.ToInt32(GUI.CApp.bll.GetSingleValue("SEC_BACCOMPR", "PDV"));

            if (mConsultarTarjetaCredito(varSECComp))
            {
                //Realizo el siguiente request
                mPagarTarjetaCredito(varSECComp);
            }
        }
        #endregion

        #region mIdentificarTerminal
        /// <summary>
        /// Consulta el número de terminal asociado según el número dado por el BAC
        /// </summary>
        private void mIdentificarTerminal()
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();

            try
            {
                //Obtengo el número de terminal a partir de la caja
                vQp.AddReplaceParam("pCaja", Program.Caja.ToString());
                vNumTerminal = Convert.ToString(CApp.bll.GetSingleValue("TERMINAL_BAC", vQp, "PDV")).Trim();
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
            }
        }
        #endregion

        #region mReducirEspaciado
        /// <summary>
        /// Elimina todos los espacios en blanco entre 
        /// palabras hasta dejar uno solo entre cada palabra
        /// </summary>
        /// <param name="pCadena"></param>
        /// <returns></returns>
        private string mReducirEspaciado(string pCadena)
        {
            while (pCadena.Contains("\n"))
            {
                pCadena = pCadena.Replace("\n", " ");
            }

            while (pCadena.Contains("  "))
            {
                pCadena = pCadena.Replace("  ", " ");
            }

            return pCadena;
        }
        #endregion

        #region mRetornaValorEspecífico
        /// <summary>
        /// Retorna un rango de caracteres especifico desde una cadena solicitada
        /// </summary>
        /// <param name="pCadena"></param>
        /// <param name="pTextoInicial"></param>
        /// <param name="pTextoFinal"></param>
        /// <returns></returns>
        private string mRetornaValorEspecífico(string pCadena, string pTextoInicial, string pTextoFinal)
        {
            string vCadena = "";
            string vSubCadena = "";
            int vPosInicialSC = 0;
            int vPosFinalSC = 0;
            int vCantCaracteres = 0;

            vCadena = mReducirEspaciado(pCadena);

            vPosInicialSC = vCadena.IndexOf(pTextoInicial) + pTextoInicial.Length + 1;
            vPosFinalSC = vCadena.IndexOf(pTextoFinal);
            vCantCaracteres = vPosFinalSC - vPosInicialSC;
            vSubCadena = (vCadena.Substring(vPosInicialSC, vCantCaracteres)).Trim();

            return vSubCadena;
        }
        #endregion

        #region mArregloCadenas
        /// <summary>
        /// Genera un arreglo de cadenas
        /// </summary>
        /// <param name="pCadena"></param>
        /// <returns></returns>
        private string[] mArregloCadenas(string pCadena)
        {
            string vCadena = "";
            string vSubCadena = "";
            int vPosInicialSC = 0;
            int vPosFinalSC = 0;
            int vCantCaracteres = 0;
            string[] vArregloCadenas = new string[50];

            vCadena = mReducirEspaciado(pCadena);

            vPosFinalSC = vCadena.IndexOf("0");
            vSubCadena = vCadena.Substring(vPosInicialSC, vPosFinalSC);
            vCadena = vCadena.Replace(vSubCadena, "");

            vPosInicialSC = vCadena.IndexOf("Cliente:");
            vPosFinalSC = vCadena.IndexOf("Monto ");
            vCantCaracteres = vPosFinalSC - vPosInicialSC;
            vSubCadena = vCadena.Substring(vPosInicialSC, vCantCaracteres);
            vCadena = vCadena.Replace(vSubCadena, "");
            vArregloCadenas = vCadena.Split(' ');
            vNombreCliente = vSubCadena;
            vPosFinalSC = vSubCadena.IndexOf(":");
            vSubCadena = vSubCadena.Substring(0, vPosFinalSC + 1);
            vNombreCliente = vNombreCliente.Replace(vSubCadena, "");
            vNombreCliente = vNombreCliente.Trim();

            return vArregloCadenas;
        }
        #endregion

        #region mRegistrarPago
        /// <summary>
        /// Se registra la solicitud de realizar el pago.
        /// </summary>
        /// <param name="pTipo"></param>
        /// <param name="pPregunta"></param>
        /// <param name="pRespuesta"></param>
        private void mRegistrarPago(string pTipo, string pDocumento, LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest pPregunta,
                                    LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse pRespuesta,
                                    string pConsecutivo, string pTipoPago, string pTipoSaldo,
                                    string pMontoPago, string pMontoPagado, string pSecuencia, string pSecInvoice, string pSecBAC)
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();
            string[] vArregloCadenas = mArregloCadenas(pDocumento);

            vQp.AddReplaceParam("pConsecutivo", pConsecutivo.ToString());

            if (pTipo.Equals("P"))
            {
                vQp.AddReplaceParam("pCodAgencia", vArregloCadenas[0]);
                vQp.AddReplaceParam("pEmpresa", varCEmpresa);
                vQp.AddReplaceParam("pConvenio", varCConvenio);
                vQp.AddReplaceParam("pIdentificacion", txtIdentificacion.Text.Trim());//Almacenar la tarjeta de credito
                vQp.AddReplaceParam("pTotal", txtMontoPago.Text.Trim());
                vQp.AddReplaceParam("pFechaVto", vArregloCadenas[16]);//Retorna la fecha y hora
                vQp.AddReplaceParam("pNumFactura", vArregloCadenas[18]);//Número de factura -- autorización
                vQp.AddReplaceParam("pCodMoneda", "0");
                vQp.AddReplaceParam("pLlave", varCLlave);
                vQp.AddReplaceParam("pNombreEmpresa", varInstit);
                vQp.AddReplaceParam("pNombreConvenio", varConvenio);
                vQp.AddReplaceParam("pCliente", vNombreCliente);
                vQp.AddReplaceParam("pNombreLlave", varLlave);
                vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
                vQp.AddReplaceParam("pNumTarjeta", vArregloCadenas[21]);
                vQp.AddReplaceParam("pTipoIdentificacion", cboTipoIdentificacion.SelectedValue.ToString());
                //vQp.AddReplaceParam("pTrack2", vTrack2);
                vQp.AddReplaceParam("pTrack2", vTrack2);
                vQp.AddReplaceParam("pMonedaPago", pTipoPago);
                vQp.AddReplaceParam("pMonedaSaldo", pTipoSaldo);
                vQp.AddReplaceParam("pSecInvoice", pSecInvoice);
                vQp.AddReplaceParam("pSecBAC", pSecBAC);


                CApp.bll.ExecuteSql("insertaReqBac", vQp, "PDV");
            }

            if (pTipo.Equals("R"))
            {
                string[] vParametros = new string[3];

                vQp.AddReplaceParam("pSystemTraceNumber", pRespuesta.Header.SystemTraceNumber);
                vQp.AddReplaceParam("pTerminal", vArregloCadenas[8]);
                vQp.AddReplaceParam("pLote", vArregloCadenas[10]);
                vQp.AddReplaceParam("pRef", vArregloCadenas[12]);
                vQp.AddReplaceParam("pFecha", vArregloCadenas[16]);
                vQp.AddReplaceParam("pHora", vArregloCadenas[17]);
                vQp.AddReplaceParam("pAutorizacion", vArregloCadenas[18]);
                vQp.AddReplaceParam("pNumTarjeta", vArregloCadenas[21]);

                if (vArregloCadenas[29].ToUpper().Equals("NO"))
                {
                    vParametros = mRetornaVuelto(pTipoPago, pTipoSaldo, "0", pMontoPago, pMontoPagado);

                    vQp.AddReplaceParam("pTipoCambio", vArregloCadenas[29] + " " + vArregloCadenas[30]);
                    vArregloCadenas[25] = vArregloCadenas[25].Replace("¢", "C");

                    vQp.AddReplaceParam("pMontoTransac", (double.Parse(vArregloCadenas[26])).ToString());
                    //vQp.AddReplaceParam("pMontoTransac", vArregloCadenas[26].ToString());
                    vQp.AddReplaceParam("pMontoConvers", (double.Parse(vArregloCadenas[26])).ToString());
                    //vQp.AddReplaceParam("pMontoConvers", vArregloCadenas[26].ToString());
                }
                else
                {
                    vParametros = mRetornaVuelto(pTipoPago, pTipoSaldo, vArregloCadenas[33], pMontoPago, pMontoPagado);

                    vQp.AddReplaceParam("pTipoCambio", vArregloCadenas[33]);

                    vArregloCadenas[24] = vArregloCadenas[24].Replace("¢", "C");
                    vQp.AddReplaceParam("pMontoTransac", (double.Parse(vArregloCadenas[25])).ToString());
                    //vQp.AddReplaceParam("pMontoTransac", pMontoPago);
                    vQp.AddReplaceParam("pMontoConvers", (double.Parse(vArregloCadenas[30])).ToString());
                    //vQp.AddReplaceParam("pMontoConvers", vArregloCadenas[26].ToString());

                }

                vParametros[1] = vParametros[1].Replace('C', ' ');

                vQp.AddReplaceParam("pDescConcep", "0");
                vQp.AddReplaceParam("pValorConcep", "0");
                vQp.AddReplaceParam("pTipo", "CP");
                vQp.AddReplaceParam("pCreadoPor", GUI.CApp.usuario.ToString());
                vQp.AddReplaceParam("pTipoPago", pTipoPago);
                vQp.AddReplaceParam("pTipoSaldo", pTipoSaldo);
                vQp.AddReplaceParam("pVuelto", (double.Parse(vParametros[1].Trim())).ToString());
                //vQp.AddReplaceParam("pVuelto", vParametros[1].Trim().ToString());
                vQp.AddReplaceParam("pMontoRecibido", (double.Parse(pMontoPagado.Trim())).ToString());
                //vQp.AddReplaceParam("pMontoRecibido", pMontoPagado.Trim().ToString());

                CApp.bll.ExecuteSql("insertaResaBac", vQp, "PDV");
            }

            vVarError = "";
            //mBuscarElemento("0",0,vPrueba)

        }
        #endregion

        #region RegistroBDBACServicios
        /// <summary>
        /// 
        /// </summary>
        /// <param name="pRespuesta"></param>
        /// <param name="pTotal"></param>
        /// <param name="pOper"></param>
        /// <param name="pProv"></param>
        /// <param name="pNumcomprob"></param>
        private void RegistroBDBACServicios(LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse pRespuesta, string pTotal, string pOper, string pProv, string pNumcomprob)
        {
            long varDocumento = Convert.ToInt64(GUI.CApp.bll.GetSingleValue("SEC_DOCUMENTO", "PDV"));

            //Parámetros:pDocumento number, pCaja number, pUsuario varchar2, pTotal number, pJornada number, pComision number, pIdTRans varchar2, pTelefono varchar2
            Utils.QueryParams qp = new LLNet.Utils.QueryParams();
            qp.AddReplaceParam("pDocumento", varDocumento.ToString());
            qp.AddReplaceParam("pCaja", Program.Caja.ToString());
            qp.AddReplaceParam("pUsuario", GUI.CApp.usuario);
            qp.AddReplaceParam("pTotal", pTotal);
            qp.AddReplaceParam("pJornada", Program.Jornada.ToString());
            if (pNumcomprob.Equals(""))
            {
                qp.AddReplaceParam("pIdTRans", "BLANCO");
            }
            else
            {
                qp.AddReplaceParam("pIdTRans", pNumcomprob);
            }
            qp.AddReplaceParam("pProveedor", pProv);
            qp.AddReplaceParam("pOperador", pOper);
            // Llama el procedimiento que almacena los datos de la recarga en la BD
            GUI.CApp.bll.ExecuteSql("WMS_P_RECIBOBACSERV", qp, "PDV");

            for (int i = 1; i <= varCantImp; i++)
            {//cantidad de impresiones
                //IMPRIME LA FACTURA
                CargarReporteBAC(varDocumento.ToString());
            }//fin cantidad de impresiones
        }
        #endregion

        #region CargarReporteBAC
        /// <summary>Imprime la factura </summary>
        /// <param name="doc"></param>
        private void CargarReporteBAC(string doc)
        {
            //selecciona los datos para imprimir
            QueryParams qp1 = new LLNet.Utils.QueryParams();
            qp1.AddReplaceParam("pDoc", doc);
            //CONSULTA LOS PARÁMETROS DE LA BD
            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "DATOIMP", qp1);
            if (dsB.Tables.Count > 0)
            {
                if (dsB.Tables[0].Rows.Count > 0)
                {
                    object[] datos = new object[5];
                    datos = dsB.Tables[0].Rows[0].ItemArray;
                    imprimirDocumentoDOS(long.Parse(datos[0].ToString()), datos[1].ToString(), long.Parse(datos[2].ToString()), datos[3].ToString(), datos[4].ToString());


                    QueryParams qp = new LLNet.Utils.QueryParams();
                    qp.AddReplaceParam("DOCUMENTO", doc);
                    CApp.bll.ExecuteSql("WMS_P_RECARGIMPRESIONES", qp, "PDV");
                }
                else
                {
                    GUI.CApp.ShowMessage("Problemas al imprimir", "ERROR", true);
                }
            }
            else
            {
                GUI.CApp.ShowMessage("Problemas al imprimir", "ERROR", true);
            }
        }
        #endregion

        #region imprimirDocumentoDOS
        /*Imprimir abrir cajón*/
        private static void imprimirDocumentoDOS(long documento, string Impresora, long formato, string prefijo, string BatName)
        {
            if (BatName == "")
                BatName = "imprimir.bat";
            string Ruta = Application.StartupPath;
            QueryParams qp = new QueryParams();
            if (Ruta != string.Empty)
            {
                System.Diagnostics.ProcessStartInfo startInfo = new System.Diagnostics.ProcessStartInfo(Ruta + "\\" + BatName);
                startInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
                string Args = "";

                string varTipoTxt = Helpers.ObjToStr(CApp.GetParam("TTXT"));

                if (varTipoTxt == "U") // SI EL TIPO DE GENERACION DE ARCHIVO ES POR USUARIO O DOCUMENTO
                {
                    if (prefijo != "")
                        Args = prefijo + CApp.usuario + ".txt ";
                    else
                        Args = CApp.usuario + ".txt ";
                }
                else
                {
                    long pDocumento = documento;
                    if (prefijo != "")
                        Args = prefijo + pDocumento + ".txt ";
                    else
                        Args = pDocumento + ".txt ";
                }
                startInfo.Arguments = Args;

                try
                {                   
                    Thread.Sleep(vtiempo); // SE LE DA TIEMPO A LA BD DE GENERAR EL ARCHIVO DE TEXTO
                    qp.AddReplaceParam("DOCUMENTO", documento.ToString());
                    qp.AddReplaceParam("FORMATO", formato.ToString());
                    qp.AddReplaceParam("USUARIO", CApp.usuario.ToString());
                    CApp.bll.ExecuteSql("GENERAR_IMPRESION_POS", qp, "PDV");
                    Thread.Sleep(vtiempo); // SE LE DA TIEMPO A LA BD DE GENERAR EL ARCHIVO DE TEXTO
                    System.Diagnostics.Process.Start(startInfo);
                }
                catch (Exception ex)
                {
                    CApp.ShowMessage(ex.Message, "Impresion de Documentos", true);
                }
            }
            else
            {
                throw new Exception("No esta Definido el Parametro UATI");
            }
            //startInfo.UseShellExecute = false; 
        }
        #endregion

        #region mArqJornadaBAC
        /// <summary>
        /// Muestra los datos del reporte con el arqueo de la jornada del BAC
        /// </summary>
        private void mArqJornadaBAC()
        {
            Utils.QueryParams qp = new LLNet.Utils.QueryParams();
            qp.AddReplaceParam("pJornada", Program.Jornada.ToString());
            qp.AddReplaceParam("pCaja", Program.Caja.ToString());

            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_REPORTE_BACSERV_ARQ", qp);

            LLNet.Tienda.Reportes.CR_ArqTarjBac objRpt = new LLNet.Tienda.Reportes.CR_ArqTarjBac();
            LLNet.Tienda.Reportes.dsArqTarjetasBAC dsdatos = new LLNet.Tienda.Reportes.dsArqTarjetasBAC();

            objRpt.Load("C\\ekono\\POS Retail 8.0.0\\CR_ArqTarjBac.rpt");

            double totalColones = 0; //monto total de la suma de colones de los montos de cada recibo
            double totalDolares = 0; //monto total de la suma de dolares de los montos de cada recibo 

            foreach (DataRow Fila in dsB.Tables[0].Rows)
            {
                object[] datos = new object[15];

                datos[0] = Convert.ToString(Fila[0]); //FECHA
                datos[1] = Convert.ToString(Fila[1]); //COMPROBANTE
                datos[2] = Convert.ToString(Fila[2]); //RECIBO
                datos[3] = Convert.ToDouble(Fila[3]); //MONTO COLONES          
                datos[4] = Convert.ToDouble(Fila[4]); //MONTO DOLARES          
                datos[5] = Convert.ToString(Fila[5]); //OPERADOR          
                datos[6] = Convert.ToString(Fila[6]); //PROVEEDOR      
                datos[7] = Convert.ToString(Fila[7]); //PROVEEDOR     
                datos[8] = Convert.ToString(Fila[8]); //PROVEEDOR     
                datos[9] = Convert.ToString(Fila[9]); //PROVEEDOR     
                datos[10] = Convert.ToString(Fila[10]); //PROVEEDOR  
                datos[11] = Convert.ToString(Fila[11]); //PROVEEDOR     
                datos[12] = Convert.ToString(Fila[12]); //PROVEEDOR    
                datos[14] = Convert.ToString(Fila[14]); //PROVEEDOR     
                totalColones += Convert.ToDouble(Fila[3]);
                totalDolares += Convert.ToDouble(Fila[4]);
                dsdatos.Tables[0].Rows.Add(datos);
            }

            string[] totales = new string[4];
            totales[0] = Program.Jornada.ToString(); //JORNADA
            totales[1] = Program.Caja.ToString(); //CAJA
            totales[2] = totalColones.ToString(); //MONTO TOTAL COLONES
            totales[3] = totalDolares.ToString(); //MONTO TOTAL COLONES

            dsdatos.Tables[1].Rows.Add(totales);

            objRpt.SetDataSource((DataSet)dsdatos);

            crystalReportViewer1.ReportSource = objRpt;
            crystalReportViewer1.Refresh();

            gridCRepJornG.Refresh();
        }
        #endregion

        #region mArqJornadaBACHR
        /// <summary>Arqueo de la Jornada Actual </summary>
        private void mArqJornadaBACHR()
        {
            gCtrlHRevG.DataSource = null;
            gCtrlHRevG.Refresh();

            Utils.QueryParams qp = new LLNet.Utils.QueryParams();
            qp.AddReplaceParam("pJornada", Program.Jornada.ToString());
            qp.AddReplaceParam("pCaja", Program.Caja.ToString());

            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_REPORTE_BACSERV_ARQ", qp);
            gCtrlHRevG.DataSource = dsB.Tables[0];
            gCtrlHRevG.Refresh();
        }
        #endregion

        #region imprimirDocumentoDOS
        private static void imprimirDocumentoDOS(long documento, string Impresora, long formato)
        {
            imprimirDocumentoDOS(documento, Impresora, formato, "", "");
        }

        private static void imprimirDocumentoDOS(long documento, string Impresora, long formato, string batName)
        {
            imprimirDocumentoDOS(documento, Impresora, formato, "", batName);
        }
        #endregion

        private void btnCancelar_Click(object sender, EventArgs e)
        {
            ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls;
            this.Close();
        }

        private void FrmRapibac_Load(object sender, EventArgs e)
        {
            try
            {
                mLimpiar();
                mLlenarParametrosTC();
                mCargaMontoMaximo();
                mCargaFondoDisponible();
                mLlenarParametros();
                mCargarEmpresas();
                mLimpiar2();
                xtraDepositos.Visible = false;
                xtraRetiros.Visible = false;

            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
            }
        }

        private void mCargaFondoDisponible()
        {
            Utils.QueryParams vQp = new LLNet.Utils.QueryParams();

            vQp.AddReplaceParam("pJORNADA", Program.Jornada.ToString());

            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "WU_FONDODISPRAPIBAC", vQp);

            if (dsB.Tables[0].Rows.Count > 0)
            {

                object[] dat = new object[2];

                //(dsB.Tables.List)).Items[0])).Rows.table.Rows.list)).Items[1])).ItemArray

                dat = dsB.Tables[0].Rows[0].ItemArray;

                textFondoDisponible.Text = dat[0].ToString();

                dat = dsB.Tables[0].Rows[1].ItemArray;

                vEfectivoCaja = dat[0].ToString();

            }
        }

        private void cboEmpBac_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                cboConvBac.Properties.Items.Clear();
                varCEmpresa = cboEmpBac.Properties.Items[cboEmpBac.SelectedIndex].Value.ToString();
                varInstit = cboEmpBac.Properties.Items[cboEmpBac.SelectedIndex].Description.ToString();
                cboConvBac.Properties.Items.Clear();
                cboConvBac.SelectedIndex = -1;
                if (cboConsultaBac.Items.Count > 0)
                    cboConsultaBac.DataSource = null;
                cboConsultaBac.DataSource = null;
                mCargarConvenios(varCEmpresa);
                mLimpiar();
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
            }
        }

        private void sBtnRevBac_Click(object sender, EventArgs e)
        {
            if (GUI.CApp.ValidateAccess("RevBacServ", "Reversion BAC Servicios"))
            {
                sBtnEnviar.Visible = false;
                btnDepositar.Visible = false;
                sbtnPagar.Visible = false;
                sbtnImprimir.Visible = false;
                btnRecargar.Visible = false;
                xtraDepositos.Visible = false;
                pnlReversion.Visible = true;
                pnlCobroYReimpresion.Visible = false;
                panel7.Visible = false;
                xtraRetiros.Visible = false;
                //mArqJornadaBACHR();
                LLenarGridPags();
                // btnReversarPago_Click(sender,e);
            }
        }

        private void sbtnPagar_Click(object sender, EventArgs e)
        {  
            if (string.IsNullOrEmpty(txtNombreClienteBac.Text.Trim()))
            {
                GUI.CApp.ShowMessage("Favor realizar la consulta de la tarjeta inicialmente", "ERROR", true);
                sBtnConsultarBac.Focus();
                return;
            }

            if (varCEmpresa.Equals(vEmpresa))
            {
                if (string.IsNullOrEmpty(txtIdentificacion.Text.Trim()))
                {
                    GUI.CApp.ShowMessage("Falta información en el campo IDENTIFICACION", "ERROR", true);
                    txtIdentificacion.Focus();
                    return;
                }
            }

            if (string.IsNullOrEmpty(txtMontoPago.Text.Trim()))
            {
                GUI.CApp.ShowMessage("Falta información en el campo MONTO A CANCELAR", "ERROR", true);
                txtMontoPago.Focus();
                return;
            }

            if (string.IsNullOrEmpty(txtMontoPagado.Text.Trim()))
            {
                GUI.CApp.ShowMessage("Falta información en el campo CANCELA CON", "ERROR", true);
                txtMontoPagado.Focus();
                return;
            }

            if (double.Parse(txtMontoPagado.Text.Trim()) < double.Parse(txtMontoPago.Text.Trim()))
            {
                GUI.CApp.ShowMessage("El monto Cancelado NO PUEDE SER MENOR que el Monto a Cancelar", "ERROR", true);
                txtMontoPagado.Focus();
                return;
            }

            if (cboMonedaSaldo.SelectedValue.ToString() != cboMonedaPago.SelectedValue.ToString())
            {
                GUI.CApp.ShowMessage("La moneda de pago no concuerda con la moneda de la tajerta", "ERROR", true);
                cboMonedaPago.Focus();
                return;
            }

            mEjecutarTramite();

        }

        private void sBtnBac_Reimp_Click(object sender, EventArgs e)
        {

            panelControl11.Visible = false;
            sBtnEnviar.Visible = false;
            btnDepositar.Visible = false;
            sbtnPagar.Visible = false;
            sbtnImprimir.Visible = true;
            btnRecargar.Visible = false;
            xtraDepositos.Visible = false;
            pnlCobroYReimpresion.Visible = true;
            pnlConsultaBac.Visible = false;
            pnlConsultaBac2.Visible = true;
            pnlReversion.Visible = false;
            mArqJornadaBAC();
            mReporteJornada();
            panel7.Visible = false;
            sbtnImprimir.Visible = true;
            simplebtnRetirar.Visible = false;
            xtraRetiros.Visible = false;
            gridControl7.Visible = false;


        }

        private void sBtnConsultarBac_Click(object sender, EventArgs e)
        {
            try
            {
                //mLimpiarDepositos();
                QueryParams vQp = new LLNet.Utils.QueryParams();

                ///Verifica si la empresa es el BAC directamente para el pago de la 
                ///tarjeta de credito
                vQp.AddReplaceParam("pParam1", "BACE");
                vEmpresa = Convert.ToString(CApp.bll.GetSingleValue("BACREFCODES", vQp, "PDV"));

                if (varCEmpresa.Equals(vEmpresa))
                {

                    if (!string.IsNullOrEmpty(txtValorDeBusqueda.Text.Trim()))
                    {
                        if (cboConsultaBac.Items.Count == 0)
                        {
                            GUI.CApp.ShowMessage("Seleccione un convenio", "ERROR", true);
                        }
                        else
                        {
                            /// llave

                            varCLlave = cboConsultaBac.SelectedValue.ToString();

                            switch (varCLlave)
                            {

                                case "13": ////pago de tarjetas

                                    vTrack2 = txtValorDeBusqueda.Text.Trim();
                                    txtNombreClienteBac.Text = vTrack2;
                                    vNombreCliente = vTrack2;

                                    break;
                                case "14":
                                    //DEPOSITOS

                                    vNombreCliente = txtNombreClienteBac.Text;
                                    vTrack2 = txtNombreClienteBac.Text;
                                    textEdicion.Text = "";
                                    if (cbxMoneda.SelectedIndex == 1)  // Si son dolares
                                    {

                                        //textTipoCambio.Text = "";
                                        textConversion.Text = "";
                                        //  textDigitada.Text = "";

                                        int vEstado = 0;
                                        QueryParams vQps = new LLNet.Utils.QueryParams();

                                        vQps.AddReplaceParam("pJornada", Program.Jornada.ToString());
                                        //Verificamos si la apertura ya se hizo
                                        vEstado = Convert.ToInt32(CApp.bll.GetSingleValue("ESTADO_TERMINAL", vQps, "PDV"));

                                        if (vEstado == 0)
                                        {
                                            mAperturaTerminal();
                                        }

                                        varSECconsulta = Convert.ToInt32(GUI.CApp.bll.GetSingleValue("SEC_BACCOMPR", "PDV"));
                                        // VALIDA LA CONVERSION DE NOSOTROS

                                        ConsultaCuenta(varSECconsulta, "1");
                                        xtraDepositos.Visible = true;

                                    }
                                    else
                                    {

                                        //COLONES
                                        int vEstado = 0;
                                        QueryParams vQps = new LLNet.Utils.QueryParams();

                                        vQps.AddReplaceParam("pJornada", Program.Jornada.ToString());
                                        //Verificamos si la apertura ya se hizo
                                        vEstado = Convert.ToInt32(CApp.bll.GetSingleValue("ESTADO_TERMINAL", vQps, "PDV"));

                                        if (vEstado == 0)
                                        {
                                            mAperturaTerminal();
                                        }
                                        varSECconsulta = Convert.ToInt32(GUI.CApp.bll.GetSingleValue("SEC_BACCOMPR", "PDV"));

                                        ConsultaCuenta(varSECconsulta, "0");
                                        xtraDepositos.Visible = true;

                                    }

                                    break;
                            }
                        }
                    }
                    else // SI SE VA POR AQUI ES PORQUE SE VA A DESLIZAR LA TARJETA PIN 
                    {
                        varCLlave = cboConsultaBac.SelectedValue.ToString();
                        switch (varCLlave)
                        {

                            case "14": ///DEPOSITOS
                                if (mVerificarTarjeta(varCLlave))
                                {
                                    txtNombreClienteBac.Text = vNombreCliente;
                                    // vTrack2 = txtNombreClienteBac.Text;
                                    int vEstado = 0;
                                    QueryParams vQps = new LLNet.Utils.QueryParams();

                                    vQps.AddReplaceParam("pJornada", Program.Jornada.ToString());
                                    //Verificamos si la apertura ya se hizo
                                    vEstado = Convert.ToInt32(CApp.bll.GetSingleValue("ESTADO_TERMINAL", vQps, "PDV"));

                                    if (vEstado == 0)
                                    {
                                        mAperturaTerminal();
                                    }
                                    varSECdeposito = Convert.ToInt32(GUI.CApp.bll.GetSingleValue("SEC_BACCOMPR", "PDV"));
                                    ConsultaCuenta(varSECdeposito, "");

                                    return;
                                }
                                else
                                {
                                    GUI.CApp.ShowMessage("Verifique los datos, vuelva a intentarlo!", "ERROR", true);
                                    mLimpiarDepositos();

                                }
                                break;

                            case "13": // PAGO DE TARJETAS DE CREDITO


                                if (mVerificarTarjeta(varCLlave))
                                {
                                    txtNombreClienteBac.Text = vNombreCliente;
                                }
                                else
                                {
                                    GUI.CApp.ShowMessage("Error, los datos de la tarjeta no son válidos", "ERROR", true);
                                    mLimpiar2();
                                }
                                break;

                            case "15": // RETIROS

                                if (string.IsNullOrEmpty(textPagaRetiros.Text.Trim()))
                                {
                                    GUI.CApp.ShowMessage("Ingrese el monto para poder hacer la consulta", "ERROR", true);
                                    return;
                                }
                                if (!string.IsNullOrEmpty(vMontoRetiroMax))
                                {

                                    if (decimal.Parse(textPagaRetiros.Text.Trim()) > decimal.Parse(vMontoRetiroMax))
                                    {
                                        GUI.CApp.ShowMessage("Verifique. El monto a Retirar es mayor al definido,el cual seria :" + vMontoRetiroMax + " Colones", "ERROR", true);
                                        textConversion.Focus();
                                        return;
                                    }


                                }

                                if (Decimal.Parse(vEfectivoCaja) == 0 && Decimal.Parse(textFondoDisponible.Text) == 0)
                                {
                                    GUI.CApp.ShowMessage("No puede hacer el retiro sin disponible ni efectivo en caja", "ERROR", true);
                                    textPagaRetiros.Focus();
                                    return;
                                }
                                if (Decimal.Parse(textPagaRetiros.Text) > (Decimal.Parse(textFondoDisponible.Text) + Decimal.Parse(vEfectivoCaja)))
                                {
                                    GUI.CApp.ShowMessage("No puede hacer el retiro, no tiene dinero suficiente efectivo en caja", "ERROR", true);
                                    textPagaRetiros.Focus();
                                    return;
                                }
                                else
                                {


                                    if (mVerificarTarjeta(varCLlave))
                                    {


                                        txtNombreClienteBac.Text = vNombreCliente;
                                        // vTrack2 = txtNombreClienteBac.Text;
                                        int vState = 0;
                                        // QueryParams vQp = new LLNet.Utils.QueryParams();

                                        vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
                                        //Verificamos si la apertura ya se hizo
                                        vState = Convert.ToInt32(CApp.bll.GetSingleValue("ESTADO_TERMINAL", vQp, "PDV"));

                                        if (vState == 0)
                                        {
                                            mAperturaTerminal();
                                        }
                                        varSECretiros = Convert.ToInt32(GUI.CApp.bll.GetSingleValue("SEC_BACCOMPR", "PDV"));

                                        mConsultaRetiros(varSECretiros, textPagaRetiros.Text.Trim());

                                        return;
                                    }
                                    else
                                    {

                                        GUI.CApp.ShowMessage("Vuelva a intentarlo.Error en la apertura del puerto del Card Reader", "ERROR", true);
                                        mLimpiarRetiros();
                                    }

                                }
                                break;

                        }

                    }
                }
            }


            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
                mRegistrarTransaccion("E", null, null, ex.Message, varSECdeposito, sec_BacInvoice);
                mLimpiarRetiros();
            }

        }
        /// <summary>
        /// consulta de cuenta
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        #region ConsultaCuenta
        /// <summary>
        /// 
        /// </summary>
        private bool ConsultaCuenta(int pConsecutivo, string pTipoMoneda)
        {
            string vCriterioBusqueda = "";
            sec_BacInvoice = Sec_BcInvoice();
            sec_BcSequence = Sec_BcSequence();
            LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = null;
            try
            {
                string[] vParametros = new string[4];
                QueryParams vQp = new LLNet.Utils.QueryParams();
                vQp.AddReplaceParam("pParam1", "DECU");
                vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');
                mLimpiarBac();
                vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                vDetTransaccion.Id = int.Parse(vParametros[0]);
                vDetTransaccion.Name = vParametros[1];
                vDetTransaccion.Integrated = vParametros[2];
                vDetTransaccion.Sequence = sec_BcSequence;
                vDetTransaccion.Invoice = sec_BacInvoice;

                if (string.IsNullOrEmpty(txtValorDeBusqueda.Text.Trim()))
                {
                    var vTarjPinPad = vTrack2;
                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 5, Value = cbxMoneda.SelectedValue.ToString() });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(vMontoConsulta) });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = vTarjPinPad });
                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };
                }
                else
                {
                    vCriterioBusqueda = txtValorDeBusqueda.Text.Trim();

                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 5, Value = cbxMoneda.SelectedValue.ToString() }); //multimoneda
                    // vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 12, Value = cboMonedaPago.SelectedValue.ToString() }); //moneda nacional
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(vMontoConsulta) }); //importe transaccion
                    //  vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 13, Value = cboMonedaSaldo.SelectedValue.ToString() });
                    //   vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = vCriterioBusqueda });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 7, Value = vCriterioBusqueda });

                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };
                }

                mRegistrarTransaccion("P", vRequest, null, null, pConsecutivo, sec_BacInvoice);

                string vPregunta = clsXmlSerializer.SerializeObject(vRequest);


                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);

                string vRespuesta = clsXmlSerializer.SerializeObject(vResponse);

                mRegistrarTransaccion("R", null, vResponse, null, pConsecutivo, sec_BacInvoice);

                StringReader stringReader = new StringReader(vRespuesta);

                stringReader.Read();

                string inner = stringReader.ReadLine();

                XmlDocument dd = new XmlDocument();

                DataSet dsAplicado = new DataSet();

                dd.Load(new StringReader(inner));

                dd.LoadXml(inner);

                dsAplicado.ReadXml(new XmlTextReader(new StringReader(dd.OuterXml)));

                DataTable vConsulta = dsAplicado.Tables[1];

                var Status = vConsulta.Rows[0].ItemArray[1];

                if (Status.Equals("Success"))
                {
                    // todo bien 
                    DataTable vConsultaContenido = dsAplicado.Tables[4];


                    var vMonto = vConsultaContenido.Rows[2].ItemArray[3];
                    var vNombreCliente = vConsultaContenido.Rows[3].ItemArray[3];
                    var vTarjeta = vConsultaContenido.Rows[4].ItemArray[3];
                    var vCantidadDigit = vConsultaContenido.Rows[5].ItemArray[3];
                    var vCantidadComercio = vConsultaContenido.Rows[6].ItemArray[3];
                    var vTipoCambio = vConsultaContenido.Rows[7].ItemArray[3];
                    var vCambio = vConsultaContenido.Rows[8].ItemArray[3];

                    // vTarjeta = Convert.ToString(vMonto);
                    txtNombreClienteBac.Text = Convert.ToString(vNombreCliente);
                    //textDigitada.Text = Convert.ToString(vCantidadDigit);
                    //   textConversion.Text = Convert.ToString(vCantidadComercio);
                    //textTipoCambio.Text = Convert.ToString(vTipoCambio);
                    //vExchange = Convert.ToString(vCambio);   // verifica con esta variable si hubo conversion 0 no, 1 si

                    var splitCuenta = Convert.ToString(vCantidadDigit);  // DE AQUI SACO EL ORIGEN DE LA CUENTA 

                    var resultad = splitCuenta.Split(' ');
                    textMonedaCuenta.Text = resultad[1];
                    textMontoDepositar.Text = "";
                    textBoxCancelaCon.Text = "";
                    textConversion.Text = "";
                    textVuelto.Text = "";
                    textCedula.Text = "";
                    labelCuenta.Text = resultad[1];

                    if (labelCuenta.Text.Equals("dólares") && pTipoMoneda.Equals("1"))
                    {
                        // desabilito
                        textEdicion.Enabled = false;
                    }
                    else if (labelCuenta.Text.Equals("colones") && pTipoMoneda.Equals("0"))
                    {
                        textEdicion.Enabled = false;

                    }

                }
                else
                {

                    if (dsAplicado.Tables.Count <= 2)
                    {
                        // mal general
                        var vDescripcion = vConsulta.Rows[0].ItemArray[2];
                        mRegistrarTransaccion("E", null, null, Convert.ToString(vDescripcion), pConsecutivo, sec_BacInvoice);
                        CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                    }
                    else
                    {
                        DataTable vConsultaContenido = dsAplicado.Tables[4];
                        var vMensaje = vConsultaContenido.Rows[0].ItemArray[3];
                        var Descripcion = vConsultaContenido.Rows[1].ItemArray[3];

                        mRegistrarTransaccion("E", null, null, Convert.ToString(Descripcion), pConsecutivo, sec_BacInvoice);
                        if (vMensaje.Equals("19"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                        }
                        else if (vMensaje.Equals("03"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("48"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("06"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("22"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("57"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("12"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else
                        {
                            GUI.CApp.ShowMessage(Descripcion.ToString(), "Respuesta del Bac", false);
                            mRegistrarTransaccion("E", null, null, Convert.ToString(Descripcion), pConsecutivo, sec_BacInvoice);
                        }
                        mLimpiar2();
                    }
                }

            }
            catch (SoapException sex)
            {
                GUI.CApp.ShowMessage(Convert.ToString(sex.Detail.FirstChild.Value), "ERROR", true);
                mRegistrarTransaccion("E", null, null, Convert.ToString(sex.Detail.FirstChild.Value), pConsecutivo, sec_BacInvoice);
                mLimpiar2();
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
                mRegistrarTransaccion("E", null, null, ex.Message, pConsecutivo, sec_BacInvoice);
                mLimpiar2();
            }

            return false;

        }

        // --------------RETIROS-------------------------


        #region mConsultaRetiros
        /// <summary>
        /// 
        /// </summary>
        private bool mConsultaRetiros(int pConsecutivo, string pMonto)
        {
            string vCriterioBusqueda = "";
            sec_BacInvoice = Sec_BcInvoice();
            sec_BcSequence = Sec_BcSequence();
            LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = null;
            try
            {
                string[] vParametros = new string[4];
                QueryParams vQp = new LLNet.Utils.QueryParams();
                vQp.AddReplaceParam("pParam1", "CRCB");
                vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');
                mLimpiarBac();
                vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                vDetTransaccion.Id = int.Parse(vParametros[0]);
                vDetTransaccion.Name = vParametros[1];
                // vDetTransaccion.Integrated = vParametros[2];
                vDetTransaccion.Sequence = sec_BcSequence;
                vDetTransaccion.Integrated = "S";
                vDetTransaccion.Invoice = sec_BacInvoice;

                if (string.IsNullOrEmpty(txtValorDeBusqueda.Text.Trim()))
                {
                    var vTarjPinPad = vTrack2;
                    var vPin = vPinBlock;
                    var vNombre = vNombreCliente;

                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();

                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = vTarjPinPad });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 3, Value = vPin });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(pMonto) });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 4, Value = vNombre });

                    ;
                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };
                }

                mRegistrarTransaccion("P", vRequest, null, null, pConsecutivo, sec_BacInvoice);

                string vPregunta = clsXmlSerializer.SerializeObject(vRequest);

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);

                string vRespuesta = clsXmlSerializer.SerializeObject(vResponse);

                mRegistrarTransaccion("R", null, vResponse, null, pConsecutivo, sec_BacInvoice);

                StringReader stringReader = new StringReader(vRespuesta);

                stringReader.Read();

                string inner = stringReader.ReadLine();

                XmlDocument dd = new XmlDocument();

                DataSet dsAplicado = new DataSet();

                dd.Load(new StringReader(inner));

                dd.LoadXml(inner);

                dsAplicado.ReadXml(new XmlTextReader(new StringReader(dd.OuterXml)));

                DataTable vConsulta = dsAplicado.Tables[1];

                var Status = vConsulta.Rows[0].ItemArray[1];

                if (Status.Equals("Success"))
                {
                    // todo bien 
                    DataTable vConsultaContenido = dsAplicado.Tables[4];


                    var vMensaje = vConsultaContenido.Rows[1].ItemArray[3];
                    var vMonto = vConsultaContenido.Rows[2].ItemArray[3];
                    var vNombrec = vConsultaContenido.Rows[3].ItemArray[3];

                    txtNombreClienteBac.Text = Convert.ToString(vNombrec);

                    string mm = Convert.ToString(vMonto);

                    string vMontoSDecimales = mm.Substring(0, mm.Length - 2);

                    string vDecimales = mm.Substring(mm.Length - 2);

                    textMontoConfirma.Text = vMontoSDecimales + "." + vDecimales + " Colones";

                    //textMontoConfirma.Text = vMonto.ToString();

                    textMensaje.Text = "CONSULTA de retiro:" + vMensaje.ToString();
                    simplebtnRetirar.Enabled = true;

                }
                else
                {

                    if (dsAplicado.Tables.Count <= 2)
                    {
                        // mal general
                        var vDescripcion = vConsulta.Rows[0].ItemArray[2];
                        mRegistrarTransaccion("E", null, null, Convert.ToString(vDescripcion), pConsecutivo, sec_BacInvoice);
                        CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                    }
                    else
                    {
                        DataTable vConsultaContenido = dsAplicado.Tables[4];
                        var vMensaje = vConsultaContenido.Rows[0].ItemArray[3];
                        var Descripcion = vConsultaContenido.Rows[1].ItemArray[3];

                        mRegistrarTransaccion("E", null, null, Convert.ToString(Descripcion), pConsecutivo, sec_BacInvoice);
                        if (vMensaje.Equals("19"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                        }
                        else if (vMensaje.Equals("03"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("48"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("06"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("22"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("57"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("12"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else
                        {
                            GUI.CApp.ShowMessage(Descripcion.ToString(), "Respuesta del Bac", false);
                            mRegistrarTransaccion("E", null, null, Convert.ToString(Descripcion), pConsecutivo, sec_BacInvoice);
                        }
                        mLimpiarRetiros();
                    }
                }

            }
            catch (SoapException sex)
            {
                GUI.CApp.ShowMessage(Convert.ToString(sex.Detail.FirstChild.Value), "ERROR", true);
                mRegistrarTransaccion("E", null, null, Convert.ToString(sex.Detail.FirstChild.Value), pConsecutivo, sec_BacInvoice);
                mLimpiar2();
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
                mRegistrarTransaccion("E", null, null, ex.Message, pConsecutivo, sec_BacInvoice);
                mLimpiar2();
            }

            return false;

        }
        #endregion

        private void cboConvBac_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {

                mLimpiarDepositos();
                mLimpiarRetiros();
                mLimpiar2();
                cboConsultaBac.DataSource = null;

                if (cboConvBac.SelectedIndex >= 0)
                {
                    varCConvenio = cboConvBac.Properties.Items[cboConvBac.SelectedIndex].Value.ToString();

                    switch (varCConvenio)
                    {

                        case "12":
                            // consulta
                            xtraDepositos.Visible = false;
                            xtraRetiros.Visible = false;
                            varConvenio = cboConvBac.Properties.Items[cboConvBac.SelectedIndex].Description.ToString();
                            mCargarLlaves(varCEmpresa, varCConvenio);
                            sbtnPagar.Visible = true;
                            btnDepositar.Visible = false;
                            simplebtnRetirar.Visible = false;
                            txtValorDeBusqueda.Enabled = true;
                            break;
                        case "13":
                            //DEPOSITOS
                            xtraDepositos.Visible = true;
                            xtraRetiros.Visible = false;
                            mCargarTipoIdentificacionDepositos();
                            mCargarMonedasDeposito();
                            mCargarLlaves(varCEmpresa, varCConvenio);
                            sbtnPagar.Visible = false;
                            simplebtnRetirar.Visible = false;
                            btnDepositar.Visible = true;
                            txtValorDeBusqueda.Enabled = true;
                            // mCargarLlavesDepositos(varCEmpresa, varCConvenio);
                            break;

                        case "14":
                            //RETIROS
                            xtraDepositos.Visible = false;
                            xtraRetiros.Visible = true;
                            mCargarTipoIdentificacionDepositos();
                            mCargarMonedasRetiro();
                            mCargarLlaves(varCEmpresa, varCConvenio);
                            sbtnPagar.Visible = false;
                            btnDepositar.Visible = false;
                            simplebtnRetirar.Visible = true;
                            txtValorDeBusqueda.Enabled = false;
                            // mCargarLlavesDepositos(varCEmpresa, varCConvenio);
                            break;
                    }


                }
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
                mRegistrarTransaccion("E", null, null, ex.Message, varSECdeposito, sec_BacInvoice);
            }

        }
        #region mCargarMonedasDeposito
        /// <summary>
        /// Carga los tipos de moneda autorizados para el pago
        /// </summary>
        private void mCargarMonedasDeposito()
        {
            cbxMoneda.DataSource = null;
            cbxMoneda.Refresh();

            try
            {
                QueryParams qp = new LLNet.Utils.QueryParams();
                DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_MONEDA_CAMBIO");

                cbxMoneda.DataSource = dsB.Tables[0];
                cbxMoneda.ValueMember = "ID";
                cbxMoneda.DisplayMember = "TIPOID";

            }
            catch (Exception er)
            {
                GUI.CApp.ShowMessage(er.Message, "ERROR", true);
            }
        }
        #endregion

        #region mCargarMonedasRetiro
        /// <summary>
        /// Carga los tipos de moneda autorizados para el pago
        /// </summary>
        private void mCargarMonedasRetiro()
        {
            cbxMonedaRetiro.DataSource = null;
            cbxMonedaRetiro.Refresh();

            try
            {
                QueryParams qp = new LLNet.Utils.QueryParams();
                DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_MONEDA_CAMBIOretiro");

                cbxMonedaRetiro.DataSource = dsB.Tables[0];
                cbxMonedaRetiro.ValueMember = "ID";
                cbxMonedaRetiro.DisplayMember = "TIPOID";

            }
            catch (Exception er)
            {
                GUI.CApp.ShowMessage(er.Message, "ERROR", true);
            }
        }
        #endregion
        private void cboConsultaBac_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                if (cboConsultaBac.SelectedIndex >= 0)
                {
                    varLlave = cboConsultaBac.Text;
                    varLlave = cboConsultaBac.Items[cboConsultaBac.SelectedIndex].ToString();
                }
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
            }
        }

        private void sBtnRepBac_Click(object sender, EventArgs e)
        {
            sBtnEnviar.Visible = false;
            btnDepositar.Visible = false;
            sbtnPagar.Visible = false;
            sbtnImprimir.Visible = true;
            btnRecargar.Visible = false;
            xtraDepositos.Visible = false;
            pnlCobroYReimpresion.Visible = true;
            pnlConsultaBac.Visible = false;
            pnlConsultaBac2.Visible = true;
            pnlReversion.Visible = false;
            panel7.Visible = false;
            sbtnImprimir.Visible = false;
            xtraRetiros.Visible = false;
            mArqJornadaBAC();
            mReporteJornada();
            panelControl11.Visible = true;
        }

        private void btnConsultar_Click(object sender, EventArgs e)
        {

            if (GUI.CApp.ValidateAccess("Reimprimir", "Reimpresion"))
            {
                sBtnEnviar.Visible = false;
                sbtnPagar.Visible = true;
                sbtnImprimir.Visible = false;
                btnRecargar.Visible = false;
                sBtnConsultarBac.Visible = true;
                //Aquí va el combo del tipo de documento de identidad y el campo cédula.
                panel7.Visible = true;
                pnlCobroYReimpresion.Visible = true;
                pnlConsultaBac.Visible = true;
                pnlConsultaBac2.Visible = false;
                pnlReversion.Visible = false;
                xtraDepositos.Visible = false;
                xtraRetiros.Visible = false;
                mLimpiarDepositos();
                cboConvBac.SelectedItem = -1;
                cboConvBac.SelectedItem = null;
                panel7.Visible = true;
            }
        }

        private void sbtnImprimir_Click(object sender, EventArgs e)
        {
            if (GUI.CApp.ValidateAccess("Reimprimir", "Reimpresion"))
            {
                foreach (int handle in gridCRepJornS.GetSelectedRows())
                {
                    //se envía el número de documento
                    mImprimeTiquete(long.Parse(Convert.ToString(gridCRepJornS.GetRowCellValue(handle, gridCRepJornS.Columns[2]))),
                        Convert.ToString(gridCRepJornS.GetRowCellValue(handle, gridCRepJornS.Columns[10])), Convert.ToString(gridCRepJornS.GetRowCellValue(handle, gridCRepJornS.Columns[11])));
                }
            }
        }

        private void sbtnRevisarPagoBac_Click(object sender, EventArgs e)
        {
            pnlReversion.Visible = false;
        }


        private void FrmRapibac_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Modifiers == Keys.Alt)
            {
                switch (e.KeyCode)
                {
                    case Keys.F:
                        if (this.btnConsultar.Visible)
                            btnConsultar.PerformClick();
                        break;
                    case Keys.R:
                        sBtnBac_Reimp.PerformClick();
                        break;
                    case Keys.C:
                        sBtnRepBac.PerformClick();
                        break;
                    case Keys.V:
                        if (this.sBtnRevBac.Visible)
                            sBtnRevBac.PerformClick();
                        break;
                    case Keys.I:
                        if (this.sbtnRevisarPagoBac.Visible)
                            sbtnRevisarPagoBac.PerformClick();
                        break;
                }
            }

            if (e.Modifiers == Keys.None)
            {
                switch (e.KeyCode)
                {
                    case Keys.F1:
                        if (this.sBtnConsultarBac.Visible)
                            sBtnConsultarBac.PerformClick();
                        break;
                    case Keys.F2:
                        if (this.btnDepositar.Visible)
                            btnDepositar.PerformClick();
                        break;
                    case Keys.F3:
                        if (this.simplebtnRetirar.Visible)
                            simplebtnRetirar.PerformClick();
                        break;
                    case Keys.F9:
                        if (this.sBtnEnviar.Visible)
                            sBtnEnviar.PerformClick();
                        break;
                    case Keys.F10:
                        if (this.sbtnPagar.Visible)
                            sbtnPagar.PerformClick();
                        break;
                    case Keys.F11:
                        if (this.sbtnImprimir.Visible)
                            sbtnImprimir.PerformClick();
                        break;
                    case Keys.F12:
                        if (btnRecargar.Enabled == true)
                            btnRecargar.PerformClick();
                        break;
                    case Keys.Escape:
                        btnCancelar.PerformClick();
                        break;
                }
            }
        }

        //// SEGMENTO DEPOSITOS/////-------------------------------------------------------------------------------------------------
        /// <summary>
        /// SECUENCIAS USADAS
        /// </summary>
        /// <returns></returns>

        #region Sec_BcInvoice

        private string Sec_BcInvoice()
        {
            string seccrdx = "";
            Utils.QueryParams qp = new LLNet.Utils.QueryParams();
            seccrdx = Convert.ToString(GUI.CApp.bll.GetSingleValue("SEC_SECRAPI", qp, "PDV"));
            return seccrdx;
        }
        #endregion

        #region Sec_BcSequence

        private int Sec_BcSequence()
        {
            string seccrdx = "";
            Utils.QueryParams qp = new LLNet.Utils.QueryParams();
            seccrdx = Convert.ToString(GUI.CApp.bll.GetSingleValue("SEC_SECRAPIsec", qp, "PDV"));


            return int.Parse(seccrdx);
        }
        #endregion


        #region Sec_Bctc

        private string Sec_Bctc()
        {
            string seccrd = "";
            Utils.QueryParams qps = new LLNet.Utils.QueryParams();
            seccrd = Convert.ToString(GUI.CApp.bll.GetSingleValue("SEC_SECTC", qps, "PDV"));
            return seccrd;
        }
        #endregion

        private void btnReversarPago_Click(object sender, EventArgs e)
        {
            vNombreCliente = "";
            varCEmpresa = "";
            varCConvenio = "";
            varCLlave = "";
            string pMontoMoneda = "";
            string pTotalTras = "";
            string pMonedaSaldo = "";
            string pTarjeta = "";
            string pTipoIdentif = "";
            string pNumCedula = "";
            string pInvoice = "";
            string pNumComprobante = "";
            string pDocumento = "";
            string pTransProveedor = "";
            string vMontoDeposito = "";
            string vTipoCuenta = "";
            string vTM = "";
            string vBacSec = "";
            string vMRecibo = "";
            string vNumr = "";
            try
            {

                if (gCtrlHRevS.RowCount > 0)
                {

                    foreach (int handle in gCtrlHRevS.GetSelectedRows())
                    {
                        // string refer = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[0]));
                        pMontoMoneda = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[0]));
                        pTotalTras = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[1]));
                        pMonedaSaldo = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[2]));
                        pTarjeta = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[3]));

                        //   pTarjeta = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[3]));
                        pTipoIdentif = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[4]));
                        pNumCedula = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[5]));
                        pTransProveedor = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[6]));
                        pInvoice = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[7]));
                        pNumComprobante = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[8]));
                        pDocumento = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[9]));

                        vMRecibo = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[10]));
                        vNumr = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[11]));

                        varCEmpresa = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[12]));
                        varCConvenio = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[13]));
                        varCLlave = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[14]));
                        vNombreCliente = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[15]));
                        vMontoDeposito = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[17]));
                        vTipoCuenta = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[18]));
                        vTM = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[19]));
                        vBacSec = Convert.ToString(gCtrlHRevS.GetRowCellValue(handle, gCtrlHRevS.Columns[20]));

                        if (string.IsNullOrEmpty(vBacSec))
                        {
                            vBacSec = "0";
                        }

                    }
                    string vResponder = GUI.CApp.ShowMessage("\nNombre del Cliente: " + vNombreCliente + "" +
                                                           "\nRecibo de Proveedor: " + pTransProveedor
                                                             + "\nNumero de recibo: " + vNumr + "\nMonto de recibo: " + vMRecibo +
                                                             "", "RapiBac Anulaciónes", true, true).ToString();

                    //Consultamos al usuario si desea realizar la conversión
                    if (vResponder.Equals("OK"))
                    {
                        mReversarRapiBac2(pInvoice, pMontoMoneda, vMontoDeposito, pMonedaSaldo, pTarjeta, pTipoIdentif, pNumCedula, pNumComprobante, pDocumento,
                          pTransProveedor, varCConvenio, Convert.ToString(vTipoCuenta), vTM, int.Parse(vBacSec), pTotalTras);
                    }
                }
            }
            catch (Exception ex)
            {
                CApp.ShowMessage(ex.Message, "Error", true);
                mRegistrarTransaccion("E", null, null, ex.Message, Convert.ToInt32(pNumComprobante), sec_BacInvoice);
            }
        }

        private void btnDepositar_Click(object sender, EventArgs e)
        {
            mDepositarTransaccion();
        }

        private void mDepositarTransaccion()
        {
            double vMontoConvertidoDol = 0;
            double vMontoConvertidoDig = 0;
            int valmoneda, valcbx;

            valcbx = cbxMoneda.SelectedIndex;

            try
            {
                if (string.IsNullOrEmpty(txtNombreClienteBac.Text.Trim()))
                {
                    GUI.CApp.ShowMessage("Favor realizar la consulta de la tarjeta inicialmente", "ERROR", true);
                    sBtnConsultarBac.Focus();
                    return;
                }

                if (varCEmpresa.Equals(vEmpresa))
                {
                    if (string.IsNullOrEmpty(textCedula.Text.Trim()))
                    {
                        GUI.CApp.ShowMessage("Falta información en el campo IDENTIFICACION", "ERROR", true);
                        txtIdentificacion.Focus();
                        return;
                    }
                }

                if (string.IsNullOrEmpty(textMontoDepositar.Text.Trim()))
                {
                    GUI.CApp.ShowMessage("Falta información en el campo MONTO A DEPOSITAR", "ERROR", true);
                    txtMontoPago.Focus();
                    return;
                }
                
                if (string.IsNullOrEmpty(textBoxCancelaCon.Text.Trim()))
                {
                    GUI.CApp.ShowMessage("Falta información en el campo CANCELA CON", "ERROR", true);
                    txtMontoPagado.Focus();
                    return;
                }
                else
                {
                    if (decimal.Parse(textBoxCancelaCon.Text.Trim()) < decimal.Parse(textMontoDepositar.Text.Trim()))
                    {
                        GUI.CApp.ShowMessage("Verifique. El monto cancelado es menor al monto pagado", "ERROR", true);
                        txtMontoPagado.Focus();
                        return;
                    }
                    // VALIDA EL PARAMETRO DIMAMICO CORRESPONDIENTE AL MONTO PERMITIDO

                    // despues de validaciones, VERIFICA QUE TIPO DE MONEDA VIENE
                    if (!string.IsNullOrEmpty(vMontoMaximo))
                    {
                        if (labelCuenta.Text.Equals("colones"))
                        {
                            if (decimal.Parse(textConversion.Text.Trim()) > decimal.Parse(vMontoMaximo))
                            {
                                GUI.CApp.ShowMessage("Verifique. El monto a depósitar es mayor al definido, el cual seria :" + vMontoMaximo + " Colones", "ERROR", true);
                                textConversion.Focus();

                                return;
                            }
                        }
                        else
                        {
                            // dolares

                            if (cbxMoneda.Text.Equals("Colon"))
                            {

                                if (decimal.Parse(textMontoDepositar.Text.Trim()) > decimal.Parse(vMontoMaximo))
                                {
                                    GUI.CApp.ShowMessage("Verifique. El monto a depósitar es mayor al definido,el cual seria :" + vMontoMaximo + " Colones", "ERROR", true);
                                    textConversion.Focus();
                                    return;
                                }

                            }
                            else
                            {

                                decimal vmXDolar = decimal.Parse(textMontoDepositar.Text) * decimal.Parse(vtcCompra);

                                if (vmXDolar > decimal.Parse(vMontoMaximo))
                                {
                                    GUI.CApp.ShowMessage("Verifique. El monto a depósitar es mayor al definido,el cual seria : " + vMontoMaximo + " Colones", "ERROR", true);
                                    textConversion.Focus();
                                    return;
                                }


                            }


                        }

                    }
                    else
                    {
                        GUI.CApp.ShowMessage("Verifique con soporte TI, parametro de Monto maximo nulo", "ERROR", true);
                        mLimpiarDepositos();
                        return;
                    }

                }

                if (textMonedaCuenta.Text.ToLower().Trim() == "colones")
                {
                    valmoneda = 0;
                }
                else
                {
                    valmoneda = 1;
                }

                if (valmoneda != valcbx)
                {
                    GUI.CApp.ShowMessage("La moneda de pago no concuerda con la moneda de la cuenta a depositar", "ERROR", true);
                    cbxMoneda.Focus();
                    return;
                }
                // despues de validaciones, VERIFICA QUE TIPO DE MONEDA VIENE

                if (cbxMoneda.SelectedIndex == 0)  // colones
                {

                    mEjecutarDeposito(varSECdeposito, Convert.ToString(textConversion.Text.Trim()), textVuelto.Text.Trim(), textMonedaCuenta.Text, textBoxCancelaCon.Text.Trim(), "");
                    mLimpiarDepositos();

                }
                else  // dolares
                {

                    mEjecutarDeposito(varSECdeposito, Convert.ToString(textConversion.Text.Trim()), textVuelto.Text.Trim(), textMonedaCuenta.Text, "", textBoxCancelaCon.Text.Trim());
                    mLimpiarDepositos();

                }

            }

            catch (SoapException sex)
            {
                GUI.CApp.ShowMessage(Convert.ToString(sex.Detail.FirstChild.Value), "ERROR", true);
                //mRegistrarTransaccion("E", null, null, Convert.ToString(sex.Detail.FirstChild.Value), pConsecutivo, sec_BacInvoice);
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
                ///  mRegistrarTransaccion("E", null, null, ex.Message, pConsecutivo, sec_BacInvoice);
            }
        }
        private void mEjecutarDeposito(int pConsultaId, string pConversion, string pVuelto, string pMonedaCuenta, string pPagoCol, string pPagoDol)
        {

            int vEstado = 0;
            QueryParams vQp = new LLNet.Utils.QueryParams();

            vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
            //Verificamos si la apertura ya se hizo
            vEstado = Convert.ToInt32(CApp.bll.GetSingleValue("ESTADO_TERMINAL", vQp, "PDV"));

            if (vEstado == 0)
            {
                mAperturaTerminal();
            }

            int varTipIde = cbxTipoIdentificacion.SelectedIndex;
            string vTd = "";


            switch (varTipIde)
            {
                case 0:
                    vTd = "1";  // cedula
                    break;
                case 1:
                    vTd = "2";  // Cedula de residencia
                    break;
                case 2:
                    vTd = "3";  // Pasaporte
                    break;
            }

            int varSECComp = Convert.ToInt32(GUI.CApp.bll.GetSingleValue("SEC_BACCOMPR", "PDV"));

            if (pMonedaCuenta.Equals("colones"))
            {

                if (ConsultarDatosDeposito(varSECComp, pConversion, "1"))
                {
                    if (cbxMoneda.SelectedIndex == 0)
                    {
                        // colones segun cuenta no combobox
                        mDepositarCuentaBancaria(varSECComp, pConversion, pVuelto, vTd, pMonedaCuenta, pPagoCol, "", "1", sec_BacTC);
                    }
                    else
                    {
                        // colones segun cuenta no combobox
                        mDepositarCuentaBancaria(varSECComp, pConversion, pVuelto, vTd, pMonedaCuenta, "", pPagoDol, "1", sec_BacTC);

                    }

                    // colones segun cuenta no combobox
                    //  mDepositarCuentaBancaria(pConsultaId, pConversion, pVuelto, vTd, pMonedaCuenta, pPagoCol, pPagoDol, "2");
                }
            }
            else
            {

                if (ConsultarDatosDeposito(varSECComp, pConversion, "2"))
                {

                    if (cbxMoneda.SelectedIndex == 0)
                    {
                        // colones segun cuenta no combobox
                        mDepositarCuentaBancaria(varSECComp, pConversion, pVuelto, vTd, pMonedaCuenta, pPagoCol, "", "2", sec_BacTC);
                    }
                    else
                    {
                        // colones segun cuenta no combobox
                        mDepositarCuentaBancaria(varSECComp, pConversion, pVuelto, vTd, pMonedaCuenta, "", pPagoDol, "2", sec_BacTC);

                    }

                }


            }
        }
        private void LLenarGridPags()
        {
            string[] vParametros = new string[3];
            QueryParams vQp = new LLNet.Utils.QueryParams();
            //Jornada
            vQp.AddReplaceParam("pJORNADA", Program.Jornada.ToString());

            //  vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');

            //Consulta los pagos de la BD
            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "TRANSAC_BACREVERSA", vQp);
            if (dsB.Tables[0].Rows.Count > 0)
            {

                gCtrlHRevG.DataSource = dsB.Tables[0];
                gCtrlHRevS.Columns[0].Visible = false;
                gCtrlHRevS.Columns[1].Visible = false;
                gCtrlHRevS.Columns[2].Visible = false;
                gCtrlHRevS.Columns[3].Visible = false;
                gCtrlHRevS.Columns[4].Visible = false;
                gCtrlHRevS.Columns[7].Visible = false;
                gCtrlHRevS.Columns[9].Visible = false;

                gCtrlHRevS.Columns[12].Visible = false;
                gCtrlHRevS.Columns[13].Visible = false;
                gCtrlHRevS.Columns[14].Visible = false;
                gCtrlHRevS.Columns[15].Visible = false;
                gCtrlHRevS.Columns[20].Visible = false;
                gCtrlHRevG.Refresh();
            }
            else
            {
                gCtrlHRevG.DataSource = null;
                gCtrlHRevG.Refresh();
            }
        }

        #region mLimpiarDepositos
        /// <summary>
        /// Limpia los textos del formulario
        /// </summary>
        private void mLimpiarDepositos()
        {


            btnRecargar.Visible = false;
            txtNombreClienteBac.Text = "";
            txtMonedaBac.Text = "";
            txtLlave.Text = "";
            txtmonto.Text = "";
            txtICEMES.Text = "";
            cboConsultaBac.Focus();
            txtValorDeBusqueda.Text = "";
            textCedula.Text = "";
            textObservacion.Text = "";
            txtVuelto.Text = "";
            textVuelto.Text = "";
            //   textTipoCambio.Text = "";
            textConversion.Text = "";
            //    textDigitada.Text = "";
            textMonedaCuenta.Text = "";
            textBoxCancelaCon.Text = "";
            textEdicion.Text = "";
            labelCuenta.Text = "";
            textMontoDepositar.Text = "";

        }
        private void mLimpiarRetiros()
        {
            textPagaRetiros.Text = "";
            txtNombreClienteBac.Text = "";
            textMensaje.Text = "";
            textMontoConfirma.Text = "";
            mCargaFondoDisponible();

        }
        #endregion

        #region ConsultarDatosDeposito
        private bool ConsultarDatosDeposito(int pConsecutivo, string pMontoDepositar, string pTMoneda)
        {
            string vCriterioBusqueda = "";
            sec_BacInvoice = Sec_BcInvoice();
            sec_BcSequence = Sec_BcSequence();


            LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = null;
            try
            {
                string[] vParametros = new string[4];
                QueryParams vQp = new LLNet.Utils.QueryParams();
                vQp.AddReplaceParam("pParam1", "DECU");
                vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');
                mLimpiarBac();
                vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                vDetTransaccion.Id = int.Parse(vParametros[0]);
                vDetTransaccion.Name = vParametros[1];
                vDetTransaccion.Integrated = vParametros[2];
                vDetTransaccion.Sequence = sec_BcSequence;
                vDetTransaccion.Invoice = sec_BacInvoice;
                if (string.IsNullOrEmpty(txtValorDeBusqueda.Text.Trim()))
                {
                    string vTarjPinPad = vTrack2;
                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 5, Value = pTMoneda });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(pMontoDepositar) });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = vTarjPinPad });
                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };
                }
                else
                {
                    vCriterioBusqueda = txtValorDeBusqueda.Text.Trim();  /// CRITERIO DE BUSQUEDA POR CUENTA BANCARIA
                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 5, Value = pTMoneda });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(pMontoDepositar) });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 7, Value = vCriterioBusqueda });
                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };
                }
                mRegistrarTransaccion("P", vRequest, null, null, pConsecutivo, sec_BacInvoice);
                string vPregunta = clsXmlSerializer.SerializeObject(vRequest);
                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);
                string vRespuesta = clsXmlSerializer.SerializeObject(vResponse);
                mRegistrarTransaccion("R", null, vResponse, null, pConsecutivo, sec_BacInvoice);

                StringReader stringReader = new StringReader(vRespuesta);

                stringReader.Read();

                string inner = stringReader.ReadLine();

                XmlDocument dd = new XmlDocument();

                DataSet dsAplicado = new DataSet();

                dd.Load(new StringReader(inner));

                dd.LoadXml(inner);

                dsAplicado.ReadXml(new XmlTextReader(new StringReader(dd.OuterXml)));

                DataTable vConsulta = dsAplicado.Tables[1];

                var Status = vConsulta.Rows[0].ItemArray[1];

                if (Status.Equals("Success"))
                {
                    // todo bien 
                    DataTable vConsultaContenido = dsAplicado.Tables[4];

                    var vMonto = vConsultaContenido.Rows[2].ItemArray[3];
                    var vNombreCliente = vConsultaContenido.Rows[3].ItemArray[3];
                    var vTarjeta = vConsultaContenido.Rows[4].ItemArray[3];
                    var vCantidadDigit = vConsultaContenido.Rows[5].ItemArray[3];
                    var vCantidadComercio = vConsultaContenido.Rows[6].ItemArray[3];
                    var vTipoCambio = vConsultaContenido.Rows[7].ItemArray[3];
                    var vCambio = vConsultaContenido.Rows[8].ItemArray[3];

                    var tc = "";
                    if (string.IsNullOrEmpty(varTCompra))
                    {
                        tc = varTCventa;
                    }
                    else
                    {
                        tc = varTCompra;
                    }

                    string vResponder = "";
                    string vResponderDolares = "";
                    decimal vVuelto = 0;
                    decimal vMontotc = 0;
                    if (textMonedaCuenta.Text.Equals("colones"))
                    {

                        if (cbxMoneda.Text.Equals("Dolar"))
                        {

                            vMontotc = decimal.Parse(textBoxCancelaCon.Text.Trim()) * decimal.Parse(tc);
                            vVuelto = vMontotc - decimal.Parse(textConversion.Text);


                            // PRIMERO QUE CONFIRME EL TIPO DE CAMBIO 

                            vResponder = GUI.CApp.ShowMessage("\nCliente: " + vNombreCliente
                                                                + "\n"
                                                              + "\nDepósito : " + textMontoDepositar.Text.Trim() + "  " + "Dólares"
                                                               + "\nConversión : " + textConversion.Text.Trim() + "  " + "Colones"
                                                               + "\nCancela con : " + textBoxCancelaCon.Text.Trim() + "  " + "Dólares"
                                                               + "\nConversión: " + vMontotc + " Colones"
                                                               + "\nTipo Cambio: " + tc
                                                                 + "\n"
                                                               + "\nVuelto: " + vVuelto + " Colones",
                                                               "CONFIRMACIÓN DE CAMBIO DE DIVISAS", true, true).ToString();


                        }
                        else
                        {
                            // en colones sin conversiones

                            string vResponderDep = GUI.CApp.ShowMessage("Cliente: " + vNombreCliente + "\nDestino: " + vTarjeta +
                             "\nDepósito de: " + textMontoDepositar.Text + " Colones" + " \nCancela con: " + textBoxCancelaCon.Text.Trim() + " " + "Colones" +
                                  "\nTipo Cambio:" + " No aplica" + "\nVuelto: " + textVuelto.Text + " Colones", "CONFIRMACION DE DEPÓSITO", true, true).ToString();

                            sec_BacTC = "";
                            if (vResponderDep.Equals("OK"))
                            {
                                return true;
                            }
                            else
                            {
                                return false;
                            }

                        }
                    }
                    else
                    {
                        // cuenta en dolares PAGA COLONES
                        if (cbxMoneda.Text.Equals("Colon"))
                        {


                            vResponderDolares = GUI.CApp.ShowMessage("\nCliente: " + vNombreCliente
                                                                    + "\nMonto a Depositar : " + textConversion.Text + " " + "Dolares"
                                                                      + "\nConversión :" + textMontoDepositar.Text + " " + "Colones" +
                                                                      "\nTipo Cambio: " + tc
                                                                      + "\n"
                                                                       + "\nVuelto: " + textVuelto.Text + " Colones",
                                                                       "CONFIRMACIÓN DE CAMBIO DE DIVISAS", true, true).ToString();

                        }
                        else
                        {

                            // cuenta dolares paga dolares
                            string vResponderDep = GUI.CApp.ShowMessage("Cliente: " + vNombreCliente + "\nDestino: " + vTarjeta +
                                    "\nPaga con : " + textMontoDepositar.Text + " " + "Dolares" +
                                     "\nDepósito de: " + textConversion.Text + " Dolares" +
                                   " \nCancela con : " + textBoxCancelaCon.Text.Trim() + " " + "Dolares"
                                    + "\nTipo Cambio:" + "No aplica" + "\nVuelto: " + textVuelto.Text + " Colones"
                                     + "", "CONFIRMACIÓN DE DEPÓSITO", true, true).ToString();
                            sec_BacTC = "";
                            if (vResponderDep.Equals("OK"))
                            {
                                return true;
                            }
                            else
                            {
                                return false;
                            }
                        }


                    }

                    //Consultamos al usuario si desea realizar la conversión
                    if (vResponder.Equals("OK"))
                    {
                        sec_BacTC = Sec_Bctc();
                        // registra el tipo de cambio
                        mRegistraMesaCambio((sec_BacTC), Convert.ToString(vNombreCliente), Convert.ToString(textBoxCancelaCon.Text), Convert.ToString(tc),
                           Convert.ToString(vMontotc), Convert.ToString(vVuelto), Convert.ToString(cbxMoneda.SelectedIndex));
                        // imrprimir
                        //VERIFICA QUE LA IMPRESION ES CORRECTA
                        if (CargaDatosTipoCambio(sec_BacTC.ToString()))
                        {

                            string vResponderDep = GUI.CApp.ShowMessage("Cliente: " + vNombreCliente + "\nDestino: " + vTarjeta +
                                "\nDepósito de: " + textConversion.Text + " Colones"
                                + " \nCancela con: " + textBoxCancelaCon.Text.Trim() + " " + "Dolares" + "\nTipo Cambio: " + tc
                                  + "", "CONFIRMACIÓN DE DEPÓSITO", true, true).ToString();
                            if (vResponderDep.Equals("OK"))
                            {
                                return true;
                            }
                            else
                            {

                                // anula recibo de la conversion
                                mAnulaMesaCambio(sec_BacTC);
                                GUI.CApp.ShowMessage("\nSe anulo la mesa de cambio número de recibo: " + sec_BacTC, "Mensaje Informativo", false);

                                return false;
                            }

                        }

                    }

                    //Consultamos al usuario si desea realizar la conversión
                    if (vResponderDolares.Equals("OK"))
                    {
                        sec_BacTC = Sec_Bctc();
                        // registra el tipo de cambio
                        mRegistraMesaCambio((sec_BacTC), Convert.ToString(vNombreCliente), Convert.ToString(textMontoDepositar.Text), Convert.ToString(tc), textConversion.Text,
                            Convert.ToString(textVuelto.Text), Convert.ToString(cbxMoneda.SelectedIndex));
                        // imrprimir

                        if (CargaDatosTipoCambio(sec_BacTC.ToString()))
                        {
                            string vResponderDep = GUI.CApp.ShowMessage("Cliente: " + vNombreCliente + "\nDestino: " + vTarjeta +
                          "\nPaga con: " + textMontoDepositar.Text + " Cólones" +
                         " \nCancela con: " + textBoxCancelaCon.Text.Trim() + " " + "Cólones"
                           + "\nDeposito de: " + vCantidadDigit + "\nConversion: " + textConversion.Text + " Dólares" + "\nTipo Cambio:" + tc
                          + "\nVuelto: " + textVuelto.Text + " Cólones"
                            + "", "CONFIRMACION DE DÉPOSITO", true, true).ToString();

                            if (vResponderDep.Equals("OK"))
                            {
                                return true;
                            }
                            else
                            {

                                // anula recibo de la conversion
                                mAnulaMesaCambio(sec_BacTC);
                                GUI.CApp.ShowMessage("Se anulo la mesa de cambio num de recibo:" + sec_BacTC, "Mensaje Informativo", false);

                                return false;
                            }

                        }

                    }

                    else
                    {
                        return false;
                    }

                }
                else
                {

                    if (dsAplicado.Tables.Count <= 2)
                    {
                        // mal general
                        var vDescripcion = vConsulta.Rows[0].ItemArray[2];
                        mRegistrarTransaccion("E", null, null, Convert.ToString(vDescripcion), pConsecutivo, sec_BacInvoice);
                        CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                    }
                    else
                    {
                        DataTable vConsultaContenido = dsAplicado.Tables[4];
                        var vMensaje = vConsultaContenido.Rows[0].ItemArray[3];
                        var Descripcion = vConsultaContenido.Rows[1].ItemArray[3];

                        mRegistrarTransaccion("E", null, null, Convert.ToString(Descripcion), pConsecutivo, sec_BacInvoice);
                        if (vMensaje.Equals("19"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                        }
                        else if (vMensaje.Equals("03"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("48"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("06"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("22"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("57"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("12"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else
                        {
                            GUI.CApp.ShowMessage(Descripcion.ToString(), "Respuesta del proveedor", false);
                            mRegistrarTransaccion("E", null, null, Convert.ToString(vMensaje), pConsecutivo, sec_BacInvoice);
                        }
                        mLimpiar2();
                    }
                }

            }
            catch (SoapException sex)
            {
                GUI.CApp.ShowMessage(Convert.ToString(sex.Detail.FirstChild.Value), "ERROR", true);
                mRegistrarTransaccion("E", null, null, Convert.ToString(sex.Detail.FirstChild.Value), pConsecutivo, sec_BacInvoice);
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
                mRegistrarTransaccion("E", null, null, ex.Message, pConsecutivo, sec_BacInvoice);
            }
            return false;

        }
        #endregion

        //anula mesa de cambio
        // registra la mesa de cambio

        private void mAnulaMesaCambio(string psec_BacTC)
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();

            vQp.AddReplaceParam("pDOCUMENTO", psec_BacTC.ToString());
            vQp.AddReplaceParam("pCAJERO", GUI.CApp.usuario.ToString());

            CApp.bll.ExecuteSql("anulaMesaCambio", vQp, "PDV");

        }
        private bool CargaDatosTipoCambio(string doc)
        {
            //selecciona los datos para imprimir
            QueryParams qp1 = new LLNet.Utils.QueryParams();
            qp1.AddReplaceParam("pDoc", doc);

            bool pGood = false;

            //CONSULTA LOS PARÁMETROS DE LA BD
            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "DATOIMP_TC", qp1);
            if (dsB.Tables.Count > 0)
            {
                if (dsB.Tables[0].Rows.Count > 0)
                {
                    object[] datos = new object[5];
                    datos = dsB.Tables[0].Rows[0].ItemArray;
                    var vFormato = "3045";

                    imprimirDocumentoTc(long.Parse(datos[0].ToString()), datos[1].ToString(), long.Parse(vFormato), datos[3].ToString(), datos[4].ToString());
                    // GUI.CApp.ShowMessage("Impresion de Cambio de Divisas realizada", "Mensaje", true);
                    pGood = true;
                }
                else
                {
                    pGood = false;
                    GUI.CApp.ShowMessage("Problemas al imprimir", "ERROR", true);
                }
            }
            else
            {
                pGood = false;
                GUI.CApp.ShowMessage("Problemas al imprimir", "ERROR", true);
            }
            return pGood;
        }

        //IMPRESION RECIBO DE CAMBIO DE DIVISAS
        private static void imprimirDocumentoTc(long documento, string Impresora, long formato, string prefijo, string BatName)
        {
            if (BatName == "")
            {
            }
            BatName = "imprimir.bat";
            Impresora = "Facturacion";
            string Ruta = Application.StartupPath;
            QueryParams qp = new QueryParams();
            if (Ruta != string.Empty)
            {
                //BatName = "imprimir.bat";
                System.Diagnostics.ProcessStartInfo startInfo = new System.Diagnostics.ProcessStartInfo(Ruta + "\\" + BatName);
                startInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;

                string Args = "";

                string varTipoTxt = Helpers.ObjToStr(CApp.GetParam("TTXT"));

                if (varTipoTxt == "U") // SI EL TIPO DE GENERACION DE ARCHIVO ES POR USUARIO O DOCUMENTO
                {
                    if (prefijo != "")
                        Args = prefijo + CApp.usuario + ".txt ";
                    else
                        Args = CApp.usuario + ".txt ";
                }
                else
                {
                    long pDocumento = documento;
                    if (prefijo != "")
                        //      Args = prefijo + pDocumento + ".txt ";
                        Args = pDocumento + ".txt ";

                    else
                        Args = pDocumento + ".txt ";
                }
                startInfo.Arguments = Args;

                try
                {
                    qp.AddReplaceParam("DOCUMENTO", documento.ToString());
                    qp.AddReplaceParam("FORMATO", formato.ToString());
                    qp.AddReplaceParam("USUARIO", CApp.usuario.ToString());
                    CApp.bll.ExecuteSql("GENERAR_IMPRESION_POS", qp, "PDV");
                    Thread.Sleep(2000); // SE LE DA TIEMPO A LA BD DE GENERAR EL ARCHIVO DE TEXTO
                    //  startInfo.UseShellExecute = false;
                    System.Diagnostics.Process.Start(startInfo);
                    //startInfo.UseShellExecute
                }
                catch (Exception ex)
                {
                    CApp.ShowMessage(ex.Message, "Impresion de Documentos", true);
                }
            }
            else
            {
                throw new Exception("No esta Definido el Parametro UATI");
            }
            //startInfo.UseShellExecute = false; 
        }

        private void mRegistraMesaCambio(string psec_BacTC, string pNombreCliente, string pMonto, string pTipoCambio, string pConversion,
         string pVuelto, string pTipoMoneda)
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();

            vQp.AddReplaceParam("pDOCUMENTO", psec_BacTC.ToString());
            vQp.AddReplaceParam("pUsuario", pNombreCliente.ToString());
            vQp.AddReplaceParam("pMONTO", pMonto);   // no puede null
            vQp.AddReplaceParam("pTIPO_CAMBIO", pTipoCambio);
            vQp.AddReplaceParam("pCONVERSION", pConversion);
            vQp.AddReplaceParam("pVUELTO", pVuelto);
            vQp.AddReplaceParam("pCAJERO", GUI.CApp.usuario.ToString());
            vQp.AddReplaceParam("pJORNADA", Program.Jornada.ToString());
            vQp.AddReplaceParam("pTIPO_MONEDA", pTipoMoneda.ToString());

            CApp.bll.ExecuteSql("insertaTipoCambio", vQp, "PDV");

        }


        #region mRetornaVueltoDepositos
        /// <summary>
        /// returna el monto del vuelto 
        /// </summary>
        /// <param name="pMonedaPago"></param>
        /// <param name="pMonedaSaldo"></param>
        /// <param name="pTipoCambio"></param>
        /// <param name="pMontoPago"></param>
        /// <param name="pMontoPagado"></param>
        /// <returns></returns>
        private string[] mRetornaVueltoDepositos(string pMonedaPago, string pMontoPago, string pMontoPagado, string pConversionBac)
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();
            string[] vParametros = new string[3];

            vQp.AddReplaceParam("pTipoPago", pMonedaPago);
            vQp.AddReplaceParam("pMonto", pMontoPago);
            vQp.AddReplaceParam("pMontoPagado", pMontoPagado);
            vQp.AddReplaceParam("pConversionBac", pConversionBac);

            vParametros = Convert.ToString(CApp.bll.GetSingleValue("CONV_TIPO_CAMBIO_DEPOSITOS", vQp, "PDV")).Split('+');

            return vParametros;
        }
        #endregion

        private void mDepositarCuentaBancaria(int pvarSECComp, string pConversion, string pVuelto, string pTipoIdentif, string pMonedaCuenta, string pPagoCol
        , string pPagoDol, string pMoneda, string pSeTC)
        {
            try
            {
                string[] vParametros = new string[3];
                QueryParams vQp = new LLNet.Utils.QueryParams();
                vQp.AddReplaceParam("pParam1", "DEPO");
                vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');
                mLimpiarBac();
                vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                vDetTransaccion.Id = int.Parse(vParametros[0]);
                vDetTransaccion.Name = vParametros[1];
                vDetTransaccion.Integrated = vParametros[2];
                vDetTransaccion.Sequence = sec_BcSequence;
                vDetTransaccion.Invoice = sec_BacInvoice;
                List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 5, Value = pMoneda });
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(pConversion) });
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 8, Value = textObservacion.Text.Trim() });
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 9, Value = pTipoIdentif });
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 10, Value = textCedula.Text.Trim() });
                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                {
                    Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                    {
                        Transaction = vDetTransaccion,
                        TerminalNumber = vNumTerminal,
                        Credentials = vBacCredenciales,
                    },
                    Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                    {
                        RequestFields = vCampos.ToArray()
                    }
                };

                mRegistrarTransaccion("P", vRequest, null, null, pvarSECComp, sec_BacInvoice);

                string vPregunta = clsXmlSerializer.SerializeObject(vRequest);

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);

                // validacion Time out pra reversar transaccion

                string vRespuesta = clsXmlSerializer.SerializeObject(vResponse);

                mRegistrarTransaccion("R", null, vResponse, null, pvarSECComp, sec_BacInvoice);

                StringReader stringReader = new StringReader(vRespuesta);
                stringReader.Read();
                var inner = stringReader.ReadToEnd();

                XmlDocument dd = new XmlDocument();

                DataSet dsAplicado = new DataSet();

                dd.Load(new StringReader(inner));

                dsAplicado.ReadXml(new XmlTextReader(new StringReader(dd.OuterXml)));

                DataTable vConsulta = dsAplicado.Tables[1];

                var Status = vConsulta.Rows[0].ItemArray[1];


                if (Status.Equals("Success"))
                {

                    foreach (LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field vCampo in vResponse.Content.ResponseFields)
                    {
                        if (vCampo.Name.Equals("Print"))
                        {
                            string vDocumento = vCampo.Value;
                            //Imprimir el comprobante y guardar los datos de pago...
                            //inserta    ResaBac

                            mRegistrarPagoDeposito("R", vDocumento, vRequest, vResponse, pvarSECComp.ToString(),
                                  cbxMoneda.SelectedValue.ToString(), cboMonedaSaldo.SelectedValue.ToString(), "", "", sec_BacInvoice, pConversion, pVuelto,
                                  pMonedaCuenta, pPagoCol, pPagoDol, pSeTC, sec_BcSequence);


                            mRegistrarPagoDeposito("P", vDocumento, vRequest, vResponse, pvarSECComp.ToString(),
                                  cbxMoneda.SelectedValue.ToString(), cboMonedaSaldo.SelectedValue.ToString(), "", "", sec_BacInvoice, pConversion, pVuelto,
                                  pMonedaCuenta, pPagoCol, pPagoDol, pSeTC, sec_BcSequence);

                            // pague servicios
                            RegistroBDBACServiciosDeposito(vResponse, textMontoDepositar.Text.Trim(), varCEmpresa, varCConvenio, pvarSECComp.ToString());
                            //RegistroBDBACServicios(vResponse, txtTotalBac.Text.Trim(), varCEmpresa, varCConvenio, mBuscarElemento("0",0,vPrueba)); 
                            GUI.CApp.ShowMessage("Deposito realizado con éxito", "ATENCION", true);
                            mLimpiarDepositos();
                            textMontoDepositar.Text = "";

                        }
                    }

                    // GUI.CApp.ShowMessage("Deposito realizado con éxito", "ATENCION", true);
                    mLimpiar2();

                }
                else
                {
                    mAnulaMesaCambio(pSeTC);

                    if (dsAplicado.Tables.Count <= 2)
                    {
                        // mal general

                        var vDescripcion = vConsulta.Rows[0].ItemArray[2];
                        CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                        mRegistrarTransaccion("E", null, null, Convert.ToString(vDescripcion), pvarSECComp, sec_BacInvoice);

                    }
                    else
                    {


                        DataTable vConsultaContenido = dsAplicado.Tables[4];

                        var vMensaje = vConsultaContenido.Rows[0].ItemArray[3];
                        var vMensajeDES = vConsultaContenido.Rows[1].ItemArray[3];

                        mRegistrarTransaccion("E", null, null, Convert.ToString(vMensajeDES), pvarSECComp, sec_BacInvoice);

                        if (vMensaje.Equals("19"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                        }
                        else if (vMensaje.Equals("03"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("48"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("31"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else
                        {

                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                            GUI.CApp.ShowMessage("", "Error mensaje del proveedor RapiBac", false);
                        }
                    }
                }

            }
            catch (TimeoutException sex)
            {
                GUI.CApp.ShowMessage(sex.Message, "Time Out", false);
                mReversarRapiBac2TimeOut(sec_BacInvoice, pMoneda, pConversion, "", "", pTipoIdentif, textCedula.Text.Trim(), "", Convert.ToString(pvarSECComp),
            "", varCConvenio, Convert.ToString(pMonedaCuenta), Convert.ToString(pSeTC), sec_BcSequence, "");

                if (!string.IsNullOrEmpty(pSeTC))
                {
                    mAnulaMesaCambio(pSeTC);
                }

                mRegistrarTransaccion("E", null, null, sex.Message, pvarSECComp, sec_BacInvoice);

            }
            catch (Exception ex)
            {
                if (!string.IsNullOrEmpty(pSeTC))
                {
                    mAnulaMesaCambio(pSeTC);
                }
                mRegistrarTransaccion("E", null, null, ex.Message, pvarSECComp, sec_BacInvoice);
            }


        }
        private void RegistroBDBACServiciosDeposito(LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse pRespuesta,
            string pTotal, string pOper, string pProv, string pNumcomprob)
        {
            long varDocumento = Convert.ToInt64(GUI.CApp.bll.GetSingleValue("SEC_DOCUMENTO", "PDV"));

            //Parámetros:pDocumento number, pCaja number, pUsuario varchar2, pTotal number, pJornada number, pComision number, pIdTRans varchar2, pTelefono varchar2
            Utils.QueryParams qp = new LLNet.Utils.QueryParams();
            qp.AddReplaceParam("pDocumento", varDocumento.ToString());
            qp.AddReplaceParam("pCaja", Program.Caja.ToString());
            qp.AddReplaceParam("pUsuario", GUI.CApp.usuario);
            qp.AddReplaceParam("pTotal", pTotal);
            qp.AddReplaceParam("pJornada", Program.Jornada.ToString());
            if (pNumcomprob.Equals(""))
            {
                qp.AddReplaceParam("pIdTRans", "BLANCO");
            }
            else
            {
                qp.AddReplaceParam("pIdTRans", pNumcomprob);
            }
            qp.AddReplaceParam("pProveedor", pProv);
            qp.AddReplaceParam("pOperador", pOper);
            // Llama el procedimiento que almacena los datos de la recarga en la BD
            GUI.CApp.bll.ExecuteSql("WMS_P_RECIBOBACSERV", qp, "PDV");

            for (int i = 1; i <= varCantImp; i++)
            {//cantidad de impresiones
                //IMPRIME LA FACTURA
                CargarReporteBACdeposito(varDocumento.ToString());
            }//fin cantidad de impresiones
        }


        private void RegistroBDBACServRetiros(LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse pRespuesta,
         string pTotal, string pOper, string pProv, string pNumcomprob)
        {
            long varDocumento = Convert.ToInt64(GUI.CApp.bll.GetSingleValue("SEC_DOCUMENTO", "PDV"));

            //Parámetros:pDocumento number, pCaja number, pUsuario varchar2, pTotal number, pJornada number, pComision number, pIdTRans varchar2, pTelefono varchar2
            Utils.QueryParams qp = new LLNet.Utils.QueryParams();
            qp.AddReplaceParam("pDocumento", varDocumento.ToString());
            qp.AddReplaceParam("pCaja", Program.Caja.ToString());
            qp.AddReplaceParam("pUsuario", GUI.CApp.usuario);
            qp.AddReplaceParam("pTotal", pTotal);
            qp.AddReplaceParam("pJornada", Program.Jornada.ToString());
            if (pNumcomprob.Equals(""))
            {
                qp.AddReplaceParam("pIdTRans", "BLANCO");
            }
            else
            {
                qp.AddReplaceParam("pIdTRans", pNumcomprob);
            }
            qp.AddReplaceParam("pProveedor", pProv);
            qp.AddReplaceParam("pOperador", pOper);
            // Llama el procedimiento que almacena los datos de la recarga en la BD
            GUI.CApp.bll.ExecuteSql("WMS_P_RECIBOBACSERV", qp, "PDV");

            for (int i = 1; i <= varCantImp; i++)
            {//cantidad de impresiones
                //IMPRIME LA FACTURA
                CargarReporteBACRetiros(varDocumento.ToString());
            }//fin de cantidad de impresiones

        }


        ///retiros pagser
        ///
        private void RegistroBDBACServiciosRetiro(LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse pRespuesta,
            string pTotal, string pOper, string pProv, string pNumcomprob)
        {
            long varDocumento = Convert.ToInt64(GUI.CApp.bll.GetSingleValue("SEC_DOCUMENTO", "PDV"));

            //Parámetros:pDocumento number, pCaja number, pUsuario varchar2, pTotal number, pJornada number, pComision number, pIdTRans varchar2, pTelefono varchar2
            Utils.QueryParams qp = new LLNet.Utils.QueryParams();
            qp.AddReplaceParam("pDocumento", varDocumento.ToString());
            qp.AddReplaceParam("pCaja", Program.Caja.ToString());
            qp.AddReplaceParam("pUsuario", GUI.CApp.usuario);
            qp.AddReplaceParam("pTotal", pTotal);
            qp.AddReplaceParam("pJornada", Program.Jornada.ToString());
            if (pNumcomprob.Equals(""))
            {
                qp.AddReplaceParam("pIdTRans", "BLANCO");
            }
            else
            {
                qp.AddReplaceParam("pIdTRans", pNumcomprob);
            }
            qp.AddReplaceParam("pProveedor", pProv);
            qp.AddReplaceParam("pOperador", pOper);
            // Llama el procedimiento que almacena los datos de la recarga en la BD
            GUI.CApp.bll.ExecuteSql("WMS_P_RECIBOBACSERV", qp, "PDV");

            //IMPRIME LA FACTURA
            //  CargarReporteBACdeposito(varDocumento.ToString());
        }

        #region mRegistrarPagoDeposito
        /// <summary>
        /// Se registra la solicitud de realizar el pago.
        /// </summary>
        /// <param name="pTipo"></param>
        /// <param name="pPregunta"></param>
        /// <param name="pRespuesta"></param>
        private void mRegistrarPagoDeposito(string pTipo, string pDocumento, LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest pPregunta,
                                    LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse pRespuesta, string pConsecutivo, string pTipoPago, string pTipoSaldo,
                                    string pMontoPago, string pMontoPagado, string pSecInvoice, string pConversion, string pVuelto, string pMonedaCuenta,
                                    string pPagoCol, string pPagoDol, string pSecMC, int pSecBAC)
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();
            string[] vArregloCadenas = mArregloCadenasDeposito(pDocumento);

            vQp.AddReplaceParam("pConsecutivo", pConsecutivo.ToString());

            if (string.IsNullOrEmpty(pPagoCol))
            {
                pPagoCol = "0";
            }

            if (string.IsNullOrEmpty(pPagoDol))
            {
                pPagoDol = "0";
            }
            if (string.IsNullOrEmpty(varTCventa))
            {
                varTCventa = "0";
            }
            if (string.IsNullOrEmpty(varTCompra))
            {
                varTCompra = "0";
            }
            if (string.IsNullOrEmpty(pSecMC))
            {
                pSecMC = "0";
            }


            if (pTipo.Equals("P"))
            {
                vQp.AddReplaceParam("pCodAgencia", vArregloCadenas[1]);
                vQp.AddReplaceParam("pEmpresa", varCEmpresa);
                vQp.AddReplaceParam("pConvenio", varCConvenio);
                vQp.AddReplaceParam("pIdentificacion", textCedula.Text.Trim());//Almacenar la tarjeta de credito
                vQp.AddReplaceParam("pTotal", textMontoDepositar.Text.Trim());
                vQp.AddReplaceParam("pFechaVto", vArregloCadenas[11]);//Retorna la fecha y hora
                vQp.AddReplaceParam("pNumFactura", vArregloCadenas[6]);//Número de factura -- autorización
                vQp.AddReplaceParam("pCodMoneda", "0");
                vQp.AddReplaceParam("pLlave", varCLlave);
                vQp.AddReplaceParam("pNombreEmpresa", varInstit);
                vQp.AddReplaceParam("pNombreConvenio", vArregloCadenas[2]);
                vQp.AddReplaceParam("pCliente", txtNombreClienteBac.Text);
                vQp.AddReplaceParam("pNombreLlave", varLlave);
                vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
                vQp.AddReplaceParam("pNumTarjeta", vArregloCadenas[7]);
                vQp.AddReplaceParam("pTipoIdentificacion", cboTipoIdentificacion.SelectedValue.ToString());
                //vQp.AddReplaceParam("pTrack2", vTrack2);
                vQp.AddReplaceParam("pTrack2", vTrack2);
                vQp.AddReplaceParam("pMonedaPago", pTipoPago);
                vQp.AddReplaceParam("pMonedaSaldo", pTipoSaldo);
                vQp.AddReplaceParam("pSecInvoice", pSecInvoice);
                vQp.AddReplaceParam("pSecBAC", Convert.ToString(pSecBAC));

                CApp.bll.ExecuteSql("insertaReqBac", vQp, "PDV");
            }

            if (pTipo.Equals("R"))
            {


                vQp.AddReplaceParam("pSystemTraceNumber", pRespuesta.Header.SystemTraceNumber);
                vQp.AddReplaceParam("pTerminal", vArregloCadenas[3]);
                vQp.AddReplaceParam("pLote", vArregloCadenas[4]);
                vQp.AddReplaceParam("pRef", vArregloCadenas[5]);

                vQp.AddReplaceParam("pFecha", vArregloCadenas[11]);
                vQp.AddReplaceParam("pHora", vArregloCadenas[12]);

                vQp.AddReplaceParam("pAutorizacion", vArregloCadenas[6]);
                vQp.AddReplaceParam("pNumTarjeta", vArregloCadenas[7]);

                vQp.AddReplaceParam("pMontoTransac", textMontoDepositar.Text.Trim());

                vQp.AddReplaceParam("pMontoConvers", (double.Parse(pConversion)).ToString());

                //tipo cambio proveedor
                vQp.AddReplaceParam("pTipoCambio", vArregloCadenas[13]);


                vQp.AddReplaceParam("pDescConcep", textObservacion.Text.Trim());
                vQp.AddReplaceParam("pValorConcep", "0");
                vQp.AddReplaceParam("pTipo", "CP");
                vQp.AddReplaceParam("pCreadoPor", GUI.CApp.usuario.ToString());
                vQp.AddReplaceParam("pTipoPago", pTipoPago);
                vQp.AddReplaceParam("pTipoSaldo", pTipoSaldo);
                vQp.AddReplaceParam("pVuelto", pVuelto);
                //vQp.AddReplaceParam("pVuelto", vParametros[1].Trim().ToString());
                vQp.AddReplaceParam("pMontoRecibido", (double.Parse(textBoxCancelaCon.Text)).ToString());

                // vQp.AddReplaceParam("pPagoCol",(double.Parse(textBoxCancelaCon.Text)).ToString());
                vQp.AddReplaceParam("pPagoCol", pPagoCol);
                vQp.AddReplaceParam("pPagoDol", pPagoDol);
                vQp.AddReplaceParam("pMonedaCuenta", pMonedaCuenta);
                vQp.AddReplaceParam("pVenta", varTCventa);
                vQp.AddReplaceParam("pCompra", varTCompra);
                vQp.AddReplaceParam("psecMC", pSecMC);

                CApp.bll.ExecuteSql("insertaResaBacDepositos", vQp, "PDV");
            }

            vVarError = "";
            //mBuscarElemento("0",0,vPrueba)
        }
        #endregion


        ////////////RETIROS /////////


        #region mRegistraRetiro
        /// <summary>
        /// Se registra la solicitud de realizar el pago.
        /// </summary>
        /// <param name="pTipo"></param>
        /// <param name="pPregunta"></param>
        /// <param name="pRespuesta"></param>
        private void mRegistraRetiro(string pTipo, string pDocumento, LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest pPregunta,
                                    LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse pRespuesta, string pConsecutivo,
            string pMontoRetiro, string pMonedaPago, string pSecInvoice, string pSecBAC)
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();
            string[] vArregloCadenas = mArregloCadenasRetiros(pDocumento);

            vQp.AddReplaceParam("pConsecutivo", pConsecutivo.ToString());

            if (pTipo.Equals("R"))  // inserta el vocuher local 
            {

                vQp.AddReplaceParam("pSystemTraceNumber", pRespuesta.Header.SystemTraceNumber);
                vQp.AddReplaceParam("pTerminal", vArregloCadenas[3]);
                vQp.AddReplaceParam("pLote", vArregloCadenas[4]);
                vQp.AddReplaceParam("pRef", vArregloCadenas[5]);

                vQp.AddReplaceParam("pFecha", vArregloCadenas[11]);
                vQp.AddReplaceParam("pHora", vArregloCadenas[12]);

                vQp.AddReplaceParam("pAutorizacion", vArregloCadenas[6]);
                vQp.AddReplaceParam("pNumTarjeta", vArregloCadenas[7]);

                vQp.AddReplaceParam("pMontoTransac", vArregloCadenas[10]);

                vQp.AddReplaceParam("pMontoRetiro", (double.Parse(vArregloCadenas[10])).ToString());

                //tipo cambio proveedor
                vQp.AddReplaceParam("pTipoCambio", vArregloCadenas[13]);
                vQp.AddReplaceParam("pTipoPago", pMonedaPago);
                vQp.AddReplaceParam("pVuelto", "0");
                vQp.AddReplaceParam("pMontoRecibido", (double.Parse(vArregloCadenas[10])).ToString());

                vQp.AddReplaceParam("pDescConcep", "retiros rapibac");
                vQp.AddReplaceParam("pValorConcep", "0");
                vQp.AddReplaceParam("pTipo", "CP");
                vQp.AddReplaceParam("pCreadoPor", GUI.CApp.usuario.ToString());
                vQp.AddReplaceParam("pMonedaPago", pMonedaPago);
                vQp.AddReplaceParam("pTipoSaldo", "0");
                vQp.AddReplaceParam("pPagoCol", (double.Parse(vArregloCadenas[10])).ToString());
                vQp.AddReplaceParam("pPagoDol", "0");

                vQp.AddReplaceParam("pMonedaCuenta", "valor");
                vQp.AddReplaceParam("pVenta", "0");
                vQp.AddReplaceParam("pCompra", "0");
                vQp.AddReplaceParam("psecMC", "0");

                CApp.bll.ExecuteSql("insertaResaBacRetiros", vQp, "PDV");
            }


            if (pTipo.Equals("P"))
            {
                vQp.AddReplaceParam("pCodAgencia", vArregloCadenas[0]);
                vQp.AddReplaceParam("pEmpresa", varCEmpresa);
                vQp.AddReplaceParam("pConvenio", varCConvenio);
                vQp.AddReplaceParam("pIdentificacion", "0");//Almacenar la tarjeta de credito
                vQp.AddReplaceParam("pTotal", (double.Parse(vArregloCadenas[10])).ToString());
                vQp.AddReplaceParam("pFechaVto", vArregloCadenas[11]);//Retorna la fecha y hora
                vQp.AddReplaceParam("pNumFactura", vArregloCadenas[6]);//Número de factura -- autorización
                vQp.AddReplaceParam("pCodMoneda", "0");
                vQp.AddReplaceParam("pLlave", varCLlave);
                vQp.AddReplaceParam("pNombreEmpresa", varInstit);
                vQp.AddReplaceParam("pNombreConvenio", vArregloCadenas[1]);
                vQp.AddReplaceParam("pCliente", txtNombreClienteBac.Text);
                vQp.AddReplaceParam("pNombreLlave", varLlave);
                vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
                vQp.AddReplaceParam("pNumTarjeta", vArregloCadenas[7]);
                vQp.AddReplaceParam("pTipoIdentificacion", cboTipoIdentificacion.SelectedValue.ToString());
                vQp.AddReplaceParam("pTrack2", vTrack2);
                vQp.AddReplaceParam("pMonedaPago", pMonedaPago);

                vQp.AddReplaceParam("pMonedaSaldo", "0");
                vQp.AddReplaceParam("pSecInvoice", pSecInvoice);
                vQp.AddReplaceParam("pSecBAC", Convert.ToString(pSecBAC));

                CApp.bll.ExecuteSql("insertaReqBac", vQp, "PDV");
            }

            vVarError = "";

        }

        #endregion

        /////////FIN ////////////////



        #region mArregloCadenasRetiros
        /// <summary>
        /// Genera un arreglo de cadenas
        /// </summary>
        /// <param name="pCadena"></param>
        /// <returns></returns>
        private string[] mArregloCadenasRetiros(string pCadena)
        {

            string vCadena = "";
            string vSubCadena = "";
            int vPosInicialSC = 0;
            int vPosFinalSC = 0;
            int vCantCaracteres = 0;
            string vTCambioProveedor = "";
            string[] vArregloCadenas = new string[50];
            //  string[] vArregloCadenas2 = new string[50];

            vArregloCadenas = pCadena.Split('\n');
            var a = vArregloCadenas[1].Trim();
            var b = vArregloCadenas[4].Trim();
            var e = vArregloCadenas[6].Trim();
            var h = vArregloCadenas[9].Trim();
            var j = vArregloCadenas[11].Trim();
            var k = vArregloCadenas[12].Trim();
            var o = vArregloCadenas[14].Trim();
  

            ﻿string[] recibo = { a, b, e, h, j, k, o, "", "", "", "", "" };

             var vPosiciones = e.Split(' ');
             var vAuto = h.Split(' ');
             var vTipoCambio = o.Split(' ');
             var tarj = j.Split(' ');

             var vTerminal = vPosiciones[1]; // TERMINAL 
             var vLote = vPosiciones[3]; // lote
             var vReferencia = vPosiciones[7]; // referencia

             var vfecha = vAuto[0];// fecha banco
             var vHora = vAuto[4]; // hora banco 
             var vAutorizacion = vAuto[15];
             var tarjMark = tarj[16];



             if (vTipoCambio[20].Equals("No"))// no aplica
             {
                 vTCambioProveedor = "No aplica";
             }
             else
             {
                 // si aplica tipo cambio 
                 vTCambioProveedor = vTipoCambio[23];

             }
       
             ﻿string[] recibo2 = { a, b, e, vTerminal, vLote, vReferencia, vAutorizacion, tarjMark , "", "", textPagaRetiros.Text.Trim(),
                                     vfecha,vHora,vTCambioProveedor };

              return recibo2;
        }
        #endregion

        #region mArregloCadenasDeposito
        /// <summary>
        /// Genera un arreglo de cadenas
        /// </summary>
        /// <param name="pCadena"></param>
        /// <returns></returns>
        private string[] mArregloCadenasDeposito(string pCadena)
        {

            string vCadena = "";
            string vSubCadena = "";
            int vPosInicialSC = 0;
            int vPosFinalSC = 0;
            int vCantCaracteres = 0;
            string vTCambioProveedor = "";
            string[] vArregloCadenas = new string[50];
            //  string[] vArregloCadenas2 = new string[50];

            vArregloCadenas = pCadena.Split('\n');
            var a = vArregloCadenas[0].Trim();
            var b = vArregloCadenas[1].Trim();
            var e = vArregloCadenas[4].Trim();
            var h = vArregloCadenas[7].Trim();
            var j = vArregloCadenas[9].Trim();
            var k = vArregloCadenas[10].Trim();
            var o = vArregloCadenas[14].Trim();
            var p = vArregloCadenas[15].Trim();
            var q = vArregloCadenas[16].Trim();
            var r = vArregloCadenas[17].Trim();
            var s = vArregloCadenas[18].Trim(); 

            ﻿string[] recibo = { a, b, e, h, j, k, o, p, q, r, s, k };

             var vPosiciones = h.Split(' ');
             var vAuto = k.Split(' ');
             var vTarjeta = o.Split(' ');
             var vDetalle = q.Split(' ');
             var vTipoCambio = s.Split(' ');

             var vMontoTrans = r.Split(' ');

             var vTerminal = vPosiciones[1]; // TERMINAL 
             var vLote = vPosiciones[3];
             var vReferencia = vPosiciones[7];
             var vAutorizacion = vAuto[15];
             var vTarj = vTarjeta[16];
             // var vDetalle2 = vDetalle[10] + vDetalle[11];
             // var vMontoRe = vMontoTrans[12];
             var vfecha = vAuto[0];
             var vHora = vAuto[6];

             if (vTipoCambio[20].Equals("No"))// no aplica
             {
                 vTCambioProveedor = "No aplica";
             }
             else
             {
                 // si aplica tipo cambio 
                 vTCambioProveedor = vTipoCambio[23];

             }
       
             ﻿string[] recibo2 = { a, b, e, vTerminal, vLote, vReferencia, vAutorizacion, vTarj, p, "", textConversion.Text.Trim(),
                                     vfecha,vHora,vTCambioProveedor };

              return recibo2;
        }
        #endregion

        private void CargarReporteBACdeposito(string doc)
        {
            //selecciona los datos para imprimir
            QueryParams qp1 = new LLNet.Utils.QueryParams();
            qp1.AddReplaceParam("pDoc", doc);
            //CONSULTA LOS PARÁMETROS DE LA BD
            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "DATOIMP_DEPO", qp1);
            if (dsB.Tables.Count > 0)
            {
                if (dsB.Tables[0].Rows.Count > 0)
                {
                    object[] datos = new object[5];
                    datos = dsB.Tables[0].Rows[0].ItemArray;
                    imprimirDocumentoDOS(long.Parse(datos[0].ToString()), datos[1].ToString(), long.Parse(datos[2].ToString()), datos[3].ToString(), datos[4].ToString());

                    //Cantidad de impresiones
                    QueryParams qp = new LLNet.Utils.QueryParams();
                    qp.AddReplaceParam("DOCUMENTO", doc);
                    CApp.bll.ExecuteSql("WMS_P_RECARGIMPRESIONES", qp, "PDV");
                }
                else
                {
                    GUI.CApp.ShowMessage("Problemas al imprimir", "ERROR", true);
                }
            }
            else
            {
                GUI.CApp.ShowMessage("Problemas al imprimir", "ERROR", true);
            }
        }

        //impresion de retiros 

        private void CargarReporteBACRetiros(string doc)
        {
            //selecciona los datos para imprimir
            QueryParams qp1 = new LLNet.Utils.QueryParams();
            qp1.AddReplaceParam("pDoc", doc);
            //CONSULTA LOS PARÁMETROS DE LA BD
            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "DATOIMP_RETI", qp1);
            if (dsB.Tables.Count > 0)
            {
                if (dsB.Tables[0].Rows.Count > 0)
                {
                    object[] datos = new object[5];
                    datos = dsB.Tables[0].Rows[0].ItemArray;
                    imprimirDocumentoDOS(long.Parse(datos[0].ToString()), datos[1].ToString(), long.Parse(datos[2].ToString()), datos[3].ToString(), datos[4].ToString());

                    //Cantidad de impresiones
                    QueryParams qp = new LLNet.Utils.QueryParams();
                    qp.AddReplaceParam("DOCUMENTO", doc);
                    CApp.bll.ExecuteSql("WMS_P_RECARGIMPRESIONES", qp, "PDV");
                }
                else
                {
                    GUI.CApp.ShowMessage("Problemas al imprimir", "ERROR", true);
                }
            }
            else
            {
                GUI.CApp.ShowMessage("Problemas al imprimir", "ERROR", true);
            }
        }


        //impresion de recibo de reversioes

        private void mReciboAnulacion(string doc)
        {
            //selecciona los datos para imprimir
            QueryParams qp1 = new LLNet.Utils.QueryParams();
            qp1.AddReplaceParam("pDoc", doc);
            //CONSULTA LOS PARÁMETROS DE LA BD
            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "DATOIMP_REVERSA", qp1);
            if (dsB.Tables.Count > 0)
            {
                if (dsB.Tables[0].Rows.Count > 0)
                {
                    object[] datos = new object[5];
                    datos = dsB.Tables[0].Rows[0].ItemArray;
                    var vFormato = "3046";

                    imprimirDocumentoTc(long.Parse(datos[0].ToString()), datos[1].ToString(), long.Parse(vFormato), datos[3].ToString(), datos[4].ToString());
                }
                else
                {
                    GUI.CApp.ShowMessage("Problemas al imprimir", "ERROR", true);
                }
            }
            else
            {
                GUI.CApp.ShowMessage("Problemas al imprimir", "ERROR", true);
            }
        }

        // SEGMENTO DE validacion de eventos EN CONTROLES

        private void keyPressMoney(object sender, KeyPressEventArgs e)
        {
            int vContadorPuntos = textMontoDepositar.Text.IndexOf('.');

            if (char.IsDigit(e.KeyChar) || char.IsControl(e.KeyChar))
            {
                e.Handled = false;
            }
            else
            {
                e.Handled = true;
            }

            if (e.KeyChar.ToString().Equals(".") && vContadorPuntos == -1)
            {
                e.Handled = false;
            }
        }
        private void numv(KeyPressEventArgs sender, string pDato)
        {

            int vContadorPuntos = pDato.IndexOf('.');

            if (char.IsDigit(sender.KeyChar) || char.IsControl(sender.KeyChar))
            {
                sender.Handled = false;
            }
            else
            {
                sender.Handled = true;
            }

            if (sender.KeyChar.ToString().Equals(".") && vContadorPuntos == -1)
            {
                sender.Handled = false;
            }

        }
        private void keyPressCancelaCon(object sender, KeyPressEventArgs e)
        {
            numv(e, textBoxCancelaCon.Text);
        }
        private void selectCommitConvers(object sender, EventArgs e)
        {

            //var vValor = (DataRowView)cboMonedaPago.SelectedValue;
            textConversion.Text = "";
            textVuelto.Text = "";
            textBoxCancelaCon.Text = "";
            textMontoDepositar.Text = "";
            // textBoxMonedaSelecc.Text = cbxMoneda.Text;
            textEdicion.Text = "";
            if (textMonedaCuenta.Text.Equals("colones") && cbxMoneda.Text.Equals("Colon"))
            {
                textEdicion.Enabled = false;
            }
            else if (textMonedaCuenta.Text.Equals("dolar") && cbxMoneda.Text.Equals("Dolar"))
            {
                textEdicion.Enabled = false;

            }
            else if (textMonedaCuenta.Text.Equals("dólares") && cbxMoneda.Text.Equals("Dolar"))
            {
                textEdicion.Enabled = false;

            }
            else
            {

                textEdicion.Enabled = true;
            }

        }


        /// <summary>
        /// Manejo de conversiones
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textMontoDepositar_TextChanged(object sender, EventArgs e)
        {
            try
            {
                varTCompra = "";
                varTCventa = "";

                if (string.IsNullOrEmpty(sender.ToString()) || ((System.Windows.Forms.TextBox)(sender)).Text == "" || textBoxCancelaCon.Text.Trim().Equals("") ||
                  ((System.Windows.Forms.TextBox)(sender)).Text.Equals("."))
                {
                    // VALOR ENVIADO NULLO SIN DATOS
                    textVuelto.Text = "";
                    textConversion.Text = "";
                    // textEdicion.Text = "";
                }
                else
                {

                    if (textMonedaCuenta.Text.Equals("colones") && cbxMoneda.SelectedIndex == 0)  // colones-- colones
                    {
                        double vConver = Convert.ToDouble(textBoxCancelaCon.Text.Trim()) - Convert.ToDouble(textMontoDepositar.Text.Trim());
                        textVuelto.Text = Convert.ToString(vConver);
                        textConversion.Text = textMontoDepositar.Text.Trim();
                    }
                    else if (textMonedaCuenta.Text.Equals("dólares") && cbxMoneda.SelectedIndex == 0)
                    { // colones a dolares
                        // HACE ESTO SI CONVIERTO 
                        decimal vMontoDepositar = (decimal.Parse(textMontoDepositar.Text) / decimal.Parse(vtcVenta));
                        var vv = Math.Round(vMontoDepositar, 2);
                        textConversion.Text = vv.ToString();
                        varTCventa = vtcVenta;
                        // textVuelto.Text=  (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text))
                        //  cancelaConChangetxt(sender, e);
                        decimal vueltoCol = (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text));
                        textVuelto.Text = vueltoCol.ToString();

                    }
                    else if (textMonedaCuenta.Text.Equals("dólares") && cbxMoneda.SelectedIndex == 0) //dolares a colones
                    {

                        // HACE ESTO SI CONVIERTO 
                        decimal vMontoDepositar = (decimal.Parse(textMontoDepositar.Text) * int.Parse("560"));  //dolares a colones
                        var vv = Math.Round(vMontoDepositar, 2);
                        textConversion.Text = vv.ToString();
                        //cancelaConChangetxt(sender, e);

                    }
                    else if (textMonedaCuenta.Text.Equals("colones") && cbxMoneda.SelectedIndex == 1) //colon a dolar
                    {

                        // HACE ESTO SI CONVIERTO 
                        decimal vMontoDepositar = (decimal.Parse(textMontoDepositar.Text) * decimal.Parse(vtcCompra));  //dolares a colones
                        var vv = Math.Round(vMontoDepositar, 2);
                        textConversion.Text = vv.ToString();
                        decimal vueltoCol = (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text)) * decimal.Parse(vtcCompra);
                        // VERIFICA SI HAY DATOS DE EDICION

                        textVuelto.Text = vueltoCol.ToString();
                        varTCompra = vtcCompra;

                        //   cancelaConChangetxt(sender, e);

                    }
                    else
                    {

                        //dolares a dolar
                        decimal vueltoCol = (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text)) * decimal.Parse(vtcCompra);
                        textConversion.Text = textMontoDepositar.Text.Trim();
                        textVuelto.Text = Convert.ToString(vueltoCol);
                    }

                }
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
            }


        }
        #region mCargarTipoIdentificacionDepositos
        /// <summary>
        /// Carga los tipos de identificación del BAC
        /// </summary>
        private void mCargarTipoIdentificacionDepositos()
        {
            cbxTipoIdentificacion.DataSource = null;
            cbxTipoIdentificacion.Refresh();

            try
            {
                QueryParams qp = new LLNet.Utils.QueryParams();
                DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_TIDENTIF_BAC");

                cbxTipoIdentificacion.DataSource = dsB.Tables[0];
                cbxTipoIdentificacion.ValueMember = "ID";
                cbxTipoIdentificacion.DisplayMember = "TIPOID";

            }
            catch (Exception er)
            {
                GUI.CApp.ShowMessage(er.Message, "ERROR", true);
            }
        }
        #endregion
        private void cancelaConChangetxt(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(sender.ToString()) || string.IsNullOrEmpty(textBoxCancelaCon.Text) || string.IsNullOrEmpty(textMontoDepositar.Text))
            {
                //   textVuelto.Text = "";
                //   textConversion.Text = "";
            }

            else
            {

                if (textMonedaCuenta.Text.Equals("colones") && cbxMoneda.SelectedIndex == 0)   // colones a colones
                {
                    decimal vueltoCol = (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text));
                    textVuelto.Text = vueltoCol.ToString();
                    textMontoDepositar_TextChanged(sender, e);

                }
                else if (textMonedaCuenta.Text.Equals("dólares") && cbxMoneda.SelectedIndex == 0)
                { // dolar a colon                 


                    decimal vueltoCol = (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text));
                    textVuelto.Text = vueltoCol.ToString();
                    textMontoDepositar_TextChanged(sender, e);

                }
                else if (textMonedaCuenta.Text.Equals("dólares") && cbxMoneda.SelectedIndex == 1)
                {
                    decimal vueltoCol = (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text)) * decimal.Parse(vtcCompra);
                    textVuelto.Text = vueltoCol.ToString();
                    textMontoDepositar_TextChanged(sender, e);
                } //dolares a colones
                else if (textMonedaCuenta.Text.Equals("colones") && cbxMoneda.SelectedIndex == 1)
                {
                    // valida si el campo edition esta lleno 
                    if (!string.IsNullOrEmpty(textEdicion.Text))
                    {

                        if (string.IsNullOrEmpty((textVuelto.Text)))
                        {
                            decimal vueltoCol = (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text));

                            textVuelto.Text = vueltoCol.ToString();

                        }
                        else
                        {
                            decimal vueltoCol = (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text));

                            if (vueltoCol < 0)
                            {
                                //  GUI.CApp.ShowMessage("ALERTA", "El monto es menor al pago", true);
                                textVuelto.Text = "0";
                                textConversion.Text = "0";

                            }
                            else
                            {


                                textEdicion_TextChanged(sender, e);
                                //   var results = vueltoCol * int.Parse(vtcCompra);

                                //  var reul = Convert.ToDouble(results) + Convert.ToDouble(textVuelto.Text);

                                //  textVuelto.Text = reul.ToString();
                            }

                        }

                    }
                    else
                    {

                        decimal vueltoCol = (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text)) * decimal.Parse(vtcCompra);
                        textVuelto.Text = vueltoCol.ToString();
                        textMontoDepositar_TextChanged(sender, e);
                        varTCompra = vtcCompra;
                    }



                } //dolares a colones


            }
        }



        private void textEdicion_TextChanged(object sender, EventArgs e)
        {
            // Editar el monto convertido de los colones que se desea pagar
            if (string.IsNullOrEmpty(sender.ToString()) || ((System.Windows.Forms.TextBox)(sender)).Text == "" || textEdicion.Text.Trim().Equals(""))
            {
                // VALOR ENVIADO NULLO SIN DATOS
                textBoxCancelaCon.Text = "";
                // textBoxCancelaCon.Enabled = true;
            }
            else
            {

                if (textMonedaCuenta.Text.Equals("colones") && cbxMoneda.SelectedIndex == 1)
                { // colon a dolar  
                    decimal vMontoEdicion = decimal.Parse(textEdicion.Text) / decimal.Parse(vtcCompra);
                    textMontoDepositar.Text = Math.Round(vMontoEdicion, 2).ToString();

                    var vVariableEntera = Math.Ceiling(vMontoEdicion);


                    //Calcula la diferencia desde el monto editado

                    //int vVariableEntera = Convert.ToInt32(vMontoEdicion);

                    // convierte el monto editado en colones
                    var vRedondeo = vVariableEntera * decimal.Parse(vtcCompra);
                    var vuelto = vRedondeo - decimal.Parse(textEdicion.Text);
                    var vMontoDepositado = vRedondeo - vuelto;

                    textMontoDepositar.Text = vVariableEntera.ToString();
                    textVuelto.Text = vuelto.ToString();
                    textConversion.Text = vMontoDepositado.ToString();
                    if (textBoxCancelaCon.Text != "")
                    {
                        decimal vueltoCol = (decimal.Parse(textBoxCancelaCon.Text) - decimal.Parse(textMontoDepositar.Text)) * decimal.Parse(vtcCompra);
                        decimal dne = vueltoCol + Convert.ToDecimal(vuelto);
                        textVuelto.Text = dne.ToString();
                    }
                    else
                    {
                        textBoxCancelaCon.Text = "";

                    }


                }
                else if (textMonedaCuenta.Text.Equals("dólares") && cbxMoneda.SelectedIndex == 0)
                {

                    decimal vMontoEdicion = decimal.Parse(textEdicion.Text) * decimal.Parse(vtcVenta);
                    textMontoDepositar.Text = vMontoEdicion.ToString();

                }


                // textVuelto.Text = vMontoEdicion.ToString();
                // textMontoDepositar_TextChanged(sender, e);

            }

        }
        private void mLlenarParametrosTC()
        {
            Utils.QueryParams vQp = new LLNet.Utils.QueryParams();
            vQp.AddReplaceParam("pCaja", Program.Caja.ToString());

            DataSet dsB = GUI.CApp.bll.getDataSet("PDV", "C_tiposCambio", vQp);

            object[] datos = new object[4];
            datos = dsB.Tables[0].Rows[0].ItemArray;

            vtcVenta = datos[0].ToString();
            vtcCompra = datos[1].ToString();

            textTCventa.Text = vtcVenta;
            textTCompra.Text = vtcCompra;
            textTCventa.Enabled = false;
            textTCompra.Enabled = false;

        }
        private void vvalidaCaracKep(object sender, KeyPressEventArgs e)
        {

            int vContadorPuntos = textEdicion.Text.IndexOf('.');


            if (char.IsDigit(e.KeyChar) || char.IsControl(e.KeyChar))
            {
                e.Handled = false;
            }
            else
            {
                e.Handled = true;
            }

            if (e.KeyChar.ToString().Equals(".") && vContadorPuntos == -1)
            {
                e.Handled = false;
            }
        }

        //REVERSIONES


        private void mReversarRapiBac2(string pInvoice, string pMontoMoneda, string pTotalTras, string pMonedaSaldo, string pTarjeta, string pTipoIdentif
         , string pNumCedula, string pNumComprobante, string pDocumento, string pTransProveedor, string pConvenio, string pTipoCuenta, string ptc, int pSecBac, string pTotalPago)
        {


            try
            {
                string[] vParametros = new string[3];
                QueryParams vQp = new LLNet.Utils.QueryParams();

                //Reversar pago de tarjeta de crédito  
                vQp.AddReplaceParam("pParam1", "RPATA");
                vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');
                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = null;
                mLimpiarBac();

                if (varCConvenio.Equals("13"))
                {

                    if (pTipoCuenta.Equals("colones"))
                    {
                        pMontoMoneda = "1";
                    }
                    else
                    {
                        pMontoMoneda = "2";
                    }
                    vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                    vDetTransaccion.Id = 102;
                    vDetTransaccion.Name = "ReversarDepositoEnCuentaBancaria";
                    vDetTransaccion.Integrated = "N";
                    vDetTransaccion.Sequence = pSecBac;
                    vDetTransaccion.Invoice = pInvoice;
                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 5, Value = pMontoMoneda });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(pTotalTras) });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 8, Value = "" });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 9, Value = pTipoIdentif });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 10, Value = pNumCedula });

                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };


                }
                else if (varCConvenio.Equals("12"))
                {

                    vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                    vDetTransaccion.Id = 122;
                    vDetTransaccion.Name = "ReversarPagoTarjetaCredito";
                    vDetTransaccion.Invoice = pInvoice;


                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 12, Value = pMontoMoneda }); // moneda de pago
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(pTotalPago) }); // total transacción
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 13, Value = pMonedaSaldo }); // moneda de saldo
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = pTarjeta }); // track2
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 9, Value = pTipoIdentif }); // tipo de identificación
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 10, Value = pNumCedula }); // número de identificación
                    //   vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 20, Value = "027246" }); // system tracer number

                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };

                }
                else
                {


                    // reversion d retiros a cuenta bancaria rapi bac
                    vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                    vDetTransaccion.Id = 101;
                    vDetTransaccion.Name = "ReversarRetiroDeCuentaBancaria";
                    vDetTransaccion.Sequence = pSecBac;
                    vDetTransaccion.Invoice = pInvoice;


                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = pTarjeta }); // moneda de pago
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(pTotalTras) }); // total transacción
                    ///   vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 20, Value = pMonedaSaldo }); // moneda de saldo

                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };

                }

                mRegistrarTransaccion("P", vRequest, null, null, Convert.ToInt32(pNumComprobante), pInvoice);

                string vPregunta = clsXmlSerializer.SerializeObject(vRequest);

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);

                string vRespuesta = clsXmlSerializer.SerializeObject(vResponse);

                mRegistrarTransaccion("R", null, vResponse, null, Convert.ToInt32(pNumComprobante), pInvoice);

                // registrar anulacion Internamente     
                if (vResponse.Header.Status == LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ResponseType.Success)
                {
                    foreach (LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field vCampo in vResponse.Content.ResponseFields)
                    {
                        if (vCampo.Name.Equals("Print"))
                        {
                            mAnulacionTransaccion(pNumComprobante, pDocumento, pTransProveedor, ptc);
                            GUI.CApp.ShowMessage("Reversion realizada con éxito", "ATENCION", true);
                            // refresca grid de transacciones

                            // imprime el recibo de reversion
                            mReciboAnulacion(pNumComprobante.ToString());
                            LLenarGridPags();
                        }
                    }
                }
                else
                {
                    GUI.CApp.ShowMessage(vResponse.Header.Description.ToString(), "ERROR", true);

                }

            }
            catch (Exception vExcepcion)
            {
                GUI.CApp.ShowMessage(vExcepcion.ToString(), "ERROR", true);

            }
        }

        private void mReversarRapiBac2TimeOut(string pInvoice, string pMontoMoneda, string pTotalTras, string pMonedaSaldo, string pTarjeta, string pTipoIdentif
        , string pNumCedula, string pNumComprobante, string pDocumento, string pTransProveedor, string pConvenio, string pTipoCuenta, string ptc, int pSecBac, string vTarjPinPad)
        {

            LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = null;
            //mLimpiarBac();

            try
            {

                if (varCConvenio.Equals("13"))
                {

                    if (pTipoCuenta.Equals("colones"))
                    {
                        pMontoMoneda = "1";
                    }
                    else
                    {
                        pMontoMoneda = "2";
                    }
                    vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                    vDetTransaccion.Id = 102;
                    vDetTransaccion.Name = "ReversarDepositoEnCuentaBancaria";
                    vDetTransaccion.Integrated = "N";
                    vDetTransaccion.Sequence = pSecBac;
                    vDetTransaccion.Invoice = pInvoice;
                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 5, Value = pMontoMoneda });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(pTotalTras) });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 8, Value = "" });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 9, Value = pTipoIdentif });
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 10, Value = pNumCedula });

                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };


                }
                if (varCConvenio.Equals("12"))
                {

                    vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                    vDetTransaccion.Id = 122;
                    vDetTransaccion.Name = "ReversarPagoTarjetaCredito";
                    vDetTransaccion.Invoice = pInvoice;


                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 12, Value = pMontoMoneda }); // moneda de pago
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(pTotalTras) }); // total transacción
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 13, Value = pMonedaSaldo }); // moneda de saldo
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = pTarjeta }); // track2
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 9, Value = pTipoIdentif }); // tipo de identificación
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 10, Value = pNumCedula }); // número de identificación
                    //   vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 20, Value = "027246" }); // system tracer number

                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };

                }


                if (varCConvenio.Equals("14"))
                {

                    // reversion d retiros a cuenta bancaria rapi bac
                    vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                    vDetTransaccion.Id = 101;
                    vDetTransaccion.Name = "ReversarRetiroDeCuentaBancaria";
                    vDetTransaccion.Sequence = pSecBac;
                    vDetTransaccion.Invoice = pInvoice;


                    List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = vTarjPinPad }); // moneda de pago
                    vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(pTotalTras) }); // total transacción
                    ///   vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 20, Value = pMonedaSaldo }); // moneda de saldo

                    vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                    {
                        Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                        {
                            Transaction = vDetTransaccion,
                            TerminalNumber = vNumTerminal,
                            Credentials = vBacCredenciales,
                        },
                        Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                        {
                            RequestFields = vCampos.ToArray()
                        }
                    };

                }
                string vPregunta = clsXmlSerializer.SerializeObject(vRequest);

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);
                // Thread.Sleep(20000000);
                string vRespuesta = clsXmlSerializer.SerializeObject(vResponse);
                if (vResponse.Header.Status == LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ResponseType.Success)
                {
                    foreach (LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field vCampo in vResponse.Content.ResponseFields)
                    {
                        if (vCampo.Name.Equals("Print"))
                        {
                            // ANULA SOLO EN EL LOG
                            LLNet.Controls.LLEventLog EventLog = new LLNet.Controls.LLEventLog(LLNet.DAL.OracleDAL.ExeLogDir);
                            EventLog.WriteLog("", Convert.ToString("Se elimino la transaccion por time out y hubo reversion exitosa, respuesta:") + vRespuesta);
                            GUI.CApp.ShowMessage("Hubo reversion automatica por time out", "Mensaje de Informacion", true);
                        }

                    }
                }
                else
                {
                    mAnulacionTransaccionTimeOut(pConvenio, pInvoice, pSecBac, pTotalTras, pMontoMoneda, pTipoIdentif, pNumCedula, pTipoCuenta, pMonedaSaldo, vTarjPinPad);
                }

            }
            catch (Exception vExcepcion)
            {
                mAnulacionTransaccionTimeOut(pConvenio, pInvoice, pSecBac, pTotalTras, pMontoMoneda, pTipoIdentif, pNumCedula, pTipoCuenta, pMonedaSaldo, vTarjPinPad);

            }
        }

        /// <summary>
        /// mAnulacionTransaccionTimeOut
        /// </summary>
        /// <param name="pConvenio"></param>
        /// <param name="pInvoice"></param>
        /// <param name="pSecBac"></param>
        /// <param name="pMonto"></param>
        /// <param name="pMontoMoneda"></param>
        /// <param name="pTipoIdentif"></param>
        /// <param name="pNumCedula"></param>
        /// <param name="pTipoCuenta"></param>
        /// <param name="pMonedaSaldo"></param>
        /// <param name="pTarjeta"></param>
        private void mAnulacionTransaccionTimeOut(string pConvenio, string pInvoice, int pSecBac, string pMonto, string pMontoMoneda, string pTipoIdentif,
           string pNumCedula, string pTipoCuenta, string pMonedaSaldo, string pTarjeta)
        {

            QueryParams vQp = new LLNet.Utils.QueryParams();
            string vXml = "";

            if (string.IsNullOrEmpty(pTipoCuenta))
            {
                pTipoCuenta = "0";
            }

            if (string.IsNullOrEmpty(pTarjeta))
            {
                pTarjeta = "0";
            }
            if (string.IsNullOrEmpty(pMonedaSaldo))
            {
                pMonedaSaldo = "0";
            }
            try
            {
                vQp.AddReplaceParam("pInvoice", Convert.ToString(pInvoice));
                vQp.AddReplaceParam("pSecBac", Convert.ToString(pSecBac));
                vQp.AddReplaceParam("pTotalTras", pMonto);
                vQp.AddReplaceParam("pMontoMoneda", pMontoMoneda);
                vQp.AddReplaceParam("pTI", pTipoIdentif);
                vQp.AddReplaceParam("pNumCedula", pNumCedula);
                vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
                vQp.AddReplaceParam("pConvenio", pConvenio);
                vQp.AddReplaceParam("pTipoCuenta", pTipoCuenta);
                vQp.AddReplaceParam("pMonedaSaldo", pMonedaSaldo);
                vQp.AddReplaceParam("pTarjeta", pTarjeta);

                CApp.bll.ExecuteSql("WMS_P_REVERSA_TRANSTIMEOUT", vQp, "PDV");

            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "Error al ejecutar internamente el registro de la anulacion", true);
                //mRegistrarTransaccion("E", null, null, ex.Message, Convert.ToInt32(pNumComprobante), sec_BacInvoice);
            }


        }

        # region mAnulacionTransaccion
        // anular transaccion
        //-------------------

        private void mAnulacionTransaccion(string pNumComprobante, string pDocumento, string pTransProveedor, string ptc)
        {
            QueryParams vQp = new LLNet.Utils.QueryParams();
            string vXml = "";

            try
            {
                vQp.AddReplaceParam("pNumComprobante", pNumComprobante.ToString());
                vQp.AddReplaceParam("pDocumento", pDocumento);
                vQp.AddReplaceParam("pTransProveedor", pTransProveedor);
                vQp.AddReplaceParam("pUsuario", GUI.CApp.usuario);
                vQp.AddReplaceParam("pJornada", Program.Jornada.ToString());
                vQp.AddReplaceParam("pTC", ptc);

                CApp.bll.ExecuteSql("WMS_P_REVERSA_TRANS", vQp, "PDV");

            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "Error al ejecutar internamente el registro de la anulacion", true);
                mRegistrarTransaccion("E", null, null, ex.Message, Convert.ToInt32(pNumComprobante), sec_BacInvoice);
            }
        }
        #endregion
        /// <summary>
        /// Boton de retiros
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void simplebtnRetirar_Click(object sender, EventArgs e)
        {

            try
            {

                if (string.IsNullOrEmpty(txtNombreClienteBac.Text.Trim()))
                {
                    GUI.CApp.ShowMessage("Favor realizar la consulta de la tarjeta inicialmente", "ERROR", true);
                    sBtnConsultarBac.Focus();
                    return;
                }
                if (string.IsNullOrEmpty(textPagaRetiros.Text.Trim()))
                {
                    GUI.CApp.ShowMessage("Falta información en el campo MONTO A DEPOSITAR", "ERROR", true);
                    textPagaRetiros.Focus();
                    return;
                }
                else
                {

                    mRetirarDinero();
                    mCargaFondoDisponible();
                }
            }
            catch (SoapException sex)
            {
                GUI.CApp.ShowMessage(Convert.ToString(sex.Detail.FirstChild.Value), "ERROR", true);
                //mRegistrarTransaccion("E", null, null, Convert.ToString(sex.Detail.FirstChild.Value), pConsecutivo, sec_BacInvoice);
            }
            catch (Exception ex)
            {
                GUI.CApp.ShowMessage(ex.Message, "ERROR", true);
                ///  mRegistrarTransaccion("E", null, null, ex.Message, pConsecutivo, sec_BacInvoice);
            }

        }

        private void mRetirarDinero()
        {

            try
            {
                string[] vParametros = new string[3];
                QueryParams vQp = new LLNet.Utils.QueryParams();
                vQp.AddReplaceParam("pParam1", "RECU");
                vParametros = Convert.ToString(CApp.bll.GetSingleValue("TRANSAC_BAC", vQp, "PDV")).Split('+');
                mLimpiarBac();
                vDetTransaccion = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Detalle();
                vDetTransaccion.Id = int.Parse(vParametros[0]);
                vDetTransaccion.Name = vParametros[1];
                vDetTransaccion.Sequence = sec_BcSequence;
                vDetTransaccion.Integrated = "S";
                vDetTransaccion.Invoice = sec_BacInvoice;

                var vTarjPinPad = vTrack2;
                var vPin = vPinBlock;
                var vNombre = vNombreCliente;

                List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field> vCampos = new List<LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field>();

                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 2, Value = vTarjPinPad });
                vCampos.Add(new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field() { Id = 6, Value = mConvertirMonto(textPagaRetiros.Text.Trim()) });

                ;

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest vRequest = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequest()
                {
                    Header = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestHeader()
                    {
                        Transaction = vDetTransaccion,
                        TerminalNumber = vNumTerminal,
                        Credentials = vBacCredenciales,
                    },
                    Content = new LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsRequestContent
                    {
                        RequestFields = vCampos.ToArray()
                    }
                };

                mRegistrarTransaccion("P", vRequest, null, null, varSECretiros, sec_BacInvoice);

                string vPregunta = clsXmlSerializer.SerializeObject(vRequest);

                LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.ExecuteTransactionsResponse vResponse = vTerminalService.ExcecuteTransaction(vRequest);

                // validacion Time out pra reversar transaccion

                string vRespuesta = clsXmlSerializer.SerializeObject(vResponse);

                mRegistrarTransaccion("R", null, vResponse, null, varSECretiros, sec_BacInvoice);

                StringReader stringReader = new StringReader(vRespuesta);
                stringReader.Read();
                var inner = stringReader.ReadToEnd();

                XmlDocument dd = new XmlDocument();

                DataSet dsAplicado = new DataSet();

                dd.Load(new StringReader(inner));

                dsAplicado.ReadXml(new XmlTextReader(new StringReader(dd.OuterXml)));

                DataTable vConsulta = dsAplicado.Tables[1];

                var Status = vConsulta.Rows[0].ItemArray[1];


                if (Status.Equals("Success"))
                {

                    foreach (LLNet.Tienda.RapiBac2.ClientTerminalServiceClient.Field vCampo in vResponse.Content.ResponseFields)
                    {
                        if (vCampo.Name.Equals("Print"))
                        {
                            string vDocumento = vCampo.Value;
                            //Imprimir el comprobante y guardar los datos de pago...
                            //inserta    ResaBac

                            mRegistraRetiro("R", vDocumento, vRequest, vResponse, varSECretiros.ToString(), "", cbxMonedaRetiro.SelectedValue.ToString(), sec_BacInvoice, Convert.ToString(sec_BcSequence));
                            mRegistraRetiro("P", vDocumento, vRequest, vResponse, varSECretiros.ToString(), "", cbxMonedaRetiro.SelectedValue.ToString(), sec_BacInvoice, Convert.ToString(sec_BcSequence));


                            // pague servicios
                            RegistroBDBACServRetiros(vResponse, textPagaRetiros.Text.Trim(), varCEmpresa, varCConvenio, varSECretiros.ToString());
                            //RegistroBDBACServicios(vResponse, txtTotalBac.Text.Trim(), varCEmpresa, varCConvenio, mBuscarElemento("0",0,vPrueba)); 
                            GUI.CApp.ShowMessage("Retiro realizado con éxito", "ATENCION", true);
                            // mLimpiarDepositos();
                            mLimpiarRetiros();
                        }
                    }

                    // GUI.CApp.ShowMessage("Deposito realizado con éxito", "ATENCION", true);
                    mLimpiarRetiros();

                }
                else
                {
                    //  mAnulaMesaCambio(pSeTC);

                    if (dsAplicado.Tables.Count <= 2)
                    {
                        // mal general

                        var vDescripcion = vConsulta.Rows[0].ItemArray[2];
                        CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                        //  mRegistrarTransaccion("E", null, null, Convert.ToString(vDescripcion), pvarSECComp, sec_BacInvoice);
                        mLimpiarRetiros();

                    }
                    else
                    {


                        DataTable vConsultaContenido = dsAplicado.Tables[4];

                        var vMensaje = vConsultaContenido.Rows[0].ItemArray[3];
                        var vMensajeDES = vConsultaContenido.Rows[1].ItemArray[3];
                        mLimpiarRetiros();

                        // mRegistrarTransaccion("E", null, null, Convert.ToString(vMensajeDES), pvarSECComp, sec_BacInvoice);

                        if (vMensaje.Equals("19"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                        }
                        else if (vMensaje.Equals("03"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("48"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else if (vMensaje.Equals("31"))
                        {
                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);

                        }
                        else
                        {

                            var vDescripcion = vConsultaContenido.Rows[1].ItemArray[3];
                            GUI.CApp.ShowMessage(Convert.ToString(vDescripcion), "Error mensaje del proveedor RapiBac", false);
                            GUI.CApp.ShowMessage("", "Error mensaje del proveedor RapiBac", false);
                            mLimpiarRetiros();
                        }
                    }
                }

            }
            catch (TimeoutException sex)
            {
                mReversarRapiBac2TimeOut(sec_BacInvoice, cbxMonedaRetiro.SelectedValue.ToString(), textPagaRetiros.Text.Trim(), "", "", "1", textCedula.Text.Trim(), "", Convert.ToString(varSECretiros),
             "", varCConvenio, "", "", sec_BcSequence, vTrack2);
                mRegistrarTransaccion("E", null, null, sex.Message, varSECretiros, sec_BacInvoice);
                mLimpiarRetiros();
                GUI.CApp.ShowMessage(sex.Message, "Error en tiempo de respuesta", false);
            }
            catch (Exception ex)
            {

                mRegistrarTransaccion("E", null, null, ex.Message, varSECretiros, sec_BacInvoice);
                mLimpiarRetiros();
                GUI.CApp.ShowMessage(ex.Message, "Error en tiempo de respuesta", false);
            }


        }


        #endregion

        private void btnRecargar_Click(object sender, EventArgs e)
        {

        }

        private void mCambioMonto(object sender, EventArgs e)
        {
            simplebtnRetirar.Enabled = false;
        }

        private void eventoPagoKeyPress(object sender, KeyPressEventArgs e)
        {
            int vContadorPuntos = textPagaRetiros.Text.IndexOf('.');

            if (char.IsDigit(e.KeyChar) || char.IsControl(e.KeyChar))
            {
                e.Handled = false;
            }
            else
            {
                e.Handled = true;
            }

            if (e.KeyChar.ToString().Equals(".") && vContadorPuntos == -1)
            {
                e.Handled = false;
            }
        }

        private void sBtnEnviar_Click(object sender, EventArgs e)
        {

        }

    }
}
